/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){
var e,t=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/network","electron","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/platform/product/common/product","vs/base/common/strings","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/common/buffer","fs","vs/base/node/pfs","vs/platform/files/common/files","os","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/uuid","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/platform/request/common/request","vs/platform/workspaces/common/workspaces","vs/base/common/json","vs/base/common/objects","vs/platform/update/common/update","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/base/common/functional","child_process","vs/platform/configuration/common/configurationRegistry","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/remote/common/tunnel","vs/base/common/keyCodes","crypto","net","vs/platform/environment/node/argv","vs/platform/product/common/productService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/process","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","util","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/electron-main/themeMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/scanCode","vs/base/common/glob","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/common/errorMessage","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/storage/node/storageMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/url/common/url","vs/platform/webview/common/resourceLoader","vs/platform/windows/electron-main/windowsFinder","vs/code/electron-main/window","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/paths","vs/base/node/extpath","vs/base/node/ports","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/electron-main/ipc.electron-main","vs/base/parts/storage/common/storage","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/code/electron-main/window","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesMainService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/waitMarkerFile","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/display/electron-main/displayMainService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/code/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-main/sharedProcessMainService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/lifecycle/common/lifecycle","vs/code/electron-main/protocol","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/storage/node/storageIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryUtils","vs/platform/telemetry/node/commonProperties","vs/platform/telemetry/node/telemetryIpc","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/electron-main/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/mimeTypes","vs/platform/webview/common/webviewManagerService","vs/platform/webview/common/webviewPortMapping","vs/platform/webview/electron-main/webviewPortMappingProvider","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","zlib","vs/platform/driver/node/driver","vs/platform/environment/node/environmentService","vs/code/electron-main/sharedProcess","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesService","vs/code/electron-main/app","string_decoder","minimist","assert","stream","vs/code/electron-main/main"],i=function(e){
for(var i=[],r=0,n=e.length;r<n;r++)i[r]=t[e[r]];return i};function r(e){const t=[];return"number"==typeof e&&t.push("code/timeOrigin",e),{mark:function(e){t.push(e,Date.now())},getMarks:function(){const e=[];for(let i=0;i<t.length;i+=2)e.push({name:t[i],startTime:t[i+1]});return e}}}function n(e){return e.MonacoPerformanceMarks||(e.MonacoPerformanceMarks=function(){if("object"==typeof performance&&"function"==typeof performance.mark)return"number"==typeof performance.timeOrigin||performance.timing?{mark(e){performance.mark(e)},getMarks(){let e=performance.timeOrigin;"number"!=typeof e&&(e=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const t=[{name:"code/timeOrigin",startTime:Math.round(e)}];for(const i of performance.getEntriesByType("mark"))t.push({name:i.name,startTime:Math.round(e+i.startTime)});return t}}:r();if("object"==typeof process){return r(Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin))}
return console.trace("perf-util loaded in UNKNOWN environment"),r()}()),e.MonacoPerformanceMarks}define(t[95],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0,t.ok=function(e,t){if(!e)throw new Error(t?`Assertion failed (${t})`:"Assertion Failed")}}),define(t[45],i([0,1]),function(e,t){"use strict";function i(e){return(t,i,r)=>{let n=null,s=null;if("function"==typeof r.value?(n="value",s=r.value):"function"==typeof r.get&&(n="get",s=r.get),!s)throw new Error("not supported");r[n]=e(s,i)}}Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0,t.createDecorator=i;let r=0;function n(){const e=`$memoize${r++}`;let t=void 0;const i=function(i,r,n){let s=null,o=null;if("function"==typeof n.value?(s="value",0!==(o=n.value).length&&console.warn("Memoize should only be used in functions with zero parameters")):"function"==typeof n.get&&(s="get",o=n.get),!o)throw new Error("not supported")
;const a=`${e}:${r}`;n[s]=function(...e){return t=this,this.hasOwnProperty(a)||Object.defineProperty(this,a,{configurable:!0,enumerable:!1,writable:!0,value:o.apply(this,e)}),this[a]}};return i.clear=()=>{void 0!==t&&Object.getOwnPropertyNames(t).forEach(i=>{0===i.indexOf(e)&&delete t[i]})},i}t.createMemoizer=n,t.memoize=function(e,t,i){return n()(e,t,i)},t.debounce=function(e,t,r){return i((i,n)=>{const s=`$debounce$${n}`,o=`$debounce$result$${n}`;return function(...n){this[o]||(this[o]=r?r():void 0),clearTimeout(this[s]),t&&(this[o]=t(this[o],...n),n=[this[o]]),this[s]=setTimeout(()=>{i.apply(this,n),this[o]=r?r():void 0},e)}})},t.throttle=function(e,t,r){return i((i,n)=>{const s=`$throttle$timer$${n}`,o=`$throttle$result$${n}`,a=`$throttle$lastRun$${n}`,c=`$throttle$pending$${n}`;return function(...n){if(this[o]||(this[o]=r?r():void 0),null!==this[a]&&void 0!==this[a]||(this[a]=-Number.MAX_VALUE),t&&(this[o]=t(this[o],...n)),this[c])return;const l=this[a]+e;l<=Date.now()?(this[a]=Date.now(),
i.apply(this,[this[o]]),this[o]=r?r():void 0):(this[c]=!0,this[s]=setTimeout(()=>{this[c]=!1,this[a]=Date.now(),i.apply(this,[this[o]]),this[o]=r?r():void 0},l-Date.now()))}})}}),define(t[19],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(()=>{if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}addListener(e){return this.listeners.push(e),()=>{this._removeListener(e)}}emit(e){this.listeners.forEach(t=>{t(e)})}_removeListener(e){this.listeners.splice(this.listeners.indexOf(e),1)}setUnexpectedErrorHandler(e){this.unexpectedErrorHandler=e}
getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(e){this.unexpectedErrorHandler(e),this.emit(e)}onUnexpectedExternalError(e){this.unexpectedErrorHandler(e)}}t.ErrorHandler=i,t.errorHandler=new i,t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},t.onUnexpectedError=function(e){n(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){n(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){let{name:t,message:i}=e;return{$isError:!0,name:t,message:i,stack:e.stacktrace||e.stack}}return e};const r="Canceled";function n(e){return e instanceof Error&&e.name===r&&e.message===r}t.isPromiseCanceledError=n;t.CancellationError=class extends Error{constructor(){super(r),this.name=this.message}},t.canceled=function(){const e=new Error(r);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},
t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")},t.readonly=function(e){return e?new Error(`readonly property '${e} cannot be changed'`):new Error("readonly property cannot be changed")},t.disposed=function(e){const t=new Error(`${e} has been disposed`);return t.name="DISPOSED",t},t.getErrorMessage=function(e){return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"};t.NotImplementedError=class extends Error{constructor(e){super("NotImplemented"),e&&(this.message=e)}};t.NotSupportedError=class extends Error{constructor(e){super("NotSupported"),e&&(this.message=e)}}}),define(t[30],i([0,1,19]),function(e,t,i){"use strict";function r(e,t){let i=0,r=e.length;if(0===r)return 0;for(;i<r;){const n=Math.floor((i+r)/2);t(e[n])?r=n:i=n+1}return i}function n(e,t){return function e(t,i,r,n,s){if(n<=r)return;const o=r+(n-r)/2|0;e(t,i,r,o,s);e(t,i,o+1,n,s);if(i(t[o],t[o+1])<=0)return;!function(e,t,i,r,n,s){let o=i,a=r+1;for(let t=i;t<=n;t++)s[t]=e[t]
;for(let c=i;c<=n;c++)o>r?e[c]=s[a++]:a>n?e[c]=s[o++]:t(s[a],s[o])<0?e[c]=s[a++]:e[c]=s[o++]}(t,i,r,o,n,s)}(e,t,0,e.length-1,[]),e}function s(e,t,i){const r=[];function n(e,t,i){if(0===t&&0===i.length)return;const n=r[r.length-1];n&&n.start+n.deleteCount===e?(n.deleteCount+=t,n.toInsert.push(...i)):r.push({start:e,deleteCount:t,toInsert:i})}let s=0,o=0;for(;;){if(s===e.length){n(s,0,t.slice(o));break}if(o===t.length){n(s,e.length-s,[]);break}const r=e[s],a=t[o],c=i(r,a);0===c?(s+=1,o+=1):c<0?(n(s,1,[]),s+=1):c>0&&(n(s,0,[a]),o+=1)}return r}function o(e,t,i,n,s){for(const o=i.length;n<s;n++){const s=e[n];if(t(s,i[o-1])<0){i.pop();const e=r(i,e=>t(s,e)<0);i.splice(e,0,s)}}}function a(e,t){const i=e.indexOf(t);if(i>-1)return e.splice(i,1),t}Object.defineProperty(t,"__esModule",{value:!0}),
t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.mergeSort=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0,t.tail=function(e,t=0){return e[e.length-(1+t)]},t.tail2=function(e){if(0===e.length)throw new Error("Invalid tail call");return[e.slice(0,e.length-1),e[e.length-1]]},t.equals=function(e,t,i=((e,t)=>e===t)){if(e===t)return!0;if(!e||!t)return!1;if(e.length!==t.length)return!1;for(let r=0,n=e.length;r<n;r++)if(!i(e[r],t[r]))return!1;return!0},t.binarySearch=function(e,t,i){let r=0,n=e.length-1;for(;r<=n;){const s=(r+n)/2|0,o=i(e[s],t);if(o<0)r=s+1;else{if(!(o>0))return s;n=s-1}}return-(r+1)},t.findFirstInSorted=r,t.quickSelect=function e(t,i,r){
if((t|=0)>=i.length)throw new TypeError("invalid index");let n=i[Math.floor(i.length*Math.random())],s=[],o=[],a=[];for(let e of i){const t=r(e,n);t<0?s.push(e):t>0?o.push(e):a.push(e)}return t<s.length?e(t,s,r):t<s.length+a.length?a[0]:e(t-(s.length+a.length),o,r)},t.mergeSort=n,t.groupBy=function(e,t){const i=[];let r=void 0;for(const s of n(e.slice(0),t))r&&0===t(r[0],s)?r.push(s):(r=[s],i.push(r));return i},t.sortedDiff=s,t.delta=function(e,t,i){const r=s(e,t,i),n=[],o=[];for(const t of r)n.push(...e.slice(t.start,t.start+t.deleteCount)),o.push(...t.toInsert);return{removed:n,added:o}},t.top=function(e,t,i){if(0===i)return[];const r=e.slice(0,i).sort(t);return o(e,t,r,i,e.length),r},t.topAsync=function(e,t,r,n,s){return 0===r?Promise.resolve([]):new Promise((a,c)=>{(async()=>{const a=e.length,c=e.slice(0,r).sort(t);for(let l=r,d=Math.min(r+n,a);l<a;l=d,d=Math.min(d+n,a)){if(l>r&&await new Promise(e=>setTimeout(e)),s&&s.isCancellationRequested)throw i.canceled();o(e,t,c,l,d)}return c})().then(a,c)})},
t.coalesce=function(e){return e.filter(e=>!!e)},t.coalesceInPlace=function(e){let t=0;for(let i=0;i<e.length;i++)e[i]&&(e[t]=e[i],t+=1);e.length=t},t.move=function(e,t,i){e.splice(i,0,e.splice(t,1)[0])},t.isFalsyOrEmpty=function(e){return!Array.isArray(e)||0===e.length},t.isNonEmptyArray=function(e){return Array.isArray(e)&&e.length>0},t.distinct=function(e,t){if(!t)return e.filter((t,i)=>e.indexOf(t)===i);const i=Object.create(null);return e.filter(e=>{const r=t(e);return!i[r]&&(i[r]=!0,!0)})},t.distinctES6=function(e){const t=new Set;return e.filter(e=>!t.has(e)&&(t.add(e),!0))},t.uniqueFilter=function(e){const t=Object.create(null);return i=>{const r=e(i);return!t[r]&&(t[r]=!0,!0)}},t.lastIndex=function(e,t){for(let i=e.length-1;i>=0;i--){if(t(e[i]))return i}return-1},t.firstOrDefault=function(e,t){return e.length>0?e[0]:t},t.commonPrefixLength=function(e,t,i=((e,t)=>e===t)){let r=0;for(let n=0,s=Math.min(e.length,t.length);n<s&&i(e[n],t[n]);n++)r++;return r},t.flatten=function(e){return[].concat(...e)},
t.range=function(e,t){let i="number"==typeof t?e:0;"number"==typeof t?i=e:(i=0,t=e);const r=[];if(i<=t)for(let e=i;e<t;e++)r.push(e);else for(let e=i;e>t;e--)r.push(e);return r},t.index=function(e,t,i){return e.reduce((e,r)=>(e[t(r)]=i?i(r):r,e),Object.create(null))},t.insert=function(e,t){return e.push(t),()=>a(e,t)},t.remove=a,t.arrayInsert=function(e,t,i){const r=e.slice(0,t),n=e.slice(t);return r.concat(i,n)},t.shuffle=function(e,t){let i;if("number"==typeof t){let e=t;i=()=>{const t=179426549*Math.sin(e++);return t-Math.floor(t)}}else i=Math.random;for(let t=e.length-1;t>0;t-=1){const r=Math.floor(i()*(t+1)),n=e[t];e[t]=e[r],e[r]=n}},t.pushToStart=function(e,t){const i=e.indexOf(t);i>-1&&(e.splice(i,1),e.unshift(t))},t.pushToEnd=function(e,t){const i=e.indexOf(t);i>-1&&(e.splice(i,1),e.push(t))},t.mapArrayOrNot=function(e,t){return Array.isArray(e)?e.map(t):t(e)},t.asArray=function(e){return Array.isArray(e)?e:[e]},t.getRandomElement=function(e){return e[Math.floor(Math.random()*e.length)]},
t.mapFind=function(e,t){for(const i of e){const e=t(i);if(void 0!==e)return e}}}),define(t[46],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0,t.once=function(e){const t=this;let i,r=!1;return function(){return r?i:(r=!0,i=e.apply(t,arguments))}}}),define(t[62],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0,function(e){e.is=function(e){return e&&"object"==typeof e&&"function"==typeof e[Symbol.iterator]};const t=Object.freeze([]);e.empty=function(){return t},e.single=function*(e){yield e},e.from=function(e){return e||t},e.isEmpty=function(e){return!0===e[Symbol.iterator]().next().done},e.first=function(e){return e[Symbol.iterator]().next().value},e.some=function(e,t){for(const i of e)if(t(i))return!0;return!1},e.filter=function*(e,t){for(const i of e)t(i)&&(yield i)},e.map=function*(e,t){for(const i of e)yield t(i)},e.concat=function*(...e){for(const t of e)for(const e of t)yield e},
e.consume=function(t,i=Number.POSITIVE_INFINITY){const r=[];if(0===i)return[r,t];const n=t[Symbol.iterator]();for(let t=0;t<i;t++){const t=n.next();if(t.done)return[r,e.empty()];r.push(t.value)}return[r,{[Symbol.iterator]:()=>n}]}}(t.Iterable||(t.Iterable={}))}),define(t[40],i([0,1]),function(e,t){"use strict";var i,r;function n(e,t=!1){let i=0,r=e.length,n="",c=0,l=16,d=0;function u(t){let r=0,n=0;for(;r<t;){const t=e.charCodeAt(i);if(t>=48&&t<=57)n=16*n+t-48;else if(t>=65&&t<=70)n=16*n+t-65+10;else{if(!(t>=97&&t<=102))break;n=16*n+t-97+10}i++,r++}return r<t&&(n=-1),n}function h(){if(n="",d=0,c=i,i>=r)return c=r,l=17;let t=e.charCodeAt(i);if(s(t)){do{i++,n+=String.fromCharCode(t),t=e.charCodeAt(i)}while(s(t));return l=15}if(o(t))return i++,n+=String.fromCharCode(t),13===t&&10===e.charCodeAt(i)&&(i++,n+="\n"),l=14;switch(t){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,n=function(){let t="",n=i
;for(;;){if(i>=r){t+=e.substring(n,i),d=2;break}const s=e.charCodeAt(i);if(34===s){t+=e.substring(n,i),i++;break}if(92!==s){if(s>=0&&s<=31){if(o(s)){t+=e.substring(n,i),d=2;break}d=6}i++}else{if(t+=e.substring(n,i),++i>=r){d=2;break}switch(e.charCodeAt(i++)){case 34:t+='"';break;case 92:t+="\\";break;case 47:t+="/";break;case 98:t+="\b";break;case 102:t+="\f";break;case 110:t+="\n";break;case 114:t+="\r";break;case 116:t+="\t";break;case 117:const r=u(4);r>=0?t+=String.fromCharCode(r):d=4;break;default:d=5}n=i}}return t}(),l=10;case 47:const s=i-1;if(47===e.charCodeAt(i+1)){for(i+=2;i<r&&!o(e.charCodeAt(i));)i++;return n=e.substring(s,i),l=12}if(42===e.charCodeAt(i+1)){i+=2;const t=r-1;let o=!1;for(;i<t;){if(42===e.charCodeAt(i)&&47===e.charCodeAt(i+1)){i+=2,o=!0;break}i++}return o||(i++,d=1),n=e.substring(s,i),l=13}return n+=String.fromCharCode(t),i++,l=16;case 45:if(n+=String.fromCharCode(t),++i===r||!a(e.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:
case 57:return n+=function(){const t=i;if(48===e.charCodeAt(i))i++;else for(i++;i<e.length&&a(e.charCodeAt(i));)i++;if(i<e.length&&46===e.charCodeAt(i)){if(!(++i<e.length&&a(e.charCodeAt(i))))return d=3,e.substring(t,i);for(i++;i<e.length&&a(e.charCodeAt(i));)i++}let r=i;if(i<e.length&&(69===e.charCodeAt(i)||101===e.charCodeAt(i)))if((++i<e.length&&43===e.charCodeAt(i)||45===e.charCodeAt(i))&&i++,i<e.length&&a(e.charCodeAt(i))){for(i++;i<e.length&&a(e.charCodeAt(i));)i++;r=i}else d=3;return e.substring(t,r)}(),l=11;default:for(;i<r&&p(t);)i++,t=e.charCodeAt(i);if(c!==i){switch(n=e.substring(c,i)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(t),i++,l=16}}function p(e){if(s(e)||o(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}return{setPosition:function(e){i=e,n="",c=0,l=16,d=0},getPosition:()=>i,scan:t?function(){let e;do{e=h()}while(e>=12&&e<=15);return e}:h,getToken:()=>l,
getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>d}}function s(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&e<=8203||8239===e||8287===e||12288===e||65279===e}function o(e){return 10===e||13===e||8232===e||8233===e}function a(e){return e>=48&&e<=57}function c(e,t,i=!1){return t>=e.offset&&t<e.offset+e.length||i&&t===e.offset+e.length}function l(e,t,r=i.DEFAULT){const s=n(e,!1);function o(e){return e?()=>e(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(e){return e?t=>e(t,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=o(t.onObjectBegin),l=a(t.onObjectProperty),d=o(t.onObjectEnd),u=o(t.onArrayBegin),h=o(t.onArrayEnd),p=a(t.onLiteralValue),f=a(t.onSeparator),g=o(t.onComment),m=a(t.onError),v=r&&r.disallowComments,w=r&&r.allowTrailingComma;function y(){for(;;){const e=s.scan();switch(s.getTokenError()){case 4:S(14);break;case 5:S(15);break;case 3:S(13);break;case 1:v||S(11);break;case 2:S(12);break;case 6:S(16)}switch(e){case 12:case 13:
v?S(10):g();break;case 16:S(1);break;case 15:case 14:break;default:return e}}}function S(e,t=[],i=[]){if(m(e),t.length+i.length>0){let e=s.getToken();for(;17!==e;){if(-1!==t.indexOf(e)){y();break}if(-1!==i.indexOf(e))break;e=y()}}}function b(e){const t=s.getTokenValue();return e?p(t):l(t),y(),!0}function _(){switch(s.getToken()){case 3:return function(){u(),y();let e=!1;for(;4!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||S(4,[],[]),f(","),y(),4===s.getToken()&&w)break}else e&&S(6,[],[]);_()||S(4,[],[4,5]),e=!0}return h(),4!==s.getToken()?S(8,[4],[]):y(),!0}();case 1:return function(){c(),y();let e=!1;for(;2!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||S(4,[],[]),f(","),y(),2===s.getToken()&&w)break}else e&&S(6,[],[]);(10!==s.getToken()?(S(3,[],[2,5]),0):(b(!1),6===s.getToken()?(f(":"),y(),_()||S(4,[],[2,5])):S(5,[],[2,5]),1))||S(4,[],[2,5]),e=!0}return d(),2!==s.getToken()?S(7,[2],[]):y(),!0}();case 10:return b(!0);default:return function(){switch(s.getToken()){case 11:
let e=0;try{"number"!=typeof(e=JSON.parse(s.getTokenValue()))&&(S(2),e=0)}catch(e){S(2)}p(e);break;case 7:p(null);break;case 8:p(!0);break;case 9:p(!1);break;default:return!1}return y(),!0}()}}return y(),17===s.getToken()?!!r.allowEmptyContent||(S(4,[],[]),!1):_()?(17!==s.getToken()&&S(9,[],[]),!0):(S(4,[],[]),!1)}function d(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":return e?Array.isArray(e)?"array":"object":"null";default:return"null"}}Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",
e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"}(t.ScanError||(t.ScanError={})),function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"}(t.SyntaxKind||(t.SyntaxKind={})),function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",
e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"}(t.ParseErrorCode||(t.ParseErrorCode={})),function(e){e.DEFAULT={allowTrailingComma:!0}}(i=t.ParseOptions||(t.ParseOptions={})),t.createScanner=n,function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",
e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",
e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",
e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"}(r||(r={})),t.getLocation=function(e,t){const i=[],r=new Object;let n=void 0;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function a(e,t,i,r){s.value=e,s.offset=t,s.length=i,s.type=r,s.colonOffset=void 0,n=s}try{l(e,{onObjectBegin:(e,s)=>{if(t<=e)throw r;n=void 0,o=t>e,i.push("")},onObjectProperty:(e,n,s)=>{if(t<n)throw r;if(a(e,n,s,"property"),i[i.length-1]=e,t<=n+s)throw r},onObjectEnd:(e,s)=>{if(t<=e)throw r;n=void 0,i.pop()},onArrayBegin:(e,s)=>{if(t<=e)throw r;n=void 0,i.push(0)},onArrayEnd:(e,s)=>{if(t<=e)throw r;n=void 0,i.pop()},
onLiteralValue:(e,i,n)=>{if(t<i)throw r;if(a(e,i,n,d(e)),t<=i+n)throw r},onSeparator:(e,s,a)=>{if(t<=s)throw r;if(":"===e&&n&&"property"===n.type)n.colonOffset=s,o=!1,n=void 0;else if(","===e){const e=i[i.length-1];"number"==typeof e?i[i.length-1]=e+1:(o=!0,i[i.length-1]=""),n=void 0}}})}catch(e){if(e!==r)throw e}return{path:i,previousNode:n,isAtPropertyKey:o,matches:e=>{let t=0;for(let r=0;t<e.length&&r<i.length;r++)if(e[t]===i[r]||"*"===e[t])t++;else if("**"!==e[t])return!1;return t===e.length}}},t.parse=function(e,t=[],r=i.DEFAULT){let n=null,s=[];const o=[];function a(e){Array.isArray(s)?s.push(e):null!==n&&(s[n]=e)}return l(e,{onObjectBegin:()=>{const e={};a(e),o.push(s),s=e,n=null},onObjectProperty:e=>{n=e},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const e=[];a(e),o.push(s),s=e,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:a,onError:(e,i,r)=>{t.push({error:e,offset:i,length:r})}},r),s[0]},t.parseTree=function(e,t=[],r=i.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0}
;function s(e){"property"===n.type&&(n.length=e-n.offset,n=n.parent)}function o(e){return n.children.push(e),e}l(e,{onObjectBegin:e=>{n=o({type:"object",offset:e,length:-1,parent:n,children:[]})},onObjectProperty:(e,t,i)=>{(n=o({type:"property",offset:t,length:-1,parent:n,children:[]})).children.push({type:"string",value:e,offset:t,length:i,parent:n})},onObjectEnd:(e,t)=>{n.length=e+t-n.offset,n=n.parent,s(e+t)},onArrayBegin:(e,t)=>{n=o({type:"array",offset:e,length:-1,parent:n,children:[]})},onArrayEnd:(e,t)=>{n.length=e+t-n.offset,n=n.parent,s(e+t)},onLiteralValue:(e,t,i)=>{o({type:d(e),offset:t,length:i,parent:n,value:e}),s(t+i)},onSeparator:(e,t,i)=>{"property"===n.type&&(":"===e?n.colonOffset=t:","===e&&s(t))},onError:(e,i,r)=>{t.push({error:e,offset:i,length:r})}},r);const a=n.children[0];return a&&delete a.parent,a},t.findNodeAtLocation=function(e,t){if(!e)return;let i=e;for(let e of t)if("string"==typeof e){if("object"!==i.type||!Array.isArray(i.children))return;let t=!1
;for(const r of i.children)if(Array.isArray(r.children)&&r.children[0].value===e){i=r.children[1],t=!0;break}if(!t)return}else{const t=e;if("array"!==i.type||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i},t.getNodePath=function e(t){if(!t.parent||!t.parent.children)return[];const i=e(t.parent);if("property"===t.parent.type){const e=t.parent.children[0].value;i.push(e)}else if("array"===t.parent.type){const e=t.parent.children.indexOf(t);-1!==e&&i.push(e)}return i},t.getNodeValue=function e(t){switch(t.type){case"array":return t.children.map(e);case"object":const i=Object.create(null);for(let r of t.children){const t=r.children[1];t&&(i[r.children[0].value]=e(t))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}},t.contains=c,t.findNodeAtOffset=function e(t,i,r=!1){if(c(t,i,r)){const n=t.children;if(Array.isArray(n))for(let t=0;t<n.length&&n[t].offset<=i;t++){const s=e(n[t],i,r);if(s)return s}return t}},t.visit=l,
t.stripComments=function(e,t){let i,r,s=n(e),o=[],a=0;do{switch(r=s.getPosition(),i=s.scan()){case 12:case 13:case 17:a!==r&&o.push(e.substring(a,r)),void 0!==t&&o.push(s.getTokenValue().replace(/[^\r\n]/g,t)),a=s.getPosition()}}while(17!==i);return o.join("")},t.getNodeType=d}),define(t[96],i([0,1,40]),function(e,t,i){"use strict";function r(e,t){let i="";for(let r=0;r<t;r++)i+=e;return i}function n(e,t){for(let e=0;e<t.length;e++){const i=t.charAt(e);if("\r"===i)return e+1<t.length&&"\n"===t.charAt(e+1)?"\r\n":"\r";if("\n"===i)return"\n"}return e&&e.eol||"\n"}function s(e,t){return-1!=="\r\n".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0}),t.isEOL=t.getEOL=t.format=void 0,t.format=function(e,t,o){let a,c,l,d,u;if(t){for(d=t.offset,u=d+t.length,l=d;l>0&&!s(e,l-1);)l--;let i=u;for(;i<e.length&&!s(e,i);)i++;c=e.substring(l,i),a=function(e,t){let i=0,r=0;const n=t.tabSize||4;for(;i<e.length;){const t=e.charAt(i);if(" "===t)r++;else{if("\t"!==t)break;r+=n}i++}return Math.floor(r/n)}(c,o)
}else c=e,a=0,l=0,d=0,u=e.length;const h=n(o,e);let p,f=!1,g=0;p=o.insertSpaces?r(" ",o.tabSize||4):"\t";const m=i.createScanner(c,!1);let v=!1;function w(){return h+r(p,a+g)}function y(){let e=m.scan();for(f=!1;15===e||14===e;)f=f||14===e,e=m.scan();return v=16===e||0!==m.getTokenError(),e}const S=[];function b(t,i,r){!v&&i<u&&r>d&&e.substring(i,r)!==t&&S.push({offset:i,length:r-i,content:t})}let _=y();if(17!==_){const e=m.getTokenOffset()+l;b(r(p,a),l,e)}for(;17!==_;){let e=m.getTokenOffset()+m.getTokenLength()+l,t=y(),i="";for(;!f&&(12===t||13===t);){b(" ",e,m.getTokenOffset()+l),e=m.getTokenOffset()+m.getTokenLength()+l,i=12===t?w():"",t=y()}if(2===t)1!==_&&(g--,i=w());else if(4===t)3!==_&&(g--,i=w());else{switch(_){case 3:case 1:g++,i=w();break;case 5:case 12:i=w();break;case 13:i=f?w():" ";break;case 6:i=" ";break;case 10:if(6===t){i="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===t||13===t?i=" ":5!==t&&17!==t&&(v=!0);break;case 16:v=!0}!f||12!==t&&13!==t||(i=w())}b(i,e,m.getTokenOffset()+l),
_=t}return S},t.getEOL=n,t.isEOL=s}),define(t[97],i([0,1,40,96,30]),function(e,t,i,r,n){"use strict";function s(e,t,r,n,s){const a=t.slice(),c=i.parseTree(e,[]);let l=void 0,d=void 0;for(;a.length>0&&(d=a.pop(),void 0===(l=i.findNodeAtLocation(c,a))&&void 0!==r);)r="string"==typeof d?{[d]:r}:[r];if(l){if("object"===l.type&&"string"==typeof d&&Array.isArray(l.children)){const t=i.findNodeAtLocation(l,[d]);if(void 0!==t){if(void 0===r){if(!t.parent)throw new Error("Malformed AST");const i=l.children.indexOf(t.parent);let r,s=t.parent.offset+t.parent.length;if(i>0){const e=l.children[i-1];r=e.offset+e.length}else if(r=l.offset+1,l.children.length>1){s=l.children[1].offset}return o(e,{offset:r,length:s-r,content:""},n)}return o(e,{offset:t.offset,length:t.length,content:JSON.stringify(r)},n)}{if(void 0===r)return[];const t=`${JSON.stringify(d)}: ${JSON.stringify(r)}`,i=s?s(l.children.map(e=>e.children[0].value)):l.children.length;let a;if(i>0){const e=l.children[i-1];a={offset:e.offset+e.length,length:0,
content:","+t}}else a=0===l.children.length?{offset:l.offset+1,length:0,content:t}:{offset:l.offset+1,length:0,content:t+","};return o(e,a,n)}}if("array"===l.type&&"number"==typeof d&&Array.isArray(l.children)){if(void 0!==r){const t=`${JSON.stringify(r)}`;let i;if(0===l.children.length||0===d)i={offset:l.offset+1,length:0,content:0===l.children.length?t:t+","};else{const e=-1===d||d>l.children.length?l.children.length:d,r=l.children[e-1];i={offset:r.offset+r.length,length:0,content:","+t}}return o(e,i,n)}{const t=d,i=l.children[t];let r;if(1===l.children.length)r={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===t){const e=l.children[t-1],i=e.offset+e.length;r={offset:i,length:l.offset+l.length-2-i,content:""}}else r={offset:i.offset,length:l.children[t+1].offset-i.offset,content:""};return o(e,r,n)}}throw new Error(`Can not add ${"number"!=typeof d?"index":"property"} to parent of type ${l.type}`)}if(void 0===r)throw new Error("Can not delete in empty document");return o(e,{
offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(r)},n)}function o(e,t,i){let n=a(e,t),s=t.offset,o=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;s>0&&!r.isEOL(n,s-1);)s--;for(;o<n.length&&!r.isEOL(n,o);)o++}const c=r.format(n,{offset:s,length:o-s},i);for(let e=c.length-1;e>=0;e--){const t=c[e];n=a(n,t),s=Math.min(s,t.offset),o=Math.max(o,t.offset+t.length),o+=t.content.length-t.length}return[{offset:s,length:e.length-(n.length-o)-s,content:n.substring(s,o)}]}function a(e,t){return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}Object.defineProperty(t,"__esModule",{value:!0}),t.applyEdits=t.applyEdit=t.withFormatting=t.setProperty=t.removeProperty=void 0,t.removeProperty=function(e,t,i){return s(e,t,void 0,i)},t.setProperty=s,t.withFormatting=o,t.applyEdit=a,t.applyEdits=function(e,t){let i=n.mergeSort(t,(e,t)=>{const i=e.offset-t.offset;return 0===i?e.length-t.length:i}),r=e.length;for(let t=i.length-1;t>=0;t--){let n=i[t]
;if(!(n.offset+n.length<=r))throw new Error("Overlapping edit");e=a(e,n),r=n.offset}return e}}),define(t[55],i([0,1,19]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.KeyCode=void 0,function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",
e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",
e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",
e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"}(t.KeyCode||(t.KeyCode={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(e,t){this._keyCodeToStr[e]=t,this._strToKeyCode[t.toLowerCase()]=e}keyCodeToStr(e){return this._keyCodeToStr[e]}strToKeyCode(e){return this._strToKeyCode[e.toLowerCase()]||0}}const n=new r,s=new r,o=new r;var a;function c(e,t){const i=!!(2048&e),r=!!(256&e);return new l(2===t?r:i,!!(1024&e),!!(512&e),2===t?i:r,255&e)}!function(){function e(e,t,i=t,r=i){n.define(e,t),s.define(e,i),o.define(e,r)}e(0,"unknown"),e(1,"Backspace"),e(2,"Tab"),e(3,"Enter"),e(4,"Shift"),e(5,"Ctrl"),e(6,"Alt"),e(7,"PauseBreak"),e(8,"CapsLock"),e(9,"Escape"),e(10,"Space"),e(11,"PageUp"),e(12,"PageDown"),e(13,"End"),e(14,"Home"),e(15,"LeftArrow","Left"),e(16,"UpArrow","Up"),e(17,"RightArrow","Right"),e(18,"DownArrow","Down"),e(19,"Insert"),
e(20,"Delete"),e(21,"0"),e(22,"1"),e(23,"2"),e(24,"3"),e(25,"4"),e(26,"5"),e(27,"6"),e(28,"7"),e(29,"8"),e(30,"9"),e(31,"A"),e(32,"B"),e(33,"C"),e(34,"D"),e(35,"E"),e(36,"F"),e(37,"G"),e(38,"H"),e(39,"I"),e(40,"J"),e(41,"K"),e(42,"L"),e(43,"M"),e(44,"N"),e(45,"O"),e(46,"P"),e(47,"Q"),e(48,"R"),e(49,"S"),e(50,"T"),e(51,"U"),e(52,"V"),e(53,"W"),e(54,"X"),e(55,"Y"),e(56,"Z"),e(57,"Meta"),e(58,"ContextMenu"),e(59,"F1"),e(60,"F2"),e(61,"F3"),e(62,"F4"),e(63,"F5"),e(64,"F6"),e(65,"F7"),e(66,"F8"),e(67,"F9"),e(68,"F10"),e(69,"F11"),e(70,"F12"),e(71,"F13"),e(72,"F14"),e(73,"F15"),e(74,"F16"),e(75,"F17"),e(76,"F18"),e(77,"F19"),e(78,"NumLock"),e(79,"ScrollLock"),e(80,";",";","OEM_1"),e(81,"=","=","OEM_PLUS"),e(82,",",",","OEM_COMMA"),e(83,"-","-","OEM_MINUS"),e(84,".",".","OEM_PERIOD"),e(85,"/","/","OEM_2"),e(86,"`","`","OEM_3"),e(110,"ABNT_C1"),e(111,"ABNT_C2"),e(87,"[","[","OEM_4"),e(88,"\\","\\","OEM_5"),e(89,"]","]","OEM_6"),e(90,"'","'","OEM_7"),e(91,"OEM_8"),e(92,"OEM_102"),e(93,"NumPad0"),e(94,"NumPad1"),
e(95,"NumPad2"),e(96,"NumPad3"),e(97,"NumPad4"),e(98,"NumPad5"),e(99,"NumPad6"),e(100,"NumPad7"),e(101,"NumPad8"),e(102,"NumPad9"),e(103,"NumPad_Multiply"),e(104,"NumPad_Add"),e(105,"NumPad_Separator"),e(106,"NumPad_Subtract"),e(107,"NumPad_Decimal"),e(108,"NumPad_Divide")}(),function(e){e.toString=function(e){return n.keyCodeToStr(e)},e.fromString=function(e){return n.strToKeyCode(e)},e.toUserSettingsUS=function(e){return s.keyCodeToStr(e)},e.toUserSettingsGeneral=function(e){return o.keyCodeToStr(e)},e.fromUserSettings=function(e){return s.strToKeyCode(e)||o.strToKeyCode(e)}}(t.KeyCodeUtils||(t.KeyCodeUtils={})),function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl",e[e.KeyCode=255]="KeyCode"}(a||(a={})),function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"}(t.KeyMod||(t.KeyMod={})),t.KeyChord=function(e,t){return(e|(65535&t)<<16>>>0)>>>0},t.createKeybinding=function(e,t){if(0===e)return null
;const i=(65535&e)>>>0,r=(4294901760&e)>>>16;return new d(0!==r?[c(i,t),c(r,t)]:[c(i,t)])},t.createSimpleKeybinding=c;class l{constructor(e,t,i,r,n){this.ctrlKey=e,this.shiftKey=t,this.altKey=i,this.metaKey=r,this.keyCode=n}equals(e){return this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){return`${this.ctrlKey?"1":"0"}${this.shiftKey?"1":"0"}${this.altKey?"1":"0"}${this.metaKey?"1":"0"}${this.keyCode}`}isModifierKey(){return 0===this.keyCode||5===this.keyCode||57===this.keyCode||6===this.keyCode||4===this.keyCode}toChord(){return new d([this])}isDuplicateModifierCase(){return this.ctrlKey&&5===this.keyCode||this.shiftKey&&4===this.keyCode||this.altKey&&6===this.keyCode||this.metaKey&&57===this.keyCode}}t.SimpleKeybinding=l;class d{constructor(e){if(0===e.length)throw i.illegalArgument("parts");this.parts=e}getHashCode(){let e="";for(let t=0,i=this.parts.length;t<i;t++)0!==t&&(e+=";"),e+=this.parts[t].getHashCode()
;return e}equals(e){if(null===e)return!1;if(this.parts.length!==e.parts.length)return!1;for(let t=0;t<this.parts.length;t++)if(!this.parts[t].equals(e.parts[t]))return!1;return!0}}t.ChordKeybinding=d;t.ResolvedKeybindingPart=class{constructor(e,t,i,r,n,s){this.ctrlKey=e,this.shiftKey=t,this.altKey=i,this.metaKey=r,this.keyLabel=n,this.keyAriaLabel=s}};t.ResolvedKeybinding=class{}}),define(t[2],i([0,1,46,62]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=void 0;const n=!1,s="__is_disposable_tracked__";function o(e){if(n&&e&&e!==u.None)try{e[s]=!0}catch(e){}}function a(e){if(!n)return e;const t=new Error("Potentially leaked disposable").stack;return setTimeout(()=>{e[s]||console.log(t)},3e3),e}class c extends Error{constructor(e){super(`Encounter errors while disposing of store. Errors: [${e.join(", ")}]`),
this.errors=e}}function l(e){if(r.Iterable.is(e)){let t=[];for(const i of e)if(i){o(i);try{i.dispose()}catch(e){t.push(e)}}if(1===t.length)throw t[0];if(t.length>1)throw new c(t);return Array.isArray(e)?[]:e}if(e)return o(e),e.dispose(),e}t.MultiDisposeError=c,t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=l,t.combinedDisposable=function(...e){return e.forEach(o),a({dispose:()=>l(e)})},t.toDisposable=function(e){const t=a({dispose:()=>{o(t),e()}});return t};class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(e){if(!e)return e;if(e===this)throw new Error("Cannot register a disposable on itself!");return o(e),
this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(e),e}}t.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new d,a(this)}dispose(){o(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}t.Disposable=u,u.None=Object.freeze({dispose(){}});t.MutableDisposable=class{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&o(e),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value&&this._value.dispose(),this._value=void 0}};t.ReferenceCollection=class{constructor(){this.references=new Map}acquire(e,...t){let r=this.references.get(e);r||(r={counter:0,
object:this.createReferencedObject(e,...t)},this.references.set(e,r));const{object:n}=r,s=i.once(()=>{0==--r.counter&&(this.destroyReferencedObject(e,r.object),this.references.delete(e))});return r.counter++,{object:n,dispose:s}}};t.ImmortalReference=class{constructor(e){this.object=e}dispose(){}}}),define(t[98],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class i{constructor(e){this.element=e,this.next=i.Undefined,this.prev=i.Undefined}}i.Undefined=new i(void 0);t.LinkedList=class{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(e){return this._insert(e,!1)}push(e){return this._insert(e,!0)}_insert(e,t){const r=new i(e);if(this._first===i.Undefined)this._first=r,this._last=r;else if(t){const e=this._last;this._last=r,r.prev=e,e.next=r}else{const e=this._first;this._first=r,
r.next=e,e.prev=r}this._size+=1;let n=!1;return()=>{n||(n=!0,this._remove(r))}}shift(){if(this._first!==i.Undefined){const e=this._first.element;return this._remove(this._first),e}}pop(){if(this._last!==i.Undefined){const e=this._last.element;return this._remove(this._last),e}}_remove(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let e=this._first;for(;e!==i.Undefined;)yield e.element,e=e.next}}}),e="object"==typeof global?global:"object"==typeof self?self:{},"function"==typeof define?define("vs/base/common/performance",[],function(){return n(e)
}):"object"==typeof module&&"object"==typeof module.exports?module.exports=n(e):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),e.perf=n(e)),define(t[3],i([0,1]),function(e,t){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.globals=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.isPreferringBrowserCodeLoad=t.browserCodeLoadingCacheStrategy=t.isElectronSandboxed=void 0;let r=!1,n=!1,s=!1,o=!1,a=!1,c=!1,l=!1,d=void 0,u="en",h=void 0,p=void 0;const f="object"==typeof self?self:"object"==typeof global?global:{};let g=void 0;"undefined"!=typeof process?g=process:void 0!==f.vscode&&(g=f.vscode.process);const m="string"==typeof(null===(i=null==g?void 0:g.versions)||void 0===i?void 0:i.electron)&&"renderer"===g.type
;if(t.isElectronSandboxed=m&&(null==g?void 0:g.sandboxed),t.browserCodeLoadingCacheStrategy=(()=>{if(t.isElectronSandboxed)return"bypassHeatCheck";const e=null==g?void 0:g.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;return"string"==typeof e?"none"===e||"code"===e||"bypassHeatCheck"===e||"bypassHeatCheckAndEagerCompile"===e?e:"bypassHeatCheck":void 0})(),t.isPreferringBrowserCodeLoad="string"==typeof t.browserCodeLoadingCacheStrategy,"object"!=typeof navigator||m)if("object"==typeof g){r="win32"===g.platform,n="darwin"===g.platform,o=(s="linux"===g.platform)&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,d="en",u="en";const e=g.env.VSCODE_NLS_CONFIG;if(e)try{const t=JSON.parse(e),i=t.availableLanguages["*"];d=t.locale,u=i||"en",h=t._translationsConfigFile}catch(e){}a=!0}else console.error("Unable to resolve platform.");else r=(p=navigator.userAgent).indexOf("Windows")>=0,n=p.indexOf("Macintosh")>=0,
l=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,s=p.indexOf("Linux")>=0,c=!0,u=d=navigator.language;!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};let v=0;n?v=1:r?v=3:s&&(v=2),t.isWindows=r,t.isMacintosh=n,t.isLinux=s,t.isLinuxSnap=o,t.isNative=a,t.isWeb=c,t.isIOS=l,t.platform=v,t.userAgent=p,t.language=u,function(e){e.value=function(){return t.language},e.isDefaultVariant=function(){return 2===t.language.length?"en"===t.language:t.language.length>=3&&("e"===t.language[0]&&"n"===t.language[1]&&"-"===t.language[2])},e.isDefault=function(){return"en"===t.language}}(t.Language||(t.Language={})),t.locale=d,t.translationsConfigFile=h,t.globals=f,t.setImmediate=function(){
if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if("function"==typeof t.globals.postMessage&&!t.globals.importScripts){let e=[];t.globals.addEventListener("message",t=>{if(t.data&&t.data.vscodeSetImmediateId)for(let i=0,r=e.length;i<r;i++){const r=e[i];if(r.id===t.data.vscodeSetImmediateId)return e.splice(i,1),void r.callback()}});let i=0;return r=>{const n=++i;e.push({id:n,callback:r}),t.globals.postMessage({vscodeSetImmediateId:n},"*")}}if(g)return g.nextTick.bind(g);const e=Promise.resolve();return t=>e.then(t)}(),function(e){e[e.Windows=1]="Windows",e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=n||l?2:r?1:3;let w=!0,y=!1;t.isLittleEndian=function(){if(!y){y=!0;const e=new Uint8Array(2);e[0]=1,e[1]=2;const t=new Uint16Array(e.buffer);w=513===t[0]}return w}}),define(t[63],i([0,1,3]),function(e,t,i){"use strict";let r;Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0,
r="undefined"!=typeof process?process:void 0!==i.globals.vscode?{get platform(){return i.globals.vscode.process.platform},get env(){return i.globals.vscode.process.env},nextTick:e=>i.setImmediate(e),cwd:()=>i.globals.vscode.process.env.VSCODE_CWD||i.globals.vscode.process.execPath.substr(0,i.globals.vscode.process.execPath.lastIndexOf("win32"===i.globals.vscode.process.platform?"\\":"/"))}:{get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},nextTick:e=>i.setImmediate(e),get env(){return Object.create(null)},cwd:()=>"/"},t.cwd=r.cwd,t.env=r.env,t.platform=r.platform,t.nextTick=r.nextTick}),define(t[6],i([0,1,63]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const r=65,n=97,s=90,o=122,a=46,c=47,l=92;class d extends Error{constructor(e,t,i){let r
;"string"==typeof t&&0===t.indexOf("not ")?(r="must not be",t=t.replace(/^not /,"")):r="must be";const n=-1!==e.indexOf(".")?"property":"argument";let s=`The "${e}" ${n} ${r} of type ${t}`;super(s+=`. Received type ${typeof i}`),this.code="ERR_INVALID_ARG_TYPE"}}function u(e,t){if("string"!=typeof e)throw new d(t,"string",e)}function h(e){return e===c||e===l}function p(e){return e===c}function f(e){return e>=r&&e<=s||e>=n&&e<=o}function g(e,t,i,r){let n="",s=0,o=-1,l=0,d=0;for(let u=0;u<=e.length;++u){if(u<e.length)d=e.charCodeAt(u);else{if(r(d))break;d=c}if(r(d)){if(o===u-1||1===l);else if(2===l){if(n.length<2||2!==s||n.charCodeAt(n.length-1)!==a||n.charCodeAt(n.length-2)!==a){if(n.length>2){const e=n.lastIndexOf(i);-1===e?(n="",s=0):s=(n=n.slice(0,e)).length-1-n.lastIndexOf(i),o=u,l=0;continue}if(0!==n.length){n="",s=0,o=u,l=0;continue}}t&&(n+=n.length>0?`${i}..`:"..",s=2)}else n.length>0?n+=`${i}${e.slice(o+1,u)}`:n=e.slice(o+1,u),s=u-o-1;o=u,l=0}else d===a&&-1!==l?++l:l=-1}return n}function m(e,t){
if(null===t||"object"!=typeof t)throw new d("pathObject","Object",t);const i=t.dir||t.root,r=t.base||`${t.name||""}${t.ext||""}`;return i?i===t.root?`${i}${r}`:`${i}${e}${r}`:r}t.win32={resolve(...e){let t="",r="",n=!1;for(let s=e.length-1;s>=-1;s--){let o;if(s>=0){if(u(o=e[s],"path"),0===o.length)continue}else 0===t.length?o=i.cwd():(void 0===(o=i.env[`=${t}`]||i.cwd())||o.slice(0,2).toLowerCase()!==t.toLowerCase()&&o.charCodeAt(2)===l)&&(o=`${t}\\`);const a=o.length;let c=0,d="",p=!1;const g=o.charCodeAt(0);if(1===a)h(g)&&(c=1,p=!0);else if(h(g))if(p=!0,h(o.charCodeAt(1))){let e=2,t=e;for(;e<a&&!h(o.charCodeAt(e));)e++;if(e<a&&e!==t){const i=o.slice(t,e);for(t=e;e<a&&h(o.charCodeAt(e));)e++;if(e<a&&e!==t){for(t=e;e<a&&!h(o.charCodeAt(e));)e++;e!==a&&e===t||(d=`\\\\${i}\\${o.slice(t,e)}`,c=e)}}}else c=1;else f(g)&&58===o.charCodeAt(1)&&(d=o.slice(0,2),c=2,a>2&&h(o.charCodeAt(2))&&(p=!0,c=3));if(d.length>0)if(t.length>0){if(d.toLowerCase()!==t.toLowerCase())continue}else t=d;if(n){if(t.length>0)break
}else if(r=`${o.slice(c)}\\${r}`,n=p,p&&t.length>0)break}return r=g(r,!n,"\\",h),n?`${t}\\${r}`:`${t}${r}`||"."},normalize(e){u(e,"path");const t=e.length;if(0===t)return".";let i,r=0,n=!1;const s=e.charCodeAt(0);if(1===t)return p(s)?"\\":e;if(h(s))if(n=!0,h(e.charCodeAt(1))){let n=2,s=n;for(;n<t&&!h(e.charCodeAt(n));)n++;if(n<t&&n!==s){const o=e.slice(s,n);for(s=n;n<t&&h(e.charCodeAt(n));)n++;if(n<t&&n!==s){for(s=n;n<t&&!h(e.charCodeAt(n));)n++;if(n===t)return`\\\\${o}\\${e.slice(s)}\\`;n!==s&&(i=`\\\\${o}\\${e.slice(s,n)}`,r=n)}}}else r=1;else f(s)&&58===e.charCodeAt(1)&&(i=e.slice(0,2),r=2,t>2&&h(e.charCodeAt(2))&&(n=!0,r=3));let o=r<t?g(e.slice(r),!n,"\\",h):"";return 0!==o.length||n||(o="."),o.length>0&&h(e.charCodeAt(t-1))&&(o+="\\"),void 0===i?n?`\\${o}`:o:n?`${i}\\${o}`:`${i}${o}`},isAbsolute(e){u(e,"path");const t=e.length;if(0===t)return!1;const i=e.charCodeAt(0);return h(i)||t>2&&f(i)&&58===e.charCodeAt(1)&&h(e.charCodeAt(2))},join(...e){if(0===e.length)return".";let i,r
;for(let t=0;t<e.length;++t){const n=e[t];u(n,"path"),n.length>0&&(void 0===i?i=r=n:i+=`\\${n}`)}if(void 0===i)return".";let n=!0,s=0;if("string"==typeof r&&h(r.charCodeAt(0))){++s;const e=r.length;e>1&&h(r.charCodeAt(1))&&(++s,e>2&&(h(r.charCodeAt(2))?++s:n=!1))}if(n){for(;s<i.length&&h(i.charCodeAt(s));)s++;s>=2&&(i=`\\${i.slice(s)}`)}return t.win32.normalize(i)},relative(e,i){if(u(e,"from"),u(i,"to"),e===i)return"";const r=t.win32.resolve(e),n=t.win32.resolve(i);if(r===n)return"";if((e=r.toLowerCase())===(i=n.toLowerCase()))return"";let s=0;for(;s<e.length&&e.charCodeAt(s)===l;)s++;let o=e.length;for(;o-1>s&&e.charCodeAt(o-1)===l;)o--;const a=o-s;let c=0;for(;c<i.length&&i.charCodeAt(c)===l;)c++;let d=i.length;for(;d-1>c&&i.charCodeAt(d-1)===l;)d--;const h=d-c,p=a<h?a:h;let f=-1,g=0;for(;g<p;g++){const t=e.charCodeAt(s+g);if(t!==i.charCodeAt(c+g))break;t===l&&(f=g)}if(g!==p){if(-1===f)return n}else{if(h>p){if(i.charCodeAt(c+g)===l)return n.slice(c+g+1);if(2===g)return n.slice(c+g)}
a>p&&(e.charCodeAt(s+g)===l?f=g:2===g&&(f=3)),-1===f&&(f=0)}let m="";for(g=s+f+1;g<=o;++g)g!==o&&e.charCodeAt(g)!==l||(m+=0===m.length?"..":"\\..");return c+=f,m.length>0?`${m}${n.slice(c,d)}`:(n.charCodeAt(c)===l&&++c,n.slice(c,d))},toNamespacedPath(e){if("string"!=typeof e)return e;if(0===e.length)return"";const i=t.win32.resolve(e);if(i.length<=2)return e;if(i.charCodeAt(0)===l){if(i.charCodeAt(1)===l){const e=i.charCodeAt(2);if(63!==e&&e!==a)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(f(i.charCodeAt(0))&&58===i.charCodeAt(1)&&i.charCodeAt(2)===l)return`\\\\?\\${i}`;return e},dirname(e){u(e,"path");const t=e.length;if(0===t)return".";let i=-1,r=0;const n=e.charCodeAt(0);if(1===t)return h(n)?e:".";if(h(n)){if(i=r=1,h(e.charCodeAt(1))){let n=2,s=n;for(;n<t&&!h(e.charCodeAt(n));)n++;if(n<t&&n!==s){for(s=n;n<t&&h(e.charCodeAt(n));)n++;if(n<t&&n!==s){for(s=n;n<t&&!h(e.charCodeAt(n));)n++;if(n===t)return e;n!==s&&(i=r=n+1)}}}}else f(n)&&58===e.charCodeAt(1)&&(r=i=t>2&&h(e.charCodeAt(2))?3:2);let s=-1,o=!0
;for(let i=t-1;i>=r;--i)if(h(e.charCodeAt(i))){if(!o){s=i;break}}else o=!1;if(-1===s){if(-1===i)return".";s=i}return e.slice(0,s)},basename(e,t){void 0!==t&&u(t,"ext"),u(e,"path");let i,r=0,n=-1,s=!0;if(e.length>=2&&f(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(r=2),void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let o=t.length-1,a=-1;for(i=e.length-1;i>=r;--i){const c=e.charCodeAt(i);if(h(c)){if(!s){r=i+1;break}}else-1===a&&(s=!1,a=i+1),o>=0&&(c===t.charCodeAt(o)?-1==--o&&(n=i):(o=-1,n=a))}return r===n?n=a:-1===n&&(n=e.length),e.slice(r,n)}for(i=e.length-1;i>=r;--i)if(h(e.charCodeAt(i))){if(!s){r=i+1;break}}else-1===n&&(s=!1,n=i+1);return-1===n?"":e.slice(r,n)},extname(e){u(e,"path");let t=0,i=-1,r=0,n=-1,s=!0,o=0;e.length>=2&&58===e.charCodeAt(1)&&f(e.charCodeAt(0))&&(t=r=2);for(let c=e.length-1;c>=t;--c){const t=e.charCodeAt(c);if(h(t)){if(!s){r=c+1;break}}else-1===n&&(s=!1,n=c+1),t===a?-1===i?i=c:1!==o&&(o=1):-1!==i&&(o=-1)}return-1===i||-1===n||0===o||1===o&&i===n-1&&i===r+1?"":e.slice(i,n)},
format:m.bind(null,"\\"),parse(e){u(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const i=e.length;let r=0,n=e.charCodeAt(0);if(1===i)return h(n)?(t.root=t.dir=e,t):(t.base=t.name=e,t);if(h(n)){if(r=1,h(e.charCodeAt(1))){let t=2,n=t;for(;t<i&&!h(e.charCodeAt(t));)t++;if(t<i&&t!==n){for(n=t;t<i&&h(e.charCodeAt(t));)t++;if(t<i&&t!==n){for(n=t;t<i&&!h(e.charCodeAt(t));)t++;t===i?r=t:t!==n&&(r=t+1)}}}}else if(f(n)&&58===e.charCodeAt(1)){if(i<=2)return t.root=t.dir=e,t;if(r=2,h(e.charCodeAt(2))){if(3===i)return t.root=t.dir=e,t;r=3}}r>0&&(t.root=e.slice(0,r));let s=-1,o=r,c=-1,l=!0,d=e.length-1,p=0;for(;d>=r;--d)if(h(n=e.charCodeAt(d))){if(!l){o=d+1;break}}else-1===c&&(l=!1,c=d+1),n===a?-1===s?s=d:1!==p&&(p=1):-1!==s&&(p=-1);return-1!==c&&(-1===s||0===p||1===p&&s===c-1&&s===o+1?t.base=t.name=e.slice(o,c):(t.name=e.slice(o,s),t.base=e.slice(o,c),t.ext=e.slice(s,c))),t.dir=o>0&&o!==r?e.slice(0,o-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...e){
let t="",r=!1;for(let n=e.length-1;n>=-1&&!r;n--){const s=n>=0?e[n]:i.cwd();u(s,"path"),0!==s.length&&(t=`${s}/${t}`,r=s.charCodeAt(0)===c)}return t=g(t,!r,"/",p),r?`/${t}`:t.length>0?t:"."},normalize(e){if(u(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===c,i=e.charCodeAt(e.length-1)===c;return 0===(e=g(e,!t,"/",p)).length?t?"/":i?"./":".":(i&&(e+="/"),t?`/${e}`:e)},isAbsolute:e=>(u(e,"path"),e.length>0&&e.charCodeAt(0)===c),join(...e){if(0===e.length)return".";let i;for(let t=0;t<e.length;++t){const r=e[t];u(r,"path"),r.length>0&&(void 0===i?i=r:i+=`/${r}`)}return void 0===i?".":t.posix.normalize(i)},relative(e,i){if(u(e,"from"),u(i,"to"),e===i)return"";if((e=t.posix.resolve(e))===(i=t.posix.resolve(i)))return"";const r=e.length,n=r-1,s=i.length-1,o=n<s?n:s;let a=-1,l=0;for(;l<o;l++){const t=e.charCodeAt(1+l);if(t!==i.charCodeAt(1+l))break;t===c&&(a=l)}if(l===o)if(s>o){if(i.charCodeAt(1+l)===c)return i.slice(1+l+1);if(0===l)return i.slice(1+l)}else n>o&&(e.charCodeAt(1+l)===c?a=l:0===l&&(a=0))
;let d="";for(l=1+a+1;l<=r;++l)l!==r&&e.charCodeAt(l)!==c||(d+=0===d.length?"..":"/..");return`${d}${i.slice(1+a)}`},toNamespacedPath:e=>e,dirname(e){if(u(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===c;let i=-1,r=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===c){if(!r){i=t;break}}else r=!1;return-1===i?t?"/":".":t&&1===i?"//":e.slice(0,i)},basename(e,t){void 0!==t&&u(t,"ext"),u(e,"path");let i,r=0,n=-1,s=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let o=t.length-1,a=-1;for(i=e.length-1;i>=0;--i){const l=e.charCodeAt(i);if(l===c){if(!s){r=i+1;break}}else-1===a&&(s=!1,a=i+1),o>=0&&(l===t.charCodeAt(o)?-1==--o&&(n=i):(o=-1,n=a))}return r===n?n=a:-1===n&&(n=e.length),e.slice(r,n)}for(i=e.length-1;i>=0;--i)if(e.charCodeAt(i)===c){if(!s){r=i+1;break}}else-1===n&&(s=!1,n=i+1);return-1===n?"":e.slice(r,n)},extname(e){u(e,"path");let t=-1,i=0,r=-1,n=!0,s=0;for(let o=e.length-1;o>=0;--o){const l=e.charCodeAt(o);if(l!==c)-1===r&&(n=!1,r=o+1),
l===a?-1===t?t=o:1!==s&&(s=1):-1!==t&&(s=-1);else if(!n){i=o+1;break}}return-1===t||-1===r||0===s||1===s&&t===r-1&&t===i+1?"":e.slice(t,r)},format:m.bind(null,"/"),parse(e){u(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const i=e.charCodeAt(0)===c;let r;i?(t.root="/",r=1):r=0;let n=-1,s=0,o=-1,l=!0,d=e.length-1,h=0;for(;d>=r;--d){const t=e.charCodeAt(d);if(t!==c)-1===o&&(l=!1,o=d+1),t===a?-1===n?n=d:1!==h&&(h=1):-1!==n&&(h=-1);else if(!l){s=d+1;break}}if(-1!==o){const r=0===s&&i?1:s;-1===n||0===h||1===h&&n===o-1&&n===s+1?t.base=t.name=e.slice(r,o):(t.name=e.slice(r,n),t.base=e.slice(r,o),t.ext=e.slice(n,o))}return s>0?t.dir=e.slice(0,s-1):i&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===i.platform?t.win32.normalize:t.posix.normalize,t.isAbsolute="win32"===i.platform?t.win32.isAbsolute:t.posix.isAbsolute,t.join="win32"===i.platform?t.win32.join:t.posix.join,
t.resolve="win32"===i.platform?t.win32.resolve:t.posix.resolve,t.relative="win32"===i.platform?t.win32.relative:t.posix.relative,t.dirname="win32"===i.platform?t.win32.dirname:t.posix.dirname,t.basename="win32"===i.platform?t.win32.basename:t.posix.basename,t.extname="win32"===i.platform?t.win32.extname:t.posix.extname,t.format="win32"===i.platform?t.win32.format:t.posix.format,t.parse="win32"===i.platform?t.win32.parse:t.posix.parse,t.toNamespacedPath="win32"===i.platform?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep="win32"===i.platform?t.win32.sep:t.posix.sep,t.delimiter="win32"===i.platform?t.win32.delimiter:t.posix.delimiter}),define(t[72],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScanCodeBinding=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.ScanCode=void 0,function(e){e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",
e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",
e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",
e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",
e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",
e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",
e[e.MAX_VALUE=193]="MAX_VALUE"}(t.ScanCode||(t.ScanCode={}));const i=[],r=Object.create(null),n=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>n[e]||0,toEnum:e=>r[e]||0,toString:e=>i[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];t.ScanCodeBinding=class{constructor(e,t,i,r,n){this.ctrlKey=e,this.shiftKey=t,this.altKey=i,this.metaKey=r,this.scanCode=n}equals(e){return this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(157===this.scanCode||161===this.scanCode)||this.shiftKey&&(158===this.scanCode||162===this.scanCode)||this.altKey&&(159===this.scanCode||163===this.scanCode)||this.metaKey&&(160===this.scanCode||164===this.scanCode)}},function(){function e(e,t){i[e]=t,r[t]=e,n[t.toLowerCase()]=e}e(0,"None"),e(1,"Hyper"),e(2,"Super"),e(3,"Fn"),e(4,"FnLock"),e(5,"Suspend"),e(6,"Resume"),e(7,"Turbo"),e(8,"Sleep"),e(9,"WakeUp"),e(10,"KeyA"),e(11,"KeyB"),
e(12,"KeyC"),e(13,"KeyD"),e(14,"KeyE"),e(15,"KeyF"),e(16,"KeyG"),e(17,"KeyH"),e(18,"KeyI"),e(19,"KeyJ"),e(20,"KeyK"),e(21,"KeyL"),e(22,"KeyM"),e(23,"KeyN"),e(24,"KeyO"),e(25,"KeyP"),e(26,"KeyQ"),e(27,"KeyR"),e(28,"KeyS"),e(29,"KeyT"),e(30,"KeyU"),e(31,"KeyV"),e(32,"KeyW"),e(33,"KeyX"),e(34,"KeyY"),e(35,"KeyZ"),e(36,"Digit1"),e(37,"Digit2"),e(38,"Digit3"),e(39,"Digit4"),e(40,"Digit5"),e(41,"Digit6"),e(42,"Digit7"),e(43,"Digit8"),e(44,"Digit9"),e(45,"Digit0"),e(46,"Enter"),e(47,"Escape"),e(48,"Backspace"),e(49,"Tab"),e(50,"Space"),e(51,"Minus"),e(52,"Equal"),e(53,"BracketLeft"),e(54,"BracketRight"),e(55,"Backslash"),e(56,"IntlHash"),e(57,"Semicolon"),e(58,"Quote"),e(59,"Backquote"),e(60,"Comma"),e(61,"Period"),e(62,"Slash"),e(63,"CapsLock"),e(64,"F1"),e(65,"F2"),e(66,"F3"),e(67,"F4"),e(68,"F5"),e(69,"F6"),e(70,"F7"),e(71,"F8"),e(72,"F9"),e(73,"F10"),e(74,"F11"),e(75,"F12"),e(76,"PrintScreen"),e(77,"ScrollLock"),e(78,"Pause"),e(79,"Insert"),e(80,"Home"),e(81,"PageUp"),e(82,"Delete"),e(83,"End"),e(84,"PageDown"),
e(85,"ArrowRight"),e(86,"ArrowLeft"),e(87,"ArrowDown"),e(88,"ArrowUp"),e(89,"NumLock"),e(90,"NumpadDivide"),e(91,"NumpadMultiply"),e(92,"NumpadSubtract"),e(93,"NumpadAdd"),e(94,"NumpadEnter"),e(95,"Numpad1"),e(96,"Numpad2"),e(97,"Numpad3"),e(98,"Numpad4"),e(99,"Numpad5"),e(100,"Numpad6"),e(101,"Numpad7"),e(102,"Numpad8"),e(103,"Numpad9"),e(104,"Numpad0"),e(105,"NumpadDecimal"),e(106,"IntlBackslash"),e(107,"ContextMenu"),e(108,"Power"),e(109,"NumpadEqual"),e(110,"F13"),e(111,"F14"),e(112,"F15"),e(113,"F16"),e(114,"F17"),e(115,"F18"),e(116,"F19"),e(117,"F20"),e(118,"F21"),e(119,"F22"),e(120,"F23"),e(121,"F24"),e(122,"Open"),e(123,"Help"),e(124,"Select"),e(125,"Again"),e(126,"Undo"),e(127,"Cut"),e(128,"Copy"),e(129,"Paste"),e(130,"Find"),e(131,"AudioVolumeMute"),e(132,"AudioVolumeUp"),e(133,"AudioVolumeDown"),e(134,"NumpadComma"),e(135,"IntlRo"),e(136,"KanaMode"),e(137,"IntlYen"),e(138,"Convert"),e(139,"NonConvert"),e(140,"Lang1"),e(141,"Lang2"),e(142,"Lang3"),e(143,"Lang4"),e(144,"Lang5"),e(145,"Abort"),
e(146,"Props"),e(147,"NumpadParenLeft"),e(148,"NumpadParenRight"),e(149,"NumpadBackspace"),e(150,"NumpadMemoryStore"),e(151,"NumpadMemoryRecall"),e(152,"NumpadMemoryClear"),e(153,"NumpadMemoryAdd"),e(154,"NumpadMemorySubtract"),e(155,"NumpadClear"),e(156,"NumpadClearEntry"),e(157,"ControlLeft"),e(158,"ShiftLeft"),e(159,"AltLeft"),e(160,"MetaLeft"),e(161,"ControlRight"),e(162,"ShiftRight"),e(163,"AltRight"),e(164,"MetaRight"),e(165,"BrightnessUp"),e(166,"BrightnessDown"),e(167,"MediaPlay"),e(168,"MediaRecord"),e(169,"MediaFastForward"),e(170,"MediaRewind"),e(171,"MediaTrackNext"),e(172,"MediaTrackPrevious"),e(173,"MediaStop"),e(174,"Eject"),e(175,"MediaPlayPause"),e(176,"MediaSelect"),e(177,"LaunchMail"),e(178,"LaunchApp2"),e(179,"LaunchApp1"),e(180,"SelectTask"),e(181,"LaunchScreenSaver"),e(182,"BrowserSearch"),e(183,"BrowserHome"),e(184,"BrowserBack"),e(185,"BrowserForward"),e(186,"BrowserStop"),e(187,"BrowserRefresh"),e(188,"BrowserFavorites"),e(189,"ZoomToggle"),e(190,"MailReply"),e(191,"MailForward"),
e(192,"MailSend")}(),function(){for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=112;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;function e(e,i){t.IMMUTABLE_CODE_TO_KEY_CODE[e]=i,0!==i&&3!==i&&5!==i&&4!==i&&6!==i&&57!==i&&(t.IMMUTABLE_KEY_CODE_TO_CODE[i]=e)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,e(0,0),e(1,0),e(2,0),e(3,0),e(4,0),e(5,0),e(6,0),e(7,0),e(8,0),e(9,0),e(46,3),e(47,9),e(48,1),e(49,2),e(50,10),e(63,8),e(64,59),e(65,60),e(66,61),e(67,62),e(68,63),e(69,64),e(70,65),e(71,66),e(72,67),e(73,68),e(74,69),e(75,70),e(76,0),e(77,79),e(78,7),e(79,19),e(80,14),e(81,11),e(82,20),e(83,13),e(84,12),e(85,17),e(86,15),e(87,18),e(88,16),e(89,78),e(90,108),e(91,103),e(92,106),e(93,104),e(94,3),e(95,94),e(96,95),e(97,96),e(98,97),e(99,98),e(100,99),e(101,100),e(102,101),e(103,102),e(104,93),e(105,107),e(107,58),e(108,0),e(109,0),e(110,71),e(111,72),e(112,73),e(113,74),e(114,75),e(115,76),e(116,77),e(117,0),e(118,0),e(119,0),e(120,0),e(121,0),e(122,0),e(123,0),e(124,0),e(125,0),e(126,0),e(127,0),
e(128,0),e(129,0),e(130,0),e(131,0),e(132,0),e(133,0),e(134,105),e(136,0),e(138,0),e(139,0),e(140,0),e(141,0),e(142,0),e(143,0),e(144,0),e(145,0),e(146,0),e(147,0),e(148,0),e(149,0),e(150,0),e(151,0),e(152,0),e(153,0),e(154,0),e(155,0),e(156,0),e(157,5),e(158,4),e(159,6),e(160,57),e(161,5),e(162,4),e(163,6),e(164,57),e(165,0),e(166,0),e(167,0),e(168,0),e(169,0),e(170,0),e(171,0),e(172,0),e(173,0),e(174,0),e(175,0),e(176,0),e(177,0),e(178,0),e(179,0),e(180,0),e(181,0),e(182,0),e(183,0),e(184,0),e(185,0),e(186,0),e(187,0),e(188,0),e(189,0),e(190,0),e(191,0),e(192,0)}()}),define(t[99],i([0,1,55,72]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeybindingParser=void 0;t.KeybindingParser=class{static _readModifiers(e){e=e.toLowerCase().trim();let t,i,r=!1,n=!1,s=!1,o=!1;do{t=!1,/^ctrl(\+|\-)/.test(e)&&(r=!0,e=e.substr("ctrl-".length),t=!0),/^shift(\+|\-)/.test(e)&&(n=!0,e=e.substr("shift-".length),t=!0),/^alt(\+|\-)/.test(e)&&(s=!0,e=e.substr("alt-".length),t=!0),
/^meta(\+|\-)/.test(e)&&(o=!0,e=e.substr("meta-".length),t=!0),/^win(\+|\-)/.test(e)&&(o=!0,e=e.substr("win-".length),t=!0),/^cmd(\+|\-)/.test(e)&&(o=!0,e=e.substr("cmd-".length),t=!0)}while(t);const a=e.indexOf(" ");return a>0?(i=e.substring(0,a),e=e.substring(a)):(i=e,e=""),{remains:e,ctrl:r,shift:n,alt:s,meta:o,key:i}}static parseSimpleKeybinding(e){const t=this._readModifiers(e),r=i.KeyCodeUtils.fromUserSettings(t.key);return[new i.SimpleKeybinding(t.ctrl,t.shift,t.alt,t.meta,r),t.remains]}static parseKeybinding(e,t){if(!e)return null;const r=[];let n;do{[n,e]=this.parseSimpleKeybinding(e),r.push(n)}while(e.length>0);return new i.ChordKeybinding(r)}static parseSimpleUserBinding(e){const t=this._readModifiers(e),n=t.key.match(/^\[([^\]]+)\]$/);if(n){const e=n[1],i=r.ScanCodeUtils.lowerCaseToEnum(e);return[new r.ScanCodeBinding(t.ctrl,t.shift,t.alt,t.meta,i),t.remains]}const s=i.KeyCodeUtils.fromUserSettings(t.key);return[new i.SimpleKeybinding(t.ctrl,t.shift,t.alt,t.meta,s),t.remains]}
static parseUserBinding(e){if(!e)return[];const t=[];let i;for(;e.length>0;)[i,e]=this.parseSimpleUserBinding(e),t.push(i);return t}}}),define(t[100],i([0,1,3]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const r=i.globals.performance&&"function"==typeof i.globals.performance.now;class n{constructor(e){this._highResolution=r&&e,this._startTime=this._now(),this._stopTime=-1}static create(e=!0){return new n(e)}stop(){this._stopTime=this._now()}elapsed(){return-1!==this._stopTime?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?i.globals.performance.now():(new Date).getTime()}}t.StopWatch=n}),define(t[5],i([0,1,19,46,2,98,100]),function(e,t,i,r,n,s,o){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.AsyncEmitter=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0,function(e){function t(e){return(t,i=null,r)=>{let n,s=!1
;return n=e(e=>{if(!s)return n?n.dispose():s=!0,t.call(i,e)},null,r),s&&n.dispose(),n}}function i(e,t){return a((i,r=null,n)=>e(e=>i.call(r,t(e)),null,n))}function r(e,t){return a((i,r=null,n)=>e(e=>{t(e),i.call(r,e)},null,n))}function s(e,t){return a((i,r=null,n)=>e(e=>t(e)&&i.call(r,e),null,n))}function o(e,t,r){let n=r;return i(e,e=>n=t(n,e))}function a(e){let t;const i=new u({onFirstListenerAdd(){t=e(i.fire,i)},onLastListenerRemove(){t.dispose()}});return i.event}function c(e,t,i=100,r=!1,n){let s,o=void 0,a=void 0,c=0;const l=new u({leakWarningThreshold:n,onFirstListenerAdd(){s=e(e=>{c++,o=t(o,e),r&&!a&&(l.fire(o),o=void 0),clearTimeout(a),a=setTimeout(()=>{const e=o;o=void 0,a=void 0,(!r||c>1)&&l.fire(e),c=0},i)})},onLastListenerRemove(){s.dispose()}});return l.event}function l(e){let t,i=!0;return s(e,e=>{const r=i||e!==t;return i=!1,t=e,r})}e.None=()=>n.Disposable.None,e.once=t,e.map=i,e.forEach=r,e.filter=s,e.signal=function(e){return e},e.any=function(...e){
return(t,i=null,r)=>n.combinedDisposable(...e.map(e=>e(e=>t.call(i,e),null,r)))},e.reduce=o,e.snapshot=a,e.debounce=c,e.stopwatch=function(e){const r=(new Date).getTime();return i(t(e),e=>(new Date).getTime()-r)},e.latch=l,e.buffer=function(e,t=!1,i=[]){let r=i.slice(),n=e(e=>{r?r.push(e):o.fire(e)});const s=()=>{r&&r.forEach(e=>o.fire(e)),r=null},o=new u({onFirstListenerAdd(){n||(n=e(e=>o.fire(e)))},onFirstListenerDidAdd(){r&&(t?setTimeout(s):s())},onLastListenerRemove(){n&&n.dispose(),n=null}});return o.event};class d{constructor(e){this.event=e}map(e){return new d(i(this.event,e))}forEach(e){return new d(r(this.event,e))}filter(e){return new d(s(this.event,e))}reduce(e,t){return new d(o(this.event,e,t))}latch(){return new d(l(this.event))}debounce(e,t=100,i=!1,r){return new d(c(this.event,e,t,i,r))}on(e,t,i){return this.event(e,t,i)}once(e,i,r){return t(this.event)(e,i,r)}}e.chain=function(e){return new d(e)},e.fromNodeEventEmitter=function(e,t,i=(e=>e)){const r=(...e)=>n.fire(i(...e)),n=new u({
onFirstListenerAdd:()=>e.on(t,r),onLastListenerRemove:()=>e.removeListener(t,r)});return n.event},e.fromDOMEventEmitter=function(e,t,i=(e=>e)){const r=(...e)=>n.fire(i(...e)),n=new u({onFirstListenerAdd:()=>e.addEventListener(t,r),onLastListenerRemove:()=>e.removeEventListener(t,r)});return n.event},e.fromPromise=function(e){const t=new u;let i=!1;return e.then(void 0,()=>null).then(()=>{i?t.fire(void 0):setTimeout(()=>t.fire(void 0),0)}),i=!0,t.event},e.toPromise=function(e){return new Promise(i=>t(e)(i))}}(a=t.Event||(t.Event={}));class c{constructor(e){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${e}_${c._idPool++}`}start(e){this._stopWatch=new o.StopWatch(!0),this._listenerCount=e}stop(){if(this._stopWatch){const e=this._stopWatch.elapsed();this._elapsedOverall+=e,this._invocationCount+=1,
console.info(`did FIRE ${this._name}: elapsed_ms: ${e.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}c._idPool=0;let l=-1;t.setGlobalLeakWarningThreshold=function(e){const t=l;return l=e,{dispose(){l=t}}};class d{constructor(e,t=Math.random().toString(18).slice(2,5)){this.customThreshold=e,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(e){let t=l;if("number"==typeof this.customThreshold&&(t=this.customThreshold),t<=0||e<t)return;this._stacks||(this._stacks=new Map);const i=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(i)||0;if(this._stacks.set(i,r+1),this._warnCountdown-=1,this._warnCountdown<=0){let i;this._warnCountdown=.5*t;let r=0;for(const[e,t]of this._stacks)(!i||r<t)&&(i=e,r=t);console.warn(`[${this.name}] potential listener LEAK detected, having ${e} listeners already. MOST frequent listener (${r}):`),console.warn(i)}
return()=>{const e=this._stacks.get(i)||0;this._stacks.set(i,e-1)}}}class u{constructor(e){var t;this._disposed=!1,this._options=e,this._leakageMon=l>0?new d(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=(null===(t=this._options)||void 0===t?void 0:t._profName)?new c(this._options._profName):void 0}get event(){return this._event||(this._event=(e,t,i)=>{var r;this._listeners||(this._listeners=new s.LinkedList);const o=this._listeners.isEmpty();o&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const a=this._listeners.push(t?[e,t]:e);o&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,e,t);const c=null===(r=this._leakageMon)||void 0===r?void 0:r.check(this._listeners.size);let l;return l={dispose:()=>{if(c&&c(),l.dispose=u._noop,!this._disposed&&(a(),this._options&&this._options.onLastListenerRemove)){
this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)}}},i instanceof n.DisposableStore?i.add(l):Array.isArray(i)&&i.push(l),l}),this._event}fire(e){var t,r;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,e]);for(null===(t=this._perfMon)||void 0===t||t.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[e,t]=this._deliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){i.onUnexpectedError(e)}}null===(r=this._perfMon)||void 0===r||r.stop()}}dispose(){var e,t,i;null===(e=this._listeners)||void 0===e||e.clear(),null===(t=this._deliveryQueue)||void 0===t||t.clear(),null===(i=this._leakageMon)||void 0===i||i.dispose(),this._disposed=!0}}t.Emitter=u,u._noop=function(){};t.PauseableEmitter=class extends u{constructor(e){super(e),this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=null==e?void 0:e.merge}pause(){this._isPaused++}
resume(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){const e=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)super.fire(this._eventQueue.shift())}fire(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):super.fire(e))}};t.AsyncEmitter=class extends u{async fireAsync(e,t,r){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new s.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,e]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[e,t]=this._asyncDeliveryQueue.shift(),n=[],s=Object.assign(Object.assign({},t),{waitUntil:t=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");r&&(t=r(t,"function"==typeof e?e:e[0])),n.push(t)}});try{"function"==typeof e?e.call(void 0,s):e[0].call(e[1],s)}catch(e){i.onUnexpectedError(e);continue}Object.freeze(n),await Promise.all(n).catch(e=>i.onUnexpectedError(e))
}}}};t.EventMultiplexer=class{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(e){const t={event:e,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);return n.toDisposable(r.once(()=>{this.hasListeners&&this.unhook(t);const e=this.events.indexOf(t);this.events.splice(e,1)}))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(e=>this.hook(e))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(e=>this.unhook(e))}hook(e){e.listener=e.event(e=>this.emitter.fire(e))}unhook(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.emitter.dispose()}};t.EventBufferer=class{constructor(){this.buffers=[]}wrapEvent(e){return(t,i,r)=>e(e=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>t.call(i,e)):t.call(i,e)},void 0,r)}bufferEvents(e){const t=[];this.buffers.push(t);const i=e()
;return this.buffers.pop(),t.forEach(e=>e()),i}};t.Relay=class{constructor(){this.listening=!1,this.inputEvent=a.None,this.inputEventListener=n.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}}),define(t[22],i([0,1,5]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const r=Object.freeze(function(e,t){const i=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(i)}}});var n;!function(e){e.isCancellationToken=function(t){
return t===e.None||t===e.Cancelled||(t instanceof s||!(!t||"object"!=typeof t)&&("boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested))},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})}(n=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}t.CancellationTokenSource=class{constructor(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}get token(){
return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=n.Cancelled}dispose(e=!1){e&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=n.None}}}),define(t[9],i([0,1,22,19,5,2]),function(e,t,i,r,n,s){"use strict";function o(e){return e&&"function"==typeof e.then}function a(e){const t=new i.CancellationTokenSource,n=e(t.token),s=new Promise((e,i)=>{t.token.onCancellationRequested(()=>{i(r.canceled())}),Promise.resolve(n).then(i=>{t.dispose(),e(i)},e=>{t.dispose(),i(e)})});return new class{cancel(){t.cancel()}then(e,t){return s.then(e,t)}catch(e){return this.then(void 0,e)}finally(e){return s.finally(e)}}}Object.defineProperty(t,"__esModule",{value:!0}),
t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.RunOnceWorker=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.ignoreErrors=t.disposableTimeout=t.timeout=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0,t.isThenable=o,t.createCancelablePromise=a,t.raceCancellation=function(e,t,i){return Promise.race([e,new Promise(e=>t.onCancellationRequested(()=>e(i)))])},t.raceCancellablePromises=async function(e){let t=-1;const i=e.map((e,i)=>e.then(e=>(t=i,e))),r=await Promise.race(i);return e.forEach((e,i)=>{i!==t&&e.cancel()}),r},t.raceTimeout=function(e,t,i){let r=void 0;const n=setTimeout(()=>{null==r||r(void 0),null==i||i()},t);return Promise.race([e.finally(()=>clearTimeout(n)),new Promise(e=>r=e)])},t.asPromise=function(e){return new Promise((t,i)=>{const r=e()
;o(r)?r.then(t,i):t(r)})};class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(e){if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){const e=()=>{this.queuedPromise=null;const e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(t=>{this.activePromise.then(e,e).then(t)})}return new Promise((e,t)=>{this.queuedPromise.then(e,t)})}return this.activePromise=e(),new Promise((e,t)=>{this.activePromise.then(t=>{this.activePromise=null,e(t)},e=>{this.activePromise=null,t(e)})})}}t.Throttler=c;t.Sequencer=class{constructor(){this.current=Promise.resolve(null)}queue(e){return this.current=this.current.then(()=>e(),()=>e())}};t.SequencerByKey=class{constructor(){this.promiseMap=new Map}queue(e,t){var i;const r=(null!==(i=this.promiseMap.get(e))&&void 0!==i?i:Promise.resolve()).catch(()=>{}).then(t).finally(()=>{this.promiseMap.get(e)===r&&this.promiseMap.delete(e)})
;return this.promiseMap.set(e,r),r}};class l{constructor(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(e,t=this.defaultDelay){return this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((e,t)=>{this.doResolve=e,this.doReject=t}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const e=this.task;return this.task=null,e()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},t),this.completionPromise}isTriggered(){return null!==this.timeout}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(r.canceled()),this.completionPromise=null)}cancelTimeout(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}t.Delayer=l;t.ThrottledDelayer=class{constructor(e){this.delayer=new l(e),this.throttler=new c}trigger(e,t){
return this.delayer.trigger(()=>this.throttler.queue(e),t)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}};function d(e,t){return t?new Promise((i,n)=>{const s=setTimeout(i,e);t.onCancellationRequested(()=>{clearTimeout(s),n(r.canceled())})}):a(t=>d(e,t))}t.Barrier=class{constructor(){this._isOpen=!1,this._promise=new Promise((e,t)=>{this._completePromise=e})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}},t.timeout=d,t.disposableTimeout=function(e,t=0){const i=setTimeout(e,t);return s.toDisposable(()=>clearTimeout(i))},t.ignoreErrors=function(e){return e.then(void 0,e=>void 0)},t.sequence=function(e){const t=[];let i=0;const r=e.length;return Promise.resolve(null).then(function n(s){null!=s&&t.push(s);const o=i<r?e[i++]():null;return o?o.then(n):Promise.resolve(t)})},t.first=function(e,t=(e=>!!e),i=null){let r=0;const n=e.length,s=()=>{if(r>=n)return Promise.resolve(i);const o=e[r++]
;return Promise.resolve(o()).then(e=>t(e)?Promise.resolve(e):s())};return s()},t.firstParallel=function(e,t=(e=>!!e),i=null){if(0===e.length)return Promise.resolve(i);let r=e.length;const n=()=>{var t,i;r=-1;for(const r of e)null===(i=(t=r).cancel)||void 0===i||i.call(t)};return new Promise((s,o)=>{for(const a of e)a.then(e=>{--r>=0&&t(e)?(n(),s(e)):0===r&&s(i)}).catch(e=>{--r>=0&&(n(),o(e))})})};class u{constructor(e){this._size=0,this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new n.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(e){return this._size++,new Promise((t,i)=>{this.outstandingPromises.push({factory:e,c:t,e:i}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const e=this.outstandingPromises.shift();this.runningPromises++;const t=e.factory();t.then(e.c,e.e),t.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,
this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=u;class h extends u{constructor(){super(1)}}t.Queue=h;t.ResourceQueue=class{constructor(){this.queues=new Map}queueFor(e){const t=e.toString();if(!this.queues.has(t)){const e=new h;e.onFinished(()=>{e.dispose(),this.queues.delete(t)}),this.queues.set(t,e)}return this.queues.get(t)}dispose(){this.queues.forEach(e=>e.dispose()),this.queues.clear()}};t.TimeoutTimer=class{constructor(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setTimeout(()=>{this._token=-1,e()},t)}setIfNotSet(e,t){-1===this._token&&(this._token=setTimeout(()=>{this._token=-1,e()},t))}};t.IntervalTimer=class{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearInterval(this._token),this._token=-1)}
cancelAndSet(e,t){this.cancel(),this._token=setInterval(()=>{e()},t)}};class p{constructor(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(e=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,e)}get delay(){return this.timeout}set delay(e){this.timeout=e}isScheduled(){return-1!==this.timeoutToken}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=p;t.RunOnceWorker=class extends p{constructor(e,t){super(e,t),this.units=[]}work(e){this.units.push(e),this.isScheduled()||this.schedule()}doRun(){const e=this.units;this.units=[],this.runner&&this.runner(e)}dispose(){this.units=[],super.dispose()}},function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){const e=Object.freeze({didTimeout:!0,
timeRemaining:()=>15});t.runWhenIdle=t=>{const i=setTimeout(()=>t(e));let r=!1;return{dispose(){r||(r=!0,clearTimeout(i))}}}}else t.runWhenIdle=(e,t)=>{const i=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0);let r=!1;return{dispose(){r||(r=!0,cancelIdleCallback(i))}}}}();t.IdleValue=class{constructor(e){this._didRun=!1,this._executor=()=>{try{this._value=e()}catch(e){this._error=e}finally{this._didRun=!0}},this._handle=t.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}},t.retry=async function(e,t,i){let r;for(let n=0;n<i;n++)try{return await e()}catch(e){r=e,await d(t)}throw r};t.TaskSequentializer=class{hasPending(e){return!!this._pending&&("number"==typeof e?this._pending.taskId===e:!!this._pending)}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var e;null===(e=this._pending)||void 0===e||e.cancel()}setPending(e,t,i){
return this._pending={taskId:e,cancel:()=>null==i?void 0:i(),promise:t},t.then(()=>this.donePending(e),()=>this.donePending(e)),t}donePending(e){this._pending&&e===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const e=this._next;this._next=void 0,e.run().then(e.promiseResolve,e.promiseReject)}}setNext(e){if(this._next)this._next.run=e;else{let t,i;const r=new Promise((e,r)=>{t=e,i=r});this._next={run:e,promise:r,promiseResolve:t,promiseReject:i}}return this._next.promise}};t.IntervalCounter=class{constructor(e){this.interval=e,this.lastIncrementTime=0,this.value=0}increment(){const e=Date.now();return e-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=e,this.value=0),this.value++,this.value}}}),define(t[101],i([0,1,5]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.registerCodicon=t.iconRegistry=void 0;const r=new class{constructor(){this._icons=new Map,
this._onDidRegister=new i.Emitter}add(e){const t=this._icons.get(e.id);t?e.description?t.description=e.description:console.error(`Duplicate registration of codicon ${e.id}`):(this._icons.set(e.id,e),this._onDidRegister.fire(e))}get(e){return this._icons.get(e)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}};t.iconRegistry=r,t.registerCodicon=function(e,t){return new n(e,t)};class n{constructor(e,t,i){this.id=e,this.definition=t,this.description=i,r.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}t.Codicon=n,t.getClassNamesArray=function(e,t){const i=["codicon","codicon-"+e];return t&&i.push("codicon-modifier-"+t),i},function(e){function t(i){if(i instanceof n)return["codicon","codicon-"+i.id];const r=e.iconIdRegex.exec(i.id);if(!r)return t(n.error);let[,,s,o]=r;const a=["codicon","codicon-"+s];return o&&a.push("codicon-modifier-"+o),a}
e.iconIdRegex=/^(codicon\/)?([a-z\-]+)(?:~([a-z\-]+))?$/i,e.asClassNameArray=t,e.asClassName=function(e){return t(e).join(" ")},e.asCSSSelector=function(e){return"."+t(e).join(".")}}(t.CSSIcon||(t.CSSIcon={})),function(e){e.add=new e("add",{character:"\\ea60"}),e.plus=new e("plus",{character:"\\ea60"}),e.gistNew=new e("gist-new",{character:"\\ea60"}),e.repoCreate=new e("repo-create",{character:"\\ea60"}),e.lightbulb=new e("lightbulb",{character:"\\ea61"}),e.lightBulb=new e("light-bulb",{character:"\\ea61"}),e.repo=new e("repo",{character:"\\ea62"}),e.repoDelete=new e("repo-delete",{character:"\\ea62"}),e.gistFork=new e("gist-fork",{character:"\\ea63"}),e.repoForked=new e("repo-forked",{character:"\\ea63"}),e.gitPullRequest=new e("git-pull-request",{character:"\\ea64"}),e.gitPullRequestAbandoned=new e("git-pull-request-abandoned",{character:"\\ea64"}),e.recordKeys=new e("record-keys",{character:"\\ea65"}),e.keyboard=new e("keyboard",{character:"\\ea65"}),e.tag=new e("tag",{character:"\\ea66"}),
e.tagAdd=new e("tag-add",{character:"\\ea66"}),e.tagRemove=new e("tag-remove",{character:"\\ea66"}),e.person=new e("person",{character:"\\ea67"}),e.personAdd=new e("person-add",{character:"\\ea67"}),e.personFollow=new e("person-follow",{character:"\\ea67"}),e.personOutline=new e("person-outline",{character:"\\ea67"}),e.personFilled=new e("person-filled",{character:"\\ea67"}),e.gitBranch=new e("git-branch",{character:"\\ea68"}),e.gitBranchCreate=new e("git-branch-create",{character:"\\ea68"}),e.gitBranchDelete=new e("git-branch-delete",{character:"\\ea68"}),e.sourceControl=new e("source-control",{character:"\\ea68"}),e.mirror=new e("mirror",{character:"\\ea69"}),e.mirrorPublic=new e("mirror-public",{character:"\\ea69"}),e.star=new e("star",{character:"\\ea6a"}),e.starAdd=new e("star-add",{character:"\\ea6a"}),e.starDelete=new e("star-delete",{character:"\\ea6a"}),e.starEmpty=new e("star-empty",{character:"\\ea6a"}),e.comment=new e("comment",{character:"\\ea6b"}),e.commentAdd=new e("comment-add",{
character:"\\ea6b"}),e.alert=new e("alert",{character:"\\ea6c"}),e.warning=new e("warning",{character:"\\ea6c"}),e.search=new e("search",{character:"\\ea6d"}),e.searchSave=new e("search-save",{character:"\\ea6d"}),e.logOut=new e("log-out",{character:"\\ea6e"}),e.signOut=new e("sign-out",{character:"\\ea6e"}),e.logIn=new e("log-in",{character:"\\ea6f"}),e.signIn=new e("sign-in",{character:"\\ea6f"}),e.eye=new e("eye",{character:"\\ea70"}),e.eyeUnwatch=new e("eye-unwatch",{character:"\\ea70"}),e.eyeWatch=new e("eye-watch",{character:"\\ea70"}),e.circleFilled=new e("circle-filled",{character:"\\ea71"}),e.primitiveDot=new e("primitive-dot",{character:"\\ea71"}),e.closeDirty=new e("close-dirty",{character:"\\ea71"}),e.debugBreakpoint=new e("debug-breakpoint",{character:"\\ea71"}),e.debugBreakpointDisabled=new e("debug-breakpoint-disabled",{character:"\\ea71"}),e.debugHint=new e("debug-hint",{character:"\\ea71"}),e.primitiveSquare=new e("primitive-square",{character:"\\ea72"}),e.edit=new e("edit",{
character:"\\ea73"}),e.pencil=new e("pencil",{character:"\\ea73"}),e.info=new e("info",{character:"\\ea74"}),e.issueOpened=new e("issue-opened",{character:"\\ea74"}),e.gistPrivate=new e("gist-private",{character:"\\ea75"}),e.gitForkPrivate=new e("git-fork-private",{character:"\\ea75"}),e.lock=new e("lock",{character:"\\ea75"}),e.mirrorPrivate=new e("mirror-private",{character:"\\ea75"}),e.close=new e("close",{character:"\\ea76"}),e.removeClose=new e("remove-close",{character:"\\ea76"}),e.x=new e("x",{character:"\\ea76"}),e.repoSync=new e("repo-sync",{character:"\\ea77"}),e.sync=new e("sync",{character:"\\ea77"}),e.clone=new e("clone",{character:"\\ea78"}),e.desktopDownload=new e("desktop-download",{character:"\\ea78"}),e.beaker=new e("beaker",{character:"\\ea79"}),e.microscope=new e("microscope",{character:"\\ea79"}),e.vm=new e("vm",{character:"\\ea7a"}),e.deviceDesktop=new e("device-desktop",{character:"\\ea7a"}),e.file=new e("file",{character:"\\ea7b"}),e.fileText=new e("file-text",{character:"\\ea7b"}),
e.more=new e("more",{character:"\\ea7c"}),e.ellipsis=new e("ellipsis",{character:"\\ea7c"}),e.kebabHorizontal=new e("kebab-horizontal",{character:"\\ea7c"}),e.mailReply=new e("mail-reply",{character:"\\ea7d"}),e.reply=new e("reply",{character:"\\ea7d"}),e.organization=new e("organization",{character:"\\ea7e"}),e.organizationFilled=new e("organization-filled",{character:"\\ea7e"}),e.organizationOutline=new e("organization-outline",{character:"\\ea7e"}),e.newFile=new e("new-file",{character:"\\ea7f"}),e.fileAdd=new e("file-add",{character:"\\ea7f"}),e.newFolder=new e("new-folder",{character:"\\ea80"}),e.fileDirectoryCreate=new e("file-directory-create",{character:"\\ea80"}),e.trash=new e("trash",{character:"\\ea81"}),e.trashcan=new e("trashcan",{character:"\\ea81"}),e.history=new e("history",{character:"\\ea82"}),e.clock=new e("clock",{character:"\\ea82"}),e.folder=new e("folder",{character:"\\ea83"}),e.fileDirectory=new e("file-directory",{character:"\\ea83"}),e.symbolFolder=new e("symbol-folder",{
character:"\\ea83"}),e.logoGithub=new e("logo-github",{character:"\\ea84"}),e.markGithub=new e("mark-github",{character:"\\ea84"}),e.github=new e("github",{character:"\\ea84"}),e.terminal=new e("terminal",{character:"\\ea85"}),e.console=new e("console",{character:"\\ea85"}),e.repl=new e("repl",{character:"\\ea85"}),e.zap=new e("zap",{character:"\\ea86"}),e.symbolEvent=new e("symbol-event",{character:"\\ea86"}),e.error=new e("error",{character:"\\ea87"}),e.stop=new e("stop",{character:"\\ea87"}),e.variable=new e("variable",{character:"\\ea88"}),e.symbolVariable=new e("symbol-variable",{character:"\\ea88"}),e.array=new e("array",{character:"\\ea8a"}),e.symbolArray=new e("symbol-array",{character:"\\ea8a"}),e.symbolModule=new e("symbol-module",{character:"\\ea8b"}),e.symbolPackage=new e("symbol-package",{character:"\\ea8b"}),e.symbolNamespace=new e("symbol-namespace",{character:"\\ea8b"}),e.symbolObject=new e("symbol-object",{character:"\\ea8b"}),e.symbolMethod=new e("symbol-method",{character:"\\ea8c"}),
e.symbolFunction=new e("symbol-function",{character:"\\ea8c"}),e.symbolConstructor=new e("symbol-constructor",{character:"\\ea8c"}),e.symbolBoolean=new e("symbol-boolean",{character:"\\ea8f"}),e.symbolNull=new e("symbol-null",{character:"\\ea8f"}),e.symbolNumeric=new e("symbol-numeric",{character:"\\ea90"}),e.symbolNumber=new e("symbol-number",{character:"\\ea90"}),e.symbolStructure=new e("symbol-structure",{character:"\\ea91"}),e.symbolStruct=new e("symbol-struct",{character:"\\ea91"}),e.symbolParameter=new e("symbol-parameter",{character:"\\ea92"}),e.symbolTypeParameter=new e("symbol-type-parameter",{character:"\\ea92"}),e.symbolKey=new e("symbol-key",{character:"\\ea93"}),e.symbolText=new e("symbol-text",{character:"\\ea93"}),e.symbolReference=new e("symbol-reference",{character:"\\ea94"}),e.goToFile=new e("go-to-file",{character:"\\ea94"}),e.symbolEnum=new e("symbol-enum",{character:"\\ea95"}),e.symbolValue=new e("symbol-value",{character:"\\ea95"}),e.symbolRuler=new e("symbol-ruler",{character:"\\ea96"
}),e.symbolUnit=new e("symbol-unit",{character:"\\ea96"}),e.activateBreakpoints=new e("activate-breakpoints",{character:"\\ea97"}),e.archive=new e("archive",{character:"\\ea98"}),e.arrowBoth=new e("arrow-both",{character:"\\ea99"}),e.arrowDown=new e("arrow-down",{character:"\\ea9a"}),e.arrowLeft=new e("arrow-left",{character:"\\ea9b"}),e.arrowRight=new e("arrow-right",{character:"\\ea9c"}),e.arrowSmallDown=new e("arrow-small-down",{character:"\\ea9d"}),e.arrowSmallLeft=new e("arrow-small-left",{character:"\\ea9e"}),e.arrowSmallRight=new e("arrow-small-right",{character:"\\ea9f"}),e.arrowSmallUp=new e("arrow-small-up",{character:"\\eaa0"}),e.arrowUp=new e("arrow-up",{character:"\\eaa1"}),e.bell=new e("bell",{character:"\\eaa2"}),e.bold=new e("bold",{character:"\\eaa3"}),e.book=new e("book",{character:"\\eaa4"}),e.bookmark=new e("bookmark",{character:"\\eaa5"}),e.debugBreakpointConditionalUnverified=new e("debug-breakpoint-conditional-unverified",{character:"\\eaa6"}),
e.debugBreakpointConditional=new e("debug-breakpoint-conditional",{character:"\\eaa7"}),e.debugBreakpointConditionalDisabled=new e("debug-breakpoint-conditional-disabled",{character:"\\eaa7"}),e.debugBreakpointDataUnverified=new e("debug-breakpoint-data-unverified",{character:"\\eaa8"}),e.debugBreakpointData=new e("debug-breakpoint-data",{character:"\\eaa9"}),e.debugBreakpointDataDisabled=new e("debug-breakpoint-data-disabled",{character:"\\eaa9"}),e.debugBreakpointLogUnverified=new e("debug-breakpoint-log-unverified",{character:"\\eaaa"}),e.debugBreakpointLog=new e("debug-breakpoint-log",{character:"\\eaab"}),e.debugBreakpointLogDisabled=new e("debug-breakpoint-log-disabled",{character:"\\eaab"}),e.briefcase=new e("briefcase",{character:"\\eaac"}),e.broadcast=new e("broadcast",{character:"\\eaad"}),e.browser=new e("browser",{character:"\\eaae"}),e.bug=new e("bug",{character:"\\eaaf"}),e.calendar=new e("calendar",{character:"\\eab0"}),e.caseSensitive=new e("case-sensitive",{character:"\\eab1"}),
e.check=new e("check",{character:"\\eab2"}),e.checklist=new e("checklist",{character:"\\eab3"}),e.chevronDown=new e("chevron-down",{character:"\\eab4"}),e.chevronLeft=new e("chevron-left",{character:"\\eab5"}),e.chevronRight=new e("chevron-right",{character:"\\eab6"}),e.chevronUp=new e("chevron-up",{character:"\\eab7"}),e.chromeClose=new e("chrome-close",{character:"\\eab8"}),e.chromeMaximize=new e("chrome-maximize",{character:"\\eab9"}),e.chromeMinimize=new e("chrome-minimize",{character:"\\eaba"}),e.chromeRestore=new e("chrome-restore",{character:"\\eabb"}),e.circleOutline=new e("circle-outline",{character:"\\eabc"}),e.debugBreakpointUnverified=new e("debug-breakpoint-unverified",{character:"\\eabc"}),e.circleSlash=new e("circle-slash",{character:"\\eabd"}),e.circuitBoard=new e("circuit-board",{character:"\\eabe"}),e.clearAll=new e("clear-all",{character:"\\eabf"}),e.clippy=new e("clippy",{character:"\\eac0"}),e.closeAll=new e("close-all",{character:"\\eac1"}),e.cloudDownload=new e("cloud-download",{
character:"\\eac2"}),e.cloudUpload=new e("cloud-upload",{character:"\\eac3"}),e.code=new e("code",{character:"\\eac4"}),e.collapseAll=new e("collapse-all",{character:"\\eac5"}),e.colorMode=new e("color-mode",{character:"\\eac6"}),e.commentDiscussion=new e("comment-discussion",{character:"\\eac7"}),e.compareChanges=new e("compare-changes",{character:"\\eafd"}),e.creditCard=new e("credit-card",{character:"\\eac9"}),e.dash=new e("dash",{character:"\\eacc"}),e.dashboard=new e("dashboard",{character:"\\eacd"}),e.database=new e("database",{character:"\\eace"}),e.debugContinue=new e("debug-continue",{character:"\\eacf"}),e.debugDisconnect=new e("debug-disconnect",{character:"\\ead0"}),e.debugPause=new e("debug-pause",{character:"\\ead1"}),e.debugRestart=new e("debug-restart",{character:"\\ead2"}),e.debugStart=new e("debug-start",{character:"\\ead3"}),e.debugStepInto=new e("debug-step-into",{character:"\\ead4"}),e.debugStepOut=new e("debug-step-out",{character:"\\ead5"}),e.debugStepOver=new e("debug-step-over",{
character:"\\ead6"}),e.debugStop=new e("debug-stop",{character:"\\ead7"}),e.debug=new e("debug",{character:"\\ead8"}),e.deviceCameraVideo=new e("device-camera-video",{character:"\\ead9"}),e.deviceCamera=new e("device-camera",{character:"\\eada"}),e.deviceMobile=new e("device-mobile",{character:"\\eadb"}),e.diffAdded=new e("diff-added",{character:"\\eadc"}),e.diffIgnored=new e("diff-ignored",{character:"\\eadd"}),e.diffModified=new e("diff-modified",{character:"\\eade"}),e.diffRemoved=new e("diff-removed",{character:"\\eadf"}),e.diffRenamed=new e("diff-renamed",{character:"\\eae0"}),e.diff=new e("diff",{character:"\\eae1"}),e.discard=new e("discard",{character:"\\eae2"}),e.editorLayout=new e("editor-layout",{character:"\\eae3"}),e.emptyWindow=new e("empty-window",{character:"\\eae4"}),e.exclude=new e("exclude",{character:"\\eae5"}),e.extensions=new e("extensions",{character:"\\eae6"}),e.eyeClosed=new e("eye-closed",{character:"\\eae7"}),e.fileBinary=new e("file-binary",{character:"\\eae8"}),
e.fileCode=new e("file-code",{character:"\\eae9"}),e.fileMedia=new e("file-media",{character:"\\eaea"}),e.filePdf=new e("file-pdf",{character:"\\eaeb"}),e.fileSubmodule=new e("file-submodule",{character:"\\eaec"}),e.fileSymlinkDirectory=new e("file-symlink-directory",{character:"\\eaed"}),e.fileSymlinkFile=new e("file-symlink-file",{character:"\\eaee"}),e.fileZip=new e("file-zip",{character:"\\eaef"}),e.files=new e("files",{character:"\\eaf0"}),e.filter=new e("filter",{character:"\\eaf1"}),e.flame=new e("flame",{character:"\\eaf2"}),e.foldDown=new e("fold-down",{character:"\\eaf3"}),e.foldUp=new e("fold-up",{character:"\\eaf4"}),e.fold=new e("fold",{character:"\\eaf5"}),e.folderActive=new e("folder-active",{character:"\\eaf6"}),e.folderOpened=new e("folder-opened",{character:"\\eaf7"}),e.gear=new e("gear",{character:"\\eaf8"}),e.gift=new e("gift",{character:"\\eaf9"}),e.gistSecret=new e("gist-secret",{character:"\\eafa"}),e.gist=new e("gist",{character:"\\eafb"}),e.gitCommit=new e("git-commit",{
character:"\\eafc"}),e.gitCompare=new e("git-compare",{character:"\\eafd"}),e.gitMerge=new e("git-merge",{character:"\\eafe"}),e.githubAction=new e("github-action",{character:"\\eaff"}),e.githubAlt=new e("github-alt",{character:"\\eb00"}),e.globe=new e("globe",{character:"\\eb01"}),e.grabber=new e("grabber",{character:"\\eb02"}),e.graph=new e("graph",{character:"\\eb03"}),e.gripper=new e("gripper",{character:"\\eb04"}),e.heart=new e("heart",{character:"\\eb05"}),e.home=new e("home",{character:"\\eb06"}),e.horizontalRule=new e("horizontal-rule",{character:"\\eb07"}),e.hubot=new e("hubot",{character:"\\eb08"}),e.inbox=new e("inbox",{character:"\\eb09"}),e.issueClosed=new e("issue-closed",{character:"\\eb0a"}),e.issueReopened=new e("issue-reopened",{character:"\\eb0b"}),e.issues=new e("issues",{character:"\\eb0c"}),e.italic=new e("italic",{character:"\\eb0d"}),e.jersey=new e("jersey",{character:"\\eb0e"}),e.json=new e("json",{character:"\\eb0f"}),e.kebabVertical=new e("kebab-vertical",{character:"\\eb10"}),
e.key=new e("key",{character:"\\eb11"}),e.law=new e("law",{character:"\\eb12"}),e.lightbulbAutofix=new e("lightbulb-autofix",{character:"\\eb13"}),e.linkExternal=new e("link-external",{character:"\\eb14"}),e.link=new e("link",{character:"\\eb15"}),e.listOrdered=new e("list-ordered",{character:"\\eb16"}),e.listUnordered=new e("list-unordered",{character:"\\eb17"}),e.liveShare=new e("live-share",{character:"\\eb18"}),e.loading=new e("loading",{character:"\\eb19"}),e.location=new e("location",{character:"\\eb1a"}),e.mailRead=new e("mail-read",{character:"\\eb1b"}),e.mail=new e("mail",{character:"\\eb1c"}),e.markdown=new e("markdown",{character:"\\eb1d"}),e.megaphone=new e("megaphone",{character:"\\eb1e"}),e.mention=new e("mention",{character:"\\eb1f"}),e.milestone=new e("milestone",{character:"\\eb20"}),e.mortarBoard=new e("mortar-board",{character:"\\eb21"}),e.move=new e("move",{character:"\\eb22"}),e.multipleWindows=new e("multiple-windows",{character:"\\eb23"}),e.mute=new e("mute",{character:"\\eb24"}),
e.noNewline=new e("no-newline",{character:"\\eb25"}),e.note=new e("note",{character:"\\eb26"}),e.octoface=new e("octoface",{character:"\\eb27"}),e.openPreview=new e("open-preview",{character:"\\eb28"}),e.package_=new e("package",{character:"\\eb29"}),e.paintcan=new e("paintcan",{character:"\\eb2a"}),e.pin=new e("pin",{character:"\\eb2b"}),e.play=new e("play",{character:"\\eb2c"}),e.run=new e("run",{character:"\\eb2c"}),e.plug=new e("plug",{character:"\\eb2d"}),e.preserveCase=new e("preserve-case",{character:"\\eb2e"}),e.preview=new e("preview",{character:"\\eb2f"}),e.project=new e("project",{character:"\\eb30"}),e.pulse=new e("pulse",{character:"\\eb31"}),e.question=new e("question",{character:"\\eb32"}),e.quote=new e("quote",{character:"\\eb33"}),e.radioTower=new e("radio-tower",{character:"\\eb34"}),e.reactions=new e("reactions",{character:"\\eb35"}),e.references=new e("references",{character:"\\eb36"}),e.refresh=new e("refresh",{character:"\\eb37"}),e.regex=new e("regex",{character:"\\eb38"}),
e.remoteExplorer=new e("remote-explorer",{character:"\\eb39"}),e.remote=new e("remote",{character:"\\eb3a"}),e.remove=new e("remove",{character:"\\eb3b"}),e.replaceAll=new e("replace-all",{character:"\\eb3c"}),e.replace=new e("replace",{character:"\\eb3d"}),e.repoClone=new e("repo-clone",{character:"\\eb3e"}),e.repoForcePush=new e("repo-force-push",{character:"\\eb3f"}),e.repoPull=new e("repo-pull",{character:"\\eb40"}),e.repoPush=new e("repo-push",{character:"\\eb41"}),e.report=new e("report",{character:"\\eb42"}),e.requestChanges=new e("request-changes",{character:"\\eb43"}),e.rocket=new e("rocket",{character:"\\eb44"}),e.rootFolderOpened=new e("root-folder-opened",{character:"\\eb45"}),e.rootFolder=new e("root-folder",{character:"\\eb46"}),e.rss=new e("rss",{character:"\\eb47"}),e.ruby=new e("ruby",{character:"\\eb48"}),e.saveAll=new e("save-all",{character:"\\eb49"}),e.saveAs=new e("save-as",{character:"\\eb4a"}),e.save=new e("save",{character:"\\eb4b"}),e.screenFull=new e("screen-full",{
character:"\\eb4c"}),e.screenNormal=new e("screen-normal",{character:"\\eb4d"}),e.searchStop=new e("search-stop",{character:"\\eb4e"}),e.server=new e("server",{character:"\\eb50"}),e.settingsGear=new e("settings-gear",{character:"\\eb51"}),e.settings=new e("settings",{character:"\\eb52"}),e.shield=new e("shield",{character:"\\eb53"}),e.smiley=new e("smiley",{character:"\\eb54"}),e.sortPrecedence=new e("sort-precedence",{character:"\\eb55"}),e.splitHorizontal=new e("split-horizontal",{character:"\\eb56"}),e.splitVertical=new e("split-vertical",{character:"\\eb57"}),e.squirrel=new e("squirrel",{character:"\\eb58"}),e.starFull=new e("star-full",{character:"\\eb59"}),e.starHalf=new e("star-half",{character:"\\eb5a"}),e.symbolClass=new e("symbol-class",{character:"\\eb5b"}),e.symbolColor=new e("symbol-color",{character:"\\eb5c"}),e.symbolConstant=new e("symbol-constant",{character:"\\eb5d"}),e.symbolEnumMember=new e("symbol-enum-member",{character:"\\eb5e"}),e.symbolField=new e("symbol-field",{character:"\\eb5f"
}),e.symbolFile=new e("symbol-file",{character:"\\eb60"}),e.symbolInterface=new e("symbol-interface",{character:"\\eb61"}),e.symbolKeyword=new e("symbol-keyword",{character:"\\eb62"}),e.symbolMisc=new e("symbol-misc",{character:"\\eb63"}),e.symbolOperator=new e("symbol-operator",{character:"\\eb64"}),e.symbolProperty=new e("symbol-property",{character:"\\eb65"}),e.wrench=new e("wrench",{character:"\\eb65"}),e.wrenchSubaction=new e("wrench-subaction",{character:"\\eb65"}),e.symbolSnippet=new e("symbol-snippet",{character:"\\eb66"}),e.tasklist=new e("tasklist",{character:"\\eb67"}),e.telescope=new e("telescope",{character:"\\eb68"}),e.textSize=new e("text-size",{character:"\\eb69"}),e.threeBars=new e("three-bars",{character:"\\eb6a"}),e.thumbsdown=new e("thumbsdown",{character:"\\eb6b"}),e.thumbsup=new e("thumbsup",{character:"\\eb6c"}),e.tools=new e("tools",{character:"\\eb6d"}),e.triangleDown=new e("triangle-down",{character:"\\eb6e"}),e.triangleLeft=new e("triangle-left",{character:"\\eb6f"}),
e.triangleRight=new e("triangle-right",{character:"\\eb70"}),e.triangleUp=new e("triangle-up",{character:"\\eb71"}),e.twitter=new e("twitter",{character:"\\eb72"}),e.unfold=new e("unfold",{character:"\\eb73"}),e.unlock=new e("unlock",{character:"\\eb74"}),e.unmute=new e("unmute",{character:"\\eb75"}),e.unverified=new e("unverified",{character:"\\eb76"}),e.verified=new e("verified",{character:"\\eb77"}),e.versions=new e("versions",{character:"\\eb78"}),e.vmActive=new e("vm-active",{character:"\\eb79"}),e.vmOutline=new e("vm-outline",{character:"\\eb7a"}),e.vmRunning=new e("vm-running",{character:"\\eb7b"}),e.watch=new e("watch",{character:"\\eb7c"}),e.whitespace=new e("whitespace",{character:"\\eb7d"}),e.wholeWord=new e("whole-word",{character:"\\eb7e"}),e.window=new e("window",{character:"\\eb7f"}),e.wordWrap=new e("word-wrap",{character:"\\eb80"}),e.zoomIn=new e("zoom-in",{character:"\\eb81"}),e.zoomOut=new e("zoom-out",{character:"\\eb82"}),e.listFilter=new e("list-filter",{character:"\\eb83"}),
e.listFlat=new e("list-flat",{character:"\\eb84"}),e.listSelection=new e("list-selection",{character:"\\eb85"}),e.selection=new e("selection",{character:"\\eb85"}),e.listTree=new e("list-tree",{character:"\\eb86"}),e.debugBreakpointFunctionUnverified=new e("debug-breakpoint-function-unverified",{character:"\\eb87"}),e.debugBreakpointFunction=new e("debug-breakpoint-function",{character:"\\eb88"}),e.debugBreakpointFunctionDisabled=new e("debug-breakpoint-function-disabled",{character:"\\eb88"}),e.debugStackframeActive=new e("debug-stackframe-active",{character:"\\eb89"}),e.debugStackframeDot=new e("debug-stackframe-dot",{character:"\\eb8a"}),e.debugStackframe=new e("debug-stackframe",{character:"\\eb8b"}),e.debugStackframeFocused=new e("debug-stackframe-focused",{character:"\\eb8b"}),e.debugBreakpointUnsupported=new e("debug-breakpoint-unsupported",{character:"\\eb8c"}),e.symbolString=new e("symbol-string",{character:"\\eb8d"}),e.debugReverseContinue=new e("debug-reverse-continue",{character:"\\eb8e"}),
e.debugStepBack=new e("debug-step-back",{character:"\\eb8f"}),e.debugRestartFrame=new e("debug-restart-frame",{character:"\\eb90"}),e.callIncoming=new e("call-incoming",{character:"\\eb92"}),e.callOutgoing=new e("call-outgoing",{character:"\\eb93"}),e.menu=new e("menu",{character:"\\eb94"}),e.expandAll=new e("expand-all",{character:"\\eb95"}),e.feedback=new e("feedback",{character:"\\eb96"}),e.groupByRefType=new e("group-by-ref-type",{character:"\\eb97"}),e.ungroupByRefType=new e("ungroup-by-ref-type",{character:"\\eb98"}),e.account=new e("account",{character:"\\eb99"}),e.bellDot=new e("bell-dot",{character:"\\eb9a"}),e.debugConsole=new e("debug-console",{character:"\\eb9b"}),e.library=new e("library",{character:"\\eb9c"}),e.output=new e("output",{character:"\\eb9d"}),e.runAll=new e("run-all",{character:"\\eb9e"}),e.syncIgnored=new e("sync-ignored",{character:"\\eb9f"}),e.pinned=new e("pinned",{character:"\\eba0"}),e.githubInverted=new e("github-inverted",{character:"\\eba1"}),e.debugAlt=new e("debug-alt",{
character:"\\eb91"}),e.serverProcess=new e("server-process",{character:"\\eba2"}),e.serverEnvironment=new e("server-environment",{character:"\\eba3"}),e.pass=new e("pass",{character:"\\eba4"}),e.stopCircle=new e("stop-circle",{character:"\\eba5"}),e.playCircle=new e("play-circle",{character:"\\eba6"}),e.record=new e("record",{character:"\\eba7"}),e.debugAltSmall=new e("debug-alt-small",{character:"\\eba8"}),e.vmConnect=new e("vm-connect",{character:"\\eba9"}),e.cloud=new e("cloud",{character:"\\ebaa"}),e.merge=new e("merge",{character:"\\ebab"}),e.exportIcon=new e("export",{character:"\\ebac"}),e.graphLeft=new e("graph-left",{character:"\\ebad"}),e.magnet=new e("magnet",{character:"\\ebae"}),e.notebook=new e("notebook",{character:"\\ebaf"}),e.redo=new e("redo",{character:"\\ebb0"}),e.checkAll=new e("check-all",{character:"\\ebb1"}),e.pinnedDirty=new e("pinned-dirty",{character:"\\ebb2"}),e.passFilled=new e("pass-filled",{character:"\\ebb3"}),e.circleLargeFilled=new e("circle-large-filled",{character:"\\ebb4"
}),e.circleLargeOutline=new e("circle-large-outline",{character:"\\ebb5"}),e.dropDownButton=new e("drop-down-button",e.chevronDown.definition)}(n=t.Codicon||(t.Codicon={}))}),define(t[64],i([0,1,2]),function(e,t,i){"use strict";function r(e){const t=e;return t&&[t.on,t.pause,t.resume,t.destroy].every(e=>"function"==typeof e)}function n(e,t){return new s(e,t)}Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.peekStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0,t.isReadableStream=r,t.isReadableBufferedStream=function(e){const t=e;return t&&r(t.stream)&&Array.isArray(t.buffer)&&"boolean"==typeof t.ended},t.newWriteableStream=n;class s{constructor(e,t){this.reducer=e,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){
this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(e){var t;if(!this.state.destroyed)if(this.state.flowing)this.listeners.data.forEach(t=>t(e));else if(this.buffer.data.push(e),"number"==typeof(null===(t=this.options)||void 0===t?void 0:t.highWaterMark)&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}error(e){this.state.destroyed||(this.state.flowing?this.listeners.error.forEach(t=>t(e)):this.buffer.error.push(e))}end(e){this.state.destroyed||(e instanceof Error?this.error(e):e&&this.write(e),this.state.flowing?(this.listeners.end.forEach(e=>e()),this.destroy()):this.state.ended=!0)}on(e,t){if(!this.state.destroyed)switch(e){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors()}}removeListener(e,t){
if(this.state.destroyed)return;let i=void 0;switch(e){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error}if(i){const e=i.indexOf(t);e>=0&&i.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const e=this.reducer(this.buffer.data);this.listeners.data.forEach(t=>t(e)),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const e of this.buffer.error)this.listeners.error.forEach(t=>t(e));this.buffer.error.length=0}}flowEnd(){return!!this.state.ended&&(this.listeners.end.forEach(e=>e()),this.listeners.end.length>0)}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}t.consumeReadable=function(e,t){const i=[];let r
;for(;null!==(r=e.read());)i.push(r);return t(i)},t.peekReadable=function(e,t,i){const r=[];let n=void 0;for(;null!==(n=e.read())&&r.length<i;)r.push(n);return null===n&&r.length>0?t(r):{read:()=>{if(r.length>0)return r.shift();if(void 0!==n){const e=n;return n=void 0,e}return e.read()}}},t.consumeStream=function(e,t){return new Promise((i,r)=>{const n=[];e.on("data",e=>n.push(e)),e.on("error",e=>r(e)),e.on("end",()=>i(t(n)))})},t.peekStream=function(e,t){return new Promise((r,n)=>{const s=new i.DisposableStore,o=[],a=i=>{if(o.push(i),o.length>t)return s.dispose(),e.pause(),r({stream:e,buffer:o,ended:!1})};s.add(i.toDisposable(()=>e.removeListener("data",a))),e.on("data",a);const c=e=>n(e);s.add(i.toDisposable(()=>e.removeListener("error",c))),e.on("error",c);const l=()=>r({stream:e,buffer:o,ended:!0});s.add(i.toDisposable(()=>e.removeListener("end",l))),e.on("end",l)})},t.toStream=function(e,t){const i=n(t);return i.end(e),i},t.toReadable=function(e){let t=!1;return{read:()=>t?null:(t=!0,e)}},
t.transform=function(e,t,i){const r=n(i);return e.on("data",e=>r.write(t.data(e))),e.on("end",()=>r.end()),e.on("error",e=>r.error(t.error?t.error(e):e)),r}}),define(t[16],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0,
t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length};const i=/{(\d+)}/g;function r(e){return e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function n(e,t){if(!e||!t)return e;const i=t.length;if(0===i||0===e.length)return e;let r=0;for(;e.indexOf(t,r)===r;)r+=i;return e.substring(r)}function s(e,t){if(!e||!t)return e;const i=t.length,r=e.length;if(0===i||0===r)return e;let n=r,s=-1;for(;-1!==(s=e.lastIndexOf(t,n-1))&&s+i===n;){if(0===s)return"";n=s}return e.substring(0,n)}function o(e,t,i=0,r=e.length,n=0,s=t.length){for(;i<r&&n<s;i++,n++){let r=e.charCodeAt(i),s=t.charCodeAt(n);if(r<s)return-1;if(r>s)return 1}const o=r-i,a=s-n;return o<a?-1:o>a?1:0}function a(e,t,i=0,r=e.length,n=0,s=t.length){for(;i<r&&n<s;i++,n++){let a=e.charCodeAt(i),d=t.charCodeAt(n);if(a===d)continue;const u=a-d;if((32!==u||!l(d))&&(-32!==u||!l(a)))return c(a)&&c(d)?u:o(e.toLowerCase(),t.toLowerCase(),i,r,n,s)}const a=r-i,d=s-n;return a<d?-1:a>d?1:0}function c(e){return e>=97&&e<=122}function l(e){
return e>=65&&e<=90}function d(e){return c(e)||l(e)}function u(e,t,i=e.length){for(let r=0;r<i;r++){const i=e.charCodeAt(r),n=t.charCodeAt(r);if(i!==n)if(d(i)&&d(n)){const e=Math.abs(i-n);if(0!==e&&32!==e)return!1}else if(String.fromCharCode(i).toLowerCase()!==String.fromCharCode(n).toLowerCase())return!1}return!0}function h(e){return 55296<=e&&e<=56319}function p(e){return 56320<=e&&e<=57343}function f(e,t){return t-56320+(e-55296<<10)+65536}function g(e,t,i){const r=e.charCodeAt(i);if(h(r)&&i+1<t){const t=e.charCodeAt(i+1);if(p(t))return f(r,t)}return r}function m(e,t){const i=e.charCodeAt(t-1);if(p(i)&&t>1){const r=e.charCodeAt(t-2);if(h(r))return f(r,i)}return i}function v(e,t){const i=P.getInstance(),r=e.length,n=t,s=g(e,r,t),o=i.getGraphemeBreakType(s);t+=s>=65536?2:1;let a=o;for(;t<r;){const n=g(e,r,t),s=i.getGraphemeBreakType(n);if(k(a,s))break;t+=n>=65536?2:1,a=s}const c=t;for(t=n,a=o;t>0;){const r=m(e,t),n=i.getGraphemeBreakType(r);if(k(n,a))break;t-=r>=65536?2:1,a=n}return[t,c]}
t.format=function(e,...t){return 0===t.length?e:e.replace(i,function(e,i){const r=parseInt(i,10);return isNaN(r)||r<0||r>=t.length?e:t[r]})},t.escape=function(e){return e.replace(/[<>&]/g,function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}})},t.escapeRegExpCharacters=r,t.count=function(e,t){let i=0;const r=t.charCodeAt(0);for(let t=e.length-1;t>=0;t--)e.charCodeAt(t)===r&&i++;return i},t.truncate=function(e,t,i="…"){return e.length<=t?e:`${e.substr(0,t)}${i}`},t.trim=function(e,t=" "){return s(n(e,t),t)},t.ltrim=n,t.rtrim=s,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.createRegExp=function(e,t,i={}){if(!e)throw new Error("Cannot create regex from empty string");t||(e=r(e)),i.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));let n="";return i.global&&(n+="g"),
i.matchCase||(n+="i"),i.multiline&&(n+="m"),i.unicode&&(n+="u"),new RegExp(e,n)},t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpContainsBackreference=function(e){return!!e.match(/([^\\]|^)(\\\\)*\\\d+/)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.splitLines=function(e){return e.split(/\r\n|\r|\n/)},t.firstNonWhitespaceIndex=function(e){for(let t=0,i=e.length;t<i;t++){const i=e.charCodeAt(t);if(32!==i&&9!==i)return t}return-1},t.getLeadingWhitespace=function(e,t=0,i=e.length){for(let r=t;r<i;r++){const i=e.charCodeAt(r);if(32!==i&&9!==i)return e.substring(t,r)}return e.substring(t,i)},t.lastNonWhitespaceIndex=function(e,t=e.length-1){for(let i=t;i>=0;i--){const t=e.charCodeAt(i);if(32!==t&&9!==t)return i}return-1},t.compare=function(e,t){return e<t?-1:e>t?1:0},t.compareSubstring=o,t.compareIgnoreCase=function(e,t){
return a(e,t,0,e.length,0,t.length)},t.compareSubstringIgnoreCase=a,t.isLowerAsciiLetter=c,t.isUpperAsciiLetter=l,t.equalsIgnoreCase=function(e,t){return e.length===t.length&&u(e,t)},t.startsWithIgnoreCase=function(e,t){const i=t.length;return!(t.length>e.length)&&u(e,t,i)},t.commonPrefixLength=function(e,t){let i,r=Math.min(e.length,t.length);for(i=0;i<r;i++)if(e.charCodeAt(i)!==t.charCodeAt(i))return i;return r},t.commonSuffixLength=function(e,t){let i,r=Math.min(e.length,t.length);const n=e.length-1,s=t.length-1;for(i=0;i<r;i++)if(e.charCodeAt(n-i)!==t.charCodeAt(s-i))return i;return r},t.isHighSurrogate=h,t.isLowSurrogate=p,t.computeCodePoint=f,t.getNextCodePoint=g,t.nextCharLength=function(e,t){const i=P.getInstance(),r=t,n=e.length,s=g(e,n,t);t+=s>=65536?2:1;let o=i.getGraphemeBreakType(s);for(;t<n;){const r=g(e,n,t),s=i.getGraphemeBreakType(r);if(k(o,s))break;t+=r>=65536?2:1,o=s}return t-r},t.prevCharLength=function(e,t){const i=P.getInstance(),r=t,n=m(e,t);t-=n>=65536?2:1
;let s=i.getGraphemeBreakType(n);for(;t>0;){const r=m(e,t),n=i.getGraphemeBreakType(r);if(k(n,s))break;t-=r>=65536?2:1,s=n}return r-t},t.getCharContainingOffset=function(e,t){return t>0&&p(e.charCodeAt(t))?v(e,t-1):v(e,t)},t.encodeUTF8=function(e){const t=e.length;let i=0,r=0;for(;r<t;){const n=g(e,t,r);r+=n>=65536?2:1,i+=n<128?1:n<2048?2:n<65536?3:4}const n=new Uint8Array(i);r=0;let s=0;for(;r<t;){const i=g(e,t,r);r+=i>=65536?2:1,i<128?n[s++]=i:i<2048?(n[s++]=192|(1984&i)>>>6,n[s++]=128|(63&i)>>>0):i<65536?(n[s++]=224|(61440&i)>>>12,n[s++]=128|(4032&i)>>>6,n[s++]=128|(63&i)>>>0):(n[s++]=240|(1835008&i)>>>18,n[s++]=128|(258048&i)>>>12,n[s++]=128|(4032&i)>>>6,n[s++]=128|(63&i)>>>0)}return n},t.decodeUTF8=function(e){const t=e.byteLength,i=[];let r=0;for(;r<t;){const n=e[r];let s
;if((s=n>=240&&r+3<t?(7&e[r++])<<18>>>0|(63&e[r++])<<12>>>0|(63&e[r++])<<6>>>0|(63&e[r++])<<0>>>0:n>=224&&r+2<t?(15&e[r++])<<12>>>0|(63&e[r++])<<6>>>0|(63&e[r++])<<0>>>0:n>=192&&r+1<t?(31&e[r++])<<6>>>0|(63&e[r++])<<0>>>0:e[r++])>=0&&s<=55295||s>=57344&&s<=65535)i.push(String.fromCharCode(s));else if(s>=65536&&s<=1114111){const e=s-65536,t=55296+((1047552&e)>>>10),r=56320+((1023&e)>>>0);i.push(String.fromCharCode(t)),i.push(String.fromCharCode(r))}else i.push(String.fromCharCode(65533))}return i.join("")};const w=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/
;t.containsRTL=function(e){return w.test(e)};const y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;t.containsEmoji=function(e){return y.test(e)};const S=/^[\t\n\r\x20-\x7E]*$/;function b(e){return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}t.isBasicASCII=function(e){return S.test(e)},t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/,t.containsUnusualLineTerminators=function(e){return t.UNUSUAL_LINE_TERMINATORS.test(e)},t.containsFullWidthCharacter=function(e){for(let t=0,i=e.length;t<i;t++)if(b(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=b,t.isEmojiImprecise=function(e){return e>=127462&&e<=127487||e>=9728&&e<=10175||e>=127744&&e<=128591||e>=128640&&e<=128764||e>=128992&&e<=129003||e>=129280&&e<=129535||e>=129648&&e<=129651||e>=129656&&e<=129666||e>=129680&&e<=129685},t.lcut=function(e,t){if(e.length<t)return e;const i=/\b/g
;let r=0;for(;i.test(e)&&!(e.length-i.lastIndex<t);)r=i.lastIndex,i.lastIndex+=1;return e.substring(r).replace(/^\s/,"")};const _=/\x1B\x5B[12]?K/g,E=/\x1b\[\d+m/g,C=/\x1b\[0?m/g;function I(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))}function k(e,t){return 0===e?5!==t&&7!==t:(2!==e||3!==t)&&(4===e||2===e||3===e||(4===t||2===t||3===t||(8!==e||8!==t&&9!==t&&11!==t&&12!==t)&&((11!==e&&9!==e||9!==t&&10!==t)&&((12!==e&&10!==e||10!==t)&&(5!==t&&13!==t&&(7!==t&&(1!==e&&((13!==e||14!==t)&&(6!==e||6!==t)))))))))}t.removeAnsiEscapeCodes=function(e){return e&&(e=(e=(e=e.replace(_,"")).replace(E,"")).replace(C,"")),e},t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=I,t.stripUTF8BOM=function(e){return I(e)?e.substr(1):e},t.fuzzyContains=function(e,t){if(!e||!t)return!1;if(e.length<t.length)return!1;const i=t.length,r=e.toLowerCase();let n=0,s=-1;for(;n<i;){const e=r.indexOf(t[n],s+1);if(e<0)return!1;s=e,n++}return!0},t.containsUppercaseCharacter=function(e,t=!1){
return!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.uppercaseFirstLetter=function(e){return e.charAt(0).toUpperCase()+e.slice(1)},t.getNLines=function(e,t=1){if(0===t)return"";let i=-1;do{i=e.indexOf("\n",i+1),t--}while(t>0&&i>=0);return-1===i?e:("\r"===e[i-1]&&i--,e.substr(0,i))},t.singleLetterHash=function(e){return(e%=52)<26?String.fromCharCode(97+e):String.fromCharCode(65+e-26)},t.getGraphemeBreakType=function(e){return P.getInstance().getGraphemeBreakType(e)},t.breakBetweenGraphemeBreakType=k,function(e){e[e.Other=0]="Other",e[e.Prepend=1]="Prepend",e[e.CR=2]="CR",e[e.LF=3]="LF",e[e.Control=4]="Control",e[e.Extend=5]="Extend",e[e.Regional_Indicator=6]="Regional_Indicator",e[e.SpacingMark=7]="SpacingMark",e[e.L=8]="L",e[e.V=9]="V",e[e.T=10]="T",e[e.LV=11]="LV",e[e.LVT=12]="LVT",e[e.ZWJ=13]="ZWJ",e[e.Extended_Pictographic=14]="Extended_Pictographic"}(t.GraphemeBreakType||(t.GraphemeBreakType={}));class P{constructor(){
this._data=JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")
}static getInstance(){return P._INSTANCE||(P._INSTANCE=new P),P._INSTANCE}getGraphemeBreakType(e){if(e<32)return 10===e?3:13===e?2:4;if(e<127)return 0;const t=this._data,i=t.length/3;let r=1;for(;r<=i;)if(e<t[3*r])r*=2;else{if(!(e>t[3*r+1]))return t[3*r+2];r=2*r+1}return 0}}P._INSTANCE=null}),define(t[23],i([0,1,16,64]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const n="undefined"!=typeof Buffer,s="undefined"!=typeof TextEncoder,o="undefined"!=typeof TextDecoder;let a,c;class l{constructor(e){this.buffer=e,this.byteLength=this.buffer.byteLength}static alloc(e){return new l(n?Buffer.allocUnsafe(e):new Uint8Array(e))}static wrap(e){
return n&&!Buffer.isBuffer(e)&&(e=Buffer.from(e.buffer,e.byteOffset,e.byteLength)),new l(e)}static fromString(e){return n?new l(Buffer.from(e)):s?(a||(a=new TextEncoder),new l(a.encode(e))):new l(i.encodeUTF8(e))}static concat(e,t){if(void 0===t){t=0;for(let i=0,r=e.length;i<r;i++)t+=e[i].byteLength}const i=l.alloc(t);let r=0;for(let t=0,n=e.length;t<n;t++){const n=e[t];i.set(n,r),r+=n.byteLength}return i}toString(){return n?this.buffer.toString():o?(c||(c=new TextDecoder),c.decode(this.buffer)):i.decodeUTF8(this.buffer)}slice(e,t){return new l(this.buffer.subarray(e,t))}set(e,t){e instanceof l?this.buffer.set(e.buffer,t):this.buffer.set(e,t)}readUInt32BE(e){return d(this.buffer,e)}writeUInt32BE(e,t){u(this.buffer,e,t)}readUInt32LE(e){return h(this.buffer,e)}writeUInt32LE(e,t){p(this.buffer,e,t)}readUInt8(e){return f(this.buffer,e)}writeUInt8(e,t){g(this.buffer,e,t)}}function d(e,t){return e[t]*2**24+65536*e[t+1]+256*e[t+2]+e[t+3]}function u(e,t,i){e[i+3]=t,t>>>=8,e[i+2]=t,t>>>=8,e[i+1]=t,t>>>=8,e[i]=t}
function h(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}function p(e,t,i){e[i+0]=255&t,t>>>=8,e[i+1]=255&t,t>>>=8,e[i+2]=255&t,t>>>=8,e[i+3]=255&t}function f(e,t){return e[t]}function g(e,t,i){e[i]=t}function m(e){return r.consumeStream(e,e=>l.concat(e))}t.VSBuffer=l,t.readUInt16LE=function(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0},t.writeUInt16LE=function(e,t,i){e[i+0]=255&t,t>>>=8,e[i+1]=255&t},t.readUInt32BE=d,t.writeUInt32BE=u,t.readUInt32LE=h,t.writeUInt32LE=p,t.readUInt8=f,t.writeUInt8=g,t.readableToBuffer=function(e){return r.consumeReadable(e,e=>l.concat(e))},t.bufferToReadable=function(e){return r.toReadable(e)},t.streamToBuffer=m,t.bufferedStreamToBuffer=async function(e){return e.ended?l.concat(e.buffer):l.concat([...e.buffer,await m(e.stream)])},t.bufferToStream=function(e){return r.toStream(e,e=>l.concat(e))},t.streamToBufferReadableStream=function(e){return r.transform(e,{data:e=>"string"==typeof e?l.fromString(e):l.wrap(e)},e=>l.concat(e))},
t.newWriteableBufferStream=function(e){return r.newWriteableStream(e=>l.concat(e),e)}}),define(t[102],i([0,1,16]),function(e,t,i){"use strict";function r(e,t){switch(typeof e){case"object":return null===e?n(349,t):Array.isArray(e)?(i=e,o=n(104579,o=t),i.reduce((e,t)=>r(t,e),o)):function(e,t){return t=n(181387,t),Object.keys(e).sort().reduce((t,i)=>(t=s(i,t),r(e[i],t)),t)}(e,t);case"string":return s(e,t);case"boolean":return function(e,t){return n(e?433:863,t)}(e,t);case"number":return n(e,t);case"undefined":return n(937,t);default:return n(617,t)}var i,o}function n(e,t){return(t<<5)-t+e|0}function s(e,t){t=n(149417,t);for(let i=0,r=e.length;i<r;i++)t=n(e.charCodeAt(i),t);return t}Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.doHash=t.hash=void 0,t.hash=function(e){return r(e,0)},t.doHash=r,t.stringHash=s;var o;function a(e,t,i=32){const r=i-t;return(e<<t|(~((1<<r)-1)&e)>>>r)>>>0}function c(e,t=0,i=e.byteLength,r=0){for(let n=0;n<i;n++)e[t+n]=r}
function l(e,t=32){return e instanceof ArrayBuffer?Array.from(new Uint8Array(e)).map(e=>e.toString(16).padStart(2,"0")).join(""):function(e,t,i="0"){for(;e.length<t;)e=i+e;return e}((e>>>0).toString(16),t/4)}t.Hasher=class{constructor(){this._value=0}get value(){return this._value}hash(e){return this._value=r(e,this._value),this._value}},function(e){e[e.BLOCK_SIZE=64]="BLOCK_SIZE",e[e.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"}(o||(o={})),t.toHexString=l;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(e){const t=e.length;if(0===t)return;const r=this._buff;let n,s,o=this._buffLen,a=this._leftoverHighSurrogate;for(0!==a?(n=a,s=-1,a=0):(n=e.charCodeAt(0),s=0);;){let c=n;if(i.isHighSurrogate(n)){if(!(s+1<t)){a=n;break}{const t=e.charCodeAt(s+1);i.isLowSurrogate(t)?(s++,
c=i.computeCodePoint(n,t)):c=65533}}else i.isLowSurrogate(n)&&(c=65533);if(o=this._push(r,o,c),!(++s<t))break;n=e.charCodeAt(s)}this._buffLen=o,this._leftoverHighSurrogate=a}_push(e,t,i){return i<128?e[t++]=i:i<2048?(e[t++]=192|(1984&i)>>>6,e[t++]=128|(63&i)>>>0):i<65536?(e[t++]=224|(61440&i)>>>12,e[t++]=128|(4032&i)>>>6,e[t++]=128|(63&i)>>>0):(e[t++]=240|(1835008&i)>>>18,e[t++]=128|(258048&i)>>>12,e[t++]=128|(4032&i)>>>6,e[t++]=128|(63&i)>>>0),t>=64&&(this._step(),t-=64,this._totalLen+=64,e[0]=e[64],e[1]=e[65],e[2]=e[66]),t}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const e=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(e/4294967296),!1),
this._buffDV.setUint32(60,e%4294967296,!1),this._step()}_step(){const e=d._bigBlock32,t=this._buffDV;for(let i=0;i<64;i+=4)e.setUint32(i,t.getUint32(i,!1),!1);for(let t=64;t<320;t+=4)e.setUint32(t,a(e.getUint32(t-12,!1)^e.getUint32(t-32,!1)^e.getUint32(t-56,!1)^e.getUint32(t-64,!1),1),!1);let i,r,n,s=this._h0,o=this._h1,c=this._h2,l=this._h3,u=this._h4;for(let t=0;t<80;t++)t<20?(i=o&c|~o&l,r=1518500249):t<40?(i=o^c^l,r=1859775393):t<60?(i=o&c|o&l|c&l,r=2400959708):(i=o^c^l,r=3395469782),n=a(s,5)+i+u+r+e.getUint32(4*t,!1)&4294967295,u=l,l=c,c=a(o,30),o=s,s=n;this._h0=this._h0+s&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+c&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+u&4294967295}}t.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))}),define(t[14],i([0,1]),function(e,t){"use strict";function i(e){return"string"==typeof e}function r(e){return!("object"!=typeof e||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)}function n(e){return void 0===e}
function s(e){return n(e)||null===e}Object.defineProperty(t,"__esModule",{value:!0}),t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0,t.isArray=function(e){return Array.isArray(e)},t.isString=i,t.isStringArray=function(e){return Array.isArray(e)&&e.every(e=>i(e))},t.isObject=r,t.isNumber=function(e){return"number"==typeof e&&!isNaN(e)},t.isBoolean=function(e){return!0===e||!1===e},t.isUndefined=n,t.isDefined=function(e){return!s(e)},t.isUndefinedOrNull=s,t.assertType=function(e,t){if(!e)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")},t.assertIsDefined=function(e){if(s(e))throw new Error("Assertion Failed: argument is undefined or null");return e},
t.assertAllDefined=function(...e){const t=[];for(let i=0;i<e.length;i++){const r=e[i];if(s(r))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(r)}return t};const o=Object.prototype.hasOwnProperty;function a(e){return"function"==typeof e}function c(e,t){if(i(t)){if(typeof e!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(e instanceof t)return}catch(e){}if(!s(e)&&e.constructor===t)return;if(1===t.length&&!0===t.call(void 0,e))return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function l(e){let t=[],i=Object.getPrototypeOf(e);for(;Object.prototype!==i;)t=t.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return t}t.isEmptyObject=function(e){if(!r(e))return!1;for(let t in e)if(o.call(e,t))return!1;return!0},t.isFunction=a,t.areFunctions=function(...e){return e.length>0&&e.every(a)},
t.validateConstraints=function(e,t){const i=Math.min(e.length,t.length);for(let r=0;r<i;r++)c(e[r],t[r])},t.validateConstraint=c,t.getAllPropertyNames=l,t.getAllMethodNames=function(e){const t=[];for(const i of l(e))"function"==typeof e[i]&&t.push(i);return t},t.createProxyObject=function(e,t){const i=e=>(function(){const i=Array.prototype.slice.call(arguments,0);return t(e,i)});let r={};for(const t of e)r[t]=i(t);return r},t.withNullAsUndefined=function(e){return null===e?void 0:e},t.withUndefinedAsNull=function(e){return void 0===e?null:e},t.NotImplementedProxy=function(e){return class{constructor(){return new Proxy({},{get(t,i){if(t[i])return t[i];throw new Error(`Not Implemented: ${e}->${String(i)}`)}})}}}}),define(t[28],i([0,1,3,16,6,14]),function(e,t,i,r,n,s){"use strict";function o(e){return 47===e||92===e}Object.defineProperty(t,"__esModule",{value:!0}),
t.parseLineAndColumnAware=t.indexOfPath=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toSlashes=t.isPathSeparator=void 0,t.isPathSeparator=o,t.toSlashes=function(e){return e.replace(/[\\/]/g,n.posix.sep)},t.getRoot=function(e,t=n.posix.sep){if(!e)return"";const i=e.length,r=e.charCodeAt(0);if(o(r)){if(o(e.charCodeAt(1))&&!o(e.charCodeAt(2))){let r=3;const n=r;for(;r<i&&!o(e.charCodeAt(r));r++);if(n!==r&&!o(e.charCodeAt(r+1)))for(r+=1;r<i;r++)if(o(e.charCodeAt(r)))return e.slice(0,r+1).replace(/[\\/]/g,t)}return t}if(d(r)&&58===e.charCodeAt(1))return o(e.charCodeAt(2))?e.slice(0,2)+t:e.slice(0,2);let s=e.indexOf("://");if(-1!==s)for(s+=3;s<i;s++)if(o(e.charCodeAt(s)))return e.slice(0,s+1);return""},t.isUNC=function(e){if(!i.isWindows)return!1;if(!e||e.length<5)return!1;let t=e.charCodeAt(0);if(92!==t)return!1;if(92!==(t=e.charCodeAt(1)))return!1;let r=2;const n=r;for(;r<e.length&&92!==(t=e.charCodeAt(r));r++);
return n!==r&&(t=e.charCodeAt(r+1),!isNaN(t)&&92!==t)};const a=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(e){return e>=65&&e<=90||e>=97&&e<=122}t.isValidBasename=function(e,t=i.isWindows){const r=t?a:c;return!(!e||0===e.length||/^\s+$/.test(e))&&(r.lastIndex=0,!r.test(e)&&((!t||!l.test(e))&&("."!==e&&".."!==e&&((!t||"."!==e[e.length-1])&&((!t||e.length===e.trim().length)&&!(e.length>255))))))},t.isEqual=function(e,t,i){const n=e===t;return!i||n?n:!(!e||!t)&&r.equalsIgnoreCase(e,t)},t.isEqualOrParent=function(e,t,i,s=n.sep){if(e===t)return!0;if(!e||!t)return!1;if(t.length>e.length)return!1;if(i){if(!r.startsWithIgnoreCase(e,t))return!1;if(t.length===e.length)return!0;let i=t.length;return t.charAt(t.length-1)===s&&i--,e.charAt(i)===s}return t.charAt(t.length-1)!==s&&(t+=s),0===e.indexOf(t)},t.isWindowsDriveLetter=d,t.sanitizeFilePath=function(e,t){return i.isWindows&&e.endsWith(":")&&(e+=n.sep),n.isAbsolute(e)||(e=n.join(t,e)),e=n.normalize(e),
i.isWindows?(e=r.rtrim(e,n.sep)).endsWith(":")&&(e+=n.sep):(e=r.rtrim(e,n.sep))||(e=n.sep),e},t.isRootOrDriveLetter=function(e){const t=n.normalize(e);return i.isWindows?!(e.length>3)&&(d(t.charCodeAt(0))&&58===t.charCodeAt(1)&&(2===e.length||92===t.charCodeAt(2))):t===n.posix.sep},t.indexOfPath=function(e,t,i){return t.length>e.length?-1:e===t?0:(i&&(e=e.toLowerCase(),t=t.toLowerCase()),e.indexOf(t))},t.parseLineAndColumnAware=function(e){const t=e.split(":");let i=void 0,r=void 0,n=void 0;if(t.forEach(e=>{const t=Number(e);s.isNumber(t)?void 0===r?r=t:void 0===n&&(n=t):i=i?[i,e].join(":"):e}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:void 0!==r?r:void 0,column:void 0!==n?n:void 0!==r?1:void 0}}}),define(t[41],i([0,1,14]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0,t.deepClone=function e(t){
if(!t||"object"!=typeof t)return t;if(t instanceof RegExp)return t;const i=Array.isArray(t)?[]:{};return Object.keys(t).forEach(r=>{t[r]&&"object"==typeof t[r]?i[r]=e(t[r]):i[r]=t[r]}),i},t.deepFreeze=function(e){if(!e||"object"!=typeof e)return e;const t=[e];for(;t.length>0;){const e=t.shift();Object.freeze(e);for(const i in e)if(r.call(e,i)){const r=e[i];"object"!=typeof r||Object.isFrozen(r)||t.push(r)}}return e};const r=Object.prototype.hasOwnProperty;function n(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(typeof e!=typeof t)return!1;if("object"!=typeof e)return!1;if(Array.isArray(e)!==Array.isArray(t))return!1;let i,r;if(Array.isArray(e)){if(e.length!==t.length)return!1;for(i=0;i<e.length;i++)if(!n(e[i],t[i]))return!1}else{const s=[];for(r in e)s.push(r);s.sort();const o=[];for(r in t)o.push(r);if(o.sort(),!n(s,o))return!1;for(i=0;i<s.length;i++)if(!n(e[s[i]],t[s[i]]))return!1}return!0}t.cloneAndChange=function(e,t){return function e(t,n,s){if(i.isUndefinedOrNull(t))return t;const o=n(t)
;if(void 0!==o)return o;if(i.isArray(t)){const i=[];for(const r of t)i.push(e(r,n,s));return i}if(i.isObject(t)){if(s.has(t))throw new Error("Cannot clone recursive data-structure");s.add(t);const i={};for(let o in t)r.call(t,o)&&(i[o]=e(t[o],n,s));return s.delete(t),i}return t}(e,t,new Set)},t.mixin=function e(t,r,n=!0){return i.isObject(t)?(i.isObject(r)&&Object.keys(r).forEach(s=>{s in t?n&&(i.isObject(t[s])&&i.isObject(r[s])?e(t[s],r[s],n):t[s]=r[s]):t[s]=r[s]}),t):r},t.equals=n,t.safeStringify=function(e){const t=new Set;return JSON.stringify(e,(e,r)=>{if(i.isObject(r)||Array.isArray(r)){if(t.has(r))return"[Circular]";t.add(r)}return r})},t.getOrDefault=function(e,t,i){const r=t(e);return void 0===r?i:r},t.distinct=function(e,t){const i=Object.create(null);return e&&t?(Object.keys(t).forEach(r=>{const s=e[r],o=t[r];n(s,o)||(i[r]=o)}),i):i},t.getCaseInsensitive=function(e,t){const i=t.toLowerCase(),r=Object.keys(e).find(e=>e.toLowerCase()===i);return r?e[r]:e[t]}}),
define(t[8],i([0,1,3,6]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const n=/^\w[\w\d+.-]*$/,s=/^\//,o=/^\/\//;const a="",c="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(e,t,i,r,l,d=!1){"object"==typeof e?(this.scheme=e.scheme||a,this.authority=e.authority||a,this.path=e.path||a,this.query=e.query||a,this.fragment=e.fragment||a):(this.scheme=function(e,t){return e||t?e:"file"}(e,d),this.authority=t||a,this.path=function(e,t){switch(e){case"https":case"http":case"file":t?t[0]!==c&&(t=c+t):t=c}return t}(this.scheme,i||a),this.query=r||a,this.fragment=l||a,function(e,t){if(!e.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${e.authority}", path: "${e.path}", query: "${e.query}", fragment: "${e.fragment}"}`);if(e.scheme&&!n.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){
if(!s.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(o.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this,d))}static isUri(e){return e instanceof d||!!e&&("string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString)}get fsPath(){return m(this,!1)}with(e){if(!e)return this;let{scheme:t,authority:i,path:r,query:n,fragment:s}=e;return void 0===t?t=this.scheme:null===t&&(t=a),void 0===i?i=this.authority:null===i&&(i=a),void 0===r?r=this.path:null===r&&(r=a),void 0===n?n=this.query:null===n&&(n=a),void 0===s?s=this.fragment:null===s&&(s=a),
t===this.scheme&&i===this.authority&&r===this.path&&n===this.query&&s===this.fragment?this:new h(t,i,r,n,s)}static parse(e,t=!1){const i=l.exec(e);return i?new h(i[2]||a,y(i[4]||a),y(i[5]||a),y(i[7]||a),y(i[9]||a),t):new h(a,a,a,a,a)}static file(e){let t=a;if(i.isWindows&&(e=e.replace(/\\/g,c)),e[0]===c&&e[1]===c){const i=e.indexOf(c,2);-1===i?(t=e.substring(2),e=c):(t=e.substring(2,i),e=e.substring(i)||c)}return new h("file",t,e,a,a)}static from(e){return new h(e.scheme,e.authority,e.path,e.query,e.fragment)}static joinPath(e,...t){if(!e.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let n;return n=i.isWindows&&"file"===e.scheme?d.file(r.win32.join(m(e,!0),...t)).path:r.posix.join(e.path,...t),e.with({path:n})}toString(e=!1){return v(this,e)}toJSON(){return this}static revive(e){if(e){if(e instanceof d)return e;{const t=new h(e);return t._formatted=e.external,t._fsPath=e._sep===u?e.fsPath:null,t}}return e}}t.URI=d;const u=i.isWindows?1:void 0;class h extends d{constructor(){
super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(e=!1){return e?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const e={$mid:1};return this._fsPath&&(e.fsPath=this._fsPath,e._sep=u),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e}}const p={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(e,t){let i=void 0,r=-1;for(let n=0;n<e.length;n++){const s=e.charCodeAt(n);if(s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57||45===s||46===s||95===s||126===s||t&&47===s)-1!==r&&(i+=encodeURIComponent(e.substring(r,n)),r=-1),void 0!==i&&(i+=e.charAt(n));else{void 0===i&&(i=e.substr(0,n))
;const t=p[s];void 0!==t?(-1!==r&&(i+=encodeURIComponent(e.substring(r,n)),r=-1),i+=t):-1===r&&(r=n)}}return-1!==r&&(i+=encodeURIComponent(e.substring(r))),void 0!==i?i:e}function g(e){let t=void 0;for(let i=0;i<e.length;i++){const r=e.charCodeAt(i);35===r||63===r?(void 0===t&&(t=e.substr(0,i)),t+=p[r]):void 0!==t&&(t+=e[i])}return void 0!==t?t:e}function m(e,t){let r;return r=e.authority&&e.path.length>1&&"file"===e.scheme?`//${e.authority}${e.path}`:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?t?e.path.substr(1):e.path[1].toLowerCase()+e.path.substr(2):e.path,i.isWindows&&(r=r.replace(/\//g,"\\")),r}function v(e,t){const i=t?g:f;let r="",{scheme:n,authority:s,path:o,query:a,fragment:l}=e;if(n&&(r+=n,r+=":"),(s||"file"===n)&&(r+=c,r+=c),s){let e=s.indexOf("@");if(-1!==e){const t=s.substr(0,e);s=s.substr(e+1),-1===(e=t.indexOf(":"))?r+=i(t,!1):(r+=i(t.substr(0,e),!1),r+=":",
r+=i(t.substr(e+1),!1)),r+="@"}-1===(e=(s=s.toLowerCase()).indexOf(":"))?r+=i(s,!1):(r+=i(s.substr(0,e),!1),r+=s.substr(e))}if(o){if(o.length>=3&&47===o.charCodeAt(0)&&58===o.charCodeAt(2)){const e=o.charCodeAt(1);e>=65&&e<=90&&(o=`/${String.fromCharCode(e+32)}:${o.substr(3)}`)}else if(o.length>=2&&58===o.charCodeAt(1)){const e=o.charCodeAt(0);e>=65&&e<=90&&(o=`${String.fromCharCode(e+32)}:${o.substr(2)}`)}r+=i(o,!0)}return a&&(r+="?",r+=i(a,!1)),l&&(r+="#",r+=t?l:f(l,!1)),r}t.uriToFsPath=m;const w=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function y(e){return e.match(w)?e.replace(w,e=>(function e(t){try{return decodeURIComponent(t)}catch(i){return t.length>3?t.substr(0,3)+e(t.substr(3)):t}})(e)):e}}),define(t[103],i([0,1,8]),function(e,t,i){"use strict";function r(e){const t=[];let i;try{const r=JSON.parse(e.arguments),n=r[r.length-1];n&&n.__$stack&&(r.pop(),i=n.__$stack),t.push(...r)}catch(i){t.push("Unable to log remote console arguments",e.arguments)}return{args:t,stack:i}}function n(e){if(!e)return e
;const t=e.indexOf("\n");return-1===t?e:e.substring(0,t)}function s(e){return`color: ${e}`}Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0,t.isRemoteConsoleLog=function(e){const t=e;return t&&"string"==typeof t.type&&"string"==typeof t.severity},t.parse=r,t.getFirstFrame=function e(t){if("string"!=typeof t)return e(r(t).stack);if(t){const e=n(t),r=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(e||"");if(r&&4===r.length)return{uri:i.URI.file(r[1]),line:Number(r[2]),column:Number(r[3])}}},t.log=function(e,t){const{args:i,stack:o}=r(e),a="string"==typeof i[0]&&1===i.length;let c=n(o);c&&(c=`(${c.trim()})`);let l=[];if(l="string"==typeof i[0]?c&&a?[`%c[${t}] %c${i[0]} %c${c}`,s("blue"),s(""),s("grey")]:[`%c[${t}] %c${i[0]}`,s("blue"),s(""),...i.slice(1)]:[`%c[${t}]%`,s("blue"),...i],c&&!a&&l.push(c),"function"!=typeof console[e.severity])throw new Error("Unknown console method");console[e.severity].apply(console,l)}}),
define(t[33],i([0,1,8,16]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0,t.getOrSet=function(e,t,i){let r=e.get(t);return void 0===r&&(r=i,e.set(t,r)),r},t.mapToString=function(e){const t=[];return e.forEach((e,i)=>{t.push(`${i} => ${e}`)}),`Map(${e.size}) {${t.join(", ")}}`},t.setToString=function(e){const t=[];return e.forEach(e=>{t.push(e)}),`Set(${e.size}) {${t.join(", ")}}`};class n{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){return e.charCodeAt(0)-this._value.charCodeAt(this._pos)}value(){return this._value[this._pos]}}t.StringIterator=n;class s{constructor(e=!0){this._caseSensitive=e}reset(e){return this._value=e,this._from=0,this._to=0,this.next()}hasNext(){
return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++){if(46===this._value.charCodeAt(this._to)){if(!e)break;this._from++}else e=!1}return this}cmp(e){return this._caseSensitive?r.compareSubstring(e,this._value,0,e.length,this._from,this._to):r.compareSubstringIgnoreCase(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=s;class o{constructor(e=!0,t=!0){this._splitOnBackslash=e,this._caseSensitive=t}reset(e){return this._value=e.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(47===t||this._splitOnBackslash&&92===t){if(!e)break;this._from++}else e=!1}return this}cmp(e){
return this._caseSensitive?r.compareSubstring(e,this._value,0,e.length,this._from,this._to):r.compareSubstringIgnoreCase(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}var a;t.PathIterator=o,function(e){e[e.Scheme=1]="Scheme",e[e.Authority=2]="Authority",e[e.Path=3]="Path",e[e.Query=4]="Query",e[e.Fragment=5]="Fragment"}(a||(a={}));class c{constructor(e){this._ignorePathCasing=e,this._states=[],this._stateIdx=0}reset(e){return this._value=e,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(e)),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){
return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(1===this._states[this._stateIdx])return r.compareIgnoreCase(e,this._value.scheme);if(2===this._states[this._stateIdx])return r.compareIgnoreCase(e,this._value.authority);if(3===this._states[this._stateIdx])return this._pathIterator.cmp(e);if(4===this._states[this._stateIdx])return r.compare(e,this._value.query);if(5===this._states[this._stateIdx])return r.compare(e,this._value.fragment);throw new Error}value(){if(1===this._states[this._stateIdx])return this._value.scheme;if(2===this._states[this._stateIdx])return this._value.authority;if(3===this._states[this._stateIdx])return this._pathIterator.value();if(4===this._states[this._stateIdx])return this._value.query;if(5===this._states[this._stateIdx])return this._value.fragment;throw new Error}}t.UriIterator=c;class l{isEmpty(){return!(this.left||this.mid||this.right||this.value)}}class d{constructor(e){this._iter=e}static forUris(e=(()=>!1)){
return new d(new c(e))}static forPaths(){return new d(new o)}static forStrings(){return new d(new n)}static forConfigKeys(){return new d(new s)}clear(){this._root=void 0}set(e,t){const i=this._iter.reset(e);let r;for(this._root||(this._root=new l,this._root.segment=i.value()),r=this._root;;){const e=i.cmp(r.segment);if(e>0)r.left||(r.left=new l,r.left.segment=i.value()),r=r.left;else if(e<0)r.right||(r.right=new l,r.right.segment=i.value()),r=r.right;else{if(!i.hasNext())break;i.next(),r.mid||(r.mid=new l,r.mid.segment=i.value()),r=r.mid}}const n=r.value;return r.value=t,r.key=e,n}get(e){var t;return null===(t=this._getNode(e))||void 0===t?void 0:t.value}_getNode(e){const t=this._iter.reset(e);let i=this._root;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())break;t.next(),i=i.mid}}return i}has(e){const t=this._getNode(e);return!(void 0===(null==t?void 0:t.value)&&void 0===(null==t?void 0:t.mid))}delete(e){return this._delete(e,!1)}deleteSuperstr(e){
return this._delete(e,!0)}_delete(e,t){const i=this._iter.reset(e),r=[];let n=this._root;for(;n;){const e=i.cmp(n.segment);if(e>0)r.push([1,n]),n=n.left;else if(e<0)r.push([-1,n]),n=n.right;else{if(!i.hasNext()){for(t?(n.left=void 0,n.mid=void 0,n.right=void 0):n.value=void 0;r.length>0&&n.isEmpty();){let[e,t]=r.pop();switch(e){case 1:t.left=void 0;break;case 0:t.mid=void 0;break;case-1:t.right=void 0}n=t}break}i.next(),r.push([0,n]),n=n.mid}}}findSubstr(e){const t=this._iter.reset(e);let i=this._root,r=void 0;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())break;t.next(),r=i.value||r,i=i.mid}}return i&&i.value||r}findSuperstr(e){const t=this._iter.reset(e);let i=this._root;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())return i.mid?this._entries(i.mid):void 0;t.next(),i=i.mid}}}forEach(e){for(const[t,i]of this)e(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(e){e&&(yield*this._entries(e.left),
e.value&&(yield[e.key,e.value]),yield*this._entries(e.mid),yield*this._entries(e.right))}}t.TernarySearchTree=d;class u{constructor(e,t){this[Symbol.toStringTag]="ResourceMap",e instanceof u?(this.map=new Map(e.map),this.toKey=null!=t?t:u.defaultToKey):(this.map=new Map,this.toKey=null!=e?e:u.defaultToKey)}set(e,t){return this.map.set(this.toKey(e),t),this}get(e){return this.map.get(this.toKey(e))}has(e){return this.map.has(this.toKey(e))}get size(){return this.map.size}clear(){this.map.clear()}delete(e){return this.map.delete(this.toKey(e))}forEach(e,t){void 0!==t&&(e=e.bind(t));for(let[t,r]of this.map)e(r,i.URI.parse(t),this)}values(){return this.map.values()}*keys(){for(let e of this.map.keys())yield i.URI.parse(e)}*entries(){for(let e of this.map.entries())yield[i.URI.parse(e[0]),e[1]]}*[Symbol.iterator](){for(let e of this.map)yield[i.URI.parse(e[0]),e[1]]}}t.ResourceMap=u,u.defaultToKey=e=>e.toString(),function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"}(t.Touch||(t.Touch={}))
;class h{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var e;return null===(e=this._head)||void 0===e?void 0:e.value}get last(){var e;return null===(e=this._tail)||void 0===e?void 0:e.value}has(e){return this._map.has(e)}get(e,t=0){const i=this._map.get(e);if(i)return 0!==t&&this.touch(i,t),i.value}set(e,t,i=0){let r=this._map.get(e);if(r)r.value=t,0!==i&&this.touch(r,i);else{switch(r={key:e,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:default:this.addItemLast(r)}this._map.set(e,r),this._size++}return this}delete(e){return!!this.remove(e)}remove(e){const t=this._map.get(e);if(t)return this._map.delete(e),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return
;if(!this._head||!this._tail)throw new Error("Invalid list");const e=this._head;return this._map.delete(e.key),this.removeItem(e),this._size--,e.value}forEach(e,t){const i=this._state;let r=this._head;for(;r;){if(t?e.bind(t)(r.value,r.key,this):e(r.value,r.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const e=this,t=this._state;let i=this._head;const r={[Symbol.iterator]:()=>r,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:i.key,done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return r}values(){const e=this,t=this._state;let i=this._head;const r={[Symbol.iterator]:()=>r,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:i.value,done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return r}entries(){const e=this,t=this._state;let i=this._head;const r={[Symbol.iterator]:()=>r,next(){
if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:[i.key,i.value],done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return r}[Symbol.iterator](){return this.entries()}trimOld(e){if(e>=this.size)return;if(0===e)return void this.clear();let t=this._head,i=this.size;for(;t&&i>e;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}addItemFirst(e){if(this._head||this._tail){if(!this._head)throw new Error("Invalid list");e.next=this._head,this._head.previous=e}else this._tail=e;this._head=e,this._state++}addItemLast(e){if(this._head||this._tail){if(!this._tail)throw new Error("Invalid list");e.previous=this._tail,this._tail.next=e}else this._head=e;this._tail=e,this._state++}removeItem(e){if(e===this._head&&e===this._tail)this._head=void 0,this._tail=void 0;else if(e===this._head){if(!e.next)throw new Error("Invalid list");e.next.previous=void 0,this._head=e.next}else if(e===this._tail){
if(!e.previous)throw new Error("Invalid list");e.previous.next=void 0,this._tail=e.previous}else{const t=e.next,i=e.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}e.next=void 0,e.previous=void 0,this._state++}touch(e,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(1===t||2===t)if(1===t){if(e===this._head)return;const t=e.next,i=e.previous;e===this._tail?(i.next=void 0,this._tail=i):(t.previous=i,i.next=t),e.previous=void 0,e.next=this._head,this._head.previous=e,this._head=e,this._state++}else if(2===t){if(e===this._tail)return;const t=e.next,i=e.previous;e===this._head?(t.previous=void 0,this._head=t):(t.previous=i,i.next=t),e.next=void 0,e.previous=this._tail,this._tail.next=e,this._tail=e,this._state++}}toJSON(){const e=[];return this.forEach((t,i)=>{e.push([i,t])}),e}fromJSON(e){this.clear();for(const[t,i]of e)this.set(t,i)}}t.LinkedMap=h;t.LRUCache=class extends h{constructor(e,t=1){super(),this._limit=e,this._ratio=Math.min(Math.max(0,t),1)}get limit(){
return this._limit}set limit(e){this._limit=e,this.checkTrim()}get ratio(){return this._ratio}set ratio(e){this._ratio=Math.min(Math.max(0,e),1),this.checkTrim()}get(e,t=2){return super.get(e,t)}peek(e){return super.get(e,0)}set(e,t){return super.set(e,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}}),define(t[73],i([0,1,16,28,6,33,9]),function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0,t.getEmptyExpression=function(){return Object.create(null)};const a="**",c="/",l="[/\\\\]",d="[^/\\\\]",u=/\//g;function h(e){switch(e){case 0:return"";case 1:return`${d}*?`;default:return`(?:${l}|${d}+${l}|${l}${d}+)*?`}}function p(e,t){if(!e)return[];const i=[];let r=!1,n=!1,s="";for(const o of e){switch(o){case t:if(!r&&!n){i.push(s),s="";continue}break;case"{":r=!0;break
;case"}":r=!1;break;case"[":n=!0;break;case"]":n=!1}s+=o}return s&&i.push(s),i}t.splitGlobAware=p;const f=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,S=new s.LRUCache(1e4),b=function(){return!1},_=function(){return null};function E(e,t){if(!e)return _;let r;const n=`${r=(r="string"!=typeof e?e.pattern:e).trim()}_${!!t.trimForExclusions}`;let s,o=S.get(n);if(o)return C(o,e);if(f.test(r)){const e=r.substr(4);o=function(t,i){return"string"==typeof t&&t.endsWith(e)?r:null}}else o=(s=g.exec(I(r,t)))?function(e,t){const i=`/${e}`,r=`\\${e}`,n=function(n,s){return"string"!=typeof n?null:s?s===e?t:null:n===e||n.endsWith(i)||n.endsWith(r)?t:null},s=[e];return n.basenames=s,n.patterns=[t],n.allBasenames=s,n}(s[1],r):(t.trimForExclusions?v:m).test(r)?function(e,t){
const i=L(e.slice(1,-1).split(",").map(e=>E(e,t)).filter(e=>e!==_),e),r=i.length;if(!r)return _;if(1===r)return i[0];const n=function(t,r){for(let n=0,s=i.length;n<s;n++)if(i[n](t,r))return e;return null},s=i.find(e=>!!e.allBasenames);s&&(n.allBasenames=s.allBasenames);const o=i.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);o.length&&(n.allPaths=o);return n}(r,t):(s=w.exec(I(r,t)))?k(s[1].substr(1),r,!0):(s=y.exec(I(r,t)))?k(s[1],r,!1):function(e){try{const t=new RegExp(`^${function e(t){if(!t)return"";let r="";const n=p(t,c);if(n.every(e=>e===a))r=".*";else{let t=!1;n.forEach((s,o)=>{if(s===a)return void(t||(r+=h(2),t=!0));let u=!1,f="",g=!1,m="";for(const t of s)if("}"!==t&&u)f+=t;else if(!g||"]"===t&&m)switch(t){case"{":u=!0;continue;case"[":g=!0;continue;case"}":const n=`(?:${p(f,",").map(t=>e(t)).join("|")})`;r+=n,u=!1,f="";break;case"]":r+="["+m+"]",g=!1,m="";break;case"?":r+=d;continue;case"*":r+=h(1);continue;default:r+=i.escapeRegExpCharacters(t)}else{let e
;m+=e="-"===t?t:"^"!==t&&"!"!==t||m?t===c?"":i.escapeRegExpCharacters(t):"^"}o<n.length-1&&(n[o+1]!==a||o+2<n.length)&&(r+=l),t=!1})}return r}(e)}$`);return function(i){return t.lastIndex=0,"string"==typeof i&&t.test(i)?e:null}}catch(e){return _}}(r);return S.set(n,o),C(o,e)}function C(e,t){return"string"==typeof t?e:function(i,s){return r.isEqualOrParent(i,t.base)?e(n.relative(t.base,i),s):null}}function I(e,t){return t.trimForExclusions&&e.endsWith("/**")?e.substr(0,e.length-2):e}function k(e,t,i){const r=n.sep!==n.posix.sep?e.replace(u,n.sep):e,s=n.sep+r,o=i?function(e,i){return"string"!=typeof e||e!==r&&!e.endsWith(s)?null:t}:function(e,i){return"string"==typeof e&&e===r?t:null};return o.allPaths=[(i?"*/":"./")+e],o}function P(e,t={}){if(!e)return b;if("string"==typeof e||D(e)){const i=E(e,t);if(i===_)return b;const r=function(e,t){return!!i(e,t)};return i.allBasenames&&(r.allBasenames=i.allBasenames),i.allPaths&&(r.allPaths=i.allPaths),r}return function(e,t){
const i=L(Object.getOwnPropertyNames(e).map(i=>(function(e,t,i){if(!1===t)return _;const r=E(e,i);if(r===_)return _;if("boolean"==typeof t)return r;if(t){const i=t.when;if("string"==typeof i){const t=(t,n,s,a)=>{if(!a||!r(t,n))return null;const c=a(i.replace("$(basename)",s));return o.isThenable(c)?c.then(t=>t?e:null):c?e:null};return t.requiresSiblings=!0,t}}return r})(i,e[i],t)).filter(e=>e!==_)),r=i.length;if(!r)return _;if(!i.some(e=>!!e.requiresSiblings)){if(1===r)return i[0];const e=function(e,t){for(let r=0,n=i.length;r<n;r++){const n=i[r](e,t);if(n)return n}return null},t=i.find(e=>!!e.allBasenames);t&&(e.allBasenames=t.allBasenames);const n=i.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);return n.length&&(e.allPaths=n),e}const s=function(e,t,r){let s=void 0;for(let o=0,a=i.length;o<a;o++){const a=i[o];a.requiresSiblings&&r&&(t||(t=n.basename(e)),s||(s=t.substr(0,t.length-n.extname(e).length)));const c=a(e,t,s,r);if(c)return c}return null},a=i.find(e=>!!e.allBasenames)
;a&&(s.allBasenames=a.allBasenames);const c=i.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);c.length&&(s.allPaths=c);return s}(e,t)}function M(e){const t={};for(const i of e)t[i]=!0;return t}function D(e){const t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}function L(e,t){const i=e.filter(e=>!!e.basenames);if(i.length<2)return e;const r=i.reduce((e,t)=>{const i=t.basenames;return i?e.concat(i):e},[]);let n;if(t){n=[];for(let e=0,i=r.length;e<i;e++)n.push(t)}else n=i.reduce((e,t)=>{const i=t.patterns;return i?e.concat(i):e},[]);const s=function(e,t){if("string"!=typeof e)return null;if(!t){let i;for(i=e.length;i>0;i--){const t=e.charCodeAt(i-1);if(47===t||92===t)break}t=e.substr(i)}const i=r.indexOf(t);return-1!==i?n[i]:null};s.basenames=r,s.patterns=n,s.allBasenames=r;const o=e.filter(e=>!e.basenames);return o.push(s),o}t.match=function(e,t,i){return!(!e||"string"!=typeof t)&&P(e)(t,void 0,i)},t.parse=P,t.hasSiblingPromiseFn=function(e){if(!e)return;let t
;return i=>(t||(t=(e()||Promise.resolve([])).then(e=>e?M(e):{})),t.then(e=>!!e[i]))},t.hasSiblingFn=function(e){if(!e)return;let t;return i=>{if(!t){const i=e();t=i?M(i):{}}return!!t[i]}},t.isRelativePattern=D,t.getBasenameTerms=function(e){return e.allBasenames||[]},t.getPathTerms=function(e){return e.allPaths||[]}}),define(t[104],i([0,1,23,16,8]),function(e,t,i,r,n){"use strict";function s(e,t){return t instanceof RegExp?{$mid:2,source:t.source,flags:r.regExpFlags(t)}:t}function o(e,t=0){if(!e||t>200)return e;if("object"==typeof e){switch(e.$mid){case 1:return n.URI.revive(e);case 2:return new RegExp(e.source,e.flags)}if(e instanceof i.VSBuffer||e instanceof Uint8Array)return e;if(Array.isArray(e))for(let i=0;i<e.length;++i)e[i]=o(e[i],t+1);else for(const i in e)Object.hasOwnProperty.call(e,i)&&(e[i]=o(e[i],t+1))}return e}Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0,t.stringify=function(e){return JSON.stringify(e,s)},t.parse=function(e){let t=JSON.parse(e)
;return t=o(t)},t.revive=o}),define(t[10],i([0,1,8,3]),function(e,t,i,r){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.Schemas=void 0,function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.userData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebook="vscode-notebook",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeSettings="vscode-settings",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.vscodeWebviewResource="vscode-webview-resource",e.extension="extension",e.vscodeFileResource="vscode-file"}(n=t.Schemas||(t.Schemas={}));t.RemoteAuthorities=new class{constructor(){this._hosts=Object.create(null),
this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(e){this._preferredWebSchema=e}setDelegate(e){this._delegate=e}set(e,t,i){this._hosts[e]=t,this._ports[e]=i}setConnectionToken(e,t){this._connectionTokens[e]=t}rewrite(e){if(this._delegate)return this._delegate(e);const t=e.authority;let s=this._hosts[t];s&&-1!==s.indexOf(":")&&(s=`[${s}]`);const o=this._ports[t],a=this._connectionTokens[t];let c=`path=${encodeURIComponent(e.path)}`;return"string"==typeof a&&(c+=`&tkn=${encodeURIComponent(a)}`),i.URI.from({scheme:r.isWeb?this._preferredWebSchema:n.vscodeRemoteResource,authority:`${s}:${o}`,path:"/vscode-remote-resource",query:c})}};t.FileAccess=new class{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(e,i,s){const o=this.toUri(e,i);return o.scheme===n.vscodeRemote?t.RemoteAuthorities.rewrite(o):r.isNative&&(s||r.isPreferringBrowserCodeLoad)&&o.scheme===n.file?o.with({scheme:n.vscodeFileResource,
authority:o.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):o}asFileUri(e,t){const i=this.toUri(e,t);return i.scheme===n.vscodeFileResource?i.with({scheme:n.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(e,t){return i.URI.isUri(e)?e:i.URI.parse(t.toUrl(e))}}}),define(t[65],i([0,1,33]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeAccents=t.normalizeNFD=t.normalizeNFC=t.canNormalize=void 0,t.canNormalize="function"==typeof String.prototype.normalize;const r=new i.LRUCache(1e4);t.normalizeNFC=function(e){return a(e,"NFC",r)};const n=new i.LRUCache(1e4);function s(e){return a(e,"NFD",n)}t.normalizeNFD=s;const o=/[^\u0000-\u0080]/;function a(e,i,r){if(!t.canNormalize||!e)return e;const n=r.get(e);if(n)return n;let s;return s=o.test(e)?e.normalize(i):e,r.set(e,s),s}t.removeAccents=function(){if(t.canNormalize){const e=/[\u0300-\u036f]/g;return function(t){return s(t).replace(e,"")}}return function(e){
return e}}()}),define(t[17],i([0,1,28,6,8,16,10,3]),function(e,t,i,r,n,s,o,a){"use strict";function c(e){return n.uriToFsPath(e,!0)}Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0,t.originalFSPath=c;class l{constructor(e){this._ignorePathCasing=e}compare(e,t,i=!1){return e===t?0:s.compare(this.getComparisonKey(e,i),this.getComparisonKey(t,i))}isEqual(e,t,i=!1){return e===t||!(!e||!t)&&this.getComparisonKey(e,i)===this.getComparisonKey(t,i)}getComparisonKey(e,t=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(e){
return this._ignorePathCasing(e)}isEqualOrParent(e,r,n=!1){if(e.scheme===r.scheme){if(e.scheme===o.Schemas.file)return i.isEqualOrParent(c(e),c(r),this._ignorePathCasing(e))&&e.query===r.query&&(n||e.fragment===r.fragment);if(t.isEqualAuthority(e.authority,r.authority))return i.isEqualOrParent(e.path,r.path,this._ignorePathCasing(e),"/")&&e.query===r.query&&(n||e.fragment===r.fragment)}return!1}joinPath(e,...t){return n.URI.joinPath(e,...t)}basenameOrAuthority(e){return t.basename(e)||e.authority}basename(e){return r.posix.basename(e.path)}extname(e){return r.posix.extname(e.path)}dirname(e){if(0===e.path.length)return e;let t;return e.scheme===o.Schemas.file?t=n.URI.file(r.dirname(c(e))).path:(t=r.posix.dirname(e.path),e.authority&&t.length&&47!==t.charCodeAt(0)&&(console.error(`dirname("${e.toString})) resulted in a relative path`),t="/")),e.with({path:t})}normalizePath(e){if(!e.path.length)return e;let t;return t=e.scheme===o.Schemas.file?n.URI.file(r.normalize(c(e))).path:r.posix.normalize(e.path),
e.with({path:t})}relativePath(e,n){if(e.scheme!==n.scheme||!t.isEqualAuthority(e.authority,n.authority))return;if(e.scheme===o.Schemas.file){const t=r.relative(c(e),c(n));return a.isWindows?i.toSlashes(t):t}let s=e.path||"/",l=n.path||"/";if(this._ignorePathCasing(e)){let e=0;for(const t=Math.min(s.length,l.length);e<t&&(s.charCodeAt(e)===l.charCodeAt(e)||s.charAt(e).toLowerCase()===l.charAt(e).toLowerCase());e++);s=l.substr(0,e)+s.substr(e)}return r.posix.relative(s,l)}resolvePath(e,t){if(e.scheme===o.Schemas.file){const i=n.URI.file(r.resolve(c(e),t));return e.with({authority:i.authority,path:i.path})}return-1===t.indexOf("/")&&(t=i.toSlashes(t),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t)),e.with({path:r.posix.resolve(e.path,t)})}isAbsolutePath(e){return!!e.path&&"/"===e.path[0]}isEqualAuthority(e,t){return e===t||s.equalsIgnoreCase(e,t)}hasTrailingPathSeparator(e,t=r.sep){if(e.scheme===o.Schemas.file){const r=c(e);return r.length>i.getRoot(r).length&&r[r.length-1]===t}{const t=e.path
;return t.length>1&&47===t.charCodeAt(t.length-1)&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,i=r.sep){return t.hasTrailingPathSeparator(e,i)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,n=r.sep){let s=!1;if(e.scheme===o.Schemas.file){const t=c(e);s=void 0!==t&&t.length===i.getRoot(t).length&&t[t.length-1]===n}else{n="/";const t=e.path;s=1===t.length&&47===t.charCodeAt(t.length-1)}return s||t.hasTrailingPathSeparator(e,n)?e:e.with({path:e.path+"/"})}}t.ExtUri=l,t.extUri=new l(()=>!1),t.extUriBiasedIgnorePathCase=new l(e=>e.scheme!==o.Schemas.file||!a.isLinux),t.extUriIgnorePathCase=new l(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),
t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri),t.distinctParents=function(e,i){const r=[];for(let n=0;n<e.length;n++){const s=i(e[n]);e.some((e,r)=>r!==n&&t.isEqualOrParent(s,i(e)))||r.push(e[n])}return r},function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime",e.parseMetaData=function(t){const i=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(e=>{const[t,r]=e.split(":");t&&r&&i.set(t,r)})
;const r=t.path.substring(0,t.path.indexOf(";"));return r&&i.set(e.META_DATA_MIME,r),i}}(t.DataUri||(t.DataUri={})),t.toLocalResource=function(e,t,i){if(t){let n=e.path;return n&&n[0]!==r.posix.sep&&(n=r.posix.sep+n),e.with({scheme:i,authority:t,path:n})}return e.with({scheme:i})}}),define(t[34],i([0,1,8,6,16,10,3,17]),function(e,t,i,r,n,s,o,a){"use strict";function c(e){return!(!o.isWindows||!e||":"!==e[1])}function l(e){return c(e)?e.charAt(0).toUpperCase()+e.slice(1):e}Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.extractDriveLetter=t.getBaseLabel=t.getPathLabel=void 0,t.getPathLabel=function(e,t,n){if("string"==typeof e&&(e=i.URI.file(e)),n){const t=n.getWorkspaceFolder(e);if(t){const i=n.getWorkspace().folders.length>1;let r;if(r=a.isEqual(t.uri,e)?"":a.relativePath(t.uri,e),i){const e=t.name?t.name:a.basename(t.uri);r=r?e+" • "+r:e}return r}}
if(e.scheme!==s.Schemas.file&&e.scheme!==s.Schemas.untitled)return e.with({query:null,fragment:null}).toString(!0);if(c(e.fsPath))return r.normalize(l(e.fsPath));let d=r.normalize(e.fsPath);return!o.isWindows&&(null==t?void 0:t.userHome)&&(d=u(d,t.userHome.fsPath)),d},t.getBaseLabel=function(e){if(!e)return;"string"==typeof e&&(e=i.URI.file(e));const t=a.basename(e)||(e.scheme===s.Schemas.file?e.fsPath:e.path);return c(t)?l(t):t},t.extractDriveLetter=function(e){return c(e)?e[0]:void 0},t.normalizeDriveLetter=l;let d=Object.create(null);function u(e,t){if(o.isWindows||!e||!t)return e;let i=d.original===t?d.normalized:void 0;return i||(i=`${n.rtrim(t,r.posix.sep)}${r.posix.sep}`,d={original:t,normalized:i}),(o.isLinux?e.startsWith(i):n.startsWithIgnoreCase(e,i))&&(e=`~/${e.substr(i.length)}`),e}t.tildify=u,t.untildify=function(e,t){return e.replace(/^~($|\/|\\)/,`${t}$1`)};const h="…",p="\\\\",f="~";var g;t.shorten=function(e,t=r.sep){const i=new Array(e.length);let n=!1;for(let r=0;r<e.length;r++){let s=e[r]
;if(""===s){i[r]=`.${t}`;continue}if(!s){i[r]=s;continue}n=!0;let o="";0===s.indexOf(p)?(o=s.substr(0,s.indexOf(p)+p.length),s=s.substr(s.indexOf(p)+p.length)):0===s.indexOf(t)?(o=s.substr(0,s.indexOf(t)+t.length),s=s.substr(s.indexOf(t)+t.length)):0===s.indexOf(f)&&(o=s.substr(0,s.indexOf(f)+f.length),s=s.substr(s.indexOf(f)+f.length));const a=s.split(t);for(let s=1;n&&s<=a.length;s++)for(let c=a.length-s;n&&c>=0;c--){n=!1;let l=a.slice(c,c+s).join(t);for(let i=0;!n&&i<e.length;i++)if(i!==r&&e[i]&&e[i].indexOf(l)>-1){const r=c+s===a.length,o=c>0&&e[i].indexOf(t)>-1?t+l:l,d=e[i].endsWith(o);n=!r||d}if(!n){let e="";(a[0].endsWith(":")||""!==o)&&(1===c&&(c=0,s++,l=a[0]+t+l),c>0&&(e=a[0]+t),e=o+e),c>0&&(e=e+h+t),e+=l,c+s<a.length&&(e=e+t+h),i[r]=e}}n&&(i[r]=s)}return i},function(e){e[e.TEXT=0]="TEXT",e[e.VARIABLE=1]="VARIABLE",e[e.SEPARATOR=2]="SEPARATOR"}(g||(g={})),t.template=function(e,t=Object.create(null)){const i=[];let r=!1,n="";for(const s of e)if("$"===s||r&&"{"===s)n&&i.push({value:n,type:g.TEXT}),
n="",r=!0;else if("}"===s&&r){const e=t[n];if("string"==typeof e)e.length&&i.push({value:e,type:g.VARIABLE});else if(e){const t=i[i.length-1];t&&t.type===g.SEPARATOR||i.push({value:e.label,type:g.SEPARATOR})}n="",r=!1}else n+=s;return n&&!r&&i.push({value:n,type:g.TEXT}),i.filter((e,t)=>{if(e.type===g.SEPARATOR){return[i[t-1],i[t+1]].every(e=>e&&(e.type===g.VARIABLE||e.type===g.TEXT)&&e.value.length>0)}return!0}).map(e=>e.value).join("")},t.mnemonicMenuLabel=function(e,t){return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,"").replace(/&/g,o.isMacintosh?"&":"&&"):e.replace(/&&|&/g,e=>"&"===e?"&&":"&")},t.mnemonicButtonLabel=function(e,t){return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,""):o.isWindows?e.replace(/&&|&/g,e=>"&"===e?"&&":"&"):e.replace(/&&/g,"_")},t.unmnemonicLabel=function(e){return e.replace(/&/g,"&&")},t.splitName=function(e){const t=-1!==e.indexOf("/")?r.posix:r.win32,i=t.basename(e),n=t.dirname(e);return i.length?{name:i,parentPath:n}:{name:n,parentPath:""}}}),
define(t[105],i([0,1,6,16,73,10,17]),function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionForMimeType=t.getMediaMime=t.isUnspecific=t.guessMimeTypes=t.clearTextMimes=t.registerTextMime=t.MIME_UNKNOWN=t.MIME_BINARY=t.MIME_TEXT=void 0,t.MIME_TEXT="text/plain",t.MIME_BINARY="application/octet-stream",t.MIME_UNKNOWN="application/unknown";let a=[],c=[],l=[];function d(e,t,i){let r=null,s=null,o=null;for(let a=i.length-1;a>=0;a--){const c=i[a];if(t===c.filenameLowercase){r=c;break}if(c.filepattern&&(!s||c.filepattern.length>s.filepattern.length)){const i=c.filepatternOnPath?e:t;n.match(c.filepatternLowercase,i)&&(s=c)}c.extension&&(!o||c.extension.length>o.extension.length)&&t.endsWith(c.extensionLowercase)&&(o=c)}return r?r.mime:s?s.mime:o?o.mime:null}t.registerTextMime=function(e,t=!1){const r=function(e){return{id:e.id,mime:e.mime,filename:e.filename,extension:e.extension,filepattern:e.filepattern,firstline:e.firstline,userConfigured:e.userConfigured,
filenameLowercase:e.filename?e.filename.toLowerCase():void 0,extensionLowercase:e.extension?e.extension.toLowerCase():void 0,filepatternLowercase:e.filepattern?e.filepattern.toLowerCase():void 0,filepatternOnPath:!!e.filepattern&&e.filepattern.indexOf(i.posix.sep)>=0}}(e);a.push(r),r.userConfigured?l.push(r):c.push(r),t&&!r.userConfigured&&a.forEach(e=>{e.mime===r.mime||e.userConfigured||(r.extension&&e.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&e.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&e.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&e.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})},t.clearTextMimes=function(e){e?(a=a.filter(e=>!e.userConfigured),l=[]):(a=[],c=[],l=[])},
t.guessMimeTypes=function(e,n){let u;if(e)switch(e.scheme){case s.Schemas.file:u=e.fsPath;break;case s.Schemas.data:u=o.DataUri.parseMetaData(e).get(o.DataUri.META_DATA_LABEL);break;default:u=e.path}if(!u)return[t.MIME_UNKNOWN];u=u.toLowerCase();const h=i.basename(u),p=d(u,h,l);if(p)return[p,t.MIME_TEXT];const f=d(u,h,c);if(f)return[f,t.MIME_TEXT];if(n){const e=function(e){r.startsWithUTF8BOM(e)&&(e=e.substr(1));if(e.length>0)for(let t=a.length-1;t>=0;t--){const i=a[t];if(!i.firstline)continue;const r=e.match(i.firstline);if(r&&r.length>0)return i.mime}return null}(n);if(e)return[e,t.MIME_TEXT]}return[t.MIME_UNKNOWN]},t.isUnspecific=function e(i){return!i||("string"==typeof i?i===t.MIME_BINARY||i===t.MIME_TEXT||i===t.MIME_UNKNOWN:1===i.length&&e(i[0]))};const u={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",
".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};t.getMediaMime=function(e){const t=i.extname(e);return u[t.toLowerCase()]},t.getExtensionForMimeType=function(e){for(const t in u)if(u[t]===e)return t}}),define(t[31],i([0,1]),function(e,t){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;t.isUUID=function(e){return i.test(e)};const r=new Uint8Array(16),n=[];for(let e=0;e<256;e++)n.push(e.toString(16).padStart(2,"0"));const s=function(e){for(let t=0;t<e.length;t++)e[t]=Math.floor(256*Math.random());return e};t.generateUuid=function(){s(r),r[6]=15&r[6]|64,r[8]=63&r[8]|128;let e=0,t="";return t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+="-",t+=n[r[e++]],t+=n[r[e++]],t+="-",t+=n[r[e++]],t+=n[r[e++]],t+="-",t+=n[r[e++]],t+=n[r[e++]],t+="-",t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]],t+=n[r[e++]]}}),define(t[106],i([0,1,24,56,46]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checksum=void 0,t.checksum=async function(e,t){const s=new Promise((t,s)=>{const o=i.createReadStream(e),a=r.createHash("sha1");o.pipe(a);const c=n.once((e,i)=>{o.removeAllListeners(),
a.removeAllListeners(),e?s(e):t(i)});o.once("error",c),o.once("end",c),a.once("error",c),a.once("data",e=>c(void 0,e.toString("hex")))});if(await s!==t)throw new Error("Hash mismatch")}}),define(t[74],i([0,1,229]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;t.LineDecoder=class{constructor(e="utf8"){this.stringDecoder=new i.StringDecoder(e),this.remaining=null}write(e){const t=[],i=this.remaining?this.remaining+this.stringDecoder.write(e):this.stringDecoder.write(e);if(i.length<1)return t;let r,n=0,s=n;for(;s<i.length;)if(13===(r=i.charCodeAt(s))||10===r){if(t.push(i.substring(n,s)),++s<i.length){const e=r;r=i.charCodeAt(s),(13===e&&10===r||10===e&&13===r)&&s++}n=s}else s++;return this.remaining=n<i.length?i.substr(n):null,t}end(){return this.remaining}}}),define(t[107],i([0,1,27]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMac=void 0;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"])
;function n(e){const t=e.replace(/\-/g,":").toLowerCase();return!r.has(t)}t.getMac=function(){return new Promise(async(e,t)=>{const r=setTimeout(()=>t("Unable to retrieve mac address (timeout after 10s)"),1e4);try{e(await new Promise((e,t)=>{try{const r=i.networkInterfaces();for(const[,t]of Object.entries(r))for(const i of t)if(n(i.mac))return e(i.mac);t("Unable to retrieve mac address (unexpected format)")}catch(e){t(e)}}))}catch(e){t(e)}finally{clearTimeout(r)}})}}),define(t[66],i([0,1,19,31,27,33,107]),function(e,t,i,r,n,s,o){"use strict";let a;Object.defineProperty(t,"__esModule",{value:!0}),t.getMachineId=t.virtualMachineHint=void 0,t.virtualMachineHint=new class{_isVirtualMachineMacAdress(e){return this._virtualMachineOUIs||(this._virtualMachineOUIs=s.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),
this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(e)}value(){if(void 0===this._value){let e=0,t=0;const i=n.networkInterfaces();for(let r in i)if(Object.prototype.hasOwnProperty.call(i,r))for(const{mac:n,internal:s}of i[r])s||(t+=1,this._isVirtualMachineMacAdress(n.toUpperCase())&&(e+=1));this._value=t>0?e/t:0}return this._value}},t.getMachineId=async function(){return a||(a=(async()=>{return await async function(){try{const t=await new Promise((t,i)=>{e(["crypto"],t,i)}),r=await o.getMac();return t.createHash("sha256").update(r,"utf8").digest("hex")}catch(e){return void i.onUnexpectedError(e)}}()||r.generateUuid()})()),a}}),
define(t[108],i([0,1,10]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getDefaultUserDataPath=void 0;const r=i.FileAccess.asFileUri("paths",e).fsPath,n=e.__$__nodeRequire(r);t.getDefaultUserDataPath=n.getDefaultUserDataPath}),define(t[25],i([0,1,6,9,24,27,3,5,67,28,31,65]),function(e,t,i,r,n,s,o,a,c,l,d,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.copy=t.move=t.whenDeleted=t.fileExists=t.dirExists=t.readDirsInDir=t.writeFileSync=t.writeFile=t.mkdirp=t.readFile=t.truncate=t.symlink=t.unlink=t.renameIgnoreError=t.rename=t.lstat=t.statLink=t.stat=t.chmod=t.exists=t.readdirSync=t.readdirWithFileTypes=t.readdir=t.rimrafSync=t.rimraf=t.RimRafMode=t.MAX_HEAP_SIZE=t.MAX_FILE_SIZE=void 0;var h;async function p(e,t=h.UNLINK){if(l.isRootOrDriveLetter(e))throw new Error("rimraf - will refuse to recursively delete root");return t===h.UNLINK?f(e):async function(e){try{const t=i.join(s.tmpdir(),d.generateUuid());try{await b(e,t)}catch(t){return f(e)}f(t)}catch(e){
if("ENOENT"!==e.code)throw e}}(e)}async function f(e){try{const t=await S(e);if(!t.isDirectory()||t.isSymbolicLink()){const i=t.mode;return 128&i||await w(e,128|i),_(e)}{const t=await g(e);await Promise.all(t.map(t=>f(i.join(e,t)))),await c.promisify(n.rmdir)(e)}}catch(e){if("ENOENT"!==e.code)throw e}}async function g(e){return v(await c.promisify(n.readdir)(e))}function m(e){return v(n.readdirSync(e))}function v(e){return o.isMacintosh?e.map(e=>u.normalizeNFC(e)):e}function w(e,t){return c.promisify(n.chmod)(e,t)}function y(e){return c.promisify(n.stat)(e)}function S(e){return c.promisify(n.lstat)(e)}function b(e,t){return c.promisify(n.rename)(e,t)}function _(e){return c.promisify(n.unlink)(e)}async function E(e,t){return c.promisify(n.mkdir)(e,{mode:t,recursive:!0})}t.MAX_FILE_SIZE="ia32"===process.arch?314572800:17179869184,t.MAX_HEAP_SIZE="ia32"===process.arch?734003200:1468006400,function(e){e[e.UNLINK=0]="UNLINK",e[e.MOVE=1]="MOVE"}(h=t.RimRafMode||(t.RimRafMode={})),t.rimraf=p,
t.rimrafSync=function e(t){if(l.isRootOrDriveLetter(t))throw new Error("rimraf - will refuse to recursively delete root");try{const r=n.lstatSync(t);if(!r.isDirectory()||r.isSymbolicLink()){const e=r.mode;return 128&e||n.chmodSync(t,128|e),n.unlinkSync(t)}m(t).map(r=>e(i.join(t,r))),n.rmdirSync(t)}catch(e){if("ENOENT"!==e.code)throw e}},t.readdir=g,t.readdirWithFileTypes=async function(e){const t=await c.promisify(n.readdir)(e,{withFileTypes:!0});if(o.isMacintosh)for(const e of t)e.name=u.normalizeNFC(e.name);return t},t.readdirSync=m,t.exists=function(e){return c.promisify(n.exists)(e)},t.chmod=w,t.stat=y,t.statLink=async function(e){let t;try{if(!(t=await S(e)).isSymbolicLink())return{stat:t}}catch(e){}try{return{stat:await y(e),symbolicLink:(null==t?void 0:t.isSymbolicLink())?{dangling:!1}:void 0}}catch(e){if("ENOENT"===e.code&&t)return{stat:t,symbolicLink:{dangling:!0}};throw e}},t.lstat=S,t.rename=b,t.renameIgnoreError=function(e,t){return new Promise(i=>n.rename(e,t,()=>i()))},t.unlink=_,
t.symlink=function(e,t,i){return c.promisify(n.symlink)(e,t,i)},t.truncate=function(e,t){return c.promisify(n.truncate)(e,t)},t.readFile=function(e,t){return c.promisify(n.readFile)(e,t)},t.mkdirp=E;const C=new Map;t.writeFile=function(e,t,i){return function(e){const t=C.get(e);if(t)return t;const i=new r.Queue;return C.set(e,i),a.Event.once(i.onFinished)(()=>{C.delete(e),i.dispose()}),i}(function(e){let t=e;(o.isWindows||o.isMacintosh)&&(t=t.toLowerCase());return t}(e)).queue(()=>{const r=k(i);return new Promise((i,s)=>(function(e,t,i,r){if(!I)return n.writeFile(e,t,{mode:i.mode,flag:i.flag},r);n.open(e,i.flag,i.mode,(e,i)=>{if(e)return r(e);n.writeFile(i,t,e=>{if(e)return n.close(i,()=>r(e));n.fdatasync(i,e=>(e&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",e),I=!1),n.close(i,e=>r(e))))})})})(e,t,r,e=>e?s(e):i()))})};let I=!0;function k(e){return e?{mode:"number"==typeof e.mode?e.mode:438,flag:"string"==typeof e.flag?e.flag:"w"}:{mode:438,flag:"w"}}
async function P(e){try{return(await y(e)).isDirectory()}catch(e){return!1}}async function M(e,t,r){const s=r||Object.create(null),o=await y(e);if(!o.isDirectory())return async function(e,t,i){return new Promise((r,s)=>{const o=n.createReadStream(e),a=n.createWriteStream(t,{mode:i});let c=!1;const l=e=>{if(!c){if(c=!0,e)return s(e);n.chmod(t,i,e=>e?s(e):r())}};o.once("error",e=>l(e)),a.once("error",e=>l(e)),a.once("close",()=>l()),o.pipe(a)})}(e,t,511&o.mode);if(s[e])return;s[e]=!0,await E(t,511&o.mode);const a=await g(e);for(let r=0;r<a.length;r++){const n=a[r];await M(i.join(e,n),i.join(t,n),s)}}t.writeFileSync=function(e,t,i){const r=k(i);if(!I)return n.writeFileSync(e,t,{mode:r.mode,flag:r.flag});const s=n.openSync(e,r.flag,r.mode);try{n.writeFileSync(s,t);try{n.fdatasyncSync(s)}catch(e){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",e),I=!1}}finally{n.closeSync(s)}},t.readDirsInDir=async function(e){const t=await g(e),r=[]
;for(const n of t)await P(i.join(e,n))&&r.push(n);return r},t.dirExists=P,t.fileExists=async function(e){try{return(await y(e)).isFile()}catch(e){return!1}},t.whenDeleted=function(e){return new Promise(t=>{let i=!1;const r=setInterval(()=>{i||(i=!0,n.exists(e,e=>{i=!1,e||(clearInterval(r),t(void 0))}))},1e3)})},t.move=async function(e,t){if(e!==t)try{await b(e,t),await i(t)}catch(r){if(!(e.toLowerCase()!==t.toLowerCase()&&"EXDEV"===r.code||e.endsWith(".")))throw r;await M(e,t),await p(e,h.MOVE),await i(t)}async function i(e){const t=await S(e);if(t.isDirectory()||t.isSymbolicLink())return;const i=await c.promisify(n.open)(e,"a");try{await c.promisify(n.futimes)(i,t.atime,new Date)}catch(e){}return c.promisify(n.close)(i)}},t.copy=M}),define(t[109],i([0,1,24,16,6,25,67]),function(e,t,i,r,n,s,o){"use strict";function a(e){return r.rtrim(n.normalize(e),n.sep)}Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0,t.realcaseSync=function e(t){const i=n.dirname(t)
;if(t===i)return t;const r=(n.basename(t)||t).toLowerCase();try{const t=s.readdirSync(i).filter(e=>e.toLowerCase()===r);if(1===t.length){const r=e(i);if(r)return n.join(r,t[0])}else if(t.length>1){const s=t.indexOf(r);if(s>=0){const r=e(i);if(r)return n.join(r,t[s])}}}catch(e){}return null},t.realpath=async function(e){try{return await o.promisify(i.realpath)(e)}catch(t){const r=a(e);return await o.promisify(i.access)(r,i.constants.R_OK),r}},t.realpathSync=function(e){try{return i.realpathSync(e)}catch(t){const r=a(e);return i.accessSync(r,i.constants.R_OK),r}}}),define(t[110],i([0,1,57]),function(e,t,i){"use strict";function r(e){try{e.removeAllListeners("connect"),e.removeAllListeners("error"),e.end(),e.destroy(),e.unref()}catch(e){console.error(e)}}Object.defineProperty(t,"__esModule",{value:!0}),t.findFreePortFaster=t.findFreePort=t.randomPort=void 0,t.randomPort=function(){return 1025+Math.floor(64510*Math.random())},t.findFreePort=function(e,t,n){let s=!1;return new Promise(o=>{const a=setTimeout(()=>{
if(!s)return s=!0,o(0)},n);!function e(t,n,s){if(0===n)return s(0);const o=new i.Socket;o.once("connect",()=>(r(o),e(t+1,n-1,s)));o.once("data",()=>{});o.once("error",i=>(r(o),"ECONNREFUSED"!==i.code?e(t+1,n-1,s):s(t)));o.connect(t,"127.0.0.1")}(e,t,e=>{if(!s)return s=!0,clearTimeout(a),o(e)})})},t.findFreePortFaster=function(e,t,r){let n=!1,s=void 0,o=1;const a=i.createServer({pauseOnConnect:!0});function c(e,t){n||(n=!0,a.removeAllListeners(),a.close(),s&&clearTimeout(s),t(e))}return new Promise(i=>{s=setTimeout(()=>{c(0,i)},r),a.on("listening",()=>{c(e,i)}),a.on("error",r=>{r&&("EADDRINUSE"===r.code||"EACCES"===r.code)&&o<t?(e++,o++,a.listen(e,"127.0.0.1")):c(0,i)}),a.on("close",()=>{c(0,i)}),a.listen(e,"127.0.0.1")})}}),define(t[75],i([0,1,47,10]),function(e,t,i,r){"use strict";function n(e,t){const i=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=e.toString().split("\n");for(const e of r){const r=i.exec(e.trim())
;r&&6===r.length&&t(parseInt(r[1]),parseInt(r[2]),r[5],parseFloat(r[3]),parseFloat(r[4]))}}Object.defineProperty(t,"__esModule",{value:!0}),t.listProcesses=void 0,t.listProcesses=function(t){return new Promise((s,o)=>{let a;const c=new Map;function l(e,i,r,n,s){const o=c.get(i);if(e===t||o){const l={name:d(r),cmd:r,pid:e,ppid:i,load:n,mem:s};c.set(e,l),e===t&&(a=l),o&&(o.children||(o.children=[]),o.children.push(l),o.children.length>1&&(o.children=o.children.sort((e,t)=>e.pid-t.pid)))}}function d(e){const t=/--disable-blink-features=Auxclick/;if(/\\watcher\\win32\\CodeHelper\.exe/.exec(e))return"watcherService ";if(/--crashes-directory/.exec(e))return"electron-crash-reporter";if(/\\pipe\\winpty-control/.exec(e))return"winpty-process";if(/conhost\.exe/.exec(e))return"console-window-host (Windows internal process)";let i=/--type=([a-zA-Z-]+)/.exec(e);if(i&&2===i.length)return"renderer"===i[1]?t.exec(e)?"shared-process":"window":i[1];const r=/[a-zA-Z-]+\.js/g;let n="";do{(i=r.exec(e))&&(n+=i+" ")}while(i)
;return n&&e.indexOf("node ")<0&&e.indexOf("node.exe")<0?`electron_node ${n}`:e}if("win32"===process.platform){const i=e=>0===e.indexOf("\\\\?\\")?e.substr(4):0===e.indexOf("\\??\\")?e.substr(4):0===e.indexOf('"\\\\?\\')?'"'+e.substr(5):0===e.indexOf('"\\??\\')?'"'+e.substr(5):e;new Promise((t,i)=>{e(["windows-process-tree"],t,i)}).then(e=>{e.getProcessList(t,r=>{e.getProcessCpuUsage(r,e=>{const r=new Map;e.forEach(e=>{const t=i(e.commandLine||"");r.set(e.pid,{name:d(t),cmd:t,pid:e.pid,ppid:e.ppid,load:e.cpu||0,mem:e.memory||0})}),(a=r.get(t))?(r.forEach(e=>{const t=r.get(e.ppid);t&&(t.children||(t.children=[]),t.children.push(e))}),r.forEach(e=>{e.children&&(e.children=e.children.sort((e,t)=>e.pid-t.pid))}),s(a)):o(new Error(`Root process ${t} not found`))})},e.ProcessDataFlag.CommandLine|e.ProcessDataFlag.Memory)})}else{function u(){let n=[a];const l=[];for(;n.length;){const e=n.shift();e&&(l.push(e.pid),e.children&&(n=n.concat(e.children)))}
let d=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",e).fsPath);d+=" "+l.join(" "),i.exec(d,{},(e,i,r)=>{if(e||r)o(e||new Error(r.toString()));else{const e=i.toString().split("\n");for(let t=0;t<l.length;t++){c.get(l[t]).load=parseFloat(e[t])}if(!a)return void o(new Error(`Root process ${t} not found`));s(a)}})}i.exec("which ps",{},(c,d,h)=>{if(c||h)if("linux"!==process.platform)o(c||new Error(h.toString()));else{const t=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",e).fsPath);i.exec(t,{},(e,t,i)=>{e||i?o(e||new Error(i.toString())):(n(t,l),u())})}else{const e=d.toString().trim(),r="-ax -o pid=,ppid=,pcpu=,pmem=,command=";i.exec(`${e} ${r}`,{maxBuffer:1024e3,env:{LC_NUMERIC:"en_US.UTF-8"}},(e,i,r)=>{e||r&&!r.includes("screen size is bogus")?o(e||new Error(r.toString())):(n(i,l),"linux"===process.platform?u():a?s(a):o(new Error(`Root process ${t} not found`)))})}})}})}}),define(t[111],i([0,1,6,24,3,65,2,25]),function(e,t,i,r,n,s,o,a){"use strict";function c(e,l,d){
const u=i.basename(e.path),h=new Map;let p=!1,f=[o.toDisposable(()=>{h.forEach(e=>o.dispose(e)),h.clear()})];try{const g=r.watch(e.path);f.push(o.toDisposable(()=>{g.removeAllListeners(),g.close()}));const m=new Set;e.isDirectory&&a.readdir(e.path).then(e=>e.forEach(e=>m.add(e))),g.on("error",(t,i)=>{p||d(`Failed to watch ${e.path} for changes using fs.watch() (${t}, ${i})`)}),g.on("change",(r,g)=>{if(p)return;let v="";if(g&&(v=g.toString(),n.isMacintosh&&(v=s.normalizeNFC(v))),!v||"change"!==r&&"rename"!==r)return;const w=e.isDirectory?i.join(e.path,v):e.path;if(e.isDirectory)if("rename"===r){const e=h.get(w);e&&o.dispose(e);const i=setTimeout(async()=>{h.delete(w);const e=await a.exists(w);if(p)return;let t;e?m.has(v)?t="changed":(t="added",m.add(v)):(m.delete(v),t="deleted"),l(t,w)},t.CHANGE_BUFFER_DELAY);h.set(w,o.toDisposable(()=>clearTimeout(i)))}else{let e;m.has(v)?e="changed":(e="added",m.add(v)),l(e,w)}else if("rename"===r||v!==u){const i=setTimeout(async()=>{const t=await a.exists(w)
;p||(t?(l("changed",w),f=[c(e,l,d)]):l("deleted",w))},t.CHANGE_BUFFER_DELAY);o.dispose(f),f=[o.toDisposable(()=>clearTimeout(i))]}else l("changed",w)})}catch(t){a.exists(e.path).then(i=>{i&&!p&&d(`Failed to watch ${e.path} for changes using fs.watch() (${t.toString()})`)})}return o.toDisposable(()=>{p=!0,f=o.dispose(f)})}Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0,t.watchFile=function(e,t,i){return c({path:e,isDirectory:!1},t,i)},t.watchFolder=function(e,t,i){return c({path:e,isDirectory:!0},t,i)},t.CHANGE_BUFFER_DELAY=100}),define(t[112],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(t[113],i([0,1,11,112,14]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerContextMenuListener=void 0,
t.registerContextMenuListener=function(){i.ipcMain.on(r.CONTEXT_MENU_CHANNEL,(e,t,s,o,a)=>{const c=function e(t,r,n){const s=new i.Menu;n.forEach(n=>{let o;o="separator"===n.type?new i.MenuItem({type:n.type}):Array.isArray(n.submenu)?new i.MenuItem({submenu:e(t,r,n.submenu),label:n.label}):new i.MenuItem({label:n.label,type:n.type,accelerator:n.accelerator,checked:n.checked,enabled:n.enabled,visible:n.visible,click:(e,i,s)=>t.sender.send(r,n.id,s)}),s.append(o)});return s}(e,o,s);c.popup({window:n.withNullAsUndefined(i.BrowserWindow.fromWebContents(e.sender)),x:a?a.x:void 0,y:a?a.y:void 0,positioningItem:a?a.positioningItem:void 0,callback:()=>{c&&e.sender.send(r.CONTEXT_MENU_CLOSE_CHANNEL,t)}})})}}),define(t[35],i([0,1,5,2,9,22,19,23,30,14,104,16]),function(e,t,i,r,n,s,o,a,c,l,d,u){"use strict";var h,p;function f(e){switch(e){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}function g(e){switch(e){case 200:return"init";case 201:return"reply:";case 202:
case 203:return"replyErr:";case 204:return"event:"}}Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.createChannelSender=t.createChannelReceiver=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0,function(e){e[e.Promise=100]="Promise",e[e.PromiseCancel=101]="PromiseCancel",e[e.EventListen=102]="EventListen",e[e.EventDispose=103]="EventDispose"}(t.RequestType||(t.RequestType={})),function(e){e[e.Initialize=200]="Initialize",e[e.PromiseSuccess=201]="PromiseSuccess",e[e.PromiseError=202]="PromiseError",e[e.PromiseErrorObj=203]="PromiseErrorObj",e[e.EventFire=204]="EventFire"}(t.ResponseType||(t.ResponseType={})),function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Idle=1]="Idle"}(h||(h={}));class m{constructor(e){this.buffer=e,this.pos=0}read(e){const t=this.buffer.slice(this.pos,this.pos+e);return this.pos+=t.byteLength,t}}class v{constructor(){this.buffers=[]}
get buffer(){return a.VSBuffer.concat(this.buffers)}write(e){this.buffers.push(e)}}function w(e){const t=a.VSBuffer.alloc(4);return t.writeUInt32BE(e,0),t}function y(e){return e.read(4).readUInt32BE(0)}function S(e){const t=a.VSBuffer.alloc(1);return t.writeUInt8(e,0),t}!function(e){e[e.Undefined=0]="Undefined",e[e.String=1]="String",e[e.Buffer=2]="Buffer",e[e.VSBuffer=3]="VSBuffer",e[e.Array=4]="Array",e[e.Object=5]="Object"}(p||(p={}));const b={Undefined:S(p.Undefined),String:S(p.String),Buffer:S(p.Buffer),VSBuffer:S(p.VSBuffer),Array:S(p.Array),Object:S(p.Object)},_="undefined"!=typeof Buffer;function E(e,t){if(void 0===t)e.write(b.Undefined);else if("string"==typeof t){const i=a.VSBuffer.fromString(t);e.write(b.String),e.write(w(i.byteLength)),e.write(i)}else if(_&&Buffer.isBuffer(t)){const i=a.VSBuffer.wrap(t);e.write(b.Buffer),e.write(w(i.byteLength)),e.write(i)}else if(t instanceof a.VSBuffer)e.write(b.VSBuffer),e.write(w(t.byteLength)),e.write(t);else if(Array.isArray(t)){e.write(b.Array),
e.write(w(t.length));for(const i of t)E(e,i)}else{const i=a.VSBuffer.fromString(JSON.stringify(t));e.write(b.Object),e.write(w(i.byteLength)),e.write(i)}}function C(e){switch(e.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return e.read(y(e)).toString();case p.Buffer:return e.read(y(e)).buffer;case p.VSBuffer:return e.read(y(e));case p.Array:{const t=y(e),i=[];for(let r=0;r<t;r++)i.push(C(e));return i}case p.Object:return JSON.parse(e.read(y(e)).toString())}}class I{constructor(e,t,i=null,r=1e3){this.protocol=e,this.ctx=t,this.logger=i,this.timeoutDelay=r,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(e=>this.onRawMessage(e)),this.sendResponse({type:200})}registerChannel(e,t){this.channels.set(e,t),setTimeout(()=>this.flushPendingRequests(e),0)}sendResponse(e){switch(e.type){case 200:{const t=this.send([e.type]);return void(this.logger&&this.logger.logOutgoing(t,0,1,g(e.type)))}case 201:case 202:case 204:case 203:{
const t=this.send([e.type,e.id],e.data);return void(this.logger&&this.logger.logOutgoing(t,e.id,1,g(e.type),e.data))}}}send(e,t){const i=new v;return E(i,e),E(i,t),this.sendBuffer(i.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onRawMessage(e){const t=new m(e),i=C(t),r=C(t),n=i[0];switch(n){case 100:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],1,`${f(n)}: ${i[2]}.${i[3]}`,r),this.onPromise({type:n,id:i[1],channelName:i[2],name:i[3],arg:r});case 102:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],1,`${f(n)}: ${i[2]}.${i[3]}`,r),this.onEventListen({type:n,id:i[1],channelName:i[2],name:i[3],arg:r});case 101:case 103:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],1,`${f(n)}`),this.disposeActiveRequest({type:n,id:i[1]})}}onPromise(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const i=new s.CancellationTokenSource;let n;try{n=t.call(this.ctx,e.name,e.arg,i.token)}catch(e){
n=Promise.reject(e)}const o=e.id;n.then(t=>{this.sendResponse({id:o,data:t,type:201}),this.activeRequests.delete(e.id)},t=>{t instanceof Error?this.sendResponse({id:o,data:{message:t.message,name:t.name,stack:t.stack?t.stack.split?t.stack.split("\n"):t.stack:void 0},type:202}):this.sendResponse({id:o,data:t,type:203}),this.activeRequests.delete(e.id)});const a=r.toDisposable(()=>i.cancel());this.activeRequests.set(e.id,a)}onEventListen(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const i=e.id,r=t.listen(this.ctx,e.name,e.arg)(e=>this.sendResponse({id:i,data:e,type:204}));this.activeRequests.set(e.id,r)}disposeActiveRequest(e){const t=this.activeRequests.get(e.id);t&&(t.dispose(),this.activeRequests.delete(e.id))}collectPendingRequest(e){let t=this.pendingRequests.get(e.channelName);t||(t=[],this.pendingRequests.set(e.channelName,t));const i=setTimeout(()=>{console.error(`Unknown channel: ${e.channelName}`),100===e.type&&this.sendResponse({id:e.id,data:{
name:"Unknown channel",message:`Channel name '${e.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);t.push({request:e,timeoutTimer:i})}flushPendingRequests(e){const t=this.pendingRequests.get(e);if(t){for(const e of t)switch(clearTimeout(e.timeoutTimer),e.request.type){case 100:this.onPromise(e.request);break;case 102:this.onEventListen(e.request)}this.pendingRequests.delete(e)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelServer=I,function(e){e[e.LocalSide=0]="LocalSide",e[e.OtherSide=1]="OtherSide"}(t.RequestInitiator||(t.RequestInitiator={}));class k{constructor(e,t=null){this.protocol=e,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new i.Emitter,this.onDidInitialize=this._onDidInitialize.event,
this.protocolListener=this.protocol.onMessage(e=>this.onBuffer(e)),this.logger=t}getChannel(e){const t=this;return{call:(i,r,n)=>t.isDisposed?Promise.reject(o.canceled()):t.requestPromise(e,i,r,n),listen:(i,r)=>t.isDisposed?Promise.reject(o.canceled()):t.requestEvent(e,i,r)}}requestPromise(e,t,i,a=s.CancellationToken.None){const c=this.lastRequestId++,l={id:c,type:100,channelName:e,name:t,arg:i};if(a.isCancellationRequested)return Promise.reject(o.canceled());let d;return new Promise((e,t)=>{if(a.isCancellationRequested)return t(o.canceled());const i=()=>{this.handlers.set(c,i=>{switch(i.type){case 201:this.handlers.delete(c),e(i.data);break;case 202:this.handlers.delete(c);const r=new Error(i.data.message);r.stack=i.data.stack,r.name=i.data.name,t(r);break;case 203:this.handlers.delete(c),t(i.data)}}),this.sendRequest(l)};let s=null;this.state===h.Idle?i():(s=n.createCancelablePromise(e=>this.whenInitialized())).then(()=>{s=null,i()});const u=()=>{s?(s.cancel(),s=null):this.sendRequest({id:c,type:101}),
t(o.canceled())},p=a.onCancellationRequested(u);d=r.combinedDisposable(r.toDisposable(u),p),this.activeRequests.add(d)}).finally(()=>{this.activeRequests.delete(d)})}requestEvent(e,t,r){const s=this.lastRequestId++,o={id:s,type:102,channelName:e,name:t,arg:r};let a=null;const c=new i.Emitter({onFirstListenerAdd:()=>{(a=n.createCancelablePromise(e=>this.whenInitialized())).then(()=>{a=null,this.activeRequests.add(c),this.sendRequest(o)})},onLastListenerRemove:()=>{a?(a.cancel(),a=null):(this.activeRequests.delete(c),this.sendRequest({id:s,type:103}))}});return this.handlers.set(s,e=>c.fire(e.data)),c.event}sendRequest(e){switch(e.type){case 100:case 102:{const t=this.send([e.type,e.id,e.channelName,e.name],e.arg);return void(this.logger&&this.logger.logOutgoing(t,e.id,0,`${f(e.type)}: ${e.channelName}.${e.name}`,e.arg))}case 101:case 103:{const t=this.send([e.type,e.id]);return void(this.logger&&this.logger.logOutgoing(t,e.id,0,f(e.type)))}}}send(e,t){const i=new v;return E(i,e),E(i,t),
this.sendBuffer(i.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onBuffer(e){const t=new m(e),i=C(t),r=C(t),n=i[0];switch(n){case 200:return this.logger&&this.logger.logIncoming(e.byteLength,0,0,g(n)),this.onResponse({type:i[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(e.byteLength,i[1],0,g(n),r),this.onResponse({type:i[0],id:i[1],data:r})}}onResponse(e){if(200===e.type)return this.state=h.Idle,void this._onDidInitialize.fire();const t=this.handlers.get(e.id);t&&t(e)}whenInitialized(){return this.state===h.Idle?Promise.resolve():i.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelClient=k;t.IPCServer=class{constructor(e){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new i.Emitter,
this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new i.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,e(({protocol:e,onDidClientDisconnect:t})=>{i.Event.once(e.onMessage)(i=>{const r=C(new m(i)),n=new I(e,r),s=new k(e);this.channels.forEach((e,t)=>n.registerChannel(t,e));const o={channelServer:n,channelClient:s,ctx:r};this._connections.add(o),this._onDidAddConnection.fire(o),t(()=>{n.dispose(),s.dispose(),this._connections.delete(o),this._onDidRemoveConnection.fire(o)})})})}get connections(){const e=[];return this._connections.forEach(t=>e.push(t)),e}getChannel(e,t){const r=this;return{call(n,s,o){let a;if(l.isFunction(t)){let e=c.getRandomElement(r.connections.filter(t));a=e?Promise.resolve(e):i.Event.toPromise(i.Event.filter(r.onDidAddConnection,t))}else a=t.routeCall(r,n,s);return P(a.then(t=>t.channelClient.getChannel(e))).call(n,s,o)},listen(i,n){if(l.isFunction(t))return r.getMulticastEvent(e,t,i,n)
;return P(t.routeEvent(r,i,n).then(t=>t.channelClient.getChannel(e))).listen(i,n)}}}getMulticastEvent(e,t,n,s){const o=this;let a=new r.DisposableStore;const c=new i.Emitter({onFirstListenerAdd:()=>{a=new r.DisposableStore;const l=new i.EventMultiplexer,d=new Map,u=t=>{const i=t.channelClient.getChannel(e).listen(n,s),r=l.add(i);d.set(t,r)};o.connections.filter(t).forEach(u),i.Event.filter(o.onDidAddConnection,t)(u,void 0,a),o.onDidRemoveConnection(e=>{const t=d.get(e);t&&(t.dispose(),d.delete(e))},void 0,a),l.event(c.fire,c,a),a.add(l)},onLastListenerRemove:()=>{a.dispose()}});return c.event}registerChannel(e,t){this.channels.set(e,t),this._connections.forEach(i=>{i.channelServer.registerChannel(e,t)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}};function P(e){return{call:(t,i,r)=>e.then(e=>e.call(t,i,r)),listen(t,r){const n=new i.Relay;return e.then(e=>n.input=e.listen(t,r)),n.event}}}t.IPCClient=class{
constructor(e,t,i=null){const r=new v;E(r,t),e.send(r.buffer),this.channelClient=new k(e,i),this.channelServer=new I(e,t,i)}getChannel(e){return this.channelClient.getChannel(e)}registerChannel(e,t){this.channelServer.registerChannel(e,t)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}},t.getDelayedChannel=P,t.getNextTickChannel=function(e){let t=!1;return{call:(i,r,s)=>t?e.call(i,r,s):n.timeout(0).then(()=>t=!0).then(()=>e.call(i,r,s)),listen(r,s){if(t)return e.listen(r,s);const o=new i.Relay;return n.timeout(0).then(()=>t=!0).then(()=>o.input=e.listen(r,s)),o.event}}};function M(e){return"o"===e[0]&&"n"===e[1]&&u.isUpperAsciiLetter(e.charCodeAt(2))}t.StaticRouter=class{constructor(e){this.fn=e}routeCall(e){return this.route(e)}routeEvent(e){return this.route(e)}async route(e){for(const t of e.connections)if(await Promise.resolve(this.fn(t.ctx)))return Promise.resolve(t);return await i.Event.toPromise(e.onDidAddConnection),await this.route(e)}},t.createChannelReceiver=function(e,t){
const r=e,n=t&&t.disableMarshalling,s=new Map;for(const e in r)M(e)&&s.set(e,i.Event.buffer(r[e],!0));return new class{listen(e,t){const i=s.get(t);if(i)return i;throw new Error(`Event not found: ${t}`)}call(e,t,i){const s=r[t];if("function"==typeof s){if(!n&&Array.isArray(i))for(let e=0;e<i.length;e++)i[e]=d.revive(i[e]);return s.apply(r,i)}throw new Error(`Method not found: ${t}`)}}},t.createChannelSender=function(e,t){const i=t&&t.disableMarshalling;return new Proxy({},{get(r,n){var s;if("string"==typeof n)return(null===(s=null==t?void 0:t.properties)||void 0===s?void 0:s.has(n))?t.properties.get(n):M(n)?e.listen(n):async function(...r){let s;s=t&&!l.isUndefinedOrNull(t.context)?[t.context,...r]:r;const o=await e.call(n,s);return i?o:d.revive(o)};throw new Error(`Property not found: ${String(n)}`)}})};const D=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function L(e){if(Array.isArray(e))return e
;if(e&&"object"==typeof e&&"function"==typeof e.toString){let t=e.toString();if("[object Object]"!==t)return t}return e}function R(e,t,i,r,n,s,o){o=function(e){return Array.isArray(e)?e.map(L):L(e)}(o);const a=D[n],c=a[r%a.length];let l=[`%c[${e}]%c[${String(t).padStart(7," ")}]%c[len: ${String(i).padStart(5," ")}]%c${String(r).padStart(5," ")} - ${s}`,"color: darkgreen","color: grey","color: grey",`color: ${c}`];/\($/.test(s)?(l=l.concat(o)).push(")"):l.push(o),console.log.apply(console,l)}t.logWithColors=R;t.IPCLogger=class{constructor(e,t){this._outgoingPrefix=e,this._incomingPrefix=t,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(e,t,i,r,n){this._totalOutgoing+=e,R(this._outgoingPrefix,this._totalOutgoing,e,t,i,r,n)}logIncoming(e,t,i,r,n){this._totalIncoming+=e,R(this._incomingPrefix,this._totalIncoming,e,t,i,r,n)}}}),define(t[114],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;t.Protocol=class{constructor(e,t){this.sender=e,this.onMessage=t
}send(e){try{this.sender.send("vscode:message",e.buffer)}catch(e){}}dispose(){this.sender.send("vscode:disconnect",null)}}}),define(t[76],i([0,1,5,35,2,23,3,63]),function(e,t,i,r,n,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PersistentProtocol=t.BufferedEmitter=t.Client=t.Protocol=t.ProtocolConstants=t.ChunkStream=void 0;let c=null;function l(){return c||(c=s.VSBuffer.alloc(0)),c}class d{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(e){this._chunks.push(e),this._totalLength+=e.byteLength}read(e){return this._read(e,!0)}peek(e){return this._read(e,!1)}_read(e,t){if(0===e)return l();if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){const i=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=e),i}if(this._chunks[0].byteLength>e){const i=this._chunks[0].slice(0,e);return t&&(this._chunks[0]=this._chunks[0].slice(e),this._totalLength-=e),i}
let i=s.VSBuffer.alloc(e),r=0,n=0;for(;e>0;){const s=this._chunks[n];if(s.byteLength>e){const o=s.slice(0,e);i.set(o,r),r+=e,t&&(this._chunks[n]=s.slice(e),this._totalLength-=e),e-=e}else i.set(s,r),r+=s.byteLength,t?(this._chunks.shift(),this._totalLength-=s.byteLength):n++,e-=s.byteLength}return i}}var u;t.ChunkStream=d,function(e){e[e.None=0]="None",e[e.Regular=1]="Regular",e[e.Control=2]="Control",e[e.Ack=3]="Ack",e[e.KeepAlive=4]="KeepAlive",e[e.Disconnect=5]="Disconnect",e[e.ReplayRequest=6]="ReplayRequest"}(u||(u={})),function(e){e[e.HeaderLength=13]="HeaderLength",e[e.AcknowledgeTime=2e3]="AcknowledgeTime",e[e.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",e[e.KeepAliveTime=5e3]="KeepAliveTime",e[e.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",e[e.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",e[e.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"}(t.ProtocolConstants||(t.ProtocolConstants={}));class h{constructor(e,t,i,r){this.type=e,this.id=t,this.ack=i,this.data=r,
this.writtenTime=0}get size(){return this.data.byteLength}}class p extends n.Disposable{constructor(e){super(),this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=e,this._isDisposed=!1,this._incomingData=new d,this._register(this._socket.onData(e=>this.acceptChunk(e))),this.lastReadTime=Date.now()}acceptChunk(e){if(e&&0!==e.byteLength)for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;){const e=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=e.readUInt32BE(9),this._state.messageType=e.readUInt8(0),this._state.id=e.readUInt32BE(1),this._state.ack=e.readUInt32BE(5);else{const t=this._state.messageType,i=this._state.id,r=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,
this._onMessage.fire(new h(t,i,r,e)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(e){this._isDisposed=!1,this._socket=e,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(e){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(e){if(this._isDisposed)return;e.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=s.VSBuffer.alloc(13);t.writeUInt8(e.type,0),t.writeUInt32BE(e.id,1),t.writeUInt32BE(e.ack,5),t.writeUInt32BE(e.data.byteLength,9),this._writeSoon(t,e.data)}_bufferAdd(e,t){const i=0===this._totalLength;return this._data.push(e,t),this._totalLength+=e.byteLength+t.byteLength,i}_bufferTake(){const e=s.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,e}_writeSoon(e,t){this._bufferAdd(e,t)&&o.setImmediate(()=>{this._writeNow()})}_writeNow(){
0!==this._totalLength&&this._socket.write(this._bufferTake())}}class g extends n.Disposable{constructor(e){super(),this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=e,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(e=>{1===e.type&&this._onMessage.fire(e.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(e){this._socketWriter.write(new h(1,0,0,e))}}t.Protocol=g;class m extends r.IPCClient{constructor(e,t,i=null){super(e,t,i),this.protocol=e}static fromSocket(e,t){return new m(new g(e),t)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end()}}t.Client=m;class v{
constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,a.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(e){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(e):this._emitter.fire(e):this._bufferedMessages.push(e)}flushBuffer(){this._bufferedMessages=[]}}t.BufferedEmitter=v;class w{constructor(e){this.data=e,this.next=null}}class y{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let e=[],t=0,i=this._first;for(;i;)e[t++]=i.data,i=i.next;return e}pop(){if(this._first)return this._first===this._last?(this._first=null,
void(this._last=null)):void(this._first=this._first.next)}push(e){const t=new w(e);if(!this._first)return this._first=t,void(this._last=t);this._last.next=t,this._last=t}}class S{constructor(){this.lastRuns=[];const e=Date.now();for(let t=0;t<S._HISTORY_LENGTH;t++)this.lastRuns[t]=e-1e3*t;setInterval(()=>{for(let e=S._HISTORY_LENGTH;e>=1;e--)this.lastRuns[e]=this.lastRuns[e-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const e=Date.now(),t=1e3*(1+S._HISTORY_LENGTH);let i=0;for(let r=0;r<S._HISTORY_LENGTH;r++)e-this.lastRuns[r]<=t&&i++;return 1-i/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;t.PersistentProtocol=class{constructor(e,t=null){this._loadEstimator=S.getInstance(),this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,this.onMessage=this._onMessage.event,this._onDidDispose=new v,this.onDidDispose=this._onDidDispose.event,
this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new y,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=e,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),t&&this._socketReader.acceptChunk(t),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){
return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=n.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const e=new h(5,0,0,l());this._socketWriter.write(e),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const e=Date.now()-this._socketWriter.lastWriteTime;if(e>=5e3){const e=new h(4,0,0,l());return this._socketWriter.write(e),void this._sendKeepAliveCheck()}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-e+5)}
_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const e=Date.now()-this._socketReader.lastReadTime;e>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-e,0)+5)}getSocket(){return this._socket}beginAcceptReconnection(e,t){this._isReconnecting=!0,this._socketDisposables=n.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=e,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(t)}
endAcceptReconnection(){this._isReconnecting=!1;const e=this._outgoingUnackMsg.toArray();for(let t=0,i=e.length;t<i;t++)this._socketWriter.write(e[t]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(e){if(e.ack>this._outgoingAckId)for(this._outgoingAckId=e.ack;;){const t=this._outgoingUnackMsg.peek();if(!(t&&t.id<=e.ack))break;this._outgoingUnackMsg.pop()}if(1===e.type){if(e.id>this._incomingMsgId)if(e.id!==this._incomingMsgId+1){const e=Date.now();e-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=e,this._socketWriter.write(new h(6,0,0,l())))}else this._incomingMsgId=e.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(e.data)}else if(2===e.type)this._onControlMessage.fire(e.data);else if(5===e.type)this._onDidDispose.fire();else if(6===e.type){const e=this._outgoingUnackMsg.toArray();for(let t=0,i=e.length;t<i;t++)this._socketWriter.write(e[t]);this._recvAckCheck()}}
readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(e){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const i=new h(1,t,this._incomingAckId,e);this._outgoingUnackMsg.push(i),this._isReconnecting||(this._socketWriter.write(i),this._recvAckCheck())}sendControl(e){const t=new h(2,0,0,e);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId)return;if(this._incomingAckTimeout)return;const e=Date.now()-this._incomingMsgLastTime;e>=2e3?this._sendAck():this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-e+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId)return;if(this._outgoingAckTimeout)return;const e=this._outgoingUnackMsg.peek(),t=Date.now()-e.writtenTime;t>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-t,0)+5)}
_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const e=new h(3,0,this._incomingAckId,l());this._socketWriter.write(e)}}}),define(t[115],i([0,1,5,35,114,11,2,23]),function(e,t,i,r,n,s,o,a){"use strict";function c(e,t){const r=i.Event.fromNodeEventEmitter(s.ipcMain,t,(e,t)=>({event:e,message:t})),n=i.Event.filter(r,({event:t})=>t.sender.id===e);return i.Event.map(n,({message:e})=>e?a.VSBuffer.wrap(e):e)}Object.defineProperty(t,"__esModule",{value:!0}),t.Server=void 0;class l extends r.IPCServer{constructor(){super(l.getOnDidClientConnect())}static getOnDidClientConnect(){const e=i.Event.fromNodeEventEmitter(s.ipcMain,"vscode:hello",({sender:e})=>e);return i.Event.map(e,e=>{const t=e.id,r=l.Clients.get(t);r&&r.dispose();const s=new i.Emitter;l.Clients.set(t,o.toDisposable(()=>s.fire()));const a=c(t,"vscode:message"),d=i.Event.any(i.Event.signal(c(t,"vscode:disconnect")),s.event);return{protocol:new n.Protocol(e,a),onDidClientDisconnect:d}})}}t.Server=l,
l.Clients=new Map}),define(t[116],i([0,1,2,5,9,14]),function(e,t,i,r,n,s){"use strict";var o,a;Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0,function(e){e[e.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"}(o=t.StorageHint||(t.StorageHint={})),function(e){e[e.None=0]="None",e[e.Initialized=1]="Initialized",e[e.Closed=2]="Closed"}(a||(a={}));class c extends i.Disposable{constructor(e,t=Object.create(null)){super(),this.database=e,this.options=t,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=this._register(new n.ThrottledDelayer(c.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(e=>this.onDidChangeItemsExternal(e)))}onDidChangeItemsExternal(e){var t,i
;null===(t=e.changed)||void 0===t||t.forEach((e,t)=>this.accept(t,e)),null===(i=e.deleted)||void 0===i||i.forEach(e=>this.accept(e,void 0))}accept(e,t){if(this.state===a.Closed)return;let i=!1;if(s.isUndefinedOrNull(t))i=this.cache.delete(e);else{this.cache.get(e)!==t&&(this.cache.set(e,t),i=!0)}i&&this._onDidChangeStorage.fire(e)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==o.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(e,t){const i=this.cache.get(e);return s.isUndefinedOrNull(i)?t:i}getBoolean(e,t){const i=this.get(e);return s.isUndefinedOrNull(i)?t:"true"===i}getNumber(e,t){const i=this.get(e);return s.isUndefinedOrNull(i)?t:parseInt(i,10)}async set(e,t){if(this.state===a.Closed)return;if(s.isUndefinedOrNull(t))return this.delete(e);const i=String(t);return this.cache.get(e)!==i?(this.cache.set(e,i),this.pendingInserts.set(e,i),this.pendingDeletes.delete(e),
this._onDidChangeStorage.fire(e),this.flushDelayer.trigger(()=>this.flushPending())):void 0}async delete(e){if(this.state===a.Closed)return;return this.cache.delete(e)?(this.pendingDeletes.has(e)||this.pendingDeletes.add(e),this.pendingInserts.delete(e),this._onDidChangeStorage.fire(e),this.flushDelayer.trigger(()=>this.flushPending())):void 0}async close(){if(this.state!==a.Closed){this.state=a.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(e){}await this.database.close(()=>this.cache)}}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const e={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(e).finally(()=>{var e;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)null===(e=this.whenFlushedCallbacks.pop())||void 0===e||e()})}async whenFlushed(){
if(this.hasPending)return new Promise(e=>this.whenFlushedCallbacks.push(e))}}t.Storage=c,c.DEFAULT_FLUSH_DELAY=100;t.InMemoryStorageDatabase=class{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(e){e.insert&&e.insert.forEach((e,t)=>this.items.set(t,e)),e.delete&&e.delete.forEach(e=>this.items.delete(e))}async close(){}}}),define(t[117],i([0,1,5,9,33,6,25]),function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SQLiteStorageDatabase=void 0;class a{constructor(e,t=Object.create(null)){this.path=e,this.options=t,this.name=s.basename(this.path),this.logger=new c(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return i.Event.None}async getItems(){const e=await this.whenConnected,t=new Map;return(await this.all(e,"SELECT * FROM ItemTable")).forEach(e=>t.set(e.key,e.value)),
this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${t.size} rows`),t}async updateItems(e){const t=await this.whenConnected;return this.doUpdateItems(t,e)}doUpdateItems(e,t){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${t.insert?n.mapToString(t.insert):"0"}), delete(${t.delete?n.setToString(t.delete):"0"})`),this.transaction(e,()=>{const i=t.insert,r=t.delete;if(i&&i.size>0){const t=[];t.push([]);let r=0;i.forEach((e,i)=>{let n=t[r];n.length>a.MAX_HOST_PARAMETERS&&(r++,n=[],t.push(n)),n.push(i,e)}),t.forEach(t=>{this.prepare(e,`INSERT INTO ItemTable VALUES ${new Array(t.length/2).fill("(?,?)").join(",")}`,e=>e.run(t),()=>{const e=[];let t=0;return i.forEach((i,r)=>{e.push(r),t+=i.length}),`Keys: ${e.join(", ")} Length: ${t}`})})}if(r&&r.size){const t=[];t.push([]);let i=0;r.forEach(e=>{let r=t[i];r.length>a.MAX_HOST_PARAMETERS&&(i++,r=[],t.push(r)),r.push(e)}),t.forEach(t=>{
this.prepare(e,`DELETE FROM ItemTable WHERE key IN (${new Array(t.length).fill("?").join(",")})`,e=>e.run(t),()=>{const e=[];return r.forEach(t=>{e.push(t)}),`Keys: ${e.join(", ")}`})})}})}async close(e){this.logger.trace(`[storage ${this.name}] close()`);const t=await this.whenConnected;return this.doClose(t,e)}doClose(e,t){return new Promise((i,r)=>{e.db.close(n=>(n&&this.handleSQLiteError(e,`[storage ${this.name}] close(): ${n}`),this.path===a.IN_MEMORY_PATH?i():e.isErroneous||e.isInMemory?"function"==typeof t?o.unlink(this.path).then(()=>this.doConnect(this.path).then(e=>{const i=()=>this.doClose(e,void 0);return this.doUpdateItems(e,{insert:t()}).then(()=>i(),e=>(i(),Promise.reject(e)))})).then(i,r):r(n||new Error("Database has errors or is in-memory without recovery option")):this.backup().then(i,e=>(this.logger.error(`[storage ${this.name}] backup(): ${e}`),i()))))})}backup(){const e=this.toBackupPath(this.path);return o.copy(this.path,e)}toBackupPath(e){return`${e}.backup`}async checkIntegrity(e){
this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${e})`);const t=await this.whenConnected,i=await this.get(t,e?"PRAGMA integrity_check":"PRAGMA quick_check"),r=e?i.integrity_check:i.quick_check;return t.isErroneous?`${r} (last error: ${t.lastError})`:t.isInMemory?`${r} (in-memory!)`:r}async connect(e,t=!0){this.logger.trace(`[storage ${this.name}] open(${e}, retryOnBusy: ${t})`);try{return await this.doConnect(e)}catch(i){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${i}`),"SQLITE_BUSY"===i.code&&t)return await r.timeout(a.BUSY_OPEN_TIMEOUT),this.connect(e,!1);try{return await o.unlink(e),await o.renameIgnoreError(this.toBackupPath(e),e),await this.doConnect(e)}catch(e){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${e}`),this.doConnect(a.IN_MEMORY_PATH)}}}handleSQLiteError(e,t){e.isErroneous=!0,e.lastError=t,this.logger.error(t)}doConnect(t){return new Promise((i,r)=>{new Promise((t,i)=>{e(["vscode-sqlite3"],t,i)
}).then(e=>{const n={db:new(this.logger.isTracing?e.verbose().Database:e.Database)(t,e=>e?n.db?n.db.close(()=>r(e)):r(e):this.exec(n,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>i(n),e=>n.db.close(()=>r(e)))),isInMemory:t===a.IN_MEMORY_PATH};n.db.on("error",e=>this.handleSQLiteError(n,`[storage ${this.name}] Error (event): ${e}`)),this.logger.isTracing&&n.db.on("trace",e=>this.logger.trace(`[storage ${this.name}] Trace (event): ${e}`))},r)})}exec(e,t){return new Promise((i,r)=>{e.db.exec(t,t=>t?(this.handleSQLiteError(e,`[storage ${this.name}] exec(): ${t}`),r(t)):i())})}get(e,t){return new Promise((i,r)=>{e.db.get(t,(t,n)=>t?(this.handleSQLiteError(e,`[storage ${this.name}] get(): ${t}`),r(t)):i(n))})}all(e,t){return new Promise((i,r)=>{e.db.all(t,(t,n)=>t?(this.handleSQLiteError(e,`[storage ${this.name}] all(): ${t}`),r(t)):i(n))})}transaction(e,t){return new Promise((i,r)=>{e.db.serialize(()=>{
e.db.run("BEGIN TRANSACTION"),t(),e.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(e,`[storage ${this.name}] transaction(): ${t}`),r(t)):i())})})}prepare(e,t,i,r){const n=e.db.prepare(t),s=i=>{this.handleSQLiteError(e,`[storage ${this.name}] prepare(): ${i} (${t}). Details: ${r()}`)};n.on("error",s),i(n),n.finalize(e=>{e&&s(e),n.removeListener("error",s)})}}t.SQLiteStorageDatabase=a,a.IN_MEMORY_PATH=":memory:",a.BUSY_OPEN_TIMEOUT=2e3,a.MAX_HOST_PARAMETERS=256;class c{constructor(e){e&&"function"==typeof e.logTrace&&(this.logTrace=e.logTrace),e&&"function"==typeof e.logError&&(this.logError=e.logError)}get isTracing(){return!!this.logTrace}trace(e){this.logTrace&&this.logTrace(e)}error(e){this.logError&&this.logError(e)}}}),define(t[118],i([13,12]),function(e,t){return e.create("vs/base/common/date",t)}),define(t[119],i([0,1,118]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const r=60,n=60*r,s=24*n,o=7*s,a=30*s,c=365*s
;t.fromNow=function e(t,l){"number"!=typeof t&&(t=t.getTime());const d=Math.round(((new Date).getTime()-t)/1e3);if(d<-30)return i.localize(0,null,e((new Date).getTime()+1e3*d,!1));if(d<30)return i.localize(1,null);let u;return d<r?(u=d,l?1===u?i.localize(2,null,u):i.localize(3,null,u):1===u?i.localize(4,null,u):i.localize(5,null,u)):d<n?(u=Math.floor(d/r),l?1===u?i.localize(6,null,u):i.localize(7,null,u):1===u?i.localize(8,null,u):i.localize(9,null,u)):d<s?(u=Math.floor(d/n),l?1===u?i.localize(10,null,u):i.localize(11,null,u):1===u?i.localize(12,null,u):i.localize(13,null,u)):d<o?(u=Math.floor(d/s),l?1===u?i.localize(14,null,u):i.localize(15,null,u):1===u?i.localize(16,null,u):i.localize(17,null,u)):d<a?(u=Math.floor(d/o),l?1===u?i.localize(18,null,u):i.localize(19,null,u):1===u?i.localize(20,null,u):i.localize(21,null,u)):d<c?(u=Math.floor(d/a),l?1===u?i.localize(22,null,u):i.localize(23,null,u):1===u?i.localize(24,null,u):i.localize(25,null,u)):(u=Math.floor(d/c),
l?1===u?i.localize(26,null,u):i.localize(27,null,u):1===u?i.localize(28,null,u):i.localize(29,null,u))},t.toLocalISOString=function(e){return e.getFullYear()+"-"+String(e.getMonth()+1).padStart(2,"0")+"-"+String(e.getDate()).padStart(2,"0")+"T"+String(e.getHours()).padStart(2,"0")+":"+String(e.getMinutes()).padStart(2,"0")+":"+String(e.getSeconds()).padStart(2,"0")+"."+(e.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(t[120],i([13,12]),function(e,t){return e.create("vs/base/common/errorMessage",t)}),define(t[77],i([0,1,120,14,30]),function(e,t,i,r,n){"use strict";function s(e,t){return t&&(e.stack||e.stacktrace)?i.localize(0,null,a(e),o(e.stack)||o(e.stacktrace)):a(e)}function o(e){return Array.isArray(e)?e.join("\n"):e}function a(e){return"string"==typeof e.code&&"number"==typeof e.errno&&"string"==typeof e.syscall?i.localize(1,null,e.message):e.message||i.localize(2,null)}Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0,t.toErrorMessage=function e(t=null,o=!1){
if(!t)return i.localize(3,null);if(Array.isArray(t)){const r=n.coalesce(t),s=e(r[0],o);return r.length>1?i.localize(4,null,s,r.length):s}if(r.isString(t))return t;if(t.detail){const e=t.detail;if(e.error)return s(e.error,o);if(e.exception)return s(e.exception,o)}return t.stack?s(t,o):t.message?t.message:i.localize(5,null)}}),define(t[121],i([13,12]),function(e,t){return e.create("vs/base/common/keybindingLabels",t)}),define(t[122],i([0,1,121]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserSettingsLabelProvider=t.ElectronAcceleratorLabelProvider=t.AriaLabelProvider=t.UILabelProvider=t.ModifierLabelProvider=void 0;class r{constructor(e,t,i=t){this.modifierLabels=[null],this.modifierLabels[2]=e,this.modifierLabels[1]=t,this.modifierLabels[3]=i}toLabel(e,t,i){if(0===t.length)return null;const r=[];for(let s=0,o=t.length;s<o;s++){const o=t[s],a=i(o);if(null===a)return null;r[s]=n(o,a,this.modifierLabels[e])}return r.join(" ")}}function n(e,t,i){if(null===t)return"";const r=[]
;return e.ctrlKey&&r.push(i.ctrlKey),e.shiftKey&&r.push(i.shiftKey),e.altKey&&r.push(i.altKey),e.metaKey&&r.push(i.metaKey),""!==t&&r.push(t),r.join(i.separator)}t.ModifierLabelProvider=r,t.UILabelProvider=new r({ctrlKey:"⌃",shiftKey:"⇧",altKey:"⌥",metaKey:"⌘",separator:""},{ctrlKey:i.localize(0,null),shiftKey:i.localize(1,null),altKey:i.localize(2,null),metaKey:i.localize(3,null),separator:"+"},{ctrlKey:i.localize(4,null),shiftKey:i.localize(5,null),altKey:i.localize(6,null),metaKey:i.localize(7,null),separator:"+"}),t.AriaLabelProvider=new r({ctrlKey:i.localize(8,null),shiftKey:i.localize(9,null),altKey:i.localize(10,null),metaKey:i.localize(11,null),separator:"+"},{ctrlKey:i.localize(12,null),shiftKey:i.localize(13,null),altKey:i.localize(14,null),metaKey:i.localize(15,null),separator:"+"},{ctrlKey:i.localize(16,null),shiftKey:i.localize(17,null),altKey:i.localize(18,null),metaKey:i.localize(19,null),separator:"+"}),t.ElectronAcceleratorLabelProvider=new r({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",
metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),t.UserSettingsLabelProvider=new r({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"})}),define(t[123],i([13,12]),function(e,t){return e.create("vs/base/node/processes",t)}),define(t[78],i([0,1,6,24,67,47,123,14,41,28,3,74,10]),function(e,t,i,r,n,s,o,a,c,l,d,u,h){"use strict";function p(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(e=process.env){return e.comspec||"cmd.exe"}Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,t.getWindowsShell=f;class g{constructor(e,t,i,r){if(void 0!==t&&void 0!==i&&void 0!==r)this.cmd=e,this.args=t,this.shell=i,this.options=r;else{const t=e
;this.cmd=t.command,this.shell=t.isShellCommand,this.args=t.args.slice(0),this.options=t.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const e=Object.create(null);Object.keys(process.env).forEach(t=>{e[t]=process.env[t]}),Object.keys(this.options.env).forEach(t=>{e[t]=this.options.env[t]}),this.options.env=e}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const t=e.lastIndexOf(i.sep);return-1!==t&&(e=e.substring(t+1)),g.WellKnowCommands[e]?e:"other"}start(e){return d.isWindows&&(this.options&&this.options.cwd&&l.isUNC(this.options.cwd)||!this.options&&l.isUNC(process.cwd()))?Promise.reject(new Error(o.localize(0,null))):this.useExec().then(t=>{let i,r;const n=new Promise((e,t)=>{i=e,r=t});if(t){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=s.exec(t,this.options,(t,n,s)=>{this.childProcess=null;t&&t.killed?r({killed:this.terminateRequested,stdout:n.toString(),stderr:s.toString()}):this.handleExec(i,e,t,n,s)})
}else{let t=null;const n=t=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(t,i,e,r);const n={terminated:this.terminateRequested};a.isNumber(t)&&(n.cmdCode=t),i(n)};if(this.shell&&d.isWindows){const e=c.deepClone(this.options);e.windowsVerbatimArguments=!0,e.detached=!1;let i=!1,r=!1;const n=[];let o=this.ensureQuotes(this.cmd);n.push(o.value),i=o.quoted,this.args&&this.args.forEach(e=>{o=this.ensureQuotes(e),n.push(o.value),r=r&&o.quoted});const a=["/s","/c"];i?r?a.push('"'+n.join(" ")+'"'):n.length>1?a.push('"'+n[0]+'" '+n.slice(1).join(" ")):a.push('"'+n[0]+'"'):a.push(n.join(" ")),t=s.spawn(f(),a,e)}else this.cmd&&(t=s.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(a.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",e=>{this.childProcess=null,r({terminated:this.terminateRequested,error:e})}),t.pid&&(this.childProcess.on("close",n),this.handleSpawn(t,i,e,r,!0)))}return n})}
handleClose(e,t,i,r){}ensureQuotes(e){return g.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&'"'===e[0]&&'"'===e[e.length-1]}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,function(t,i){if(d.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};i&&(e.cwd=i);const r=s.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise(e=>{r.once("error",t=>{e({success:!1,error:t})}),r.once("exit",(t,i)=>{e(0===t?{success:!0}:{success:!1,code:null!==t?t:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?p(e.status):1})}else if(d.isLinux||d.isMacintosh)try{const i=h.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",e).fsPath;return new Promise(e=>{s.execFile(i,[t.pid.toString()],{encoding:"utf8",shell:!0},(t,i,r)=>{e(t?{success:!1,error:t}:{success:!0})})})}catch(e){
return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}(t,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!d.isWindows)return e(!1);const t=s.spawn(f(),["/s","/c"]);t.on("error",t=>e(!0)),t.on("exit",t=>e(!1))})}}t.AbstractProcess=g,g.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},g.regexp=/^[^"].* .*[^"]/;t.LineProcess=class extends g{constructor(e,t,i,r){super(e,t,i,r),this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,t,i,r,n){[r,n].forEach((e,i)=>{const r=new u.LineDecoder;r.write(e).forEach(e=>{t({line:e,source:0===i?0:1})});const n=r.end();n&&t({line:n,source:0===i?0:1})}),e({terminated:this.terminateRequested,error:i})}handleSpawn(e,t,i,r,n){const s=new u.LineDecoder,o=new u.LineDecoder
;e.stdout.on("data",e=>{s.write(e).forEach(e=>i({line:e,source:0}))}),e.stderr.on("data",e=>{o.write(e).forEach(e=>i({line:e,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=o}handleClose(e,t,i,r){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&i({line:s,source:1})}},t.createQueuedSender=function(e){let t=[],i=!1;const r=function(n){if(i)return void t.push(n);e.send(n,e=>{if(e&&console.error(e),i=!1,t.length>0){const e=t.slice(0);t=[],e.forEach(e=>r(e))}})&&!d.isWindows||(i=!0)};return{send:r}},function(e){e.findExecutable=async function(e,t,s){if(i.isAbsolute(e))return e;if(void 0===t&&(t=process.cwd()),"."!==i.dirname(e))return i.join(t,e);if(void 0===s&&a.isString(process.env.PATH)&&(s=process.env.PATH.split(i.delimiter)),void 0===s||0===s.length)return i.join(t,e);async function o(e){return!!await n.promisify(r.exists)(e)&&!(await n.promisify(r.stat)(e)).isDirectory()}for(let r of s){
let n;if(n=i.isAbsolute(r)?i.join(r,e):i.join(t,r,e),await o(n))return n;let s=n+".com";if(await o(s))return s;if(s=n+".exe",await o(s))return s}return i.join(t,e)}}(t.win32||(t.win32={}))}),define(t[124],i([0,1,27,3,78]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShell=void 0,t.getSystemShell=function(e,t=process.env){return 3===e?r.isWindows?function(e){if(!o){const t=r.isWindows&&parseFloat(i.release())>=10,s=e.hasOwnProperty("PROCESSOR_ARCHITEW6432"),a=`${e.windir}\\${s?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;o=t?a:n.getWindowsShell(e)}return o}(t):n.getWindowsShell(t):r.isLinux&&1===e||r.isMacintosh&&2===e?"/bin/bash":function(e){if(!s){let t;if(r.isWindows)t="/bin/bash";else{if(!(t=e.SHELL))try{t=i.userInfo().shell}catch(e){}t||(t="sh"),"/bin/false"===t&&(t="/bin/bash")}s=t}return s}(t)};let s=null;let o=null}),define(t[79],i([0,1,47,2,9,41,5,78,35,103,22,19,23,3]),function(e,t,i,r,n,s,o,a,c,l,d,u,h,p){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;t.Server=class extends c.ChannelServer{constructor(e){super({send:e=>{try{process.send&&process.send(e.buffer.toString("base64"))}catch(e){}},onMessage:o.Event.fromNodeEventEmitter(process,"message",e=>h.VSBuffer.wrap(Buffer.from(e,"base64")))},e),process.once("disconnect",()=>this.dispose())}};t.Client=class{constructor(e,t){this.modulePath=e,this.options=t,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new o.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const i=t&&t.timeout?t.timeout:6e4;this.disposeDelayer=new n.Delayer(i),this.child=null,this._client=null}getChannel(e){const t=this;return{call:(i,r,n)=>t.requestPromise(e,i,r,n),listen:(i,r)=>t.requestEvent(e,i,r)}}requestPromise(e,t,i,s=d.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(u.canceled());this.disposeDelayer.cancel()
;const o=this.getCachedChannel(e),a=n.createCancelablePromise(e=>o.call(t,i,e)),c=s.onCancellationRequested(()=>a.cancel()),l=r.toDisposable(()=>a.cancel());return this.activeRequests.add(l),a.finally(()=>{c.dispose(),this.activeRequests.delete(l),0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(e,t,i){if(!this.disposeDelayer)return o.Event.None;let r;this.disposeDelayer.cancel();const n=new o.Emitter({onFirstListenerAdd:()=>{const s=this.getCachedChannel(e).listen(t,i);r=s(n.fire,n),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return n.event}get client(){if(!this._client){const e=this.options&&this.options.args?this.options.args:[],t=Object.create(null);t.env=Object.assign(Object.assign({},s.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),
this.options&&this.options.env&&(t.env=Object.assign(Object.assign({},t.env),this.options.env)),this.options&&this.options.freshExecArgv&&(t.execArgv=[]),this.options&&"number"==typeof this.options.debug&&(t.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&"number"==typeof this.options.debugBrk&&(t.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.isMacintosh&&t.env&&delete t.env.DYLD_LIBRARY_PATH,this.child=i.fork(this.modulePath,e,t);const n=new o.Emitter;o.Event.fromNodeEventEmitter(this.child,"message",e=>e)(e=>{l.isRemoteConsoleLog(e)?l.log(e,`IPC Library: ${this.options.serverName}`):n.fire(h.VSBuffer.wrap(Buffer.from(e,"base64")))});const d=this.options.useQueue?a.createQueuedSender(this.child):this.child,u={send:e=>this.child&&this.child.connected&&d.send(e.buffer.toString("base64")),onMessage:n.event};this._client=new c.ChannelClient(u);const f=()=>this.disposeClient();process.once("exit",f),
this.child.on("error",e=>console.warn('IPC "'+this.options.serverName+'" errored with '+e)),this.child.on("exit",(e,t)=>{process.removeListener("exit",f),this.activeRequests.forEach(e=>r.dispose(e)),this.activeRequests.clear(),0!==e&&"SIGTERM"!==t&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+e+" and signal "+t),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:e,signal:t})})}return this._client}getCachedChannel(e){let t=this.channels.get(e);return t||(t=this.client.getChannel(e),this.channels.set(e,t)),t}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}}),define(t[125],i([13,12]),function(e,t){return e.create("vs/code/electron-main/app",t)}),define(t[126],i([13,12]),function(e,t){
return e.create("vs/code/electron-main/window",t)}),define(t[127],i([13,12]),function(e,t){return e.create("vs/platform/configuration/common/configurationRegistry",t)}),define(t[128],i([13,12]),function(e,t){return e.create("vs/platform/dialogs/electron-main/dialogMainService",t)}),define(t[129],i([13,12]),function(e,t){return e.create("vs/platform/environment/node/argv",t)}),define(t[130],i([13,12]),function(e,t){return e.create("vs/platform/environment/node/argvHelper",t)}),define(t[131],i([13,12]),function(e,t){return e.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(t[132],i([13,12]),function(e,t){return e.create("vs/platform/extensions/common/extensionValidator",t)}),define(t[133],i([13,12]),function(e,t){return e.create("vs/platform/files/common/fileService",t)}),define(t[134],i([13,12]),function(e,t){return e.create("vs/platform/files/common/files",t)}),define(t[135],i([13,12]),function(e,t){return e.create("vs/platform/files/common/io",t)}),
define(t[136],i([13,12]),function(e,t){return e.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(t[137],i([13,12]),function(e,t){return e.create("vs/platform/issue/electron-main/issueMainService",t)}),define(t[138],i([13,12]),function(e,t){return e.create("vs/platform/menubar/electron-main/menubar",t)}),define(t[139],i([13,12]),function(e,t){return e.create("vs/platform/request/common/request",t)}),define(t[140],i([13,12]),function(e,t){return e.create("vs/platform/telemetry/common/telemetryService",t)}),define(t[141],i([13,12]),function(e,t){return e.create("vs/platform/update/common/update.config.contribution",t)}),define(t[142],i([13,12]),function(e,t){return e.create("vs/platform/windows/electron-main/windowsMainService",t)}),define(t[143],i([13,12]),function(e,t){return e.create("vs/platform/workspaces/common/workspaces",t)}),define(t[144],i([13,12]),function(e,t){return e.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",t)}),
define(t[145],i([13,12]),function(e,t){return e.create("vs/platform/workspaces/electron-main/workspacesMainService",t)}),define(t[80],i([0,1,5,2]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionHostDebugChannelClient=t.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this._onCloseEmitter=new i.Emitter,this._onReloadEmitter=new i.Emitter,this._onTerminateEmitter=new i.Emitter,this._onAttachEmitter=new i.Emitter}call(e,t,i){switch(t){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:i[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:i[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:i[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:i[0],port:i[1],subId:i[2]}))}throw new Error("Method not implemented.")}listen(e,t,i){switch(t){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event
;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}t.ExtensionHostDebugBroadcastChannel=n,n.ChannelName="extensionhostdebugservice";t.ExtensionHostDebugChannelClient=class extends r.Disposable{constructor(e){super(),this.channel=e}reload(e){this.channel.call("reload",[e])}get onReload(){return this.channel.listen("reload")}close(e){this.channel.call("close",[e])}get onClose(){return this.channel.listen("close")}attachSession(e,t,i){this.channel.call("attach",[e,t,i])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(e,t){this.channel.call("terminate",[e,t])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(e,t,i){return this.channel.call("openExtensionDevelopmentHostWindow",[e,t,i])}}}),define(t[81],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isRemoteDiagnosticError=void 0,
t.isRemoteDiagnosticError=function(e){return!!e.hostName&&!!e.errorMessage}}),define(t[58],i([0,1,230,129,3]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildVersionMessage=t.buildHelpMessage=t.formatOptions=t.parseArgs=t.OPTIONS=void 0;const s={o:r.localize(0,null),e:r.localize(1,null),t:r.localize(2,null)};t.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:r.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:r.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:r.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:r.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:r.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:r.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:r.localize(9,null)},"user-data-dir":{type:"string",cat:"o",
args:"dir",description:r.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:r.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:r.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:r.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:r.localize(14,null)},category:{type:"string",cat:"e",description:r.localize(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:r.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:r.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:r.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:r.localize(19,null)},verbose:{type:"boolean",cat:"t",description:r.localize(20,null)},log:{type:"string",cat:"t",
args:"level",description:r.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:r.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:r.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:r.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:r.localize(25,null)},sync:{type:"string",cat:"t",description:r.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:r.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:r.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:r.localize(29,null)},"max-memory":{type:"string",cat:"t",description:r.localize(30,null)},telemetry:{type:"boolean",cat:"t",
description:r.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{
type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const o={onUnknownOption:()=>{},onMultipleValues:()=>{}};function a(e,t){let i=""
;return t.args&&(i=Array.isArray(t.args)?` <${t.args.join("> <")}>`:` <${t.args}>`),t.alias?`-${t.alias} --${e}${i}`:`--${e}${i}`}function c(e,t){let i=0,r=[];for(const t in e){const n=e[t],s=a(t,n);i=Math.max(i,s.length),r.push([s,n.description])}let n=i+2+1;if(t-n<25)return r.reduce((e,t)=>e.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let s=t-n-1,o=[];for(const e of r){let t=e[0],i=d(e[1],s),r=l(n-t.length-2);o.push("  "+t+r+i[0]);for(let e=1;e<i.length;e++)o.push(l(n)+i[e])}return o}function l(e){return" ".repeat(e)}function d(e,t){let i=[];for(;e.length;){let r=e.length<t?e.length:e.lastIndexOf(" ",t),n=e.slice(0,r).trim();e=e.slice(r),i.push(n)}return i}t.parseArgs=function(e,t,r=o){const n={},s=[],a=[];for(let e in t){if("_"===e[0])continue;const i=t[e];i.alias&&(n[e]=i.alias),"string"===i.type||"string[]"===i.type?(s.push(e),i.deprecates&&s.push(i.deprecates)):"boolean"===i.type&&(a.push(e),i.deprecates&&a.push(i.deprecates))}const c=i(e,{string:s,boolean:a,alias:n}),l={},d=c
;l._=c._.map(e=>String(e)).filter(e=>e.length>0),delete d._;for(let e in t){const i=t[e];i.alias&&delete d[i.alias];let n=d[e];i.deprecates&&d.hasOwnProperty(i.deprecates)&&(n||(n=d[i.deprecates]),delete d[i.deprecates]),void 0!==n&&("string[]"===i.type?n&&!Array.isArray(n)&&(n=[n]):"string"===i.type&&Array.isArray(n)&&(n=n.pop(),r.onMultipleValues(e,n)),l[e]=n),delete d[e]}for(let e in d)r.onUnknownOption(e);return l},t.formatOptions=c,t.buildHelpMessage=function(e,t,i,o,a=!0){const l=process.stdout.isTTY&&process.stdout.columns||80;let d=[`${e} ${i}`];d.push(""),d.push(`${r.localize(32,null)}: ${t} [${r.localize(33,null)}][${r.localize(34,null)}...]`),d.push(""),a&&(n.isWindows?d.push(r.localize(35,null,t)):d.push(r.localize(36,null,t)),d.push(""));const u={};for(const e in o){const t=o[e];if(t.description&&t.cat){let i=u[t.cat];i||(u[t.cat]=i={}),i[e]=t}}for(let e in u){const t=e;let i=u[t];i&&(d.push(s[t]),d.push(...c(i,l)),d.push(""))}return d.join("\n")},t.buildVersionMessage=function(e,t){
return`${e||r.localize(37,null)}\n${t||r.localize(38,null)}\n${process.arch}`}}),define(t[146],i([0,1,58,57,80]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronExtensionHostDebugBroadcastChannel=void 0;t.ElectronExtensionHostDebugBroadcastChannel=class extends n.ExtensionHostDebugBroadcastChannel{constructor(e){super(),this.windowsMainService=e}call(e,t,i){return"openExtensionDevelopmentHostWindow"===t?this.openExtensionDevelopmentHostWindow(i[0],i[1],i[2]):super.call(e,t,i)}async openExtensionDevelopmentHostWindow(e,t,n){const s=i.parseArgs(e,i.OPTIONS);s.debugRenderer=n;const o=s.extensionDevelopmentPath;if(!o)return{};const[a]=this.windowsMainService.openExtensionDevelopmentHostWindow(o,{context:5,cli:s,userEnv:Object.keys(t).length>0?t:void 0});if(!n)return{};const c=a.win.webContents.debugger;let l=c.isAttached()?1/0:0;const d=r.createServer(e=>{0==l++&&c.attach();let t=!1;const i=i=>{t||e.write(JSON.stringify(i)+"\0")},r=(e,t,r,n)=>i({method:t,params:r,
sessionId:n});a.win.on("close",()=>{c.removeListener("message",r),e.end(),t=!0}),c.addListener("message",r);let n=Buffer.alloc(0);e.on("data",e=>{for(let t=(n=Buffer.concat([n,e])).indexOf(0);-1!==t;t=n.indexOf(0)){let e;try{const i=n.slice(0,t).toString("utf8");n=n.slice(t+1),e=JSON.parse(i)}catch(e){console.error("error reading cdp line",e)}c.sendCommand(e.method,e.params,e.sessionId).then(t=>i({id:e.id,sessionId:e.sessionId,result:t})).catch(t=>i({id:e.id,sessionId:e.sessionId,error:{code:0,message:t.message}}))}}),e.on("error",e=>{console.error("error on cdp pipe:",e)}),e.on("close",()=>{t=!0,0==--l&&c.detach()})});return await new Promise(e=>d.listen(0,e)),a.win.on("close",()=>d.close()),{rendererDebugPort:d.address().port}}}}),define(t[147],i([0,1,6,27,24]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createWaitMarkerFile=void 0,t.createWaitMarkerFile=function(e){const t=i.join(r.tmpdir(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{
return n.writeFileSync(t,""),e&&console.log(`Marker file for --wait created: ${t}`),t}catch(t){return void(e&&console.error(`Failed to create marker file for --wait: ${t}`))}}}),define(t[148],i([0,1,132]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const r=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function n(e){return"*"===(e=e.trim())||r.test(e)}function s(e){if(!n(e))return null;if("*"===(e=e.trim()))return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let t=e.match(r);return t?{hasCaret:"^"===t[1],hasGreaterEquals:">="===t[1],majorBase:"x"===t[2]?0:parseInt(t[2],10),majorMustEqual:"x"!==t[2],minorBase:"x"===t[4]?0:parseInt(t[4],10),minorMustEqual:"x"!==t[4],patchBase:"x"===t[6]?0:parseInt(t[6],10),patchMustEqual:"x"!==t[6],
preRelease:t[8]||null}:null}function o(e){if(!e)return null;let t=e.majorBase,i=e.majorMustEqual,r=e.minorBase,n=e.minorMustEqual,s=e.patchBase,o=e.patchMustEqual;return e.hasCaret&&(0===t?o=!1:(n=!1,o=!1)),{majorBase:t,majorMustEqual:i,minorBase:r,minorMustEqual:n,patchBase:s,patchMustEqual:o,isMinimum:e.hasGreaterEquals}}function a(e,t){let i,r;if(i="string"==typeof e?o(s(e)):e,r="string"==typeof t?o(s(t)):t,!i||!r)return!1;let n=i.majorBase,a=i.minorBase,c=i.patchBase,l=r.majorBase,d=r.minorBase,u=r.patchBase,h=r.majorMustEqual,p=r.minorMustEqual,f=r.patchMustEqual;return r.isMinimum?n>l||!(n<l)&&(a>d||!(a<d)&&c>=u):(1!==n||0!==l||h&&p&&f||(l=1,d=0,u=0,h=!0,p=!1,f=!1),!(n<l)&&(n>l?!h:!(a<d)&&(a>d?!p:!(c<u)&&(!(c>u)||!f))))}function c(e,t,r=[]){let n=o(s(t));if(!n)return r.push(i.localize(0,null,t)),!1;if(0===n.majorBase){if(!n.majorMustEqual||!n.minorMustEqual)return r.push(i.localize(1,null,t)),!1}else if(!n.majorMustEqual)return r.push(i.localize(2,null,t)),!1
;return!!a(e,n)||(r.push(i.localize(3,null,e,t)),!1)}t.isValidVersionStr=n,t.parseVersion=s,t.normalizeVersion=o,t.isValidVersion=a,t.isValidExtensionVersion=function(e,t,i){return!(!t.isBuiltin&&void 0!==t.main)||c(e,t.engines.vscode,i)},t.isEngineValid=function(e,t){return"*"===e||c(t,e)},t.isVersionValid=c}),define(t[149],i([0,1,35,79,2,10]),function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class o extends n.Disposable{constructor(e,t,i,r){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=r,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const t=this._register(new r.Client(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{
this.isDisposed||(this.restartCounter<=o.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=i.createChannelSender(i.getNextTickChannel(t.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(e=>!this.isDisposed&&this.onDidFilesChange(e))),this._register(this.service.onDidLogMessage(e=>this.onLogMessage(e))),this.setFolders(this.folders)}setVerboseLogging(e){this.verboseLogging=e,!this.isDisposed&&this.service&&this.service.setVerboseLogging(e)}error(e){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${e}`})}setFolders(e){this.folders=e,this.service&&this.service.setRoots(e)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=o,o.MAX_RESTARTS=5}),define(t[150],i([0,1,35,79,2,10]),function(e,t,i,r,n,s){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class o extends n.Disposable{constructor(e,t,i,r,n={}){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=r,this.watcherOptions=n,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const t=this._register(new r.Client(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=o.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=i.createChannelSender(i.getNextTickChannel(t.getChannel("watcher"))),
this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(e=>!this.isDisposed&&this.onDidFilesChange(e))),this._register(this.service.onDidLogMessage(e=>this.onLogMessage(e))),this.service.setRoots(this.folders)}error(e){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${e}`})}setVerboseLogging(e){this.verboseLogging=e,this.service&&this.service.setVerboseLogging(e)}setFolders(e){this.folders=e,this.service&&this.service.setRoots(e)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=o,o.MAX_RESTARTS=5}),define(t[151],i([0,1,47,74,73,10]),function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class o{constructor(e,t,i,r,s){this.watchedFolder=e,this.eventCallback=i,this.logCallback=r,this.verboseLogging=s,this.restartCounter=0,Array.isArray(t)?this.ignored=t.map(e=>n.parse(e)):this.ignored=[],
this.verboseLogging&&this.log(`Start watching: ${e}`),this.startWatcher()}startWatcher(){const t=[this.watchedFolder];this.verboseLogging&&t.push("-verbose"),this.handle=i.spawn(s.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",e).fsPath,t);const n=new r.LineDecoder;this.handle.stdout.on("data",e=>{const t=[];n.write(e).forEach(e=>{const i=e.split("|");if(2===i.length){const e=Number(i[0]),r=i[1];if(e>=0&&e<3){if(this.ignored&&this.ignored.some(e=>e(r)))return void(this.verboseLogging&&this.log(r));t.push({type:o.changeTypeMap[e],path:r})}else this.log(i[1])}}),t.length>0&&this.eventCallback(t)}),this.handle.on("error",e=>this.onError(e)),this.handle.stderr.on("data",e=>this.onError(e)),this.handle.on("exit",(e,t)=>this.onExit(e,t))}onError(e){this.error("process error: "+e.toString())}onExit(e,t){this.handle&&(this.error(`terminated unexpectedly (code: ${e}, signal: ${t})`),this.restartCounter<=o.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,
this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(e){this.logCallback({type:"error",message:`[File Watcher (C#)] ${e}`})}log(e){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${e}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=o,o.MAX_RESTARTS=5,o.changeTypeMap=[0,1,2]}),define(t[152],i([0,1,151,6,16]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;t.FileWatcher=class{constructor(e,t,i,s){this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=s,this.service=void 0,this.folder=e[0],0===this.folder.path.indexOf("\\\\")&&this.folder.path.endsWith(r.posix.sep)&&(this.folder.path=n.rtrim(this.folder.path,r.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){
return new i.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,e=>this.onFileEvents(e),e=>this.onLogMessage(e),this.verboseLogging)}setVerboseLogging(e){this.verboseLogging=e,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(e){this.isDisposed||e.length>0&&this.onDidFilesChange(e)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}}),define(t[68],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class i{constructor(e,t=[],i=!1){this.ctor=e,this.staticArguments=t,this.supportsDelayedInstantiation=i}}t.SyncDescriptor=i;t.createSyncDescriptor=(e,...t)=>new i(e,t)}),define(t[153],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class i{constructor(e){this.incoming=new Map,this.outgoing=new Map,this.data=e}}t.Node=i;t.Graph=class{constructor(e){this._hashFn=e,this._nodes=new Map}roots(){const e=[]
;for(let t of this._nodes.values())0===t.outgoing.size&&e.push(t);return e}insertEdge(e,t){const i=this.lookupOrInsertNode(e),r=this.lookupOrInsertNode(t);i.outgoing.set(this._hashFn(t),r),r.incoming.set(this._hashFn(e),i)}removeNode(e){const t=this._hashFn(e);this._nodes.delete(t);for(let e of this._nodes.values())e.outgoing.delete(t),e.incoming.delete(t)}lookupOrInsertNode(e){const t=this._hashFn(e);let r=this._nodes.get(t);return r||(r=new i(e),this._nodes.set(t,r)),r}lookup(e){return this._nodes.get(this._hashFn(e))}isEmpty(){return 0===this._nodes.size}toString(){let e=[];for(let[t,i]of this._nodes)e.push(`${t}, (incoming)[${[...i.incoming.keys()].join(", ")}], (outgoing)[${[...i.outgoing.keys()].join(",")}]`);return e.join("\n")}}}),define(t[4],i([0,1]),function(e,t){"use strict";var i;function r(e,t,r,n){t[i.DI_TARGET]===t?t[i.DI_DEPENDENCIES].push({id:e,index:r,optional:n}):(t[i.DI_DEPENDENCIES]=[{id:e,index:r,optional:n}],t[i.DI_TARGET]=t)}function n(e){
if(i.serviceIds.has(e))return i.serviceIds.get(e);const t=function(e,i,n){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(t,e,n,!1)};return t.toString=()=>e,i.serviceIds.set(e,t),t}Object.defineProperty(t,"__esModule",{value:!0}),t.optional=t.createDecorator=t.IInstantiationService=t._util=void 0,function(e){e.serviceIds=new Map,e.DI_TARGET="$di$target",e.DI_DEPENDENCIES="$di$dependencies",e.getServiceDependencies=function(t){return t[e.DI_DEPENDENCIES]||[]}}(i=t._util||(t._util={})),t.IInstantiationService=n("instantiationService"),t.createDecorator=n,t.optional=function(e){return function(t,i,n){if(3!==arguments.length)throw new Error("@optional-decorator can only be used to decorate a parameter");r(e,t,n,!0)}}}),define(t[154],i([0,1,4,5,2,11,9]),function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisplayMainService=t.IDisplayMainService=void 0,t.IDisplayMainService=i.createDecorator("displayMainService")
;t.DisplayMainService=class extends n.Disposable{constructor(){super(),this._onDidDisplayChanged=this._register(new r.Emitter),this.onDidDisplayChanged=this._onDidDisplayChanged.event;const e=this._register(new o.RunOnceScheduler(()=>{this._onDidDisplayChanged.fire()},100));s.app.whenReady().then(()=>{const t=(t,i,r)=>{e.schedule()};s.screen.on("display-metrics-changed",t),this._register(n.toDisposable(()=>s.screen.removeListener("display-metrics-changed",t))),s.screen.on("display-added",t),this._register(n.toDisposable(()=>s.screen.removeListener("display-added",t))),s.screen.on("display-removed",t),this._register(n.toDisposable(()=>s.screen.removeListener("display-removed",t)))})}}}),define(t[82],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EncryptionMainService=t.IEncryptionMainService=void 0,t.IEncryptionMainService=i.createDecorator("encryptionMainService");t.EncryptionMainService=class{constructor(e){this.machineId=e}encryption(){
return new Promise((t,i)=>e(["vscode-encrypt"],t,i))}async encrypt(e){try{return(await this.encryption()).encrypt(this.machineId,e)}catch(t){return e}}async decrypt(e){try{return(await this.encryption()).decrypt(this.machineId,e)}catch(t){return e}}}}),define(t[52],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=i.createDecorator("environmentService"),t.INativeEnvironmentService=i.createDecorator("nativeEnvironmentService")}),define(t[155],i([0,1,131,4,10]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",
e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=5]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"}(t.SortBy||(t.SortBy={})),function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"}(t.SortOrder||(t.SortOrder={})),function(e){e.Uninstall="uninstall"}(t.StatisticType||(t.StatisticType={})),function(e){e[e.None=0]="None",e[e.Install=1]="Install",e[e.Update=2]="Update"}(t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=r.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";t.ExtensionManagementError=class extends Error{constructor(e,t){super(e),this.code=t}},t.IExtensionManagementService=r.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",
t.IGlobalExtensionEnablementService=r.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=r.createDecorator("IExtensionTipsService"),t.DefaultIconPath=n.FileAccess.asBrowserUri("./media/defaultIcon.png",e).toString(!0),t.ExtensionsLabel=i.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=i.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"}}),define(t[156],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionUrlTrustService=void 0,t.IExtensionUrlTrustService=i.createDecorator("extensionUrlTrustService")}),define(t[157],i([0,1,16,4]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"],function(e){e[e.System=0]="System",e[e.User=1]="User"}(t.ExtensionType||(t.ExtensionType={}));t.ExtensionIdentifier=class{constructor(e){this.value=e,this._lower=e.toLowerCase()}static equals(e,t){if(null==e)return null==t;if(null==t)return!1
;if("string"==typeof e||"string"==typeof t){let r="string"==typeof e?e:e.value,n="string"==typeof t?t:t.value;return i.equalsIgnoreCase(r,n)}return e._lower===t._lower}static toKey(e){return"string"==typeof e?e.toLowerCase():e._lower}},t.isLanguagePackExtension=function(e){return!(!e.contributes||!e.contributes.localizations)&&e.contributes.localizations.length>0},t.isAuthenticaionProviderExtension=function(e){return!(!e.contributes||!e.contributes.authentication)&&e.contributes.authentication.length>0},t.IBuiltinExtensionsScannerService=r.createDecorator("IBuiltinExtensionsScannerService")}),define(t[158],i([0,1,16,157]),function(e,t,i,r){"use strict";function n(e,t){return e.uuid&&t.uuid?e.uuid===t.uuid:e.id===t.id||0===i.compareIgnoreCase(e.id,t.id)}Object.defineProperty(t,"__esModule",{value:!0}),
t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0,t.areSameExtensions=n;class s{constructor(e,t){this.version=t,this.id=e.id,this.uuid=e.uuid}key(){return`${this.id}-${this.version}`}equals(e){return e instanceof s&&(n(this,e)&&this.version===e.version)}}t.ExtensionIdentifierWithVersion=s,t.adoptToGalleryExtensionId=function(e){return e.toLocaleLowerCase()},t.getGalleryExtensionId=function(e,t){return`${e.toLocaleLowerCase()}.${t.toLocaleLowerCase()}`},t.groupByExtension=function(e,t){const i=[],r=e=>{for(const r of i)if(r.some(i=>n(t(i),t(e))))return r;return null};for(const t of e){const e=r(t);e?e.push(t):i.push([t])}return i},t.getLocalExtensionTelemetryData=function(e){return{id:e.identifier.id,name:e.manifest.name,galleryId:null,publisherId:e.publisherId,publisherName:e.manifest.publisher,
publisherDisplayName:e.publisherDisplayName,dependencies:e.manifest.extensionDependencies&&e.manifest.extensionDependencies.length>0}},t.getGalleryExtensionTelemetryData=function(e){return Object.assign({id:e.identifier.id,name:e.name,galleryId:e.identifier.uuid,publisherId:e.publisherId,publisherName:e.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:!!(e.properties.dependencies&&e.properties.dependencies.length>0)},e.telemetryData)},t.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge"),t.getMaliciousExtensionsSet=function(e){const t=new Set;for(const i of e)i.malicious&&t.add(i.id.id);return t}}),define(t[26],i([0,1,134,6,8,4,16,14,33]),function(e,t,i,r,n,s,o,a,c){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),
t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FileType=t.IFileService=void 0,t.IFileService=s.createDecorator("fileService"),function(e){e[e.Unknown=0]="Unknown",e[e.File=1]="File",e[e.Directory=2]="Directory",e[e.SymbolicLink=64]="SymbolicLink"}(t.FileType||(t.FileType={})),function(e){e[e.FileReadWrite=2]="FileReadWrite",
e[e.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",e[e.FileReadStream=16]="FileReadStream",e[e.FileFolderCopy=8]="FileFolderCopy",e[e.PathCaseSensitive=1024]="PathCaseSensitive",e[e.Readonly=2048]="Readonly",e[e.Trash=4096]="Trash"}(t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={})),t.hasReadWriteCapability=function(e){return!!(2&e.capabilities)},t.hasFileFolderCopyCapability=function(e){return!!(8&e.capabilities)},t.hasOpenReadWriteCloseCapability=function(e){return!!(4&e.capabilities)},t.hasFileReadStreamCapability=function(e){return!!(16&e.capabilities)},function(e){e.FileExists="EntryExists",e.FileNotFound="EntryNotFound",e.FileNotADirectory="EntryNotADirectory",e.FileIsADirectory="EntryIsADirectory",e.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",e.FileTooLarge="EntryTooLarge",e.NoPermissions="NoPermissions",e.Unavailable="Unavailable",e.Unknown="Unknown"}(l=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class d extends Error{constructor(e,t){super(e),
this.code=t}}function u(e,t){const i=new d(e.toString(),t);return h(i,t),i}function h(e,t){return e.name=t?`${t} (FileSystemError)`:"FileSystemError",e}function p(e){if(!e)return l.Unknown;if(e instanceof d)return e.code;const t=/^(.+) \(FileSystemError\)$/.exec(e.name);if(!t)return l.Unknown;switch(t[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}t.FileSystemProviderError=d,t.createFileSystemProviderError=u,t.ensureFileSystemProviderError=function(e){return e||u(i.localize(0,null),l.Unknown)},t.markAsFileSystemProviderError=h,t.toFileSystemProviderErrorCode=p,t.toFileOperationResult=function(e){if(e instanceof g)return e.fileOperationResult;switch(p(e)){
case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}},function(e){e[e.CREATE=0]="CREATE",e[e.DELETE=1]="DELETE",e[e.MOVE=2]="MOVE",e[e.COPY=3]="COPY"}(t.FileOperation||(t.FileOperation={}));t.FileOperationEvent=class{constructor(e,t,i){this.resource=e,this.operation=t,this.target=i}isOperation(e){return this.operation===e}},function(e){e[e.UPDATED=0]="UPDATED",e[e.ADDED=1]="ADDED",e[e.DELETED=2]="DELETED"}(t.FileChangeType||(t.FileChangeType={}));class f{constructor(e,t){this.ignorePathCasing=t,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=e;for(const t of e)switch(t.type){case 1:this.added||(this.added=c.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(t.resource,t);break;case 0:this.updated||(this.updated=c.TernarySearchTree.forUris(()=>this.ignorePathCasing)),
this.updated.set(t.resource,t);break;case 2:this.deleted||(this.deleted=c.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(t.resource,t)}}contains(e,...t){return this.doContains(e,{includeChildren:!1},...t)}affects(e,...t){return this.doContains(e,{includeChildren:!0},...t)}doContains(e,t,...i){var r,n,s,o,a,c;if(!e)return!1;const l=i.length>0;if(!l||i.includes(1)){if(null===(r=this.added)||void 0===r?void 0:r.get(e))return!0;if(t.includeChildren&&(null===(n=this.added)||void 0===n?void 0:n.findSuperstr(e)))return!0}if(!l||i.includes(0)){if(null===(s=this.updated)||void 0===s?void 0:s.get(e))return!0;if(t.includeChildren&&(null===(o=this.updated)||void 0===o?void 0:o.findSuperstr(e)))return!0}if(!l||i.includes(2)){if(null===(a=this.deleted)||void 0===a?void 0:a.findSubstr(e))return!0;if(t.includeChildren&&(null===(c=this.deleted)||void 0===c?void 0:c.findSuperstr(e)))return!0}return!1}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}
gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(e){const t=[],i=1===e?this.added:0===e?this.updated:this.deleted;if(i)for(const[,e]of i)t.push(e);return t}filter(e){return new f(this.changes.filter(t=>e(t)),this.ignorePathCasing)}}t.FileChangesEvent=f,t.isParent=function(e,t,i){return!(!e||!t||e===t)&&(!(t.length>e.length)&&(t.charAt(t.length-1)!==r.sep&&(t+=r.sep),i?o.startsWithIgnoreCase(e,t):0===e.indexOf(t)))};class g extends Error{constructor(e,t,i){super(e),this.fileOperationResult=t,this.options=i}static isFileOperationError(e){return e instanceof Error&&!a.isUndefinedOrNull(e.fileOperationResult)}}t.FileOperationError=g,function(e){e[e.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",e[e.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",e[e.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",e[e.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",e[e.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",e[e.FILE_READ_ONLY=5]="FILE_READ_ONLY",
e[e.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",e[e.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",e[e.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",e[e.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",e[e.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",e[e.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"}(t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",function(e){e[e.FILE=0]="FILE",e[e.FOLDER=1]="FOLDER",e[e.ROOT_FOLDER=2]="ROOT_FOLDER"}(t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="",t.etag=function(e){if("number"==typeof e.size&&"number"==typeof e.mtime)return e.mtime.toString(29)+e.size.toString(31)},t.whenProviderRegistered=async function(e,t){if(!t.canHandleResource(n.URI.from({scheme:e.scheme
})))return new Promise(i=>{const r=t.onDidChangeFileSystemProviderRegistrations(t=>{t.scheme===e.scheme&&t.added&&(r.dispose(),i())})})},t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class m{static formatSize(e){return a.isNumber(e)||(e=0),e<m.KB?i.localize(1,null,e.toFixed(0)):e<m.MB?i.localize(2,null,(e/m.KB).toFixed(2)):e<m.GB?i.localize(3,null,(e/m.MB).toFixed(2)):e<m.TB?i.localize(4,null,(e/m.GB).toFixed(2)):i.localize(5,null,(e/m.TB).toFixed(2))}}t.ByteSize=m,m.KB=1024,m.MB=m.KB*m.KB,m.GB=m.MB*m.KB,m.TB=m.GB*m.KB}),define(t[53],i([0,1,231,130,26,58]),function(e,t,i,r,n,s){"use strict";function o(e,t){const o={onUnknownOption:e=>{console.warn(r.localize(0,null,e))},onMultipleValues:(e,t)=>{console.warn(r.localize(1,null,e,t))}},a=s.parseArgs(e,s.OPTIONS,t?o:void 0);return a.goto&&a._.forEach(e=>i(/^(\w:)?[^:]+(:\d*){0,2}$/.test(e),r.localize(2,null))),
a["max-memory"]&&i(parseInt(a["max-memory"])>=n.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${n.MIN_MAX_MEMORY_SIZE_MB} MB.`),a}function a(e){return"1"===e.VSCODE_CLI}Object.defineProperty(t,"__esModule",{value:!0}),t.isLaunchedFromCli=t.addArg=t.parseCLIProcessArgv=t.parseMainProcessArgv=void 0,t.parseMainProcessArgv=function(e){let[,...t]=e;return process.env.VSCODE_DEV&&(t=function(e){const t=e.findIndex(e=>!/^-/.test(e));if(t>-1)return[...e.slice(0,t),...e.slice(t+1)]}(t)||[]),o(t,!a(process.env))},t.parseCLIProcessArgv=function(e){const[,,...t]=e;return o(t,!0)},t.addArg=function(e,...t){const i=e.indexOf("--");return-1===i?e.push(...t):e.splice(i,0,...t),e},t.isLaunchedFromCli=a}),define(t[159],i([0,1,47,31,3,53,77,124]),function(e,t,i,r,n,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0,t.resolveShellEnv=async function(e,t,l){
return t["force-disable-user-env"]?(e.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):n.isWindows?(e.trace("resolveShellEnv(): skipped (Windows)"),{}):s.isLaunchedFromCli(l)&&!t["force-user-env"]?(e.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(s.isLaunchedFromCli(l)?e.trace("resolveShellEnv(): running (--force-user-env)"):e.trace("resolveShellEnv(): running (macOS/Linux)"),c||(c=async function(e){const t=new Promise((t,s)=>{const o=process.env.ELECTRON_RUN_AS_NODE;e.trace("getUnixShellEnvironment#runAsNode",o);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;e.trace("getUnixShellEnvironment#noAttach",c);const l=r.generateUuid().replace(/-/g,"").substr(0,12),d=new RegExp(l+"(.*)"+l),u=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),h=`'${process.execPath}' -p '"${l}" + JSON.stringify(process.env) + "${l}"'`;e.trace("getUnixShellEnvironment#env",u),e.trace("getUnixShellEnvironment#spawn",h)
;const p=a.getSystemShell(n.platform),f=i.spawn(p,["-ilc",h],{detached:!0,stdio:["ignore","pipe",process.stderr],env:u}),g=[];f.on("error",()=>t({})),f.stdout.on("data",e=>g.push(e)),f.on("close",i=>{if(0!==i)return s(new Error("Failed to get environment"));const r=Buffer.concat(g).toString("utf8");e.trace("getUnixShellEnvironment#raw",r);const n=d.exec(r),a=n?n[1]:"{}";try{const i=JSON.parse(a);o?i.ELECTRON_RUN_AS_NODE=o:delete i.ELECTRON_RUN_AS_NODE,c?i.ELECTRON_NO_ATTACH_CONSOLE=c:delete i.ELECTRON_NO_ATTACH_CONSOLE,delete i.XDG_RUNTIME_DIR,e.trace("getUnixShellEnvironment#result",i),t(i)}catch(t){e.error("getUnixShellEnvironment#error",t),s(t)}})});try{return await t}catch(t){return e.error("getUnixShellEnvironment#error",o.toErrorMessage(t)),{}}}(e)),c)};let c=void 0}),define(t[83],i([0,1,135,23,26,19]),function(e,t,i,r,n,s){"use strict";function o(e){if(e.isCancellationRequested)throw s.canceled();return!0}function a(e,t){if(null==t?void 0:t.limits){
if("number"==typeof t.limits.memory&&e>t.limits.memory)throw n.createFileSystemProviderError(i.localize(0,null),n.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if("number"==typeof t.limits.size&&e>t.limits.size)throw n.createFileSystemProviderError(i.localize(1,null),n.FileSystemProviderErrorCode.FileTooLarge)}return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0,t.readFileIntoStream=async function(e,t,i,s,c,l){let d=void 0;try{await async function(e,t,i,s,c,l){o(l);const d=await e.open(t,{create:!1});o(l);try{let t=0,u=0,h=c&&"number"==typeof c.length?c.length:void 0,p=r.VSBuffer.alloc(Math.min(c.bufferSize,"number"==typeof h?h:c.bufferSize)),f=c&&"number"==typeof c.position?c.position:0,g=0;do{u=await e.read(d,f,p.buffer,g,p.byteLength-g),f+=u,t+=u,"number"==typeof h&&(h-=u),(g+=u)===p.byteLength&&(await i.write(s(p)),p=r.VSBuffer.alloc(Math.min(c.bufferSize,"number"==typeof h?h:c.bufferSize)),g=0)}while(u>0&&("number"!=typeof h||h>0)&&o(l)&&a(t,c));if(g>0){let e=g
;"number"==typeof h&&(e=Math.min(g,h)),i.write(s(p.slice(0,e)))}}catch(e){throw n.ensureFileSystemProviderError(e)}finally{await e.close(d)}}(e,t,i,s,c,l)}catch(e){d=e}finally{d&&c.errorTransformer&&(d=c.errorTransformer(d)),i.end(d)}}}),define(t[84],i([0,1,8,26,3]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0,t.toFileChanges=function(e){return e.map(e=>({type:e.type,resource:i.URI.file(e.path)}))},t.normalizeFileChanges=function(e){const t=new s;for(const i of e)t.processEvent(i);return t.normalize()};class s{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(e){const t=this.mapPathToChange.get(e.path);if(t){const i=t.type,r=e.type;1===i&&2===r?(this.mapPathToChange.delete(e.path),this.normalized.splice(this.normalized.indexOf(t),1)):2===i&&1===r?t.type=0:1===i&&0===r||(t.type=r)}else this.normalized.push(e),this.mapPathToChange.set(e.path,e)}normalize(){const e=[],t=[]
;return this.normalized.filter(t=>2===t.type||(e.push(t),!1)).sort((e,t)=>e.path.length-t.path.length).filter(e=>!t.some(t=>r.isParent(e.path,t,!n.isLinux))&&(t.push(e.path),!0)).concat(e)}}}),define(t[160],i([0,1,84,2,25,109,111,9,6]),function(e,t,i,r,n,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;t.FileWatcher=class extends r.Disposable{constructor(e,t,i,r){super(),this.path=e,this.onDidFilesChange=t,this.onLogMessage=i,this.verboseLogging=r,this.fileChangesDelayer=this._register(new a.ThrottledDelayer(2*o.CHANGE_BUFFER_DELAY)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(e){this.verboseLogging=e}async startWatching(){try{const{stat:e,symbolicLink:t}=await n.statLink(this.path);if(this.isDisposed)return;let i=this.path;if(t)try{i=await s.realpath(i)}catch(e){this.onError(e)}e.isDirectory()?this._register(o.watchFolder(i,(e,t)=>{this.onFileChange({type:"changed"===e?0:"added"===e?1:2,path:c.join(this.path,c.basename(t))})
},e=>this.onError(e))):this._register(o.watchFile(i,e=>{this.onFileChange({type:"changed"===e?0:2,path:this.path})},e=>this.onError(e)))}catch(e){this.onError(e)}}onFileChange(e){this.fileChangesBuffer.push(e),this.verboseLogging&&this.onVerbose(`${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`),this.fileChangesDelayer.trigger(async()=>{const e=this.fileChangesBuffer;this.fileChangesBuffer=[];const t=i.normalizeFileChanges(e);this.verboseLogging&&t.forEach(e=>{this.onVerbose(`>> normalized ${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`)}),t.length>0&&this.onDidFilesChange(t)})}onError(e){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${e}`})}onVerbose(e){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${e}`})}dispose(){this.isDisposed=!0,super.dispose()}}}),define(t[69],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0
;t.ServiceCollection=class{constructor(...e){this._entries=new Map;for(let[t,i]of e)this.set(t,i)}set(e,t){const i=this._entries.get(e);return this._entries.set(e,t),i}has(e){return this._entries.has(e)}get(e){return this._entries.get(e)}}}),define(t[161],i([0,1,19,153,68,4,69,9]),function(e,t,i,r,n,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class l extends Error{constructor(e){super("cyclic dependency between services"),this.message=e.toString()}}class d{constructor(e=new o.ServiceCollection,t=!1,i){this._services=e,this._strict=t,this._parent=i,this._services.set(s.IInstantiationService,this)}createChild(e){return new d(e,this._strict,this)}invokeFunction(e,...t){let r=h.traceInvocation(e),n=!1;try{return e({get:(e,t)=>{if(n)throw i.illegalState("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(e,r)
;if(!o&&t!==s.optional)throw new Error(`[invokeFunction] unknown service '${e}'`);return o}},...t)}finally{n=!0,r.stop()}}createInstance(e,...t){let i,r;return e instanceof n.SyncDescriptor?(i=h.traceCreation(e.ctor),r=this._createInstance(e.ctor,e.staticArguments.concat(t),i)):(i=h.traceCreation(e),r=this._createInstance(e,t,i)),i.stop(),r}_createInstance(e,t=[],i){let r=s._util.getServiceDependencies(e).sort((e,t)=>e.index-t.index),n=[];for(const t of r){let r=this._getOrCreateServiceInstance(t.id,i);if(!r&&this._strict&&!t.optional)throw new Error(`[createInstance] ${e.name} depends on UNKNOWN service ${t.id}.`);n.push(r)}let o=r.length>0?r[0].index:t.length;if(t.length!==o){console.warn(`[createInstance] First service dependency of ${e.name} at position ${o+1} conflicts with ${t.length} static arguments`);let i=o-t.length;t=i>0?t.concat(new Array(i)):t.slice(0,o)}return new e(...[...t,...n])}_setServiceInstance(e,t){if(this._services.get(e)instanceof n.SyncDescriptor)this._services.set(e,t);else{
if(!this._parent)throw new Error("illegalState - setting UNKNOWN service instance");this._parent._setServiceInstance(e,t)}}_getServiceInstanceOrDescriptor(e){let t=this._services.get(e);return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(e):t}_getOrCreateServiceInstance(e,t){let i=this._getServiceInstanceOrDescriptor(e);return i instanceof n.SyncDescriptor?this._createAndCacheServiceInstance(e,i,t.branch(e,!0)):(t.branch(e,!1),i)}_createAndCacheServiceInstance(e,t,i){const o=new r.Graph(e=>e.id.toString());let a=0;const c=[{id:e,desc:t,_trace:i}];for(;c.length;){const t=c.pop();if(o.lookupOrInsertNode(t),a++>1e3)throw new l(o);for(let i of s._util.getServiceDependencies(t.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(i.id);if(r||i.optional||console.warn(`[createInstance] ${e} depends on ${i.id} which is NOT registered.`),r instanceof n.SyncDescriptor){const e={id:i.id,desc:r,_trace:t._trace.branch(i.id,!0)};o.insertEdge(t,e),c.push(e)}}}for(;;){const e=o.roots();if(0===e.length){
if(!o.isEmpty())throw new l(o);break}for(const{data:t}of e){if(this._getServiceInstanceOrDescriptor(t.id)instanceof n.SyncDescriptor){const e=this._createServiceInstanceWithOwner(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace);this._setServiceInstance(t.id,e)}o.removeNode(t)}}return this._getServiceInstanceOrDescriptor(e)}_createServiceInstanceWithOwner(e,t,i=[],r,s){if(this._services.get(e)instanceof n.SyncDescriptor)return this._createServiceInstance(t,i,r,s);if(this._parent)return this._parent._createServiceInstanceWithOwner(e,t,i,r,s);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}_createServiceInstance(e,t=[],i,r){if(i){const i=new a.IdleValue(()=>this._createInstance(e,t,r));return new Proxy(Object.create(null),{get(e,t){if(t in e)return e[t];let r=i.value,n=r[t];return"function"!=typeof n?n:(n=n.bind(r),e[t]=n,n)},set:(e,t,r)=>(i.value[t]=r,!0)})}return this._createInstance(e,t,r)}}var u;t.InstantiationService=d,function(e){
e[e.Creation=0]="Creation",e[e.Invocation=1]="Invocation",e[e.Branch=2]="Branch"}(u||(u={}));class h{constructor(e,t){this.type=e,this.name=t,this._start=Date.now(),this._dep=[]}static traceInvocation(e){return c?new h(1,e.name||e.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(e){return c?new h(0,e.name):h._None}branch(e,t){let i=new h(2,e.toString());return this._dep.push([e,t,i]),i}stop(){let e=Date.now()-this._start;h._totals+=e;let t=!1;let i=[`${0===this.type?"CREATE":"CALL"} ${this.name}`,`${function e(i,r){let n=[],s=new Array(i+1).join("\t");for(const[o,a,c]of r._dep)if(a&&c){t=!0,n.push(`${s}CREATES -> ${o}`);let r=e(i+1,c);r&&n.push(r)}else n.push(`${s}uses -> ${o}`);return n.join("\n")}(1,this)}`,`DONE, took ${e.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(e>2||t)&&console.log(i.join("\n"))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(t[162],i([0,1,4]),function(e,t,i){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.SharedProcessMainService=t.ISharedProcessMainService=void 0,t.ISharedProcessMainService=i.createDecorator("sharedProcessMainService");t.SharedProcessMainService=class{constructor(e){this.sharedProcess=e}whenSharedProcessReady(){return this.sharedProcess.whenReady()}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}}}),define(t[163],i([0,1,19,122,55]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BaseResolvedKeybinding=void 0;t.BaseResolvedKeybinding=class extends n.ResolvedKeybinding{constructor(e,t){if(super(),0===t.length)throw i.illegalArgument("parts");this._os=e,this._parts=t}getLabel(){return r.UILabelProvider.toLabel(this._os,this._parts,e=>this._getLabel(e))}getAriaLabel(){return r.AriaLabelProvider.toLabel(this._os,this._parts,e=>this._getAriaLabel(e))}getElectronAccelerator(){
return this._parts.length>1?null:r.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,e=>this._getElectronAccelerator(e))}getUserSettingsLabel(){return r.UserSettingsLabelProvider.toLabel(this._os,this._parts,e=>this._getUserSettingsLabel(e))}isWYSIWYG(){return this._parts.every(e=>this._isWYSIWYG(e))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(e=>this._getPart(e))}_getPart(e){return new n.ResolvedKeybindingPart(e.ctrlKey,e.shiftKey,e.altKey,e.metaKey,this._getLabel(e),this._getAriaLabel(e))}getDispatchParts(){return this._parts.map(e=>this._getDispatchPart(e))}}}),define(t[164],i([0,1,55,163]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.USLayoutResolvedKeybinding=void 0;class n extends r.BaseResolvedKeybinding{constructor(e,t){super(t,e.parts)}_keyCodeToUILabel(e){if(2===this._os)switch(e){case 15:return"←";case 16:return"↑";case 17:return"→";case 18:return"↓"}return i.KeyCodeUtils.toString(e)}_getLabel(e){
return e.isDuplicateModifierCase()?"":this._keyCodeToUILabel(e.keyCode)}_getAriaLabel(e){return e.isDuplicateModifierCase()?"":i.KeyCodeUtils.toString(e.keyCode)}_keyCodeToElectronAccelerator(e){if(e>=93&&e<=108)return null;switch(e){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return i.KeyCodeUtils.toString(e)}_getElectronAccelerator(e){return e.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(e.keyCode)}_getUserSettingsLabel(e){if(e.isDuplicateModifierCase())return"";const t=i.KeyCodeUtils.toUserSettingsUS(e.keyCode);return t?t.toLowerCase():t}_isWYSIWYG(){return!0}_getDispatchPart(e){return n.getDispatchStr(e)}static getDispatchStr(e){if(e.isModifierKey())return null;let t="";return e.ctrlKey&&(t+="ctrl+"),e.shiftKey&&(t+="shift+"),e.altKey&&(t+="alt+"),e.metaKey&&(t+="meta+"),t+=i.KeyCodeUtils.toString(e.keyCode)}}t.USLayoutResolvedKeybinding=n}),define(t[165],i([0,1,4,5,2]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.KeyboardLayoutMainService=t.IKeyboardLayoutMainService=void 0,t.IKeyboardLayoutMainService=i.createDecorator("keyboardLayoutMainService");function s(e){return{keyboardMapping:e.getKeyMap(),keyboardLayoutInfo:e.getCurrentKeyboardLayout()}}t.KeyboardLayoutMainService=class extends n.Disposable{constructor(){super(),this._onDidChangeKeyboardLayout=this._register(new r.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const t=await new Promise((t,i)=>{e(["native-keymap"],t,i)});this._keyboardLayoutData=s(t),t.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=s(t),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}}}),define(t[166],i([0,1,9]),function(e,t,i){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.handleVetos=void 0,t.handleVetos=function(e,t){if(0===e.length)return Promise.resolve(!1);const r=[];let n=!1;for(let s of e){if(!0===s)return Promise.resolve(!0);i.isThenable(s)&&r.push(s.then(e=>{e&&(n=!0)},e=>{t(e),n=!0}))}return Promise.all(r).then(()=>n)}}),define(t[7],i([0,1,4,2,3,5,77]),function(e,t,i,r,n,s,o){"use strict";function a(){return(new Date).toISOString()}var c;Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.DelegatedLogService=t.MultiplexLogService=t.ConsoleLogInMainService=t.LogServiceAdapter=t.ConsoleLogService=t.ConsoleLogMainService=t.AbstractLogService=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=i.createDecorator("logService"),t.ILoggerService=i.createDecorator("loggerService"),function(e){e[e.Trace=0]="Trace",e[e.Debug=1]="Debug",e[e.Info=2]="Info",e[e.Warning=3]="Warning",e[e.Error=4]="Error",e[e.Critical=5]="Critical",
e[e.Off=6]="Off"}(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class l extends r.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new s.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogService=l;t.ConsoleLogMainService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e),this.useColors=!n.isWindows}trace(e,...t){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}debug(e,...t){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}info(e,...t){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}warn(e,...t){
this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${a()}][0m`,e,...t):console.warn(`[main ${a()}]`,e,...t))}error(e,...t){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}critical(e,...t){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}dispose(){}flush(){}};t.ConsoleLogService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e)}trace(e,...t){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){
this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}};class d extends l{constructor(e,i=t.DEFAULT_LOG_LEVEL){super(),this.adapter=e,this.setLevel(i)}trace(e,...t){this.getLevel()<=c.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=c.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=c.Info&&this.adapter.consoleLog("info",[this.extractMessage(e),...t])}warn(e,...t){this.getLevel()<=c.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=c.Error&&this.adapter.consoleLog("error",[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=c.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(e),...t])}extractMessage(e){return"string"==typeof e?e:o.toErrorMessage(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.LogServiceAdapter=d;t.ConsoleLogInMainService=class extends d{
constructor(e,i=t.DEFAULT_LOG_LEVEL){super({consoleLog:(t,i)=>e.consoleLog(t,i)},i)}};t.MultiplexLogService=class extends l{constructor(e){super(),this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const i of this.logServices)i.trace(e,...t)}debug(e,...t){for(const i of this.logServices)i.debug(e,...t)}info(e,...t){for(const i of this.logServices)i.info(e,...t)}warn(e,...t){for(const i of this.logServices)i.warn(e,...t)}error(e,...t){for(const i of this.logServices)i.error(e,...t)}critical(e,...t){for(const i of this.logServices)i.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}};t.DelegatedLogService=class extends r.Disposable{constructor(e){super(),this.logService=e,this._register(e)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(e){this.logService.setLevel(e)}getLevel(){return this.logService.getLevel()
}trace(e,...t){this.logService.trace(e,...t)}debug(e,...t){this.logService.debug(e,...t)}info(e,...t){this.logService.info(e,...t)}warn(e,...t){this.logService.warn(e,...t)}error(e,...t){this.logService.error(e,...t)}critical(e,...t){this.logService.critical(e,...t)}flush(){this.logService.flush()}};function u(e){switch(e){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.NullLogService=class{constructor(){this.onDidChangeLogLevel=(new s.Emitter).event}setLevel(e){}getLevel(){return c.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}},t.getLogLevel=function(e){if(e.verbose)return c.Trace;if("string"==typeof e.logLevel){const t=u(e.logLevel.toLowerCase());if(void 0!==t)return t}return t.DEFAULT_LOG_LEVEL},t.parseLogLevel=u,t.LogLevelToString=function(e){switch(e){case c.Trace:return"trace";case c.Debug:
return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}});var s=this&&this.__decorate||function(e,t,i,r){var n,s=arguments.length,o=s<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,i):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,i,r);else for(var a=e.length-1;a>=0;a--)(n=e[a])&&(o=(s<3?n(o):s>3?n(t,i,o):n(t,i))||o);return s>3&&o&&Object.defineProperty(t,i,o),o},o=this&&this.__param||function(e,t){return function(i,r){t(i,r,e)}};define(t[167],i([0,1,5,2,10,8,52,11,7,33,3]),function(e,t,i,r,n,a,c,l,d,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileProtocolHandler=void 0;let p=class extends r.Disposable{constructor(e,t){super(),this.logService=t,this.validRoots=u.TernarySearchTree.forUris(()=>!h.isLinux);const{defaultSession:i}=l.session;this.validRoots.set(a.URI.file(e.appRoot),!0),this.validRoots.set(a.URI.file(e.extensionsPath),!0),
i.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(e,t)=>this.handleResourceRequest(e,t)),h.isPreferringBrowserCodeLoad&&(this.logService.info(`Intercepting ${n.Schemas.file}: protocol and blocking it`),i.protocol.interceptFileProtocol(n.Schemas.file,(e,t)=>this.handleFileRequest(e,t))),this._register(r.toDisposable(()=>{i.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),h.isPreferringBrowserCodeLoad&&i.protocol.uninterceptProtocol(n.Schemas.file)}))}injectWindowsMainService(e){this._register(e.onWindowReady(e=>{var t,n;if((null===(t=e.config)||void 0===t?void 0:t.extensionDevelopmentPath)||(null===(n=e.config)||void 0===n?void 0:n.extensionTestsPath)){const t=new r.DisposableStore;if(t.add(i.Event.any(e.onClose,e.onDestroy)(()=>t.dispose())),e.config.extensionDevelopmentPath)for(const i of e.config.extensionDevelopmentPath)t.add(this.addValidRoot(a.URI.file(i)));e.config.extensionTestsPath&&t.add(this.addValidRoot(a.URI.file(e.config.extensionTestsPath)))}}))}addValidRoot(e){
return this.validRoots.get(e)?r.Disposable.None:(this.validRoots.set(e,!0),r.toDisposable(()=>this.validRoots.delete(e)))}async handleFileRequest(e,t){const i=a.URI.parse(e.url);this.logService.error(`Refused to load resource ${i.fsPath} from ${n.Schemas.file}: protocol`),t({error:-3})}async handleResourceRequest(e,t){const i=a.URI.parse(e.url),r=n.FileAccess.asFileUri(i);if(this.validRoots.findSubstr(r))return t({path:r.fsPath});this.logService.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${r.fsPath}}`),t({error:-3})}};p=s([o(0,c.INativeEnvironmentService),o(1,d.ILogService)],p),t.FileProtocolHandler=p}),define(t[168],i([0,1,2,26,5,17,133,33,30,34,7,23,64,9,22,10,83,62,169]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let b=class extends i.Disposable{constructor(e){super(),this.logService=e,this.BUFFER_SIZE=65536,this._onDidChangeFileSystemProviderRegistrations=this._register(new n.Emitter),
this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new n.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new n.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new n.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new n.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new n.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(e,t){if(this.provider.has(e))throw new Error(`A filesystem provider for the scheme '${e}' is already registered.`);S.mark(`code/registerFilesystem/${e}`),this.provider.set(e,t),
this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:e,provider:t});const n=new i.DisposableStore;return n.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new r.FileChangesEvent(e,!this.isPathCaseSensitive(t))))),n.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:e}))),"function"==typeof t.onDidErrorOccur&&n.add(t.onDidErrorOccur(e=>this._onError.fire(new Error(e)))),i.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:e,provider:t}),this.provider.delete(e),i.dispose(n)})}async activateProvider(e){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:e,join(e){e&&t.push(e)}}),this.provider.has(e)||await Promise.all(t)}canHandleResource(e){return this.provider.has(e.scheme)}hasCapability(e,t){const i=this.provider.get(e.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return y.Iterable.map(this.provider,([e,t])=>({scheme:e,capabilities:t.capabilities}))}async withProvider(e){
if(!a.isAbsolutePath(e))throw new r.FileOperationError(c.localize(0,null,this.resourceForError(e)),8);await this.activateProvider(e.scheme);const t=this.provider.get(e.scheme);if(!t){const t=new Error;throw t.name="ENOPRO",t.message=c.localize(1,null,e.toString()),t}return t}async withReadProvider(e){const t=await this.withProvider(e);if(r.hasOpenReadWriteCloseCapability(t)||r.hasReadWriteCapability(t)||r.hasFileReadStreamCapability(t))return t;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(e){const t=await this.withProvider(e);if(r.hasOpenReadWriteCloseCapability(t)||r.hasReadWriteCapability(t))return t;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(e,t){try{return await this.doResolveFile(e,t)}catch(t){
if(r.toFileSystemProviderErrorCode(t)===r.FileSystemProviderErrorCode.FileNotFound)throw new r.FileOperationError(c.localize(2,null,this.resourceForError(e)),1);throw r.ensureFileSystemProviderError(t)}}async doResolveFile(e,t){const i=await this.withProvider(e),r=this.isPathCaseSensitive(i),n=null==t?void 0:t.resolveTo,s=null==t?void 0:t.resolveSingleChildDescendants,o=null==t?void 0:t.resolveMetadata,a=await i.stat(e);let c;return this.toFileStat(i,e,a,void 0,!!o,(t,i)=>(c||((c=l.TernarySearchTree.forUris(()=>!r)).set(e,!0),d.isNonEmptyArray(n)&&n.forEach(e=>c.set(e,!0))),!!Boolean(c.findSuperstr(t.resource)||c.get(t.resource))||!(!t.isDirectory||!s)&&1===i))}async toFileStat(e,t,i,n,s,o){const c={resource:t,name:u.getBaseLabel(t),isFile:0!=(i.type&r.FileType.File),isDirectory:0!=(i.type&r.FileType.Directory),isSymbolicLink:0!=(i.type&r.FileType.SymbolicLink),mtime:i.mtime,ctime:i.ctime,size:i.size,etag:r.etag({mtime:i.mtime,size:i.size})};if(c.isDirectory&&o(c,n)){try{
const i=await e.readdir(t),r=await Promise.all(i.map(async([r,n])=>{try{const c=a.joinPath(t,r),l=s?await e.stat(c):{type:n};return await this.toFileStat(e,c,l,i.length,s,o)}catch(e){return this.logService.trace(e),null}}));c.children=d.coalesce(r)}catch(e){this.logService.trace(e),c.children=[]}return c}return c}async resolveAll(e){return Promise.all(e.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(e){const t=await this.withProvider(e);try{return!!await t.stat(e)}catch(e){return!1}}async canCreateFile(e,t){try{await this.doValidateCreateFile(e,t)}catch(e){return e}return!0}async doValidateCreateFile(e,t){if(!(null==t?void 0:t.overwrite)&&await this.exists(e))throw new r.FileOperationError(c.localize(3,null,this.resourceForError(e)),3,t)}async createFile(e,t=p.VSBuffer.fromString(""),i){await this.doValidateCreateFile(e,i);const n=await this.writeFile(e,t)
;return this._onDidRunOperation.fire(new r.FileOperationEvent(e,0,n)),n}async writeFile(e,t,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);try{let s;if(await this.validateWriteFile(n,e,i)||await this.mkdirp(n,a.dirname(e)),!r.hasReadWriteCapability(n)||t instanceof p.VSBuffer)s=t;else if(f.isReadableStream(t)){const e=await f.peekStream(t,3);s=e.ended?p.VSBuffer.concat(e.buffer):e}else s=f.peekReadable(t,e=>p.VSBuffer.concat(e),3);!r.hasOpenReadWriteCloseCapability(n)||r.hasReadWriteCapability(n)&&s instanceof p.VSBuffer?await this.doWriteUnbuffered(n,e,s):await this.doWriteBuffered(n,e,s instanceof p.VSBuffer?p.bufferToReadable(s):s)}catch(t){throw new r.FileOperationError(c.localize(4,null,this.resourceForError(e),r.ensureFileSystemProviderError(t).toString()),r.toFileOperationResult(t),i)}return this.resolve(e,{resolveMetadata:!0})}async validateWriteFile(e,t,i){let n=void 0;try{n=await e.stat(t)}catch(e){return}
if(0!=(n.type&r.FileType.Directory))throw new r.FileOperationError(c.localize(5,null,this.resourceForError(t)),0,i);if(i&&"number"==typeof i.mtime&&"string"==typeof i.etag&&i.etag!==r.ETAG_DISABLED&&"number"==typeof n.mtime&&"number"==typeof n.size&&i.mtime<n.mtime&&i.etag!==r.etag({mtime:i.mtime,size:n.size}))throw new r.FileOperationError(c.localize(6,null),3,i);return n}async readFile(e,t){const i=await this.withReadProvider(e),r=await this.doReadAsFileStream(i,e,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await p.streamToBuffer(r.value)})}async readFileStream(e,t){const i=await this.withReadProvider(e);return this.doReadAsFileStream(i,e,t)}async doReadAsFileStream(e,t,i){const n=new m.CancellationTokenSource,s=this.validateReadFile(t,i).then(e=>e,e=>{throw n.cancel(),e});try{let o;i&&"string"==typeof i.etag&&i.etag!==r.ETAG_DISABLED&&await s,
o=!r.hasOpenReadWriteCloseCapability(e)&&!r.hasFileReadStreamCapability(e)||r.hasReadWriteCapability(e)&&(null==i?void 0:i.preferUnbuffered)?this.readFileUnbuffered(e,t,i):r.hasFileReadStreamCapability(e)?Promise.resolve(this.readFileStreamed(e,t,n.token,i)):Promise.resolve(this.readFileBuffered(e,t,n.token,i));const[a,l]=await Promise.all([s,o]);return Object.assign(Object.assign({},a),{value:l})}catch(e){throw new r.FileOperationError(c.localize(7,null,this.resourceForError(t),r.ensureFileSystemProviderError(e).toString()),r.toFileOperationResult(e),i)}}readFileStreamed(e,t,i,n=Object.create(null)){const s=e.readFileStream(t,n,i);return f.transform(s,{data:e=>e instanceof p.VSBuffer?e:p.VSBuffer.wrap(e),error:e=>new r.FileOperationError(c.localize(8,null,this.resourceForError(t),r.ensureFileSystemProviderError(e).toString()),r.toFileOperationResult(e),n)},e=>p.VSBuffer.concat(e))}readFileBuffered(e,t,i,n=Object.create(null)){const s=p.newWriteableBufferStream()
;return w.readFileIntoStream(e,t,s,e=>e,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:e=>new r.FileOperationError(c.localize(9,null,this.resourceForError(t),r.ensureFileSystemProviderError(e).toString()),r.toFileOperationResult(e),n)}),i),s}async readFileUnbuffered(e,t,i){let r=await e.readFile(t);return i&&"number"==typeof i.position&&(r=r.slice(i.position)),i&&"number"==typeof i.length&&(r=r.slice(0,i.length)),this.validateReadFileLimits(t,r.byteLength,i),p.bufferToStream(p.VSBuffer.wrap(r))}async validateReadFile(e,t){const i=await this.resolve(e,{resolveMetadata:!0});if(i.isDirectory)throw new r.FileOperationError(c.localize(10,null,this.resourceForError(e)),0,t);if(t&&"string"==typeof t.etag&&t.etag!==r.ETAG_DISABLED&&t.etag===i.etag)throw new r.FileOperationError(c.localize(11,null),2,t);return this.validateReadFileLimits(e,i.size,t),i}validateReadFileLimits(e,t,i){if(null==i?void 0:i.limits){let n=void 0;if("number"==typeof i.limits.memory&&t>i.limits.memory&&(n=9),
"number"==typeof i.limits.size&&t>i.limits.size&&(n=7),"number"==typeof n)throw new r.FileOperationError(c.localize(12,null,this.resourceForError(e)),n)}}async canMove(e,t,i){return this.doCanMoveCopy(e,t,"move",i)}async canCopy(e,t,i){return this.doCanMoveCopy(e,t,"copy",i)}async doCanMoveCopy(e,t,i,r){if(e.toString()!==t.toString())try{const n="move"===i?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e):await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(n,e,s,t,i,r)}catch(e){return e}return!0}async move(e,t,i){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(n,e,s,t,"move",!!i),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new r.FileOperationEvent(e,"move"===o?2:3,a)),a}async copy(e,t,i){
const n=await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(n,e,s,t,"copy",!!i),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new r.FileOperationEvent(e,"copy"===o?3:2,a)),a}async doMoveCopy(e,t,i,n,s,o){if(t.toString()===n.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(e,t,i,n,s,o);if(c&&!l&&o&&await this.del(n,{recursive:!0}),await this.mkdirp(i,a.dirname(n)),"copy"===s){if(e===i&&r.hasFileFolderCopyCapability(e))await e.copy(t,n,{overwrite:o});else{const r=await this.resolve(t);r.isDirectory?await this.doCopyFolder(e,r,i,n):await this.doCopyFile(e,t,i,n)}return s}return e===i?(await e.rename(t,n,{overwrite:o}),s):(await this.doMoveCopy(e,t,i,n,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(e,t,i,n){
return r.hasOpenReadWriteCloseCapability(e)&&r.hasOpenReadWriteCloseCapability(i)?this.doPipeBuffered(e,t,i,n):r.hasOpenReadWriteCloseCapability(e)&&r.hasReadWriteCapability(i)?this.doPipeBufferedToUnbuffered(e,t,i,n):r.hasReadWriteCapability(e)&&r.hasOpenReadWriteCloseCapability(i)?this.doPipeUnbufferedToBuffered(e,t,i,n):r.hasReadWriteCapability(e)&&r.hasReadWriteCapability(i)?this.doPipeUnbuffered(e,t,i,n):void 0}async doCopyFolder(e,t,i,r){await i.mkdir(r),Array.isArray(t.children)&&await Promise.all(t.children.map(async t=>{const n=a.joinPath(r,t.name);return t.isDirectory?this.doCopyFolder(e,await this.resolve(t.resource),i,n):this.doCopyFile(e,t.resource,i,n)}))}async doValidateMoveCopy(e,t,i,n,s,o){let a=!1;if(e===i){const{providerExtUri:i,isPathCaseSensitive:r}=this.getExtUri(e);if(r||(a=i.isEqual(t,n)),a&&"copy"===s)throw new Error(c.localize(13,null,this.resourceForError(t),this.resourceForError(n)))
;if(!a&&i.isEqualOrParent(n,t))throw new Error(c.localize(14,null,this.resourceForError(t),this.resourceForError(n)))}const l=await this.exists(n);if(l&&!a){if(!o)throw new r.FileOperationError(c.localize(15,null,this.resourceForError(t),this.resourceForError(n)),4);if(e===i){const{providerExtUri:i}=this.getExtUri(e);if(i.isEqualOrParent(t,n))throw new Error(c.localize(16,null,this.resourceForError(t),this.resourceForError(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(e){const t=this.isPathCaseSensitive(e);return{providerExtUri:t?a.extUri:a.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(e){return!!(1024&e.capabilities)}async createFolder(e){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);await this.mkdirp(t,e);const i=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new r.FileOperationEvent(e,0,i)),i}async mkdirp(e,t){const i=[],{providerExtUri:n}=this.getExtUri(e);for(;!n.isEqual(t,a.dirname(t));)try{
if(0==((await e.stat(t)).type&r.FileType.Directory))throw new Error(c.localize(17,null,this.resourceForError(t)));break}catch(e){if(r.toFileSystemProviderErrorCode(e)!==r.FileSystemProviderErrorCode.FileNotFound)throw e;i.push(a.basename(t)),t=a.dirname(t)}for(let n=i.length-1;n>=0;n--){t=a.joinPath(t,i[n]);try{await e.mkdir(t)}catch(e){if(r.toFileSystemProviderErrorCode(e)!==r.FileSystemProviderErrorCode.FileExists)throw e}}}async canDelete(e,t){try{await this.doValidateDelete(e,t)}catch(e){return e}return!0}async doValidateDelete(e,t){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);if(!!(null==t?void 0:t.useTrash)&&!(4096&i.capabilities))throw new Error(c.localize(18,null,this.resourceForError(e)));const n=await this.exists(e);if(!n)throw new r.FileOperationError(c.localize(19,null,this.resourceForError(e)),1);if(!!!(null==t?void 0:t.recursive)&&n){const t=await this.resolve(e)
;if(t.isDirectory&&Array.isArray(t.children)&&t.children.length>0)throw new Error(c.localize(20,null,this.resourceForError(e)))}return i}async del(e,t){const i=await this.doValidateDelete(e,t),n=!!(null==t?void 0:t.useTrash),s=!!(null==t?void 0:t.recursive);await i.delete(e,{recursive:s,useTrash:n}),this._onDidRunOperation.fire(new r.FileOperationEvent(e,1))}watch(e,t={recursive:!1,excludes:[]}){let r=!1,n=i.toDisposable(()=>r=!0);return this.doWatch(e,t).then(e=>{r?i.dispose(e):n=e},e=>this.logService.error(e)),i.toDisposable(()=>i.dispose(n))}async doWatch(e,t){const r=await this.withProvider(e),n=this.toWatchKey(r,e,t),s=this.activeWatchers.get(n)||{count:0,disposable:r.watch(e,t)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,s),s.count+=1,i.toDisposable(()=>{s.count--,0===s.count&&(i.dispose(s.disposable),this.activeWatchers.delete(n))})}toWatchKey(e,t,i){const{providerExtUri:r}=this.getExtUri(e);return[r.getComparisonKey(t),String(i.recursive),i.excludes.join()].join()}dispose(){
super.dispose(),this.activeWatchers.forEach(e=>i.dispose(e.disposable)),this.activeWatchers.clear()}ensureWriteQueue(e,t){const{providerExtUri:r}=this.getExtUri(e),s=r.getComparisonKey(t);let o=this.writeQueues.get(s);if(!o){o=new g.Queue,this.writeQueues.set(s,o),n.Event.once(o.onFinished)(()=>{this.writeQueues.delete(s),i.dispose(o)})}return o}async doWriteBuffered(e,t,i){return this.ensureWriteQueue(e,t).queue(async()=>{const n=await e.open(t,{create:!0});try{f.isReadableStream(i)||f.isReadableBufferedStream(i)?await this.doWriteStreamBufferedQueued(e,n,i):await this.doWriteReadableBufferedQueued(e,n,i)}catch(e){throw r.ensureFileSystemProviderError(e)}finally{await e.close(n)}})}async doWriteStreamBufferedQueued(e,t,i){let r,n=0;if(f.isReadableBufferedStream(i)){if(i.buffer.length>0){const r=p.VSBuffer.concat(i.buffer);await this.doWriteBuffer(e,t,r,r.byteLength,n,0),n+=r.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise(async(i,s)=>{r.on("data",async i=>{r.pause();try{
await this.doWriteBuffer(e,t,i,i.byteLength,n,0)}catch(e){return s(e)}n+=i.byteLength,setTimeout(()=>r.resume())}),r.on("error",e=>s(e)),r.on("end",()=>i())})}async doWriteReadableBufferedQueued(e,t,i){let r,n=0;for(;null!==(r=i.read());)await this.doWriteBuffer(e,t,r,r.byteLength,n,0),n+=r.byteLength}async doWriteBuffer(e,t,i,r,n,s){let o=0;for(;o<r;){o+=await e.write(t,n+o,i.buffer,s+o,r-o)}}async doWriteUnbuffered(e,t,i){return this.ensureWriteQueue(e,t).queue(()=>this.doWriteUnbufferedQueued(e,t,i))}async doWriteUnbufferedQueued(e,t,i){let r;r=i instanceof p.VSBuffer?i:f.isReadableStream(i)?await p.streamToBuffer(i):f.isReadableBufferedStream(i)?await p.bufferedStreamToBuffer(i):p.readableToBuffer(i),await e.writeFile(t,r.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(e,t,i,r){return this.ensureWriteQueue(i,r).queue(()=>this.doPipeBufferedQueued(e,t,i,r))}async doPipeBufferedQueued(e,t,i,n){let s=void 0,o=void 0;try{s=await e.open(t,{create:!1}),o=await i.open(n,{create:!0})
;const a=p.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,d=0;do{d=await e.read(s,c,a.buffer,l,a.byteLength-l),await this.doWriteBuffer(i,o,a,d,c,l),c+=d,(l+=d)===a.byteLength&&(l=0)}while(d>0)}catch(e){throw r.ensureFileSystemProviderError(e)}finally{await Promise.all(["number"==typeof s?e.close(s):Promise.resolve(),"number"==typeof o?i.close(o):Promise.resolve()])}}async doPipeUnbuffered(e,t,i,r){return this.ensureWriteQueue(i,r).queue(()=>this.doPipeUnbufferedQueued(e,t,i,r))}async doPipeUnbufferedQueued(e,t,i,r){return i.writeFile(r,await e.readFile(t),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(e,t,i,r){return this.ensureWriteQueue(i,r).queue(()=>this.doPipeUnbufferedToBufferedQueued(e,t,i,r))}async doPipeUnbufferedToBufferedQueued(e,t,i,n){const s=await i.open(n,{create:!0});try{const n=await e.readFile(t);await this.doWriteBuffer(i,s,p.VSBuffer.wrap(n),n.byteLength,0,0)}catch(e){throw r.ensureFileSystemProviderError(e)}finally{await i.close(s)}}async doPipeBufferedToUnbuffered(e,t,i,r){
const n=await p.streamToBuffer(this.readFileBuffered(e,t,m.CancellationToken.None));await this.doWriteUnbuffered(i,r,n)}throwIfFileSystemIsReadonly(e,t){if(2048&e.capabilities)throw new r.FileOperationError(c.localize(21,null,this.resourceForError(t)),6);return e}resourceForError(e){return e.scheme===v.Schemas.file?e.fsPath:e.toString(!0)}};b=s([o(0,h.ILogService)],b),t.FileService=b}),define(t[170],i([0,1,24,67,2,26,5,3,25,6,17,28,9,7,136,84,150,152,149,160,64,83,30,23]),function(e,t,i,r,n,s,o,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b,_,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;t.DiskFileSystemProvider=class extends n.Disposable{constructor(e,t){var i;super(),this.logService=e,this.options=t,this.BUFFER_SIZE=(null===(i=this.options)||void 0===i?void 0:i.bufferSize)||65536,this.onDidChangeCapabilities=o.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new o.Emitter),
this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new o.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new h.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=30,a.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:t,symbolicLink:i}=await c.statLink(this.toFilePath(e));return{type:this.toType(t,i),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(e){try{const t=await c.readdirWithFileTypes(this.toFilePath(e)),i=[];return await Promise.all(t.map(async t=>{try{let r;r=t.isSymbolicLink()?(await this.stat(d.joinPath(e,t.name))).type:this.toType(t),i.push([t.name,r])}catch(e){this.logService.trace(e)}})),i}catch(e){throw this.toFileSystemProviderError(e)}}toType(e,t){let i
;return i=(null==t?void 0:t.dangling)?s.FileType.Unknown:e.isFile()?s.FileType.File:e.isDirectory()?s.FileType.Directory:s.FileType.Unknown,t&&(i|=s.FileType.SymbolicLink),i}async readFile(e){try{const t=this.toFilePath(e);return await c.readFile(t)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(e,t,i){const r=S.newWriteableStream(e=>E.VSBuffer.concat(e.map(e=>E.VSBuffer.wrap(e))).buffer);return b.readFileIntoStream(this,e,r,e=>e.buffer,Object.assign(Object.assign({},t),{bufferSize:this.BUFFER_SIZE}),i),r}async writeFile(e,t,i){let r=void 0;try{const n=this.toFilePath(e);if(!i.create||!i.overwrite){if(await c.exists(n)){if(!i.overwrite)throw s.createFileSystemProviderError(f.localize(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw s.createFileSystemProviderError(f.localize(1,null),s.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(e,{create:!0}),await this.write(r,0,t,0,t.byteLength)}catch(e){throw this.toFileSystemProviderError(e)}finally{
"number"==typeof r&&await this.close(r)}}async open(e,t){try{const n=this.toFilePath(e);let s=void 0;if(t.create){if(a.isWindows&&await c.exists(n))try{await c.truncate(n,0),s="r+"}catch(e){this.logService.trace(e)}s||(s="w")}else s="r";const o=await r.promisify(i.open)(n,s);return this.mapHandleToPos.set(o,0),t.create&&this.writeHandles.add(o),o}catch(e){throw this.toFileSystemProviderError(e)}}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await r.promisify(i.fdatasync)(e)}catch(e){this.canFlush=!1,this.logService.error(e)}return await r.promisify(i.close)(e)}catch(e){throw this.toFileSystemProviderError(e)}}async read(e,t,n,s,o){const a=this.normalizePos(e,t);let c=null;try{const t=await r.promisify(i.read)(e,n,s,o,a);return c="number"==typeof t?t:t.bytesRead}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,c)}}normalizePos(e,t){return t===this.mapHandleToPos.get(e)?null:t}updatePos(e,t,i){const r=this.mapHandleToPos.get(e)
;"number"==typeof r&&("number"==typeof t||("number"==typeof i?this.mapHandleToPos.set(e,r+i):this.mapHandleToPos.delete(e)))}async write(e,t,i,r,n){return h.retry(()=>this.doWrite(e,t,i,r,n),100,3)}async doWrite(e,t,n,s,o){const a=this.normalizePos(e,t);let c=null;try{const t=await r.promisify(i.write)(e,n,s,o,a);return c="number"==typeof t?t:t.bytesWritten}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,c)}}async mkdir(e){try{await r.promisify(i.mkdir)(this.toFilePath(e))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(e,t){try{const i=this.toFilePath(e);await this.doDelete(i,t)}catch(e){throw this.toFileSystemProviderError(e)}}async doDelete(e,t){t.recursive?await c.rimraf(e,c.RimRafMode.MOVE):await c.unlink(e)}async rename(e,t,i){const r=this.toFilePath(e),n=this.toFilePath(t);if(r!==n)try{await this.validateTargetDeleted(e,t,"move",i.overwrite),await c.move(r,n)}catch(e){
throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(f.localize(2,null,l.basename(r),l.basename(l.dirname(n)),e.toString()))),this.toFileSystemProviderError(e)}}async copy(e,t,i){const r=this.toFilePath(e),n=this.toFilePath(t);if(r!==n)try{await this.validateTargetDeleted(e,t,"copy",i.overwrite),await c.copy(r,n)}catch(e){throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(f.localize(3,null,l.basename(r),l.basename(l.dirname(n)),e.toString()))),this.toFileSystemProviderError(e)}}async validateTargetDeleted(e,t,i,r){const n=this.toFilePath(e),o=this.toFilePath(t);let a=!1;if(!!(1024&this.capabilities)||(a=u.isEqual(n,o,!0)),a&&"copy"===i)throw s.createFileSystemProviderError(f.localize(4,null),s.FileSystemProviderErrorCode.FileExists);if(!a&&await c.exists(o)){if(!r)throw s.createFileSystemProviderError(f.localize(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}watch(e,t){
return t.recursive?this.watchRecursive(e,t.excludes):this.watchNonRecursive(e)}watchRecursive(e,t){const i={path:this.toFilePath(e),excludes:t},r=_.insert(this.recursiveFoldersToWatch,i);return this.refreshRecursiveWatchers(),n.toDisposable(()=>{r(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var e,t,i;if(this.recursiveWatcher instanceof w.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(n.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,n=void 0;(null===(t=null===(e=this.options)||void 0===e?void 0:e.watcher)||void 0===t?void 0:t.usePolling)?(r=m.FileWatcher,n=null===(i=this.options)||void 0===i?void 0:i.watcher):r=1===this.recursiveFoldersToWatch.length?a.isWindows?v.FileWatcher:m.FileWatcher:w.FileWatcher,
this.recursiveWatcher=new r(this.recursiveFoldersToWatch,e=>this._onDidChangeFile.fire(g.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===p.LogLevel.Trace,n),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))}}watchNonRecursive(e){const t=new y.FileWatcher(this.toFilePath(e),e=>this._onDidChangeFile.fire(g.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===p.LogLevel.Trace),i=this.logService.onDidChangeLogLevel(()=>{t.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)});return n.combinedDisposable(t,i)}toFilePath(e){return l.normalize(e.fsPath)}toFileSystemProviderError(e){if(e instanceof s.FileSystemProviderError)return e
;let t;switch(e.code){case"ENOENT":t=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=s.FileSystemProviderErrorCode.NoPermissions;break;default:t=s.FileSystemProviderErrorCode.Unknown}return s.createFileSystemProviderError(e,t)}dispose(){super.dispose(),n.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,n.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}}),define(t[171],i([0,1,7]),function(e,t,i){"use strict";function r(e,t){switch(t){case i.LogLevel.Trace:return e.trace;case i.LogLevel.Debug:return e.debug;case i.LogLevel.Info:return e.info;case i.LogLevel.Warning:return e.warn;case i.LogLevel.Error:return e.error;case i.LogLevel.Critical:return e.critical;default:throw new Error("Invalid log level")}}
Object.defineProperty(t,"__esModule",{value:!0}),t.BufferLogService=void 0;t.BufferLogService=class extends i.AbstractLogService{constructor(e=i.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(e),this._register(this.onDidChangeLogLevel(e=>{this._logger&&this._logger.setLevel(e)}))}set logger(e){this._logger=e;for(const{level:t,args:i}of this.buffer){r(e,t).apply(e,i)}this.buffer=[]}_log(e,...t){if(this._logger){r(this._logger,e).apply(this._logger,t)}else this.getLevel()<=e&&this.buffer.push({level:e,args:t})}trace(e,...t){this._log(i.LogLevel.Trace,e,...t)}debug(e,...t){this._log(i.LogLevel.Debug,e,...t)}info(e,...t){this._log(i.LogLevel.Info,e,...t)}warn(e,...t){this._log(i.LogLevel.Warning,e,...t)}error(e,...t){this._log(i.LogLevel.Error,e,...t)}critical(e,...t){this._log(i.LogLevel.Critical,e,...t)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}}),define(t[172],i([0,1,7,5]),function(e,t,i,r){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.FollowerLogService=t.LoggerChannelClient=t.LoggerChannel=void 0;t.LoggerChannel=class{constructor(e){this.service=e,this.onDidChangeLogLevel=r.Event.buffer(e.onDidChangeLogLevel,!0)}listen(e,t){switch(t){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"setLevel":return this.service.setLevel(i),Promise.resolve();case"consoleLog":return this.consoleLog(i[0],i[1]),Promise.resolve()}throw new Error(`Call not found: ${t}`)}consoleLog(e,t){let i=console.log;switch(e){case"error":i=console.error;break;case"warn":i=console.warn;break;case"info":i=console.info}i.call(console,...t)}};class n{constructor(e){this.channel=e}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(e){n.setLevel(this.channel,e)}static setLevel(e,t){return e.call("setLevel",t)}consoleLog(e,t){this.channel.call("consoleLog",[e,t])}}t.LoggerChannelClient=n
;t.FollowerLogService=class extends i.DelegatedLogService{constructor(e,t){super(t),this.parent=e,this._register(e.onDidChangeLogLevel(e=>t.setLevel(e)))}setLevel(e){super.setLevel(e),this.parent.setLevel(e)}}}),define(t[173],i([0,1,6,7,26]),function(e,t,i,r,n){"use strict";function s(e,t,i){switch(t){case r.LogLevel.Trace:e.trace(i);break;case r.LogLevel.Debug:e.debug(i);break;case r.LogLevel.Info:e.info(i);break;case r.LogLevel.Warning:e.warn(i);break;case r.LogLevel.Error:e.error(i);break;case r.LogLevel.Critical:e.critical(i);break;default:throw new Error("Invalid log level")}}Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogService=t.createRotatingLogger=void 0,t.createRotatingLogger=function(t,i,r,n){return e.__$__nodeRequire("spdlog").createRotatingLogger(t,i,r,n)};t.SpdLogService=class extends r.AbstractLogService{constructor(e,t,i){super(),this.name=e,this.logsFolder=t,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(i),this._createSpdLogLogger(),
this._register(this.onDidChangeLogLevel(e=>{this._logger&&this._logger.setLevel(e)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=async function(t,r){try{const s=await new Promise((t,i)=>{e(["spdlog"],t,i)});s.setAsyncMode(8192,500);const o=i.join(r,`${t}.log`);return s.createRotatingLoggerAsync(t,o,5*n.ByteSize.MB,6)}catch(e){console.error(e)}return null}(this.name,this.logsFolder).then(e=>{if(e){this._logger=e,this._logger.setLevel(this.getLevel());for(const{level:e,message:t}of this.buffer)s(this._logger,e,t);this.buffer=[]}})),this._loggerCreationPromise}_log(e,t){this._logger?s(this._logger,e,t):this.getLevel()<=e&&this.buffer.push({level:e,message:t})}trace(e,...t){this.getLevel()<=r.LogLevel.Trace&&this._log(r.LogLevel.Trace,this.format([e,...t]))}debug(e,...t){this.getLevel()<=r.LogLevel.Debug&&this._log(r.LogLevel.Debug,this.format([e,...t]))}info(e,...t){this.getLevel()<=r.LogLevel.Info&&this._log(r.LogLevel.Info,this.format([e,...t]))}warn(e,...t){
this.getLevel()<=r.LogLevel.Warning&&this._log(r.LogLevel.Warning,this.format([e,...t]))}error(e,...t){if(this.getLevel()<=r.LogLevel.Error)if(e instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=e.stack,this._log(r.LogLevel.Error,this.format(t))}else this._log(r.LogLevel.Error,this.format([e,...t]))}critical(e,...t){this.getLevel()<=r.LogLevel.Critical&&this._log(r.LogLevel.Critical,this.format([e,...t]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(e){let t="";for(let i=0;i<e.length;i++){let r=e[i];if("object"==typeof r)try{r=JSON.stringify(r)}catch(e){}t+=(i>0?" ":"")+r}return t}}}),define(t[174],i([0,1]),function(e,t){"use strict";function i(e){return void 0!==e.submenu}
function r(e){return"vscode.menubar.separator"===e.id}function n(e){return void 0!==e.uri}Object.defineProperty(t,"__esModule",{value:!0}),t.isMenubarMenuItemAction=t.isMenubarMenuItemUriAction=t.isMenubarMenuItemSeparator=t.isMenubarMenuItemSubmenu=void 0,t.isMenubarMenuItemSubmenu=i,t.isMenubarMenuItemSeparator=r,t.isMenubarMenuItemUriAction=n,t.isMenubarMenuItemAction=function(e){return!i(e)&&!r(e)&&!n(e)}}),define(t[15],i([0,1,3,63,10,17]),function(e,t,i,r,n,s){"use strict";let o;if(Object.defineProperty(t,"__esModule",{value:!0}),i.isWeb||void 0===e||"function"!=typeof e.__$__nodeRequire)o={},0===Object.keys(o).length&&Object.assign(o,{version:"1.53.0-dev",nameShort:i.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:i.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/master/LICENSE.txt",
extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser"]});else{const t=s.dirname(n.FileAccess.asFileUri("",e));o=e.__$__nodeRequire(s.joinPath(t,"product.json").fsPath);const i=e.__$__nodeRequire(s.joinPath(t,"package.json").fsPath);r.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`}),Object.assign(o,{version:i.version})}t.default=o}),define(t[59],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=i.createDecorator("productService")}),define(t[175],i([0,1,56,7,59]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionUrlTrustService=void 0;let a=class{constructor(e,t){this.productService=e,this.logService=t,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(e,t){
if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const r=/^(.*)#([^#]+)$/.exec(t);if(!r)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",t),!1;const[,n,s]=r;let o=this.trustedExtensionUrlPublicKeys.get(e);if(!o){if(!(o=this.productService.trustedExtensionUrlPublicKeys[e])||0===o.length)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",e),!1;this.trustedExtensionUrlPublicKeys.set(e,[...o])}const a=Buffer.from(decodeURIComponent(s),"base64");if(a.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",t),!1;const c=a.slice(0,6),l=a.readUIntBE(0,6),d=Date.now()-l;if(d<0||d>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",t),!1
;const u=a.slice(6),h=i.createVerify("SHA256");h.write(c),h.write(Buffer.from(n)),h.end();for(let r=0;r<o.length;r++){let n=o[r];if(null!==n){if("string"==typeof n)try{n=i.createPublicKey({key:Buffer.from(n,"base64"),format:"der",type:"spki"}),o[r]=n}catch(t){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${r+1} for ${e}:`,t),o[r]=null;continue}if(h.verify(n,u))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",t),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",t),!1}};a=s([o(0,n.IProductService),o(1,r.ILogService)],a),t.ExtensionUrlTrustService=a}),define(t[36],i([0,1,14,95]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;t.Registry=new class{constructor(){this.data=new Map}add(e,t){r.ok(i.isString(e)),r.ok(i.isObject(t)),
r.ok(!this.data.has(e),"There is already an extension with this id"),this.data.set(e,t)}knows(e){return this.data.has(e)}as(e){return this.data.get(e)||null}}}),define(t[176],i([0,1,36,5]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};const n=new class{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(e,t){var i;this.schemasById[(i=e,i.length>0&&"#"===i.charAt(i.length-1)?i.substring(0,i.length-1):i)]=t,this._onDidChangeSchema.fire(e)}notifySchemaChanged(e){this._onDidChangeSchema.fire(e)}getSchemaContributions(){return{schemas:this.schemasById}}};i.Registry.add(t.Extensions.JSONContribution,n)}),define(t[48],i([0,1,127,5,36,14,176]),function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"},function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"}(t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},
t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const a=n.Registry.as(o.Extensions.JSONContribution);function c(e){return e.substring(1,e.length-1)}function l(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.OVERRIDE_PROPERTY_PATTERN=new RegExp("\\[.*\\]$"),t.overrideIdentifierFromKey=c,t.getDefaultValue=l;const d=new class{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:i.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},
patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(e,t=!0){this.registerConfigurations([e],t)}registerConfigurations(e,i=!0){const r=[];e.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,i)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(e){const i=[],r=e=>{if(e.properties)for(const t in e.properties)i.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t]);e.allOf&&e.allOf.forEach(e=>r(e))};for(const t of e){r(t);const e=this.configurationContributors.indexOf(t)
;-1!==e&&this.configurationContributors.splice(e,1)}a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}registerDefaultConfigurations(e){const r=[],n=[];for(const s of e)for(const e in s)if(r.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]=Object.assign(Object.assign({},this.defaultValues[e]||{}),s[e]);const r={type:"object",default:this.defaultValues[e],description:i.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};n.push(c(e)),this.configurationProperties[e]=r,this.defaultLanguageConfigurationOverridesNode.properties[e]=r}else{this.defaultValues[e]=s[e];const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterDefaultConfigurations(e){const i=[];for(const r of e)for(const e in r)if(i.push(e),
delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const t of e)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(e,i=!0,r=3){r=s.isUndefinedOrNull(e.scope)?r:e.scope;let n=[],o=e.properties;if(o)for(let e in o){if(i&&u(e)){delete o[e];continue}const a=o[e];this.updatePropertyDefaultValue(e,a),t.OVERRIDE_PROPERTY_PATTERN.test(e)?a.scope=void 0:a.scope=s.isUndefinedOrNull(a.scope)?r:a.scope,!o[e].hasOwnProperty("included")||o[e].included?(this.configurationProperties[e]=o[e],
!o[e].deprecationMessage&&o[e].markdownDeprecationMessage&&(o[e].deprecationMessage=o[e].markdownDeprecationMessage),n.push(e)):(this.excludedConfigurationProperties[e]=o[e],delete o[e])}let a=e.allOf;if(a)for(let e of a)n.push(...this.validateAndRegisterProperties(e,i,r));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(e){const t=e=>{let i=e.properties;if(i)for(const e in i)this.updateSchema(e,i[e]);let r=e.allOf;r&&r.forEach(t)};t(e)}updateSchema(e,i){switch(t.allSettings.properties[e]=i,i.scope){case 1:t.applicationSettings.properties[e]=i;break;case 2:t.machineSettings.properties[e]=i;break;case 6:t.machineOverridableSettings.properties[e]=i;break;case 3:t.windowSettings.properties[e]=i;break;case 4:t.resourceSettings.properties[e]=i;break;case 5:t.resourceSettings.properties[e]=i,
this.resourceLanguageSettingsSchema.properties[e]=i}}removeFromSchema(e,i){switch(delete t.allSettings.properties[e],i.scope){case 1:delete t.applicationSettings.properties[e];break;case 2:delete t.machineSettings.properties[e];break;case 6:delete t.machineOverridableSettings.properties[e];break;case 3:delete t.windowSettings.properties[e];break;case 4:case 5:delete t.resourceSettings.properties[e]}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const r=`[${e}]`,n={type:"object",description:i.localize(2,null),errorMessage:i.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,n),t.allSettings.properties[r]=n,t.applicationSettings.properties[r]=n,t.machineSettings.properties[r]=n,t.machineOverridableSettings.properties[r]=n,t.windowSettings.properties[r]=n,t.resourceSettings.properties[r]=n}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,t){let i=this.defaultValues[e];s.isUndefined(i)&&(i=t.default),
s.isUndefined(i)&&(i=l(t.type)),t.default=i}};function u(e){return e.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(e)?i.localize(5,null,e):void 0!==d.getConfigurationProperties()[e]?i.localize(6,null,e):null:i.localize(4,null)}n.Registry.add(t.Extensions.Configuration,d),t.validateProperty=u,t.getScopes=function(){const e=[],t=d.getConfigurationProperties();for(const i of Object.keys(t))e.push([i,t[i].scope]);return e.push(["launch",4]),e.push(["task",4]),e}}),define(t[18],i([0,1,41,14,8,36,4,48]),function(e,t,i,r,n,s,o,a){"use strict";function c(e,t){const i=Object.create(null);for(let r in e)l(i,r,e[r],t);return i}function l(e,t,i,r){const n=t.split("."),s=n.pop();let o=e;for(let e=0;e<n.length;e++){let i=n[e],s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:return void r(`Ignoring ${t} as ${n.slice(0,e+1).join(".")} is ${JSON.stringify(s)}`)}o=s}if("object"==typeof o&&null!==o)try{o[s]=i}catch(e){r(`Ignoring ${t} as ${n.join(".")} is ${JSON.stringify(o)}`)
}else r(`Ignoring ${t} as ${n.join(".")} is ${JSON.stringify(o)}`)}function d(e,t,i){const r=function(e,t){let i=e;for(const e of t){if("object"!=typeof i||null===i)return;i=i[e]}return i}(e,t.split("."));return void 0===r?i:r}function u(e){return`[${e}]`}Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=o.createDecorator("configurationService"),t.isConfigurationOverrides=function(e){return e&&"object"==typeof e&&(!e.overrideIdentifier||"string"==typeof e.overrideIdentifier)&&(!e.resource||e.resource instanceof n.URI)},function(e){e[e.USER=1]="USER",e[e.USER_LOCAL=2]="USER_LOCAL",e[e.USER_REMOTE=3]="USER_REMOTE",e[e.WORKSPACE=4]="WORKSPACE",
e[e.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",e[e.DEFAULT=6]="DEFAULT",e[e.MEMORY=7]="MEMORY"}(t.ConfigurationTarget||(t.ConfigurationTarget={})),t.ConfigurationTargetToString=function(e){switch(e){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}},t.compare=function e(t,r){const n=r?t?r.keys.filter(e=>-1===t.keys.indexOf(e)):[...r.keys]:[],s=t?r?t.keys.filter(e=>-1===r.keys.indexOf(e)):[...t.keys]:[],o=[];if(r&&t)for(const e of t.keys)if(-1!==r.keys.indexOf(e)){const n=d(t.contents,e),s=d(r.contents,e);i.equals(n,s)||o.push(e)}const c=[],l=e=>{const t={};for(const i of e)for(const e of i.identifiers)t[u(e)]=i;return t},h=r?l(r.overrides):{},p=t?l(t.overrides):{};if(Object.keys(h).length)for(const e of n){const t=h[e];t&&c.push([a.overrideIdentifierFromKey(e),t.keys])}if(Object.keys(p).length)for(const e of s){const t=p[e];t&&c.push([a.overrideIdentifierFromKey(e),t.keys])}
if(Object.keys(h).length&&Object.keys(p).length)for(const t of o){const i=p[t],r=h[t];if(i&&r){const n=e({contents:i.contents,keys:i.keys,overrides:[]},{contents:r.contents,keys:r.keys,overrides:[]});c.push([a.overrideIdentifierFromKey(t),[...n.added,...n.removed,...n.updated]])}}return{added:n,removed:s,updated:o,overrides:c}},t.toOverrides=function(e,t){const i=[];for(const r of Object.keys(e))if(a.OVERRIDE_PROPERTY_PATTERN.test(r)){const n={};for(const t in e[r])n[t]=e[r][t];i.push({identifiers:[a.overrideIdentifierFromKey(r).trim()],keys:Object.keys(n),contents:c(n,t)})}return i},t.toValuesTree=c,t.addToValueTree=l,t.removeFromValueTree=function(e,t){!function e(t,i){const r=i.shift();if(0===i.length)return void delete t[r];if(-1!==Object.keys(t).indexOf(r)){const n=t[r];"object"!=typeof n||Array.isArray(n)||(e(n,i),0===Object.keys(n).length&&delete t[r])}}(e,t.split("."))},t.getConfigurationValue=d,t.merge=function e(t,i,n){Object.keys(i).forEach(s=>{
"__proto__"!==s&&(s in t?r.isObject(t[s])&&r.isObject(i[s])?e(t[s],i[s],n):n&&(t[s]=i[s]):t[s]=i[s])})},t.getConfigurationKeys=function(){const e=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();return Object.keys(e)},t.getDefaultValues=function(){const e=Object.create(null),t=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();for(let i in t){l(e,i,t[i].default,e=>console.error(`Conflict in default settings: ${e}`))}return e},t.keyFromOverrideIdentifier=u,t.getMigratedSettingValue=function(e,t,i){const r=e.inspect(t),n=e.inspect(i);return void 0!==r.userValue||void 0!==r.workspaceValue||void 0!==r.workspaceFolderValue?r.value:void 0!==n.userValue||void 0!==n.workspaceValue||void 0!==n.workspaceFolderValue?n.value:r.defaultValue}}),define(t[177],i([0,1,40,33,30,14,41,8,48,18,36,2,5]),function(e,t,i,r,n,s,o,a,c,l,d,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class p{constructor(e={},t=[],i=[]){this._contents=e,this._keys=t,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return 0===this._keys.length&&0===Object.keys(this._contents).length&&0===this._overrides.length}getValue(e){return e?l.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,t){const i=this.getContentsForOverrideIdentifer(t);return i?e?l.getConfigurationValue(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.keys;return[]}override(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||"object"!=typeof t||!Object.keys(t).length)return this;let i={}
;for(const e of n.distinct([...Object.keys(this.contents),...Object.keys(t)])){let r=this.contents[e],n=t[e];n&&("object"==typeof r&&"object"==typeof n?(r=o.deepClone(r),this.mergeContents(r,n)):r=n),i[e]=r}return new p(i,this.keys,this.overrides)}merge(...e){const t=o.deepClone(this.contents),i=o.deepClone(this.overrides),r=[...this.keys];for(const s of e){this.mergeContents(t,s.contents);for(const e of s.overrides){const[t]=i.filter(t=>n.equals(t.identifiers,e.identifiers));t?this.mergeContents(t.contents,e.contents):i.push(o.deepClone(e))}for(const e of s.keys)-1===r.indexOf(e)&&r.push(e)}return new p(t,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,t){for(const i of Object.keys(t))i in e&&s.isObject(e[i])&&s.isObject(t[i])?this.mergeContents(e[i],t[i]):e[i]=o.deepClone(t[i])}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?o.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.contents;return null}toJSON(){return{
contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),l.addToValueTree(this.contents,e,t,e=>{throw new Error(e)})}removeValue(e){this.removeKey(e)&&l.removeFromValueTree(this.contents,e)}addKey(e){let t=this.keys.length;for(let i=0;i<t;i++)0===e.indexOf(this.keys[i])&&(t=i);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return-1!==t&&(this.keys.splice(t,1),!0)}}t.ConfigurationModel=p;t.DefaultConfigurationModel=class extends p{constructor(){const e=l.getDefaultValues(),t=l.getConfigurationKeys(),i=[];for(const t of Object.keys(e))c.OVERRIDE_PROPERTY_PATTERN.test(t)&&i.push({identifiers:[c.overrideIdentifierFromKey(t).trim()],keys:Object.keys(e[t]),contents:l.toValuesTree(e[t],e=>console.error(`Conflict in default settings file: ${e}`))});super(e,t,i)}};class f{constructor(e,t){this._name=e,this._scopes=t,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get errors(){
return this._parseErrors}parseContent(e){if(!s.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t)}}parseRaw(e){this._raw=e;const t=this.doParseRaw(e);this._configurationModel=new p(t.contents,t.keys,t.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let t={},r=null,n=[],s=[],o=[];function a(e){Array.isArray(n)?n.push(e):r&&(n[r]=e)}let c={onObjectBegin:()=>{let e={};a(e),s.push(n),n=e,r=null},onObjectProperty:e=>{r=e},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{let e=[];a(e),s.push(n),n=e,r=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:a,onError:(e,t,i)=>{o.push({error:e,offset:t,length:i})}};if(e)try{i.visit(e,c),t=n[0]||{}}catch(e){console.error(`Error while parsing settings file ${this._name}: ${e}`),this._parseErrors=[e]}return t}doParseRaw(e){if(this._scopes){const t=d.Registry.as(c.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,t,!0,this._scopes)}return{
contents:l.toValuesTree(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`)),keys:Object.keys(e),overrides:l.toOverrides(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`))}}filterByScope(e,t,i,r){const n={};for(let s in e)if(c.OVERRIDE_PROPERTY_PATTERN.test(s)&&i)n[s]=this.filterByScope(e[s],t,!1,r);else{const i=this.getScope(s,t);void 0!==i&&-1===r.indexOf(i)||(n[s]=e[s])}return n}getScope(e,t){const i=t[e];return i?void 0!==i.scope?i.scope:3:void 0}}t.ConfigurationModelParser=f;t.UserSettings=class extends u.Disposable{constructor(e,t,i,r){super(),this.userSettingsResource=e,this.scopes=t,this.fileService=r,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(h.Event.filter(this.fileService.onDidFilesChange,e=>e.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}
async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new p}}reprocess(){return this.parser.parse(),this.parser.configurationModel}};class g{constructor(e,t,i=new p,n=new p,s=new r.ResourceMap,o=new p,a=new r.ResourceMap,c=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=i,this._workspaceConfiguration=n,this._folderConfigurations=s,this._memoryConfiguration=o,this._memoryConfigurationByResource=a,this._freeze=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new r.ResourceMap,this._userConfiguration=null}getValue(e,t,i){return this.getConsolidateConfigurationModel(t,i).getValue(e)}updateValue(e,t,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource))||(r=new p,this._memoryConfigurationByResource.set(i.resource,r)):r=this._memoryConfiguration,
void 0===t?r.removeValue(e):r.setValue(e,t),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,i){
const r=this.getConsolidateConfigurationModel(t,i),s=this.getFolderConfigurationModelForResource(t.resource,i),o=t.resource&&this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration,a=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),c=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),l=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),d=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),u=i?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,h=s?t.overrideIdentifier?s.freeze().override(t.overrideIdentifier).getValue(e):s.freeze().getValue(e):void 0,p=t.overrideIdentifier?o.override(t.overrideIdentifier).getValue(e):o.getValue(e),f=r.getValue(e),g=n.distinct(n.flatten(r.overrides.map(e=>e.identifiers))).filter(t=>void 0!==r.getOverrideValue(e,t))
;return{defaultValue:a,userValue:c,userLocalValue:l,userRemoteValue:d,workspaceValue:u,workspaceFolderValue:h,memoryValue:p,value:f,default:void 0!==a?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:void 0!==c?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:void 0!==l?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:void 0!==d?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:void 0!==u?{value:this._workspaceConfiguration.freeze().getValue(e),
override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:void 0!==h?{value:null==s?void 0:s.freeze().getValue(e),override:t.overrideIdentifier?null==s?void 0:s.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:void 0!==p?{value:o.getValue(e),override:t.overrideIdentifier?o.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:g.length?g:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,
this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const i=t.filter(e=>c.OVERRIDE_PROPERTY_PATTERN.test(e)).map(t=>{
const i=c.overrideIdentifierFromKey(t),r=this._defaultConfiguration.getKeysForOverrideIdentifier(i),n=e.getKeysForOverrideIdentifier(i),s=[...n.filter(e=>-1===r.indexOf(e)),...r.filter(e=>-1===n.indexOf(e)),...r.filter(t=>!o.equals(this._defaultConfiguration.override(i).getValue(t),e.override(i).getValue(t)))];return[i,s]});return this.updateDefaultConfiguration(e),{keys:t,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:i,removed:r,overrides:n}=l.compare(this.localUserConfiguration,e),s=[...t,...i,...r];return s.length&&this.updateLocalUserConfiguration(e),{keys:s,overrides:n}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:i,removed:r,overrides:n}=l.compare(this.remoteUserConfiguration,e);let s=[...t,...i,...r];return s.length&&this.updateRemoteUserConfiguration(e),{keys:s,overrides:n}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:i,removed:r,overrides:n}=l.compare(this.workspaceConfiguration,e);let s=[...t,...i,...r]
;return s.length&&this.updateWorkspaceConfiguration(e),{keys:s,overrides:n}}compareAndUpdateFolderConfiguration(e,t){const i=this.folderConfigurations.get(e),{added:r,updated:n,removed:s,overrides:o}=l.compare(i,t);let a=[...r,...n,...s];return!a.length&&i||this.updateFolderConfiguration(e,t),{keys:a,overrides:o}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:r,removed:n,overrides:s}=l.compare(t,void 0);return{keys:[...i,...r,...n],overrides:s}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){
return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let i=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},t){let i=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const r=t.getFolder(e);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const n=this._memoryConfigurationByResource.get(e);n&&(i=i.merge(n))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){
let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(t=i.merge(r),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=i}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const i=t.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:i,overrides:r,keys:n}=this._folderConfigurations.get(t);return e.push([t,{contents:i,overrides:r,keys:n}]),e},[])}}allKeys(){
const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),n=this.parseConfigurationModel(e.workspace),s=e.folders.reduce((e,t)=>(e.set(a.URI.revive(t[0]),this.parseConfigurationModel(t[1])),e),new r.ResourceMap);return new g(t,i,new p,n,s,new p,new r.ResourceMap,!1)}
static parseConfigurationModel(e){return new p(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=g,t.mergeChanges=function(...e){if(0===e.length)return{keys:[],overrides:[]};if(1===e.length)return e[0];const t=new Set,i=new Map;for(const n of e)n.keys.forEach(e=>t.add(e)),n.overrides.forEach(([e,t])=>{const n=r.getOrSet(i,e,new Set);t.forEach(e=>n.add(e))});const n=[];return i.forEach((e,t)=>n.push([t,[...e.values()]])),{keys:[...t.values()],overrides:n}};class m{constructor(e,t,i,r){this.change=e,this.previous=t,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const n=new Set;e.keys.forEach(e=>n.add(e)),e.overrides.forEach(([,e])=>e.forEach(e=>n.add(e))),this.affectedKeys=[...n.values()];const s=new p;this.affectedKeys.forEach(e=>s.setValue(e,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}
affectsConfiguration(e,t){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,t,null===(i=this.previous)||void 0===i?void 0:i.workspace):void 0,n=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!o.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let i,r=l.toValuesTree({[t]:!0},()=>{});for(;"object"==typeof r&&(i=Object.keys(r)[0]);){if(!(e=e[i]))return!1;r=r[i]}return!0}}t.ConfigurationChangeEvent=m;t.AllKeysConfigurationChangeEvent=class extends m{constructor(e,t,i,r){super({keys:e.allKeys(),overrides:[]},void 0,e,t),this.source=i,this.sourceConfig=r}}}),define(t[178],i([0,1,36,48,2,18,177,5,9,17]),function(e,t,i,r,n,s,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;t.ConfigurationService=class extends n.Disposable{constructor(e,t){super(),this.settingsResource=e,this._onDidChangeConfiguration=this._register(new a.Emitter),
this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new o.UserSettings(this.settingsResource,void 0,l.extUriBiasedIgnorePathCase,t)),this.configuration=new o.Configuration(new o.DefaultConfigurationModel,new o.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new c.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(i.Registry.as(r.Extensions.Configuration).onDidUpdateConfiguration(e=>this.onDidDefaultConfigurationChange(e))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const e=await this.userConfiguration.loadConfiguration();this.configuration=new o.Configuration(new o.DefaultConfigurationModel,e)}getConfigurationData(){return this.configuration.toData()}getValue(e,t){const i="string"==typeof e?e:void 0,r=s.isConfigurationOverrides(e)?e:s.isConfigurationOverrides(t)?t:{};return this.configuration.getValue(i,r,void 0)}updateValue(e,t,i,r){
return Promise.reject(new Error("not supported"))}inspect(e){return this.configuration.inspect(e,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const e=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(e)}onDidChangeUserConfiguration(e){const t=this.configuration.toData(),i=this.configuration.compareAndUpdateLocalUserConfiguration(e);this.trigger(i,t,1)}onDidDefaultConfigurationChange(e){const t=this.configuration.toData(),i=this.configuration.compareAndUpdateDefaultConfiguration(new o.DefaultConfigurationModel,e);this.trigger(i,t,6)}trigger(e,t,i){const r=new o.ConfigurationChangeEvent(e,{data:t},this.configuration);r.source=i,r.sourceConfig=this.getTargetConfiguration(i),this._onDidChangeConfiguration.fire(r)}getTargetConfiguration(e){switch(e){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}}),define(t[179],i([0,1,4]),function(e,t,i){"use strict";var r
;Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAuthorityResolverError=t.RemoteAuthorityResolverErrorCode=t.IRemoteAuthorityResolverService=void 0,t.IRemoteAuthorityResolverService=i.createDecorator("remoteAuthorityResolverService"),function(e){e.Unknown="Unknown",e.NotAvailable="NotAvailable",e.TemporarilyNotAvailable="TemporarilyNotAvailable",e.NoResolverFound="NoResolverFound"}(r=t.RemoteAuthorityResolverErrorCode||(t.RemoteAuthorityResolverErrorCode={}));class n extends Error{constructor(e,t=r.Unknown,i){super(e),this._message=e,this._code=t,this._detail=i,this.isHandled=t===r.NotAvailable&&!0===i,"function"==typeof Object.setPrototypeOf&&Object.setPrototypeOf(this,n.prototype)}static isTemporarilyNotAvailable(e){return e instanceof n&&e._code===r.TemporarilyNotAvailable}static isNoResolverFound(e){return e instanceof n&&e._code===r.NoResolverFound}static isHandled(e){return e instanceof n&&e.isHandled}}t.RemoteAuthorityResolverError=n}),
define(t[180],i([0,1,76,31,2,23,5,179,19,9]),function(e,t,i,r,n,s,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionHostPersistentConnection=t.ManagementPersistentConnection=t.ReconnectionPermanentFailureEvent=t.ConnectionGainEvent=t.ReconnectionRunningEvent=t.ReconnectionWaitEvent=t.ConnectionLostEvent=t.PersistentConnectionEventType=t.connectRemoteAgentTunnel=t.connectRemoteAgentExtensionHost=t.connectRemoteAgentManagement=t.ConnectionType=void 0;const d=12e4,u=3e4;async function h(e,t,r){const n=L(e,t),{protocol:o,ownsProtocol:a}=await new Promise((t,r)=>{e.logService.trace(`${n} 1/6. invoking socketFactory.connect().`),e.socketFactory.connect(e.host,e.port,`reconnectionToken=${e.reconnectionToken}&reconnection=${e.reconnectionProtocol?"true":"false"}`,(s,o)=>{if(s||!o)return e.logService.error(`${n} socketFactory.connect() failed. Error:`),e.logService.error(s),void r(s);e.logService.trace(`${n} 2/6. socketFactory.connect() was successful.`),
e.reconnectionProtocol?(e.reconnectionProtocol.beginAcceptReconnection(o,null),t({protocol:e.reconnectionProtocol,ownsProtocol:!1})):t({protocol:new i.PersistentProtocol(o,null),ownsProtocol:!0})})});return new Promise((i,c)=>{const l=setTimeout(()=>{const t=new Error("handshake timeout");t.code="ETIMEDOUT",t.syscall="connect",e.logService.error(`${n} the handshake took longer than 10 seconds. Error:`),e.logService.error(t),a&&P(o),c(t)},1e4),d=o.onControlMessage(async u=>{const h=JSON.parse(u.toString());d.dispose();const p=M(h);if(p)return e.logService.error(`${n} received error control message when negotiating connection. Error:`),e.logService.error(p),a&&P(o),c(p);if("sign"===h.type){e.logService.trace(`${n} 4/6. received SignRequest control message.`);const c=await e.signService.sign(h.data),d={type:"connectionType",commit:e.commit,signedData:c,desiredConnectionType:t};r&&(d.args=r),e.logService.trace(`${n} 5/6. sending ConnectionTypeRequest control message.`),
o.sendControl(s.VSBuffer.fromString(JSON.stringify(d))),clearTimeout(l),i({protocol:o,ownsProtocol:a})}else{const t=new Error("handshake error");e.logService.error(`${n} received unexpected control message. Error:`),e.logService.error(t),a&&P(o),c(t)}});e.logService.trace(`${n} 3/6. sending AuthRequest control message.`);const u={type:"auth",auth:e.connectionToken||"00000000000000000000"};o.sendControl(s.VSBuffer.fromString(JSON.stringify(u)))})}async function p(e,t,i){const r=Date.now(),n=L(e,t),{protocol:s,ownsProtocol:o}=await h(e,t,i);return new Promise((t,i)=>{const a=s.onControlMessage(c=>{a.dispose();const l=JSON.parse(c.toString()),d=M(l);if(d)return e.logService.error(`${n} received error control message when negotiating connection. Error:`),e.logService.error(d),o&&P(s),i(d);e.reconnectionProtocol&&e.reconnectionProtocol.endAcceptReconnection(),e.logService.trace(`${n} 6/6. handshake finished, connection is up and running after ${R(r)}!`),t({protocol:s,firstMessage:l})})})}async function f(e){
const{protocol:t}=await p(e,1,void 0);return{protocol:t}}async function g(e,t){const{protocol:i,firstMessage:r}=await p(e,2,t);return{protocol:i,debugPort:r&&r.debugPort}}async function m(e,t,i){const{host:r,port:n,connectionToken:s}=await e.addressProvider.getAddress();return{commit:e.commit,host:r,port:n,connectionToken:s,reconnectionToken:t,reconnectionProtocol:i,socketFactory:e.socketFactory,signService:e.signService,logService:e.logService}}function v(e){return l.createCancelablePromise(t=>new Promise((i,r)=>{const n=setTimeout(i,1e3*e);t.onCancellationRequested(()=>{clearTimeout(n),i()})}))}!function(e){e[e.Management=1]="Management",e[e.ExtensionHost=2]="ExtensionHost",e[e.Tunnel=3]="Tunnel"}(t.ConnectionType||(t.ConnectionType={})),t.connectRemoteAgentManagement=async function(e,t,i){try{const n=r.generateUuid(),s=await m(e,n,null),{protocol:o}=await k(s.logService,f(s),d);return new C(e,t,i,n,o)}catch(t){
throw e.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),e.logService.error(t),E.triggerPermanentFailure(),t}},t.connectRemoteAgentExtensionHost=async function(e,t){try{const i=r.generateUuid(),n=await m(e,i,null),{protocol:s,debugPort:o}=await k(n.logService,g(n,t),d);return new I(e,t,i,s,o)}catch(t){throw e.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),e.logService.error(t),E.triggerPermanentFailure(),t}},t.connectRemoteAgentTunnel=async function(e,t){const i=await m(e,r.generateUuid(),null);return await k(i.logService,async function(e,t){const i=Date.now(),r=L(e,3),{protocol:n}=await h(e,3,t);return e.logService.trace(`${r} 6/6. handshake finished, connection is up and running after ${R(i)}!`),n}(i,{port:t}),d)},function(e){e[e.ConnectionLost=0]="ConnectionLost",e[e.ReconnectionWait=1]="ReconnectionWait",
e[e.ReconnectionRunning=2]="ReconnectionRunning",e[e.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",e[e.ConnectionGain=4]="ConnectionGain"}(t.PersistentConnectionEventType||(t.PersistentConnectionEventType={}));class w{constructor(){this.type=0}}t.ConnectionLostEvent=w;class y{constructor(e,t){this.durationSeconds=e,this.cancellableTimer=t,this.type=1}skipWait(){this.cancellableTimer.cancel()}}t.ReconnectionWaitEvent=y;class S{constructor(){this.type=2}}t.ReconnectionRunningEvent=S;class b{constructor(){this.type=4}}t.ConnectionGainEvent=b;class _{constructor(){this.type=3}}t.ReconnectionPermanentFailureEvent=_;class E extends n.Disposable{constructor(e,t,i,r){super(),this._connectionType=e,this._onDidStateChange=this._register(new o.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=t,this.reconnectionToken=i,this.protocol=r,this._isReconnecting=!1,this._onDidStateChange.fire(new b),this._register(r.onSocketClose(()=>this._beginReconnecting())),
this._register(r.onSocketTimeout(()=>this._beginReconnecting())),E._instances.push(this),E._permanentFailure&&this._gotoPermanentFailure()}static triggerPermanentFailure(){this._permanentFailure=!0,this._instances.forEach(e=>e._gotoPermanentFailure())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(E._permanentFailure)return;const e=D(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${e} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new w);const t=[5,5,10,10,10,10,10,30],i=Date.now();let r=-1;do{const n=++r<t.length?t[r]:t[t.length-1];try{const t=v(n);this._onDidStateChange.fire(new y(n,t)),this._options.logService.info(`${e} waiting for ${n} seconds before reconnecting...`);try{await t}catch(e){}if(E._permanentFailure){
this._options.logService.error(`${e} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new S),this._options.logService.info(`${e} resolving connection...`);const r=await m(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${e} connecting to ${r.host}:${r.port}...`),await k(r.logService,this._reconnect(r),u),this._options.logService.info(`${e} reconnected!`),this._onDidStateChange.fire(new b);break}catch(t){if("VSCODE_CONNECTION_ERROR"===t.code){this._options.logService.error(`${e} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(t),E.triggerPermanentFailure();break}if(Date.now()-i>108e5){this._options.logService.error(`${e} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(t),E.triggerPermanentFailure();break}
if(a.RemoteAuthorityResolverError.isTemporarilyNotAvailable(t)){this._options.logService.info(`${e} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(t);continue}if(("ETIMEDOUT"===t.code||"ENETUNREACH"===t.code||"ECONNREFUSED"===t.code||"ECONNRESET"===t.code)&&"connect"===t.syscall){this._options.logService.info(`${e} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(t);continue}if(c.isPromiseCanceledError(t)){this._options.logService.info(`${e} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(t);continue}this._options.logService.error(`${e} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(t),E.triggerPermanentFailure();break}}while(!E._permanentFailure)}_gotoPermanentFailure(){
this._onDidStateChange.fire(new _),P(this.protocol)}}E._permanentFailure=!1,E._instances=[];class C extends E{constructor(e,t,r,n,s){super(1,e,n,s),this.client=this._register(new i.Client(s,{remoteAuthority:t,clientId:r},e.ipcLogger))}async _reconnect(e){await f(e)}}t.ManagementPersistentConnection=C;class I extends E{constructor(e,t,i,r,n){super(2,e,i,r),this._startArguments=t,this.debugPort=n}async _reconnect(e){await g(e,this._startArguments)}}function k(e,t,i){return new Promise((r,n)=>{let s=setTimeout(()=>{const t=new Error("Time limit reached");t.code="ETIMEDOUT",t.syscall="connect",e.error("[remote-connection] The time limit has been reached for a connection. Error:"),e.error(t),n(t)},i);t.then(e=>{clearTimeout(s),r(e)},e=>{clearTimeout(s),n(e)})})}function P(e){try{e.acceptDisconnect();const t=e.getSocket();e.dispose(),t.dispose()}catch(e){c.onUnexpectedError(e)}}function M(e){if(e&&"error"===e.type){const t=new Error(`Connection error: ${e.reason}`);return t.code="VSCODE_CONNECTION_ERROR",t}
return null}function D(e,t,i){return`[remote-connection][${function(e,t){for(;e.length<t;)e+=" ";return e}(function(e){switch(e){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}(e),13)}][${t.substr(0,5)}…][${i?"reconnect":"initial"}]`}function L(e,t){return`${D(t,e.reconnectionToken,!!e.reconnectionProtocol)}[${e.host}:${e.port}]`}function R(e){return`${Date.now()-e} ms`}t.ExtensionHostPersistentConnection=I}),define(t[85],i([0,1,10]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteName=t.getRemoteAuthority=void 0,t.getRemoteAuthority=function(e){return e.scheme===i.Schemas.vscodeRemote?e.authority:void 0},t.getRemoteName=function(e){if(!e)return;const t=e.indexOf("+");return t<0?e:e.substr(0,t)}}),define(t[54],i([0,1,5,4,7]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.TunnelService=t.AbstractTunnelService=t.isAllInterfaces=t.ALL_INTERFACES_ADDRESSES=t.isLocalhost=t.LOCALHOST_ADDRESSES=t.extractLocalHostUriMetaDataForPortMapping=t.ITunnelService=void 0,t.ITunnelService=r.createDecorator("tunnelService"),t.extractLocalHostUriMetaDataForPortMapping=function(e){if("http"!==e.scheme&&"https"!==e.scheme)return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(e.authority);return t?{address:t[1],port:+t[2]}:void 0},t.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"],t.isLocalhost=function(e){return t.LOCALHOST_ADDRESSES.indexOf(e)>=0},t.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"],t.isAllInterfaces=function(e){return t.ALL_INTERFACES_ADDRESSES.indexOf(e)>=0};let a=class{constructor(e){this.logService=e,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map}setTunnelProvider(e){
return e?(this._tunnelProvider=e,{dispose:()=>{this._tunnelProvider=void 0}}):{dispose:()=>{}}}get tunnels(){return new Promise(async e=>{const t=[],i=Array.from(this._tunnels.values());for(let e of i){const i=Array.from(e.values());for(let e of i){const i=await e.value;i&&t.push(i)}}e(t)})}dispose(){for(const e of this._tunnels.values()){for(const{value:t}of e.values())t.then(e=>null==e?void 0:e.dispose());e.clear()}this._tunnels.clear()}openTunnel(e,t,i,r){if(!e)return;t||(t="localhost");const n=this.retainOrCreateTunnel(e,t,i,r);return n?n.then(e=>{if(!e)return void this.removeEmptyTunnelFromMap(t,i);const r=this.makeTunnel(e);return e.tunnelRemoteHost===t&&e.tunnelRemotePort===i||this.logService.warn("Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):n}makeTunnel(e){return{tunnelRemotePort:e.tunnelRemotePort,tunnelRemoteHost:e.tunnelRemoteHost,tunnelLocalPort:e.tunnelLocalPort,localAddress:e.localAddress,dispose:()=>{
const t=this._tunnels.get(e.tunnelRemoteHost);if(t){const i=t.get(e.tunnelRemotePort);i&&(i.refcount--,this.tryDisposeTunnel(e.tunnelRemoteHost,e.tunnelRemotePort,i))}}}}async tryDisposeTunnel(e,t,i){if(i.refcount<=0){const r=i.value.then(e=>{e&&(e.dispose(!0),this._onTunnelClosed.fire({host:e.tunnelRemoteHost,port:e.tunnelRemotePort}))});return this._tunnels.has(e)&&this._tunnels.get(e).delete(t),r}}async closeTunnel(e,t){const i=this._tunnels.get(e);if(i&&i.has(t)){const r=i.get(t);r.refcount=0,await this.tryDisposeTunnel(e,t,r)}}addTunnelToMap(e,t,i){this._tunnels.has(e)||this._tunnels.set(e,new Map),this._tunnels.get(e).set(t,{refcount:1,value:i})}async removeEmptyTunnelFromMap(e,t){const i=this._tunnels.get(e);if(i){const r=i.get(t);await r||i.delete(t),0===i.size&&this._tunnels.delete(e)}}getTunnelFromMap(e,t){const i="localhost"===(r=e)?"127.0.0.1":"127.0.0.1"===r?"localhost":void 0;var r;let n;if(i){const t=this._tunnels.get(e),r=this._tunnels.get(i)
;n=t&&r?new Map([...Array.from(t.entries()),...Array.from(r.entries())]):null!=t?t:r}else n=this._tunnels.get(e);return n?n.get(t):void 0}isPortPrivileged(e){return e<1024}};a=s([o(0,n.ILogService)],a),t.AbstractTunnelService=a;t.TunnelService=class extends a{retainOrCreateTunnel(e,t,i,r){const n=this.getTunnelFromMap(t,i);if(n)return++n.refcount,n.value;if(this._tunnelProvider){const e=void 0===r?i:r,n={remoteAddress:{host:t,port:i},localAddressPort:r},s={elevationRequired:this.isPortPrivileged(e)},o=this._tunnelProvider.forwardPort(n,s);return o&&this.addTunnelToMap(t,i,o),o}}}}),define(t[38],i([0,1,139,4,48,36,23]),function(e,t,i,r,n,s,o){"use strict";function a(e){return e.res.statusCode&&e.res.statusCode>=200&&e.res.statusCode<300||1223===e.res.statusCode}function c(e){return 204===e.res.statusCode}Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=r.createDecorator("requestService"),t.isSuccess=a,t.asText=async function(e){
if(!a(e))throw new Error("Server returned "+e.res.statusCode);return c(e)?null:(await o.streamToBuffer(e.stream)).toString()},t.asJson=async function(e){if(!a(e))throw new Error("Server returned "+e.res.statusCode);if(c(e))return null;const t=(await o.streamToBuffer(e.stream)).toString();try{return JSON.parse(t)}catch(e){throw e.message+=":\n"+t,e}},s.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:i.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:i.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:i.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:i.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[i.localize(4,null),i.localize(5,null),i.localize(6,null)],default:"override",description:i.localize(7,null)},
"http.systemCertificates":{type:"boolean",default:!0,description:i.localize(8,null)}}})}),define(t[181],i([0,1,182,14]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0,t.getProxyAgent=async function(t,n={}){const s=i.parse(t),o=n.proxyUrl||function(e){return"http:"===e.protocol?process.env.HTTP_PROXY||process.env.http_proxy||null:"https:"===e.protocol&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}(s);if(!o)return null;const a=i.parse(o);if(!/^https?:$/.test(a.protocol||""))return null;const c={host:a.hostname||"",port:a.port||("https"===a.protocol?"443":"80"),auth:a.auth,rejectUnauthorized:!r.isBoolean(n.strictSSL)||n.strictSSL};return"http:"===s.protocol?new(await new Promise((t,i)=>{e(["http-proxy-agent"],t,i)}))(c):new(await new Promise((t,i)=>{e(["https-proxy-agent"],t,i)}))(c)}}),define(t[183],i([0,1,31,23]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.getServiceMachineId=void 0,t.getServiceMachineId=async function(e,t,n){let s=n&&n.get("storage.serviceMachineId",0)||null;if(s)return s;try{const r=(await t.readFile(e.serviceMachineIdResource)).value.toString();s=i.isUUID(r)?r:null}catch(e){s=null}if(!s){s=i.generateUuid();try{await t.writeFile(e.serviceMachineIdResource,r.VSBuffer.fromString(s))}catch(e){}}return n&&n.store("storage.serviceMachineId",s,0,1),s}}),define(t[86],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ISignService=t.SIGN_SERVICE_ID=void 0,t.SIGN_SERVICE_ID="signService",t.ISignService=i.createDecorator(t.SIGN_SERVICE_ID)}),define(t[184],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SignService=void 0;t.SignService=class{vsda(){return new Promise((t,i)=>e(["vsda"],t,i))}async sign(e){try{const t=new((await this.vsda()).signer);if(t)return t.sign(e)}catch(e){}return e}}}),define(t[37],i([0,1,4]),function(e,t,i){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=i.createDecorator("stateService")}),define(t[20],i([0,1,11,7,37,5,4,166,3,2,9]),function(e,t,i,r,n,a,c,l,d,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LifecycleMainService=t.LifecycleMainPhase=t.UnloadReason=t.ILifecycleMainService=void 0,t.ILifecycleMainService=c.createDecorator("lifecycleMainService"),function(e){e[e.CLOSE=1]="CLOSE",e[e.QUIT=2]="QUIT",e[e.RELOAD=3]="RELOAD",e[e.LOAD=4]="LOAD"}(t.UnloadReason||(t.UnloadReason={})),function(e){e[e.Starting=1]="Starting",e[e.Ready=2]="Ready",e[e.AfterWindowOpen=3]="AfterWindowOpen"}(t.LifecycleMainPhase||(t.LifecycleMainPhase={}));let p=class e extends u.Disposable{constructor(e,t){super(),this.logService=e,this.stateService=t,this._onBeforeShutdown=this._register(new a.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new a.Emitter),this.onWillShutdown=this._onWillShutdown.event,
this._onBeforeWindowClose=this._register(new a.Emitter),this.onBeforeWindowClose=this._onBeforeWindowClose.event,this._onBeforeWindowUnload=this._register(new a.Emitter),this.onBeforeWindowUnload=this._onBeforeWindowUnload.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(e.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(e.QUIT_FROM_RESTART_MARKER)}registerListeners(){const e=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,
this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),d.isMacintosh&&0===this.windowCounter&&this.beginOnWillShutdown())};i.app.addListener("before-quit",e);const t=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),!this._quitRequested&&d.isMacintosh||i.app.quit()};i.app.addListener("window-all-closed",t),i.app.once("will-quit",r=>{this.logService.trace("Lifecycle#app.on(will-quit)"),r.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),i.app.removeListener("before-quit",e),i.app.removeListener("window-all-closed",t),i.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const e=[];return this._onWillShutdown.fire({join(t){t&&e.push(t)}}),this.pendingWillShutdownPromise=Promise.all(e).then(()=>void 0,e=>this.logService.error(e)),this.pendingWillShutdownPromise}set phase(e){
if(e<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===e)return;this.logService.trace(`lifecycle (main): phase changed (value: ${e})`),this._phase=e;const t=this.phaseWhen.get(this._phase);t&&(t.open(),this.phaseWhen.delete(this._phase))}async when(e){if(e<=this._phase)return;let t=this.phaseWhen.get(e);t||(t=new h.Barrier,this.phaseWhen.set(e,t)),await t.wait()}registerWindow(e){this.windowCounter++,e.win.on("close",t=>{const i=e.id;this.windowToCloseRequest.has(i)?this.windowToCloseRequest.delete(i):(this.logService.trace(`Lifecycle#window.on('close') - window ID ${e.id}`),t.preventDefault(),this.unload(e,1).then(t=>{t?this.windowToCloseRequest.delete(i):(this.windowToCloseRequest.add(i),this.logService.trace(`Lifecycle#onBeforeWindowClose.fire() - window ID ${i}`),this._onBeforeWindowClose.fire(e),e.close())}))}),e.win.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${e.id}`),this.windowCounter--,
0!==this.windowCounter||d.isMacintosh&&!this._quitRequested||this.beginOnWillShutdown()})}async reload(e,t){await this.unload(e,3)||e.reload(t)}async unload(e,t){if(!e.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${e.id}`);const i=this._quitRequested?2:t;let r=await this.onBeforeUnloadWindowInRenderer(e,i);return r?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${e.id})`),this.handleWindowUnloadVeto(r)):(r=await this.onBeforeUnloadWindowInMain(e,i))?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${e.id})`),this.handleWindowUnloadVeto(r)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${e.id})`),await this.onWillUnloadWindowInRenderer(e,i),!1)}handleWindowUnloadVeto(e){return!!e&&(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0)}resolvePendingQuitPromise(e){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(e),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}
onBeforeUnloadWindowInRenderer(e,t){return new Promise(r=>{const n=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${n}`,o=`vscode:cancel${n}`;i.ipcMain.once(s,()=>{r(!1)}),i.ipcMain.once(o,()=>{r(!0)}),e.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:o,reason:t})})}onBeforeUnloadWindowInMain(e,t){const i=[];return this._onBeforeWindowUnload.fire({reason:t,window:e,veto(e){i.push(e)}}),l.handleVetos(i,e=>this.logService.error(e))}onWillUnloadWindowInRenderer(e,t){return new Promise(r=>{const n=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;i.ipcMain.once(n,()=>r()),e.send("vscode:onWillUnload",{replyChannel:n,reason:t})})}quit(t){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${t}`),t&&this.stateService.setItem(e.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(e=>{this.pendingQuitPromiseResolve=e,this.logService.trace("Lifecycle#quit() - calling app.quit()"),i.app.quit()}),this.pendingQuitPromise)}relaunch(t){
this.logService.trace("Lifecycle#relaunch()");const r=process.argv.slice(1);if((null==t?void 0:t.addArgs)&&r.push(...t.addArgs),null==t?void 0:t.removeArgs)for(const e of t.removeArgs){const t=r.indexOf(e);t>=0&&r.splice(t,1)}let n=!1;i.app.once("quit",()=>{if(!n){this.stateService.setItem(e.QUIT_FROM_RESTART_MARKER,!0);try{if(d.isWindows){const e=process.env.VSCODE_CWD;e&&process.chdir(e)}}catch(e){this.logService.error(e)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),i.app.relaunch({args:r})}}),this.quit().then(e=>n=e)}async kill(e){this.logService.trace("Lifecycle#kill()"),await Promise.race([h.timeout(1e3),(async()=>{for(const e of i.BrowserWindow.getAllWindows())if(e&&!e.isDestroyed()){let t;t=e.webContents&&!e.webContents.isDestroyed()?new Promise(t=>e.once("closed",t)):Promise.resolve(),e.destroy(),await t}})()]),i.app.exit(e)}};p.QUIT_FROM_RESTART_MARKER="quit.from.restart",p=s([o(0,r.ILogService),o(1,n.IStateService)],p),t.LifecycleMainService=p}),
define(t[185],i([0,1,6,24,52,25,14,7]),function(e,t,i,r,n,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class d{constructor(e,t){this.dbPath=e,this.onError=t,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(this._database)return;const e=await this.loadAsync();this._database||(this._database=e)}loadSync(){try{return this.lastFlushedSerializedDatabase=r.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(e){return"ENOENT"!==e.code&&this.onError(e),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await a.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(e){return"ENOENT"!==e.code&&this.onError(e),{}}}getItem(e,t){const i=this.database[e];return c.isUndefinedOrNull(i)?t:i}setItem(e,t){if(c.isUndefinedOrNull(t))return this.removeItem(e)
;("string"!=typeof t&&"number"!=typeof t&&"boolean"!=typeof t||this.database[e]!==t)&&(this.database[e]=t,this.saveSync())}removeItem(e){c.isUndefined(this.database[e])||(this.database[e]=void 0,this.saveSync())}saveSync(){const e=JSON.stringify(this.database,null,4);if(e!==this.lastFlushedSerializedDatabase)try{a.writeFileSync(this.dbPath,e),this.lastFlushedSerializedDatabase=e}catch(e){this.onError(e)}}}t.FileStorage=d;let u=class e{constructor(t,r){this.fileStorage=new d(i.join(t.userDataPath,e.STATE_FILE),e=>r.error(e))}init(){return this.fileStorage.init()}getItem(e,t){return this.fileStorage.getItem(e,t)}setItem(e,t){this.fileStorage.setItem(e,t)}removeItem(e){this.fileStorage.removeItem(e)}};u.STATE_FILE="storage.json",u=s([o(0,n.INativeEnvironmentService),o(1,l.ILogService)],u),t.StateService=u}),define(t[87],i([0,1,4,5,2,14]),function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const o="__$__targetStorageMarker";var a;t.IStorageService=i.createDecorator("storageService"),function(e){e[e.NONE=0]="NONE",e[e.SHUTDOWN=1]="SHUTDOWN"}(a=t.WillSaveStateReason||(t.WillSaveStateReason={})),function(e){e[e.GLOBAL=0]="GLOBAL",e[e.WORKSPACE=1]="WORKSPACE"}(t.StorageScope||(t.StorageScope={})),function(e){e[e.USER=0]="USER",e[e.MACHINE=1]="MACHINE"}(t.StorageTarget||(t.StorageTarget={}));class c extends n.Disposable{constructor(){super(...arguments),this._onDidChangeValue=this._register(new r.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this._workspaceKeyTargets=void 0,
this._globalKeyTargets=void 0}emitDidChangeValue(e,t){t===o?(0===e?this._globalKeyTargets=void 0:1===e&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:e})):this._onDidChangeValue.fire({scope:e,key:t,target:this.getKeyTargets(e)[t]})}emitWillSaveState(e){this._onWillSaveState.fire({reason:e})}store(e,t,i,r){s.isUndefinedOrNull(t)?this.remove(e,i):this.withPausedEmitters(()=>{this.updateKeyTarget(e,i,r),this.doStore(e,t,i)})}remove(e,t){this.withPausedEmitters(()=>{this.updateKeyTarget(e,t,void 0),this.doRemove(e,t)})}withPausedEmitters(e){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{e()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(e,t){const i=[],r=this.getKeyTargets(e);for(const e of Object.keys(r)){r[e]===t&&i.push(e)}return i}updateKeyTarget(e,t,i){const r=this.getKeyTargets(t);"number"==typeof i?r[e]!==i&&(r[e]=i,this.doStore(o,JSON.stringify(r),t)):"number"==typeof r[e]&&(delete r[e],this.doStore(o,JSON.stringify(r),t))}
get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(e){return 0===e?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(e){const t=this.get(o,e);if(t)try{return JSON.parse(t)}catch(e){}return Object.create(null)}isNew(e){return!0===this.getBoolean(t.IS_NEW_KEY,e)}flush(){return this._onWillSaveState.fire({reason:a.NONE}),this.doFlush()}}t.AbstractStorageService=c;async function l(e,t,i,r){const n=e=>{try{return JSON.parse(e)}catch(t){return e}},s=new Map,o=new Map;e.forEach((e,t)=>{s.set(t,e),o.set(t,n(e))});const a=new Map,c=new Map;t.forEach((e,t)=>{a.set(t,e),c.set(t,n(e))}),console.group(`Storage: Global (path: ${i})`);let l=[];s.forEach((e,t)=>{l.push({key:t,value:e})}),console.table(l),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${r})`)
;let d=[];a.forEach((e,t)=>{d.push({key:t,value:e})}),console.table(d),console.groupEnd(),console.log(c)}t.InMemoryStorageService=class extends c{constructor(){super(...arguments),this.globalCache=new Map,this.workspaceCache=new Map}getCache(e){return 0===e?this.globalCache:this.workspaceCache}get(e,t,i){const r=this.getCache(t).get(e);return s.isUndefinedOrNull(r)?i:r}getBoolean(e,t,i){const r=this.getCache(t).get(e);return s.isUndefinedOrNull(r)?i:"true"===r}getNumber(e,t,i){const r=this.getCache(t).get(e);return s.isUndefinedOrNull(r)?i:parseInt(r,10)}doStore(e,t,i){const r=String(t);this.getCache(i).get(e)!==r&&(this.getCache(i).set(e,r),this.emitDidChangeValue(i,e))}doRemove(e,t){this.getCache(t).delete(e)&&this.emitDidChangeValue(t,e)}logStorage(){l(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(e){}async doFlush(){}async close(){}},t.logStorage=l}),define(t[88],i([0,1,4,5,2,7,52,117,116,6,87]),function(e,t,i,r,n,a,c,l,d,u,h){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.StorageMainService=t.IStorageMainService=void 0,t.IStorageMainService=i.createDecorator("storageMainService");let p=class e extends n.Disposable{constructor(e,t){super(),this.logService=e,this.environmentService=t,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.storage=new d.Storage(new d.InMemoryStorageDatabase)}get items(){return this.storage.items}get storagePath(){return this.environmentService.extensionTestsLocationURI?l.SQLiteStorageDatabase.IN_MEMORY_PATH:u.join(this.environmentService.globalStorageHome.fsPath,e.STORAGE_NAME)}createLogginOptions(){return{logTrace:this.logService.getLevel()===a.LogLevel.Trace?e=>this.logService.trace(e):void 0,logError:e=>this.logService.error(e)}}initialize(){return this.initializePromise||(this.initializePromise=this.doInitialize()),this.initializePromise}async doInitialize(){
this.storage.dispose(),this.storage=new d.Storage(new l.SQLiteStorageDatabase(this.storagePath,{logging:this.createLogginOptions()})),this._register(this.storage.onDidChangeStorage(e=>this._onDidChangeStorage.fire({key:e}))),await this.storage.init();const e=this.storage.getBoolean(h.IS_NEW_KEY);void 0===e?this.storage.set(h.IS_NEW_KEY,!0):e&&this.storage.set(h.IS_NEW_KEY,!1)}get(e,t){return this.storage.get(e,t)}getBoolean(e,t){return this.storage.getBoolean(e,t)}getNumber(e,t){return this.storage.getNumber(e,t)}store(e,t){return this.storage.set(e,t)}remove(e){return this.storage.delete(e)}close(){return this._onWillSaveState.fire(),this.storage.close()}};p.STORAGE_NAME="state.vscdb",p=s([o(0,a.ILogService),o(1,c.IEnvironmentService)],p),t.StorageMainService=p}),define(t[29],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ITelemetryService=void 0,t.ITelemetryService=i.createDecorator("telemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(t[89],i([0,1,27,66,81,24,6,40,75,15,3,8,29,4,62,10,26]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w){"use strict";async function y(e,t){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{
tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,n=new Map,s=2e4;const o={count:0,maxReached:!1};await function e(t,o,l,d){const u=o.substring(t.length+1);return new Promise(h=>{a.readdir(o,{withFileTypes:!0},async(a,p)=>{var f,g,m;if(a)return void h();if(d.count>=s)return d.count+=p.length,d.maxReached=!0,void h();let v=p.length;if(0===v)return void h();let w=p;d.count+p.length>s&&(d.maxReached=!0,v=s-d.count,w=p.slice(0,v)),d.count+=p.length;for(const s of w)if(s.isDirectory()){if(l.includes(s.name)||await e(t,c.join(o,s.name),l,d),0==--v)return void h()}else{
const e=s.name.lastIndexOf(".");if(e>=0){const t=s.name.substring(e+1);t&&r.set(t,(null!==(f=r.get(t))&&void 0!==f?f:0)+1)}for(const e of i)!1!==(null===(g=e.relativePathPattern)||void 0===g?void 0:g.test(u))&&e.filePattern.test(s.name)&&n.set(e.tag,(null!==(m=n.get(e.tag))&&void 0!==m?m:0)+1);if(0==--v)return void h()}})})}(e,e,t,o);const l=await _(e);return{configFiles:S(n),fileTypes:S(r),fileCount:o.count,maxFilesReached:o.maxReached,launchConfigFiles:l}}function S(e){return[...m.Iterable.map(e.entries(),([e,t])=>({name:e,count:t}))].sort((e,t)=>t.count-e.count)}function b(){const e={os:`${i.type()} ${i.arch()} ${i.release()}`,memory:`${(i.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(i.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(100*r.virtualMachineHint.value())}%`},t=i.cpus();return t&&t.length>0&&(e.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),e}function _(e){let t=new Map,i=c.join(e,".vscode","launch.json");return new Promise((e,r)=>{a.exists(i,r=>{if(!r)return e([])
;a.readFile(i,(r,n)=>{if(r)return e([]);const s=[],o=l.parse(n.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),e([]);if("object"===l.getNodeType(o)&&o.configurations)for(const e of o.configurations){const i=e.type;i&&(t.has(i)?t.set(i,t.get(i)+1):t.set(i,1))}return e(S(t))})})})}Object.defineProperty(t,"__esModule",{value:!0}),t.DiagnosticsService=t.collectLaunchConfigs=t.getMachineInfo=t.collectWorkspaceStats=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=g.createDecorator(t.ID),t.collectWorkspaceStats=y,t.getMachineInfo=b,t.collectLaunchConfigs=_;let E=class{constructor(e){this.telemetryService=e}formatMachineInfo(e){const t=[];return t.push(`OS Version:       ${e.os}`),t.push(`CPUs:             ${e.cpus}`),t.push(`Memory (System):  ${e.memory}`),t.push(`VM:               ${e.vmHint}`),t.join("\n")}formatEnvironment(e){const t=[]
;t.push(`Version:          ${u.default.nameShort} ${u.default.version} (${u.default.commit||"Commit unknown"}, ${u.default.date||"Date unknown"})`),t.push(`OS Version:       ${i.type()} ${i.arch()} ${i.release()}`);const n=i.cpus();return n&&n.length>0&&t.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),t.push(`Memory (System):  ${(i.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(i.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||t.push(`Load (avg):       ${i.loadavg().map(e=>Math.round(e)).join(", ")}`),t.push(`VM:               ${Math.round(100*r.virtualMachineHint.value())}%`),t.push(`Screen Reader:    ${e.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${e.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(e.gpuFeatureStatus)}`),t.join("\n")}async getPerformanceInfo(e,t){return Promise.all([d.listProcesses(e.mainPID),this.formatWorkspaceMetadata(e)]).then(async i=>{let[r,s]=i,o=this.formatProcessList(e,r);return t.forEach(t=>{
if(n.isRemoteDiagnosticError(t))o+=`\n${t.errorMessage}`,s+=`\n${t.errorMessage}`;else if(o+=`\n\nRemote: ${t.hostName}`,t.processes&&(o+=`\n${this.formatProcessList(e,t.processes)}`),t.workspaceMetadata){s+=`\n|  Remote: ${t.hostName}`;for(const e of Object.keys(t.workspaceMetadata)){const i=t.workspaceMetadata[e];let r=`${i.fileCount} files`;i.maxFilesReached&&(r=`more than ${r}`),s+=`|    Folder (${e}): ${r}`,s+=this.formatWorkspaceStats(i)}}}),{processInfo:o,workspaceInfo:s}})}async getSystemInfo(e,t){const{memory:r,vmHint:n,os:s,cpus:o}=b(),a={os:s,memory:r,cpus:o,vmHint:n,processArgs:`${e.mainArguments.join(" ")}`,gpuStatus:e.gpuFeatureStatus,screenReader:`${e.screenReader?"yes":"no"}`,remoteData:t};return h.isWindows||(a.load=`${i.loadavg().map(e=>Math.round(e)).join(", ")}`),h.isLinux&&(a.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),
Promise.resolve(a)}async getDiagnostics(e,t){const i=[];return d.listProcesses(e.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(e)),i.push(""),i.push(this.formatProcessList(e,r)),e.windows.some(e=>e.folderURIs&&e.folderURIs.length>0&&!e.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(e))),t.forEach(t=>{if(n.isRemoteDiagnosticError(t))i.push(`\n${t.errorMessage}`);else if(i.push("\n\n"),i.push(`Remote:           ${t.hostName}`),i.push(this.formatMachineInfo(t.machineInfo)),t.processes&&i.push(this.formatProcessList(e,t.processes)),t.workspaceMetadata)for(const e of Object.keys(t.workspaceMetadata)){const r=t.workspaceMetadata[e];let n=`${r.fileCount} files`;r.maxFilesReached&&(n=`more than ${n}`),i.push(`Folder (${e}): ${n}`),i.push(this.formatWorkspaceStats(r))}}),i.push(""),i.push(""),i.join("\n")))}formatWorkspaceStats(e){const t=[];let i=0;const r=(e,r)=>{const s=` ${e}(${r})`;i+s.length>60?(t.push(n),
i=(n="|                 ").length):i+=s.length,n+=s};let n="|      File types:";let s=e.fileTypes.length>10?10:e.fileTypes.length;for(let t=0;t<s;t++){const i=e.fileTypes[t];r(i.name,i.count)}if(t.push(n),e.configFiles.length>=0&&(n="|      Conf files:",i=0,e.configFiles.forEach(e=>{r(e.name,e.count)}),t.push(n)),e.launchConfigFiles.length>0){let i="|      Launch Configs:";e.launchConfigFiles.forEach(e=>{const t=e.count>1?` ${e.name}(${e.count})`:` ${e.name}`;i+=t}),t.push(i)}return t.join("\n")}expandGPUFeatures(e){const t=Math.max(...Object.keys(e).map(e=>e.length));return Object.keys(e).map(i=>`${i}:  ${" ".repeat(t-i.length)}  ${e[i]}`).join("\n                  ")}formatWorkspaceMetadata(e){const t=[],i=[];return e.windows.forEach(e=>{0===e.folderURIs.length||e.remoteAuthority||(t.push(`|  Window (${e.title})`),e.folderURIs.forEach(e=>{const r=p.URI.revive(e);if(r.scheme===v.Schemas.file){const e=r.fsPath;i.push(y(e,["node_modules",".git"]).then(i=>{let r=`${i.fileCount} files`
;i.maxFilesReached&&(r=`more than ${r}`),t.push(`|    Folder (${c.basename(e)}): ${r}`),t.push(this.formatWorkspaceStats(i))}).catch(i=>{t.push(`|      Error: Unable to collect workspace stats for folder ${e} (${i.toString()})`)}))}else t.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(e=>t.join("\n")).catch(e=>`Unable to collect workspace stats: ${e}`)}formatProcessList(e,t){const i=new Map;e.windows.forEach(e=>i.set(e.pid,e.title));const r=[];return r.push("CPU %\tMem MB\t   PID\tProcess"),t&&this.formatProcessItem(e.mainPID,i,r,t,0),r.join("\n")}formatProcessItem(e,t,r,n,s){let o;0===s?o=n.pid===e?`${u.default.applicationName} main`:"remote agent":(o=`${"  ".repeat(s)} ${n.name}`,"window"===n.name&&(o=`${o} (${t.get(n.pid)})`));const a="win32"===process.platform?n.mem:i.totalmem()*(n.mem/100);r.push(`${n.load.toFixed(0).padStart(5," ")}\t${(a/w.ByteSize.MB).toFixed(0).padStart(6," ")}\t${n.pid.toFixed(0).padStart(6," ")}\t${o}`),
Array.isArray(n.children)&&n.children.forEach(i=>this.formatProcessItem(e,t,r,i,s+1))}async reportWorkspaceStats(e){for(const{uri:t}of e.folders){const i=p.URI.revive(t);if(i.scheme!==v.Schemas.file)continue;const r=i.fsPath;try{const t=await y(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":e.telemetryId,rendererSessionId:e.rendererSessionId}),t.fileTypes.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})}),t.launchConfigFiles.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})}),t.configFiles.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})})}catch(e){}}}};E=s([o(0,f.ITelemetryService)],E),t.DiagnosticsService=E}),
define(t[186],i([0,1,19,155,158,41,29,38,148,52,22,7,26,8,59,87,183,4,17]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S){"use strict";var b,_;Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0,function(e){e[e.None=0]="None",e[e.IncludeVersions=1]="IncludeVersions",e[e.IncludeFiles=2]="IncludeFiles",e[e.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",e[e.IncludeSharedAccounts=8]="IncludeSharedAccounts",e[e.IncludeVersionProperties=16]="IncludeVersionProperties",e[e.ExcludeNonValidated=32]="ExcludeNonValidated",e[e.IncludeInstallationTargets=64]="IncludeInstallationTargets",e[e.IncludeAssetUri=128]="IncludeAssetUri",e[e.IncludeStatistics=256]="IncludeStatistics",e[e.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",e[e.Unpublished=4096]="Unpublished"}(b||(b={})),function(e){e[e.Tag=1]="Tag",e[e.ExtensionId=4]="ExtensionId",e[e.Category=5]="Category",e[e.ExtensionName=7]="ExtensionName",e[e.Target=8]="Target",e[e.Featured=9]="Featured",
e[e.SearchText=10]="SearchText",e[e.ExcludeWithFlags=12]="ExcludeWithFlags"}(_||(_={}));const E={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},C={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:b.None,criteria:[],assetTypes:[]};class k{constructor(e=I){this.state=e}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){
return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(e,t=this.state.pageSize){return new k(Object.assign(Object.assign({},this.state),{pageNumber:e,pageSize:t}))}withFilter(e,...t){const i=[...this.state.criteria,...t.length?t.map(t=>({filterType:e,value:t})):[{filterType:e}]];return new k(Object.assign(Object.assign({},this.state),{criteria:i}))}withSortBy(e){return new k(Object.assign(Object.assign({},this.state),{sortBy:e}))}withSortOrder(e){return new k(Object.assign(Object.assign({},this.state),{sortOrder:e}))}withFlags(...e){return new k(Object.assign(Object.assign({},this.state),{flags:e.reduce((e,t)=>e|t,0)}))}withAssetTypes(...e){return new k(Object.assign(Object.assign({},this.state),{assetTypes:e}))}get raw(){const{criteria:e,pageNumber:t,pageSize:i,sortBy:r,sortOrder:n,flags:s,assetTypes:o}=this.state;return{filters:[{criteria:e,pageNumber:t,pageSize:i,sortBy:r,sortOrder:n}],assetTypes:o,flags:s}}get searchText(){
const e=this.state.criteria.filter(e=>e.filterType===_.SearchText)[0];return e&&e.value?e.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(e=>String(e.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function P(e,t){const i=(e||[]).filter(e=>e.statisticName===t)[0];return i?i.value:0}function M(e){return e.files.filter(e=>0===e.assetType.indexOf("Microsoft.VisualStudio.Code.Translation.")).reduce((t,i)=>{const r=T(e,i.assetType);return r&&t.push([i.assetType.substring("Microsoft.VisualStudio.Code.Translation.".length),r]),t},[])}function D(e){if(e.properties){const t=e.properties.filter(e=>e.key===E.Repository),i=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),r=t.filter(e=>i.test(e.value))[0];return r?{uri:r.value,fallbackUri:r.value}:null}return T(e,E.Repository)}function L(e){return{uri:`${e.fallbackAssetUri}/${E.VSIX}?redirect=true`,fallbackUri:`${e.fallbackAssetUri}/${E.VSIX}`}}function R(e){const t=T(e,E.Icon);if(t)return t
;const i=r.DefaultIconPath;return{uri:i,fallbackUri:i}}function T(e,t){return e.files.filter(e=>e.assetType===t)[0]?{uri:`${e.assetUri}/${t}`,fallbackUri:`${e.fallbackAssetUri}/${t}`}:null}function O(e,t){const i=e.properties?e.properties.filter(e=>e.key===t):[],r=i.length>0&&i[0].value;return r?r.split(",").map(e=>n.adoptToGalleryExtensionId(e)):[]}function A(e){const t=e.properties?e.properties.filter(e=>e.key===C.Engine):[];return t.length>0&&t[0].value||""}function x(e){const t=e.properties?e.properties.filter(e=>e.key===C.LocalizedLanguages):[],i=t.length>0&&t[0].value||"";return i?i.split(","):[]}function F(e){const t=e.properties?e.properties.find(e=>e.key===C.WebExtension):void 0;return!!t&&"true"===t.value}function U(e){return e.files.some(e=>e.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?S.joinPath(g.URI.parse(e.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function W(e,t,i,r,s){const o={manifest:T(t,E.Manifest),readme:T(t,E.Details),
changelog:T(t,E.Changelog),license:T(t,E.License),repository:D(t),download:L(t),icon:R(t),coreTranslations:M(t)};return{identifier:{id:n.getGalleryExtensionId(e.publisher.publisherName,e.extensionName),uuid:e.extensionId},name:e.extensionName,version:t.version,date:t.lastUpdated,displayName:e.displayName,publisherId:e.publisher.publisherId,publisher:e.publisher.publisherName,publisherDisplayName:e.publisher.displayName,description:e.shortDescription||"",installCount:P(e.statistics,"install"),rating:P(e.statistics,"averagerating"),ratingCount:P(e.statistics,"ratingcount"),assetUri:g.URI.parse(t.assetUri),webResource:U(t),assetTypes:t.files.map(({assetType:e})=>e),assets:o,properties:{dependencies:O(t,C.Dependency),extensionPack:O(t,C.ExtensionPack),engine:A(t),localizedLanguages:x(t),webExtension:F(t)},telemetryData:{index:(r.pageNumber-1)*r.pageSize+i,searchText:r.searchText,querySource:s},preview:(a=e.flags,-1!==a.indexOf("preview"))};var a}let N=class{constructor(e,t,i,r,n,s,o){this.requestService=e,
this.logService=t,this.environmentService=i,this.telemetryService=r,this.fileService=n,this.productService=s;const a=s.extensionsGallery;this.extensionsGalleryUrl=a&&a.serviceUrl,this.extensionsControlUrl=a&&a.controlUrl,this.commonHeadersPromise=B(s.version,this.environmentService,this.fileService,o)}api(e=""){return`${this.extensionsGalleryUrl}${e}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(e,t){const i=[];let{total:r,firstPage:n,getPage:s}=await this.query({names:e,pageSize:e.length},t);i.push(...n);for(let e=1;i.length<r&&(n=await s(e,t)).length;e++)i.push(...n);return i}async getCompatibleExtension(e,t){const i=await this.getCompatibleExtensionByEngine(e,t);return(null==i?void 0:i.properties.webExtension)?i.webResource?i:null:i}async getCompatibleExtensionByEngine(e,t){const i=r.isIExtensionIdentifier(e)?null:e;if(i&&i.properties.engine&&d.isEngineValid(i.properties.engine,this.productService.version))return i;const{id:n,uuid:s}=i?i.identifier:e
;let o=(new k).withFlags(b.IncludeAssetUri,b.IncludeStatistics,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,1).withFilter(_.Target,"Microsoft.VisualStudio.Code");o=s?o.withFilter(_.ExtensionId,s):o.withFilter(_.ExtensionName,n);const{galleryExtensions:a}=await this.queryGallery(o,h.CancellationToken.None),[c]=a;if(!c||!c.versions.length)return null;if(t){const e=c.versions.filter(e=>e.version===t)[0];if(e){const t=W(c,e,0,o);if(t.properties.engine&&d.isEngineValid(t.properties.engine,this.productService.version))return t}return null}const l=await this.getLastValidExtensionVersion(c,c.versions);return l?W(c,l,0,o):null}async query(e,t){const r=h.CancellationToken.isCancellationToken(e)?{}:e,n=h.CancellationToken.isCancellationToken(e)?e:t;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let s=r.text||"";const o=a.getOrDefault(r,e=>e.pageSize,50)
;let c=(new k).withFlags(b.IncludeLatestVersionOnly,b.IncludeAssetUri,b.IncludeStatistics,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,o).withFilter(_.Target,"Microsoft.VisualStudio.Code");s?((s=(s=(s=(s=s.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,i)=>(c=c.withFilter(_.Category,i||t),""))).replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,i)=>(c=c.withFilter(_.Tag,i||t),""))).replace(/\bfeatured(\s+|\b|$)/g,()=>(c=c.withFilter(_.Featured),""))).trim())&&(s=s.length<200?s:s.substring(0,200),c=c.withFilter(_.SearchText,s)),c=c.withSortBy(0)):c=r.ids?c.withFilter(_.ExtensionId,...r.ids):r.names?c.withFilter(_.ExtensionName,...r.names):c.withSortBy(4),"number"==typeof r.sortBy&&(c=c.withSortBy(r.sortBy)),"number"==typeof r.sortOrder&&(c=c.withSortOrder(r.sortOrder));const{galleryExtensions:l,total:d}=await this.queryGallery(c,n);return{firstPage:l.map((e,t)=>W(e,e.versions[0],t,c,r.source)),total:d,pageSize:c.pageSize,getPage:async(e,t)=>{
if(t.isCancellationRequested)throw i.canceled();const n=c.withPage(e+1),{galleryExtensions:s}=await this.queryGallery(n,t);return s.map((e,t)=>W(e,e.versions[0],t,n,r.source))}}}async queryGallery(e,t){if(!this.isEnabled())throw new Error("No extension gallery service configured.");e=e.withFlags(e.flags,b.ExcludeNonValidated).withFilter(_.ExcludeWithFlags,function(...e){return String(e.reduce((e,t)=>e|t,0))}(b.Unpublished));const r=await this.commonHeadersPromise,n=JSON.stringify(e.raw),s=Object.assign(Object.assign({},r),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(n.length)}),o=(new Date).getTime();let a,c,d=0;try{if((a=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:n,headers:s},t)).res.statusCode&&a.res.statusCode>=400&&a.res.statusCode<500)return{galleryExtensions:[],total:d};const r=await l.asJson(a);if(r){
const e=r.results[0],t=e.extensions,i=e.resultMetadata&&e.resultMetadata.filter(e=>"ResultCount"===e.metadataType)[0];return{galleryExtensions:t,total:d=i&&i.metadataItems.filter(e=>"TotalCount"===e.name)[0].count||0}}return{galleryExtensions:[],total:d}}catch(e){throw c=e,e}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},e.telemetryData),{requestBodySize:String(n.length),duration:(new Date).getTime()-o,success:!!a&&l.isSuccess(a),responseBodySize:null==a?void 0:a.res.headers["Content-Length"],statusCode:a?String(a.res.statusCode):void 0,errorCode:c?i.isPromiseCanceledError(c)?"canceled":i.getErrorMessage(c).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(d)}))}}async reportStatistic(e,t,i,r){if(!this.isEnabled())return;const n=await this.commonHeadersPromise,s=Object.assign(Object.assign({},n),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",
url:this.api(`/publishers/${e}/extensions/${t}/${i}/stats?statType=${r}`),headers:s},h.CancellationToken.None)}catch(e){}}async download(e,t,i){this.logService.trace("ExtensionGalleryService#download",e.identifier.id);const r=n.getGalleryExtensionTelemetryData(e),s=(new Date).getTime(),o=1===i?"install":2===i?"update":"",a=o?{uri:`${e.assets.download.uri}&${o}=true`,fallbackUri:`${e.assets.download.fallbackUri}?${o}=true`}:e.assets.download,c=await this.getAsset(a);await this.fileService.writeFile(t,c.stream),(e=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},r),{duration:e})))((new Date).getTime()-s)}async getReadme(e,t){if(e.assets.readme){const i=await this.getAsset(e.assets.readme,{},t);return await l.asText(i)||""}return""}async getManifest(e,t){if(e.assets.manifest){const i=await this.getAsset(e.assets.manifest,{},t),r=await l.asText(i);return r?JSON.parse(r):null}return null}async getCoreTranslation(e,t){
const i=e.assets.coreTranslations.filter(e=>e[0]===t.toUpperCase())[0];if(i){const e=await this.getAsset(i[1]),t=await l.asText(e);return t?JSON.parse(t):null}return null}async getChangelog(e,t){if(e.assets.changelog){const i=await this.getAsset(e.assets.changelog,{},t);return await l.asText(i)||""}return""}async getAllVersions(e,t){let i=(new k).withFlags(b.IncludeVersions,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,1).withFilter(_.Target,"Microsoft.VisualStudio.Code");i=e.identifier.uuid?i.withFilter(_.ExtensionId,e.identifier.uuid):i.withFilter(_.ExtensionName,e.identifier.id);const r=[],{galleryExtensions:n}=await this.queryGallery(i,h.CancellationToken.None);return n.length&&(t?await Promise.all(n[0].versions.map(async e=>{let t;try{t=await this.getEngine(e)}catch(e){}t&&d.isEngineValid(t,this.productService.version)&&r.push({version:e.version,date:e.lastUpdated})})):r.push(...n[0].versions.map(e=>({version:e.version,date:e.lastUpdated})))),r}async getAsset(e,t={},r=h.CancellationToken.None){
const n=await this.commonHeadersPromise,s=Object.assign(Object.assign({},n),t.headers||{});t=Object.assign(Object.assign(Object.assign({},t),{type:"GET"}),{headers:s});const o=e.uri,a=e.fallbackUri,c=Object.assign(Object.assign({},t),{url:o});try{const e=await this.requestService.request(c,r);if(200===e.res.statusCode)return e;const n=await l.asText(e);throw new Error(`Expected 200, got back ${e.res.statusCode} instead.\n\n${n}`)}catch(e){if(i.isPromiseCanceledError(e))throw e;const n=i.getErrorMessage(e);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:o,message:n});const s=Object.assign(Object.assign({},t),{url:a});return this.requestService.request(s,r)}}async getLastValidExtensionVersion(e,t){const i=this.getLastValidExtensionVersionFromProperties(e,t);return i||this.getLastValidExtensionVersionRecursively(e,t)}getLastValidExtensionVersionFromProperties(e,t){for(const e of t){const t=A(e);if(!t)return null;if(d.isEngineValid(t,this.productService.version))return e}return null}
async getEngine(e){const t=A(e);if(t)return t;const i=T(e,E.Manifest);if(!i)throw new Error("Manifest was not found");const r=await this.getAsset(i,{headers:{"Accept-Encoding":"gzip"}}),n=await l.asJson(r);if(n)return n.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(e,t){if(!t.length)return null;const i=t[0],r=await this.getEngine(i);return d.isEngineValid(r,this.productService.version)?(i.properties=i.properties||[],i.properties.push({key:C.Engine,value:r}),i):this.getLastValidExtensionVersionRecursively(e,t.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const e=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},h.CancellationToken.None);if(200!==e.res.statusCode)throw new Error("Could not get extensions report.");const t=await l.asJson(e),i=new Map;if(t)for(const e of t.malicious){const t=i.get(e)||{id:{id:e},
malicious:!0,slow:!1};t.malicious=!0,i.set(e,t)}return[...i.values()]}};async function B(e,t,i,r){const n={"X-Market-Client-Id":`VSCode ${e}`,"User-Agent":`VSCode ${e}`},s=await w.getServiceMachineId(t,i,r);return n["X-Market-User-Id"]=s,n}N=s([o(0,l.IRequestService),o(1,p.ILogService),o(2,u.IEnvironmentService),o(3,c.ITelemetryService),o(4,f.IFileService),o(5,m.IProductService),o(6,y.optional(v.IStorageService))],N),t.ExtensionGalleryService=N,t.resolveMarketplaceHeaders=B}),define(t[187],i([0,1,5,2,31,29]),function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalStorageDatabaseChannelClient=t.GlobalStorageDatabaseChannel=void 0;class o extends r.Disposable{constructor(e,t){super(),this.logService=e,this.storageMainService=t,this._onDidChangeItems=this._register(new i.Emitter),this.onDidChangeItems=this._onDidChangeItems.event,this.whenReady=this.init()}async init(){try{await this.storageMainService.initialize()}catch(e){
this.logService.error(`[storage] init(): Unable to init global storage due to ${e}`)}this.initTelemetry(),this.registerListeners()}initTelemetry(){void 0===this.storageMainService.get(s.instanceStorageKey,void 0)&&this.storageMainService.store(s.instanceStorageKey,n.generateUuid()),void 0===this.storageMainService.get(s.firstSessionDateStorageKey,void 0)&&this.storageMainService.store(s.firstSessionDateStorageKey,(new Date).toUTCString());const e=this.storageMainService.get(s.currentSessionDateStorageKey,void 0),t=(new Date).toUTCString();this.storageMainService.store(s.lastSessionDateStorageKey,void 0===e?null:e),this.storageMainService.store(s.currentSessionDateStorageKey,t)}registerListeners(){this._register(i.Event.debounce(this.storageMainService.onDidChangeStorage,(e,t)=>(e?e.push(t):e=[t],e),o.STORAGE_CHANGE_DEBOUNCE_TIME)(e=>{e.length&&this._onDidChangeItems.fire(this.serializeEvents(e))}))}serializeEvents(e){const t=new Map,i=new Set;return e.forEach(e=>{const r=this.storageMainService.get(e.key)
;"string"==typeof r?t.set(e.key,r):i.add(e.key)}),{changed:Array.from(t.entries()),deleted:Array.from(i.values())}}listen(e,t){switch(t){case"onDidChangeItems":return this.onDidChangeItems}throw new Error(`Event not found: ${t}`)}async call(e,t,i){switch(await this.whenReady,t){case"getItems":return Array.from(this.storageMainService.items.entries());case"updateItems":{const e=i;if(e.insert)for(const[t,i]of e.insert)this.storageMainService.store(t,i);e.delete&&e.delete.forEach(e=>this.storageMainService.remove(e));break}default:throw new Error(`Call not found: ${t}`)}}}t.GlobalStorageDatabaseChannel=o,o.STORAGE_CHANGE_DEBOUNCE_TIME=100;t.GlobalStorageDatabaseChannelClient=class extends r.Disposable{constructor(e){super(),this.channel=e,this._onDidChangeItemsExternal=this._register(new i.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){
this.onDidChangeItemsOnMainListener=this.channel.listen("onDidChangeItems")(e=>this.onDidChangeItemsOnMain(e))}onDidChangeItemsOnMain(e){(Array.isArray(e.changed)||Array.isArray(e.deleted))&&this._onDidChangeItemsExternal.fire({changed:e.changed?new Map(e.changed):void 0,deleted:e.deleted?new Set(e.deleted):void 0})}async getItems(){const e=await this.channel.call("getItems");return new Map(e)}updateItems(e){const t=Object.create(null);return e.insert&&(t.insert=Array.from(e.insert.entries())),e.delete&&(t.delete=Array.from(e.delete.values())),this.channel.call("updateItems",t)}async close(){r.dispose(this.onDidChangeItemsOnMainListener)}dispose(){super.dispose(),r.dispose(this.onDidChangeItemsOnMainListener)}}}),define(t[188],i([0,1,15,140,16,4,18,48,2,41,36]),function(e,t,i,r,n,a,c,l,d,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let p=class{constructor(e,t){this._configurationService=t,this._experimentProperties={},this._disposables=new d.DisposableStore,
this._cleanupPatterns=[],this._appender=e.appender,this._commonProperties=e.commonProperties||Promise.resolve({}),this._piiPaths=e.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!e.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let e of this._piiPaths)this._cleanupPatterns.push(new RegExp(n.escapeRegExpCharacters(e),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(e=>{const t=/^[a-f0-9]+$/i.test(e["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!t})}))}setExperimentProperty(e,t){this._experimentProperties[e]=t}setEnabled(e){this._enabled=e}_updateUserOptIn(){var e;const t=null===(e=this._configurationService)||void 0===e?void 0:e.getValue(f);this._userOptIn=t?t.enableTelemetry:this._userOptIn}get isOptedIn(){
return this._userOptIn&&this._enabled}async getTelemetryInfo(){const e=await this._commonProperties;return{sessionId:e.sessionID,instanceId:e["common.instanceId"],machineId:e["common.machineId"],msftInternal:e["common.msftInternal"]}}dispose(){this._disposables.dispose()}publicLog(e,t,i){return this.isOptedIn?this._commonProperties.then(r=>{t=u.mixin(t,r),t=u.mixin(t,this._experimentProperties),t=u.cloneAndChange(t,e=>{if("string"==typeof e)return this._cleanupInfo(e,i)}),this._appender.log(e,t)},e=>{console.error(e)}):Promise.resolve(void 0)}publicLog2(e,t,i){return this.publicLog(e,t,i)}publicLogError(e,t){return this.sendErrorTelemetry?this.publicLog(e,t,!0):Promise.resolve(void 0)}publicLogError2(e,t){return this.publicLogError(e,t)}_cleanupInfo(e,t){let i=e;if(t){const t=[];for(let i of this._cleanupPatterns)for(;;){const r=i.exec(e);if(!r)break;t.push([r.index,i.lastIndex])}
const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(i="";;){const o=n.exec(e);if(!o)break;!r.test(o[0])&&t.every(([e,t])=>o.index<e||o.index>=t)&&(i+=e.substring(s,o.index)+"<REDACTED: user-file-path>",s=n.lastIndex)}s<e.length&&(i+=e.substr(s))}for(let e of this._cleanupPatterns)i=i.replace(e,"");return i}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=s([o(1,a.optional(c.IConfigurationService))],p),t.TelemetryService=p;const f="telemetry";h.Registry.as(l.Extensions.Configuration).registerConfiguration({id:f,order:110,type:"object",title:r.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:i.default.privacyStatementUrl?r.localize(2,null,i.default.privacyStatementUrl):r.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(t[189],i([0,1,18,41,14]),function(e,t,i,r,n){"use strict";function s(e){if(!e)return[]
;const t=[];return function e(t,i,r){r&&"object"==typeof r&&!Array.isArray(r)?Object.keys(r).forEach(n=>e(t,i?`${i}.${n}`:n,r[n])):t.push(i)}(t,"",e),t}Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(e,t){return Promise.resolve(void 0)}publicLog2(e,t){return this.publicLog(e,t)}publicLogError(e,t){return Promise.resolve(void 0)}publicLogError2(e,t){return this.publicLogError(e,t)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}},t.combinedAppender=function(...e){return{log:(t,i)=>e.forEach(e=>e.log(t,i)),flush:()=>Promise.all(e.map(e=>e.flush()))}},t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)},
t.configurationTelemetry=function(e,t){return t.onDidChangeConfiguration(t=>{6!==t.source&&e.publicLog2("updateConfiguration",{configurationSource:i.ConfigurationTargetToString(t.source),configurationKeys:s(t.sourceConfig)})})},t.validateTelemetryData=function(e){const t=Object.create(null),i=Object.create(null),s=Object.create(null);!function e(t,i,s=0,o){if(!t)return;for(let a of Object.getOwnPropertyNames(t)){const c=t[a],l=o?o+a:a;Array.isArray(c)?i[l]=r.safeStringify(c):c instanceof Date?i[l]=c.toISOString():n.isObject(c)?s<2?e(c,i,s+1,l+"."):i[l]=r.safeStringify(c):i[l]=c}}(e,s);for(let e in s){const r=s[e=e.length>150?e.substr(e.length-149):e];"number"==typeof r?i[e]=r:"boolean"==typeof r?i[e]=r?1:0:"string"==typeof r?t[e]=r.substring(0,1023):null!=r&&(t[e]=r)}return{properties:t,measurements:i}},t.cleanRemoteAuthority=function(e){if(!e)return"none";let t="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(i=>{0===e.indexOf(`${i}+`)&&(t=i)}),t}}),
define(t[190],i([0,1,3,27,31,25]),function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0,t.resolveCommonProperties=async function(e,t,o,a,c,l){const d=Object.create(null);d["common.machineId"]=o,d.sessionID=n.generateUuid()+Date.now(),d.commitHash=e,d.version=t,d["common.platformVersion"]=(r.release()||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=i.PlatformToString(i.platform),d["common.nodePlatform"]=process.platform,d["common.nodeArch"]=process.arch,d["common.product"]=l||"desktop";const u=function(e){if(!process||!process.env||!process.env.USERDNSDOMAIN)return!1;const t=process.env.USERDNSDOMAIN.toLowerCase();return e.some(e=>t===e)}(a||[]);u&&(d["common.msftInternal"]=u);let h=0;const p=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),
i.isLinuxSnap&&(d["common.snap"]="true");try{const e=await s.readFile(c,"utf8");d["common.source"]=e.slice(0,30)}catch(e){}return d}}),define(t[191],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryAppenderClient=t.TelemetryAppenderChannel=void 0;t.TelemetryAppenderChannel=class{constructor(e){this.appender=e}listen(e,t){throw new Error(`Event not found: ${t}`)}call(e,t,{eventName:i,data:r}){return this.appender.log(i,r),Promise.resolve(null)}};t.TelemetryAppenderClient=class{constructor(e){this.channel=e}log(e,t){return this.channel.call("log",{eventName:e,data:t}).then(void 0,e=>`Failed to log telemetry: ${console.warn(e)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}}),define(t[192],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ColorScheme=void 0,function(e){e.DARK="dark",e.LIGHT="light",e.HIGH_CONTRAST="hc"}(t.ColorScheme||(t.ColorScheme={}))}),
define(t[193],i([0,1,4,2,36,5,192,101]),function(e,t,i,r,n,s,o,a){"use strict";var c;Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=i.createDecorator("themeService"),function(e){e.isThemeColor=function(e){return e&&"object"==typeof e&&"string"==typeof e.id}}(c=t.ThemeColor||(t.ThemeColor={})),t.themeColorFromId=function(e){return{id:e}},function(e){e.isThemeIcon=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(void 0===e.color||c.isThemeColor(e.color))};const t=/^\$\(([a-z.]+\/)?([a-z-~]+)\)$/i;e.fromString=function(e){const i=t.exec(e);if(!i)return;let[,r,n]=i;return r&&"codicon/"!==r?{id:r+n}:{id:n}},e.modify=function(e,t){let i=e.id;const r=i.lastIndexOf("~");return-1!==r&&(i=i.substring(0,r)),t&&(i=`${i}~${t}`),{id:i}},e.isEqual=function(e,t){var i,r
;return e.id===t.id&&(null===(i=e.color)||void 0===i?void 0:i.id)===(null===(r=t.color)||void 0===r?void 0:r.id)},e.asClassNameArray=a.CSSIcon.asClassNameArray,e.asClassName=a.CSSIcon.asClassName,e.asCSSSelector=a.CSSIcon.asCSSSelector}(t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=a.Codicon.file,t.FolderThemeIcon=a.Codicon.folder,t.getThemeTypeSelector=function(e){switch(e){case o.ColorScheme.DARK:return"vs-dark";case o.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}},t.Extensions={ThemingContribution:"base.contributions.theming"};let l=new class{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new s.Emitter}onColorThemeChange(e){return this.themingParticipants.push(e),this.onThemingParticipantAddedEmitter.fire(e),r.toDisposable(()=>{const t=this.themingParticipants.indexOf(e);this.themingParticipants.splice(t,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){
return this.themingParticipants}};n.Registry.add(t.Extensions.ThemingContribution,l),t.registerThemingParticipant=function(e){return l.onColorThemeChange(e)};t.Themable=class extends r.Disposable{constructor(e){super(),this.themeService=e,this.theme=e.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(e=>this.onThemeChange(e)))}onThemeChange(e){this.theme=e,this.updateStyles()}updateStyles(){}getColor(e,t){let i=this.theme.getColor(e);return i&&t&&(i=t(i,this.theme)),i?i.toString():null}}}),define(t[70],i([0,1,3,11,37,4]),function(e,t,i,r,n,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeMainService=t.IThemeMainService=void 0;t.IThemeMainService=a.createDecorator("themeMainService");let c=class{constructor(e){this.stateService=e,r.ipcMain.on("vscode:changeColorTheme",(e,t,i)=>{"string"==typeof i&&this.storeBackgroundColor(JSON.parse(i))})}storeBackgroundColor(e){this.stateService.setItem("theme",e.baseTheme),this.stateService.setItem("themeBackground",e.background)}
getBackgroundColor(){if((i.isWindows||i.isMacintosh)&&r.nativeTheme.shouldUseInvertedColorScheme)return"#000000";let e=this.stateService.getItem("themeBackground",null);if(!e){let t;e="hc-black"===(t=(i.isWindows||i.isMacintosh)&&r.nativeTheme.shouldUseInvertedColorScheme?"hc-black":this.stateService.getItem("theme","vs-dark").split(" ")[0])?"#000000":"vs"===t?"#FFFFFF":"#1E1E1E"}return i.isMacintosh&&"#1E1E1E"===e.toUpperCase()&&(e="#171717"),e}};c=s([o(0,n.IStateService)],c),t.ThemeMainService=c}),define(t[42],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUpdateService=t.State=t.UpdateType=t.StateType=void 0,function(e){e.Uninitialized="uninitialized",e.Idle="idle",e.CheckingForUpdates="checking for updates",e.AvailableForDownload="available for download",e.Downloading="downloading",e.Downloaded="downloaded",e.Updating="updating",e.Ready="ready"}(t.StateType||(t.StateType={})),function(e){e[e.Setup=0]="Setup",e[e.Archive=1]="Archive",e[e.Snap=2]="Snap"
}(t.UpdateType||(t.UpdateType={})),t.State={Uninitialized:{type:"uninitialized"},Idle:(e,t)=>({type:"idle",updateType:e,error:t}),CheckingForUpdates:e=>({type:"checking for updates",context:e}),AvailableForDownload:e=>({type:"available for download",update:e}),Downloading:e=>({type:"downloading",update:e}),Downloaded:e=>({type:"downloaded",update:e}),Updating:e=>({type:"updating",update:e}),Ready:e=>({type:"ready",update:e})},t.IUpdateService=i.createDecorator("updateService")}),define(t[194],i([0,1,36,48,141,3]),function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),i.Registry.as(r.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:n.localize(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:n.localize(1,null),tags:["usesOnlineServices"],enumDescriptions:[n.localize(2,null),n.localize(3,null),n.localize(4,null),n.localize(5,null)]},"update.channel":{type:"string",
default:"default",scope:1,description:n.localize(6,null),deprecationMessage:n.localize(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:n.localize(8,null),description:n.localize(9,null),included:s.isWindows&&!s.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:n.localize(10,null),tags:["usesOnlineServices"]}}})}),define(t[195],i([0,1]),function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UpdateChannel=void 0;t.UpdateChannel=class{constructor(e){this.service=e}listen(e,t){switch(t){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"checkForUpdates":return this.service.checkForUpdates(i);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state)
;case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${t}`)}}}),define(t[90],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IURLService=void 0,t.IURLService=i.createDecorator("urlService")}),define(t[196],i([0,1,8]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URLHandlerRouter=t.URLHandlerChannelClient=t.URLHandlerChannel=void 0;t.URLHandlerChannel=class{constructor(e){this.handler=e}listen(e,t){throw new Error(`Event not found: ${t}`)}call(e,t,r){switch(t){case"handleURL":return this.handler.handleURL(i.URI.revive(r[0]),r[1])}throw new Error(`Call not found: ${t}`)}};t.URLHandlerChannelClient=class{constructor(e){this.channel=e}handleURL(e,t){return this.channel.call("handleURL",[e.toJSON(),t])}};t.URLHandlerRouter=class{constructor(e){this.next=e}async routeCall(e,t,r,n){if("handleURL"!==t)throw new Error(`Call not found: ${t}`);if(r){const t=i.URI.revive(r);if(t&&t.query){
const i=/\bwindowId=(\d+)/.exec(t.query);if(i){const t=i[1],r=new RegExp(`window:${t}`),n=e.connections.find(e=>r.test(e.ctx));if(n)return n}}}return this.next.routeCall(e,t,r,n)}routeEvent(e,t){throw new Error(`Event not found: ${t}`)}}}),define(t[197],i([0,1,8,9,2,15]),function(e,t,i,r,n,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeURLService=t.AbstractURLService=void 0;class o extends n.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(e,t){const i=[...this.handlers.values()];return r.first(i.map(i=>()=>i.handleURL(e,t)),void 0,!1).then(e=>e||!1)}registerHandler(e){return this.handlers.add(e),n.toDisposable(()=>this.handlers.delete(e))}}t.AbstractURLService=o;t.NativeURLService=class extends o{create(e){let{authority:t,path:r,query:n,fragment:o}=e||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&r&&0!==r.indexOf("/")&&(r=`/${r}`),i.URI.from({scheme:s.default.urlProtocol,authority:t,path:r,query:n,fragment:o})}}}),
define(t[198],i([0,1,5,15,11,8,2,3,9]),function(e,t,i,r,n,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronURLListener=void 0;t.ElectronURLListener=class{constructor(e,t,c,l){if(this.urlService=t,this.uris=[],this.retryCount=0,this.flushDisposable=o.Disposable.None,this.disposables=new o.DisposableStore,this.uris=e,a.isWindows){const e=l.isBuilt?[]:[`"${l.appRoot}"`];e.push("--open-url","--"),n.app.setAsDefaultProtocolClient(r.default.urlProtocol,process.execPath,e)}const d=i.Event.map(i.Event.fromNodeEventEmitter(n.app,"open-url",(e,t)=>({event:e,url:t})),({event:e,url:t})=>(e.preventDefault(),t));this.disposables.add(d(e=>{const t=function(e){try{return s.URI.parse(e)}catch(e){return null}}(e);t&&this.urlService.open(t,{originalUrl:e})})),c.getWindows().filter(e=>e.isReady).length>0?this.flush():i.Event.once(c.onWindowReady)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const e=[];for(const t of this.uris){await this.urlService.open(t.uri,{
originalUrl:t.url})||e.push(t)}0!==e.length&&(this.uris=e,this.flushDisposable=c.disposableTimeout(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}}),define(t[199],i([0,1,105,6]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWebviewContentMimeType=void 0;const n=new Map([[".svg","image/svg+xml"],[".txt","text/plain"],[".css","text/css"],[".js","application/javascript"],[".json","application/json"],[".html","text/html"],[".htm","text/html"],[".xhtml","application/xhtml+xml"],[".oft","font/otf"],[".xml","application/xml"]]);t.getWebviewContentMimeType=function(e){const t=r.extname(e.fsPath).toLowerCase();return n.get(t)||i.getMediaMime(e.fsPath)||i.MIME_UNKNOWN}}),define(t[91],i([0,1,22,28,10,6,8,199]),function(e,t,i,r,n,s,o,a){"use strict";var c;function l(e,t){let i=e.fsPath+(e.fsPath.endsWith(s.sep)?"":s.sep),n=t.fsPath;return r.isUNC(e.fsPath)&&r.isUNC(t.fsPath)&&(i=i.toLowerCase(),n=n.toLowerCase()),n.startsWith(i)}
Object.defineProperty(t,"__esModule",{value:!0}),t.loadLocalResource=t.WebviewResourceResponse=t.webviewPartitionId=void 0,t.webviewPartitionId="webview",function(e){let t;!function(e){e[e.Success=0]="Success",e[e.Failed=1]="Failed",e[e.AccessDenied=2]="AccessDenied"}(t=e.Type||(e.Type={}));e.StreamSuccess=class{constructor(e,i){this.stream=e,this.mimeType=i,this.type=t.Success}},e.Failed={type:t.Failed},e.AccessDenied={type:t.AccessDenied}}(c=t.WebviewResourceResponse||(t.WebviewResourceResponse={})),t.loadLocalResource=async function(e,t,r,s,d){d.debug(`loadLocalResource - being. requestUri=${e}`);let u=function(e,t){const i=function(e){if(e.scheme===n.Schemas.vscodeWebviewResource){return o.URI.parse(encodeURIComponent(e.path).replace(/%2F/gi,"/").replace(/^\/([a-z0-9\-]+)(\/{1,2})/i,(e,t,i)=>1===i.length?`${t}:///`:`${t}://`)).with({query:e.query,fragment:e.fragment})}return e}(e);for(const e of t)if(l(e,i))return i;return}(e,t.roots)
;if(d.debug(`loadLocalResource - found resource to load. requestUri=${e}, resourceToLoad=${u}`),!u)return c.AccessDenied;const h=a.getWebviewContentMimeType(e);if(t.rewriteUri&&(u=t.rewriteUri(u)),u.scheme===n.Schemas.http||u.scheme===n.Schemas.https){const t=await s.request({url:u.toString(!0)},i.CancellationToken.None);return d.debug(`loadLocalResource - Loaded over http(s). requestUri=${e}, response=${t.res.statusCode}`),200===t.res.statusCode?new c.StreamSuccess(t.stream,h):c.Failed}try{const t=await r.readFileStream(u);return d.debug(`loadLocalResource - Loaded using fileReader. requestUri=${e}`),new c.StreamSuccess(t,h)}catch(t){return d.debug(`loadLocalResource - Error using fileReader. requestUri=${e}`),console.log(t),c.Failed}}}),define(t[200],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IWebviewManagerService=void 0,t.IWebviewManagerService=i.createDecorator("webviewManagerService")}),define(t[201],i([0,1,10,8,54]),function(e,t,i,r,n){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.WebviewPortMappingManager=void 0;t.WebviewPortMappingManager=class{constructor(e,t,i){this._getExtensionLocation=e,this._getMappings=t,this.tunnelService=i,this._tunnels=new Map}async getRedirect(e,t){const s=r.URI.parse(t),o=n.extractLocalHostUriMetaDataForPortMapping(s);if(o)for(const t of this._getMappings())if(t.webviewPort===o.port){const r=this._getExtensionLocation();if(r&&r.scheme===i.Schemas.vscodeRemote){const i=e&&await this.getOrCreateTunnel(e,t.extensionHostPort);if(i){if(i.tunnelLocalPort===t.webviewPort)return;return encodeURI(s.with({authority:`127.0.0.1:${i.tunnelLocalPort}`}).toString(!0))}}if(t.webviewPort!==t.extensionHostPort)return encodeURI(s.with({authority:`${o.address}:${t.extensionHostPort}`}).toString(!0))}}dispose(){for(const e of this._tunnels.values())e.dispose();this._tunnels.clear()}async getOrCreateTunnel(e,t){const i=this._tunnels.get(t);if(i)return i;const r=await this.tunnelService.openTunnel({getAddress:async()=>e
},void 0,t);return r&&this._tunnels.set(t,r),r}}}),define(t[202],i([0,1,11,2,8,54,91,201]),function(e,t,i,r,n,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WebviewPortMappingProvider=void 0;let d=class extends r.Disposable{constructor(e){super(),this._tunnelService=e,this._webviewData=new Map,i.session.fromPartition(c.webviewPartitionId).webRequest.onBeforeRequest({urls:["*://localhost:*/*","*://127.0.0.1:*/*","*://0.0.0.0:*/*"]},async(e,t)=>{let i;try{i=n.URI.parse(e.lastCommittedOrigin)}catch(e){return t({})}const r=i.authority,s=this._webviewData.get(r);if(!s)return t({});const o=await s.manager.getRedirect(s.metadata.resolvedAuthority,e.url);return t(o?{redirectURL:o}:{})})}async registerWebview(e,t){const i=new l.WebviewPortMappingManager(()=>{var t;return null===(t=this._webviewData.get(e))||void 0===t?void 0:t.metadata.extensionLocation},()=>{var t;return(null===(t=this._webviewData.get(e))||void 0===t?void 0:t.metadata.mappings)||[]},this._tunnelService)
;this._webviewData.set(e,{metadata:t,manager:i})}unregisterWebview(e){const t=this._webviewData.get(e);t&&(t.manager.dispose(),this._webviewData.delete(e))}async updateWebviewMetadata(e,t){const i=this._webviewData.get(e);i&&this._webviewData.set(e,Object.assign(Object.assign({},i),t))}};d=s([o(0,a.ITunnelService)],d),t.WebviewPortMappingProvider=d}),define(t[60],i([0,1,3]),function(e,t,i){"use strict";function r(e){if(i.isWeb)return"custom";const t=e.getValue("window");if(t){if(i.isMacintosh&&!0===t.nativeTabs)return"native";if(i.isMacintosh&&!1===t.nativeFullScreen)return"native";const e=t.titleBarStyle;if("native"===e||"custom"===e)return e}return i.isLinux?"native":"custom"}Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270},t.isWorkspaceToOpen=function(e){return!!e.workspaceUri},
t.isFolderToOpen=function(e){return!!e.folderUri},t.isFileToOpen=function(e){return!!e.fileUri},t.getMenuBarVisibility=function(e){const t=r(e),i=e.getValue("window.menuBarVisibility");return"native"===t&&"compact"===i?"default":i},t.getTitleBarStyle=r,t.zoomLevelToZoomFactor=function(e=0){return Math.pow(1.2,e)}}),define(t[32],i([0,1,4]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IWindowsMainService=t.WindowMode=t.OpenContext=void 0,function(e){e[e.CLI=0]="CLI",e[e.DOCK=1]="DOCK",e[e.MENU=2]="MENU",e[e.DIALOG=3]="DIALOG",e[e.DESKTOP=4]="DESKTOP",e[e.API=5]="API"}(t.OpenContext||(t.OpenContext={})),function(e){e[e.Maximized=0]="Maximized",e[e.Normal=1]="Normal",e[e.Minimized=2]="Minimized",e[e.Fullscreen=3]="Fullscreen"}(t.WindowMode||(t.WindowMode={})),t.IWindowsMainService=i.createDecorator("windowsMainService")}),define(t[203],i([0,1,11,232,23,2,10,8,26,7,38,91,32]),function(e,t,i,r,n,a,c,l,d,u,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.WebviewProtocolProvider=void 0;let g=class t extends a.Disposable{constructor(e,t,r,n){super(),this.fileService=e,this.logService=t,this.requestService=r,this.windowsMainService=n,this.webviewMetadata=new Map,this.requestIdPool=1,this.pendingResourceReads=new Map;const s=i.session.fromPartition(p.webviewPartitionId),o=this.handleWebviewRequest.bind(this);i.protocol.registerFileProtocol(c.Schemas.vscodeWebview,o),s.protocol.registerFileProtocol(c.Schemas.vscodeWebview,o);const l=this.handleWebviewResourceRequest.bind(this);i.protocol.registerStreamProtocol(c.Schemas.vscodeWebviewResource,l),s.protocol.registerStreamProtocol(c.Schemas.vscodeWebviewResource,l),this._register(a.toDisposable(()=>{i.protocol.unregisterProtocol(c.Schemas.vscodeWebviewResource),s.protocol.unregisterProtocol(c.Schemas.vscodeWebviewResource),i.protocol.unregisterProtocol(c.Schemas.vscodeWebview),s.protocol.unregisterProtocol(c.Schemas.vscodeWebview)}))}streamToNodeReadable(e){return new class extends r.Readable{constructor(){
super(...arguments),this.listening=!1}_read(t){this.listening||(this.listening=!0,e.on("data",t=>{try{this.push(t.buffer)||e.pause()}catch(e){this.emit(e)}}),e.on("end",()=>{try{this.push(null)}catch(e){this.emit(e)}}),e.on("error",e=>this.emit("error",e))),e.resume()}_destroy(t,i){e.destroy(),i(null)}}}async registerWebview(e,t){this.webviewMetadata.set(e,t)}unregisterWebview(e){this.webviewMetadata.delete(e)}async updateWebviewMetadata(e,t){const i=this.webviewMetadata.get(e);i&&this.webviewMetadata.set(e,Object.assign(Object.assign({},i),t))}async handleWebviewRequest(i,r){try{const n=l.URI.parse(i.url),s=t.validWebviewFilePaths.get(n.path);if("string"==typeof s){const t=n.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${s}`:`vs/workbench/contrib/webview/browser/pre/${s}`,i=c.FileAccess.asFileUri(t,e);return r(decodeURIComponent(i.fsPath))}}catch(e){}r({error:-10})}async handleWebviewResourceRequest(e,t){try{
const i=l.URI.parse(e.url),r=i.authority,s=this.webviewMetadata.get(r);if(s){let e;s.remoteConnectionData&&(e=e=>{var t;return!s.remoteConnectionData||e.scheme!==c.Schemas.vscodeRemote&&(null===(t=s.extensionLocation)||void 0===t?void 0:t.scheme)!==c.Schemas.vscodeRemote?e:l.URI.parse(`http://${s.remoteConnectionData.host}:${s.remoteConnectionData.port}`).with({path:"/vscode-remote-resource",query:`tkn=${s.remoteConnectionData.connectionToken}&path=${encodeURIComponent(e.path)}`})});const o={readFileStream:async e=>{if(e.scheme===c.Schemas.file)return(await this.fileService.readFileStream(e)).value;const t=this.windowsMainService.getWindowById(s.windowId);if(!t)throw new d.FileOperationError("Could not find window for resource",1);const o=this.requestIdPool++,a=new Promise(e=>{this.pendingResourceReads.set(o,{resolve:e})});t.send(`vscode:loadWebviewResource-${r}`,o,i);const l=await a;if(!l)throw new d.FileOperationError("Could not read file",1);return n.bufferToStream(l)}},a=await p.loadLocalResource(i,{
extensionLocation:s.extensionLocation,roots:s.localResourceRoots,remoteConnectionData:s.remoteConnectionData,rewriteUri:e},o,this.requestService,this.logService);if(a.type===p.WebviewResourceResponse.Type.Success)return t({statusCode:200,data:this.streamToNodeReadable(a.stream),headers:{"Content-Type":a.mimeType,"Access-Control-Allow-Origin":"*"}});if(a.type===p.WebviewResourceResponse.Type.AccessDenied)return console.error("Webview: Cannot load resource outside of protocol root"),t({data:void 0,statusCode:401})}}catch(e){}return t({data:void 0,statusCode:404})}didLoadResource(e,t){const i=this.pendingResourceReads.get(e);if(!i)throw new Error("Unknown request");this.pendingResourceReads.delete(e),i.resolve(t)}};g.validWebviewFilePaths=new Map([["/index.html","index.html"],["/electron-browser/index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"]]),g=s([o(0,d.IFileService),o(1,u.ILogService),o(2,h.IRequestService),o(3,f.IWindowsMainService)],g),t.WebviewProtocolProvider=g}),
define(t[204],i([0,1,11,2,8,26,7,54,38,202,203,32]),function(e,t,i,r,n,a,c,l,d,u,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WebviewMainService=void 0;let f=class extends r.Disposable{constructor(e,t,i,r,n){super(),this.windowsMainService=n,this.protocolProvider=this._register(new h.WebviewProtocolProvider(e,t,i,n)),this.portMappingProvider=this._register(new u.WebviewPortMappingProvider(r))}async registerWebview(e,t,i){const r=i.extensionLocation?n.URI.from(i.extensionLocation):void 0;this.protocolProvider.registerWebview(e,Object.assign(Object.assign({},i),{windowId:t,extensionLocation:r,localResourceRoots:i.localResourceRoots.map(e=>n.URI.from(e))})),this.portMappingProvider.registerWebview(e,{extensionLocation:r,mappings:i.portMappings,resolvedAuthority:i.remoteConnectionData})}async unregisterWebview(e){this.protocolProvider.unregisterWebview(e),this.portMappingProvider.unregisterWebview(e)}async updateWebviewMetadata(e,t){var i
;const r=t.extensionLocation?n.URI.from(t.extensionLocation):void 0;this.protocolProvider.updateWebviewMetadata(e,Object.assign(Object.assign({},t),{extensionLocation:r,localResourceRoots:null===(i=t.localResourceRoots)||void 0===i?void 0:i.map(e=>n.URI.from(e))})),this.portMappingProvider.updateWebviewMetadata(e,Object.assign(Object.assign({},t),{extensionLocation:r}))}async setIgnoreMenuShortcuts(e,t){let r;if("number"==typeof e.windowId){const{windowId:t}=e,i=this.windowsMainService.getWindowById(t);if(!i)throw new Error(`Invalid windowId: ${t}`);r=i.win.webContents}else{const{webContentsId:t}=e;if(!(r=i.webContents.fromId(t)))throw new Error(`Invalid webContentsId: ${t}`)}r.isDestroyed()||r.setIgnoreMenuShortcuts(t)}async didLoadResource(e,t){this.protocolProvider.didLoadResource(e,t)}};f=s([o(0,a.IFileService),o(1,c.ILogService),o(2,d.IRequestService),o(3,l.ITunnelService),o(4,p.IWindowsMainService)],f),t.WebviewMainService=f}),define(t[92],i([0,1,8,17]),function(e,t,i,r){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.findWindowOnExtensionDevelopmentPath=t.findWindowOnWorkspaceOrFolder=t.findWindowOnFile=void 0,t.findWindowOnFile=function(e,t,i){for(const n of e){const e=n.openedWorkspace;if(e){const s=i(e);if(s){if(s.folders.some(e=>r.extUriBiasedIgnorePathCase.isEqualOrParent(t,e.uri)))return n}else if(r.extUriBiasedIgnorePathCase.isEqualOrParent(t,e.configPath))return n}}const n=e.filter(e=>e.openedFolderUri&&r.extUriBiasedIgnorePathCase.isEqualOrParent(t,e.openedFolderUri));if(n.length)return n.sort((e,t)=>-(e.openedFolderUri.path.length-t.openedFolderUri.path.length))[0]},t.findWindowOnWorkspaceOrFolder=function(e,t){for(const i of e){if(i.openedWorkspace&&r.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,t))return i;if(i.openedFolderUri&&r.extUriBiasedIgnorePathCase.isEqual(i.openedFolderUri,t))return i}},t.findWindowOnExtensionDevelopmentPath=function(e,t){var n,s
;const o=e=>t.some(t=>r.extUriBiasedIgnorePathCase.isEqual(i.URI.file(t),i.URI.file(e)));for(const t of e)if(null===(s=null===(n=t.config)||void 0===n?void 0:n.extensionDevelopmentPath)||void 0===s?void 0:s.some(e=>o(e)))return t}}),define(t[205],i([0,1,5,2,9]),function(e,t,i,r,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ActiveWindowManager=void 0;t.ActiveWindowManager=class extends r.Disposable{constructor({onDidOpenWindow:e,onDidFocusWindow:t,getActiveWindowId:s}){super(),this.disposables=this._register(new r.DisposableStore),i.Event.latch(i.Event.any(e,t))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=n.createCancelablePromise(()=>s()),(async()=>{try{const e=await this.firstActiveWindowIdPromise;this.activeWindowId="number"==typeof this.activeWindowId?this.activeWindowId:e}catch(e){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(e){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),
this.firstActiveWindowIdPromise=void 0),this.activeWindowId=e}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}}),define(t[39],i([0,1,4,143,8,3,6,17,97,40,10,34,28,85]),function(e,t,i,r,n,s,o,a,c,l,d,u,h,p){"use strict";function f(e){return e.hasOwnProperty("folderUri")}function g(e){return m(e)||v(e)}function m(e){return e&&"object"==typeof e&&"string"==typeof e.path&&(!e.name||"string"==typeof e.name)}function v(e){return e&&"object"==typeof e&&"string"==typeof e.uri&&(!e.name||"string"==typeof e.name)}function w(e){return e instanceof n.URI}Object.defineProperty(t,"__esModule",{value:!0}),
t.toStoreData=t.restoreRecentlyOpened=t.useSlashForPath=t.rewriteWorkspaceFileForNewLocation=t.getStoredWorkspaceFolder=t.hasWorkspaceFileExtension=t.isSingleFolderWorkspaceInitializationPayload=t.isUntitledWorkspace=t.toWorkspaceIdentifier=t.isWorkspaceIdentifier=t.isSingleFolderWorkspaceIdentifier=t.isRawUriWorkspaceFolder=t.isRawFileWorkspaceFolder=t.isStoredWorkspaceFolder=t.reviveWorkspaceIdentifier=t.isRecentFile=t.isRecentFolder=t.isRecentWorkspace=t.IWorkspacesService=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_EXTENSION=void 0,t.WORKSPACE_EXTENSION="code-workspace",t.WORKSPACE_FILTER=[{name:r.localize(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json",t.IWorkspacesService=i.createDecorator("workspacesService"),t.isRecentWorkspace=function(e){return e.hasOwnProperty("workspace")},t.isRecentFolder=f,t.isRecentFile=function(e){return e.hasOwnProperty("fileUri")},t.reviveWorkspaceIdentifier=function(e){return{id:e.id,configPath:n.URI.revive(e.configPath)}
},t.isStoredWorkspaceFolder=g,t.isRawFileWorkspaceFolder=m,t.isRawUriWorkspaceFolder=v,t.isSingleFolderWorkspaceIdentifier=w,t.isWorkspaceIdentifier=function(e){const t=e;return t&&"string"==typeof t.id&&t.configPath instanceof n.URI},t.toWorkspaceIdentifier=function(e){return e.configuration?{configPath:e.configuration,id:e.id}:1===e.folders.length?e.folders[0].uri:void 0},t.isUntitledWorkspace=function(e,t){return a.extUriBiasedIgnorePathCase.isEqualOrParent(e,t.untitledWorkspacesHome)},t.isSingleFolderWorkspaceInitializationPayload=function(e){return w(e.folder)};const y="."+t.WORKSPACE_EXTENSION;t.hasWorkspaceFileExtension=function(e){return("string"==typeof e?o.extname(e):a.extname(e))===y};const S="/";function b(e,t,i,r,n=!s.isWindows,o){if(e.scheme!==r.scheme)return{name:i,uri:e.toString(!0)};let a=t?void 0:o.relativePath(r,e);if(void 0!==a)0===a.length?a=".":s.isWindows&&e.scheme===d.Schemas.file&&!n&&(a=a.replace(/\//g,"\\"));else if(e.scheme===d.Schemas.file)a=e.fsPath,
s.isWindows&&(a=u.normalizeDriveLetter(a),n&&(a=h.toSlashes(a)));else{if(!o.isEqualAuthority(e.authority,r.authority))return{name:i,uri:e.toString(!0)};a=e.path}return{name:i,path:a}}function _(e){return!s.isWindows||e.some(e=>m(e)&&e.path.indexOf(S)>=0)}t.getStoredWorkspaceFolder=b,t.rewriteWorkspaceFileForNewLocation=function(e,t,i,r,a){let d=function(e,t){let i=l.parse(t);if(!i||!Array.isArray(i.folders))throw new Error(`${e} looks like an invalid workspace file.`);i.folders=i.folders.filter(e=>g(e));return i}(t,e);const u=a.dirname(t),h=a.dirname(r),f=[],v=_(d.folders);for(const e of d.folders){const t=m(e)?a.resolvePath(u,e.path):n.URI.parse(e.uri);let r;r=!i&&(!m(e)||o.isAbsolute(e.path)),f.push(b(t,r,e.name,h,v,a))}const w={insertSpaces:!1,tabSize:4,eol:s.isLinux||s.isMacintosh?"\n":"\r\n"},y=c.setProperty(e,["folders"],f,w);let S=c.applyEdits(e,y);return d.remoteAuthority===p.getRemoteAuthority(r)&&(S=c.applyEdits(S,c.removeProperty(S,["remoteAuthority"],w))),S},t.useSlashForPath=_,
t.restoreRecentlyOpened=function(e,t){const i={workspaces:[],files:[]};if(e){const r=function(e,i){for(let r=0;r<e.length;r++)try{i(e[r],r)}catch(i){t.warn(`Error restoring recent entry ${JSON.stringify(e[r])}: ${i.toString()}. Skip entry.`)}},s=e;Array.isArray(s.workspaces3)&&r(s.workspaces3,(e,t)=>{const r=Array.isArray(s.workspaceLabels)&&s.workspaceLabels[t]||void 0;"object"==typeof e&&"string"==typeof e.id&&"string"==typeof e.configURIPath?i.workspaces.push({label:r,workspace:{id:e.id,configPath:n.URI.parse(e.configURIPath)}}):"string"==typeof e&&i.workspaces.push({label:r,folderUri:n.URI.parse(e)})}),Array.isArray(s.files2)&&r(s.files2,(e,t)=>{const r=Array.isArray(s.fileLabels)&&s.fileLabels[t]||void 0;"string"==typeof e&&i.files.push({label:r,fileUri:n.URI.parse(e)})})}return i},t.toStoreData=function(e){const t={workspaces3:[],files2:[]};let i=!1;const r=[];for(const n of e.workspaces)f(n)?t.workspaces3.push(n.folderUri.toString()):t.workspaces3.push({id:n.workspace.id,
configURIPath:n.workspace.configPath.toString()}),r.push(n.label||null),i=i||!!n.label;i&&(t.workspaceLabels=r),i=!1;const n=[];for(const r of e.files)t.files2.push(r.fileUri.toString()),n.push(r.label||null),i=i||!!r.label;return i&&(t.fileLabels=n),t}}),define(t[49],i([0,1,4,39]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWorkspaceBackupInfo=t.IBackupMainService=void 0,t.IBackupMainService=i.createDecorator("backupMainService"),t.isWorkspaceBackupInfo=function(e){const t=e;return t&&r.isWorkspaceIdentifier(t.workspace)}}),define(t[50],i([0,1,4,11,9,37,3,6,65,25,14,128,39,34]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DialogMainService=t.IDialogMainService=void 0,t.IDialogMainService=i.createDecorator("dialogMainService");let m=class e{constructor(e){this.stateService=e,this.mapWindowToDialogQueue=new Map,this.noWindowDialogQueue=new n.Queue}pickFileFolder(e,t){
return this.doPick(Object.assign(Object.assign({},e),{pickFolders:!0,pickFiles:!0,title:p.localize(0,null)}),t)}pickFolder(e,t){return this.doPick(Object.assign(Object.assign({},e),{pickFolders:!0,title:p.localize(1,null)}),t)}pickFile(e,t){return this.doPick(Object.assign(Object.assign({},e),{pickFiles:!0,title:p.localize(2,null)}),t)}pickWorkspace(e,t){const i=p.localize(3,null),r=g.mnemonicButtonLabel(p.localize(4,null)),n=f.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},e),{pickFiles:!0,title:i,filters:n,buttonLabel:r}),t)}async doPick(t,i){const n={title:t.title,buttonLabel:t.buttonLabel,filters:t.filters};n.defaultPath=t.defaultPath||this.stateService.getItem(e.workingDirPickerStorageKey),"boolean"!=typeof t.pickFiles&&"boolean"!=typeof t.pickFolders||(n.properties=void 0,t.pickFiles&&t.pickFolders&&(n.properties=["multiSelections","openDirectory","openFile","createDirectory"])),
n.properties||(n.properties=["multiSelections",t.pickFolders?"openDirectory":"openFile","createDirectory"]),c.isMacintosh&&n.properties.push("treatPackageAsDirectory");const s=i||r.BrowserWindow.getFocusedWindow(),o=await this.showOpenDialog(n,h.withNullAsUndefined(s));if(o&&o.filePaths&&o.filePaths.length>0)return this.stateService.setItem(e.workingDirPickerStorageKey,l.dirname(o.filePaths[0])),o.filePaths}getDialogQueue(e){if(!e)return this.noWindowDialogQueue;let t=this.mapWindowToDialogQueue.get(e.id);return t||(t=new n.Queue,this.mapWindowToDialogQueue.set(e.id,t)),t}showMessageBox(e,t){return this.getDialogQueue(t).queue(async()=>t?r.dialog.showMessageBox(t,e):r.dialog.showMessageBox(e))}showSaveDialog(e,t){return this.getDialogQueue(t).queue(async()=>{let i;return(i=t?await r.dialog.showSaveDialog(t,e):await r.dialog.showSaveDialog(e)).filePath=function(e){return e&&c.isMacintosh&&(e=d.normalizeNFC(e)),e}(i.filePath),i})}showOpenDialog(e,t){return this.getDialogQueue(t).queue(async()=>{
if(e.defaultPath){await u.exists(e.defaultPath)||(e.defaultPath=void 0)}let i;return(i=t?await r.dialog.showOpenDialog(t,e):await r.dialog.showOpenDialog(e)).filePaths=function(e){return e&&e.length>0&&c.isMacintosh&&(e=e.map(e=>d.normalizeNFC(e))),e}(i.filePaths),i})}};m.workingDirPickerStorageKey="pickerWorkingDir",m=s([o(0,a.IStateService)],m),t.DialogMainService=m}),define(t[206],i([0,1,8,17,4,33,39]),function(e,t,i,r,n,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toWorkspaceFolders=t.toWorkspaceFolder=t.WorkspaceFolder=t.Workspace=t.IWorkspaceFolder=t.IWorkspace=t.WorkbenchState=t.IWorkspaceContextService=void 0,t.IWorkspaceContextService=n.createDecorator("contextService"),function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"}(t.WorkbenchState||(t.WorkbenchState={})),function(e){e.isIWorkspace=function(e){return!(!e||"object"!=typeof e||"string"!=typeof e.id||!Array.isArray(e.folders))}}(t.IWorkspace||(t.IWorkspace={})),function(e){
e.isIWorkspaceFolder=function(e){return!(!e||"object"!=typeof e||!i.URI.isUri(e.uri)||"string"!=typeof e.name||"function"!=typeof e.toResource)}}(t.IWorkspaceFolder||(t.IWorkspaceFolder={}));t.Workspace=class{constructor(e,t,i,r){this._id=e,this._configuration=i,this._ignorePathCasing=r,this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(e){this._id=e.id,this._configuration=e.configuration,this._ignorePathCasing=e._ignorePathCasing,this.folders=e.folders}get folders(){return this._folders}set folders(e){this._folders=e,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(e){this._configuration=e}getFolder(e){return e&&this._foldersMap.findSubstr(e.with({scheme:e.scheme,authority:e.authority,path:e.path}))||null}updateFoldersMap(){this._foldersMap=s.TernarySearchTree.forUris(this._ignorePathCasing);for(const e of this.folders)this._foldersMap.set(e.uri,e)}toJSON(){return{id:this.id,folders:this.folders,
configuration:this.configuration}}};class a{constructor(e,t){this.raw=t,this.uri=e.uri,this.index=e.index,this.name=e.name}toResource(e){return r.joinPath(this.uri,e)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=a,t.toWorkspaceFolder=function(e){return new a({uri:e,index:0,name:r.basenameOrAuthority(e)},{uri:e.toString()})},t.toWorkspaceFolders=function(e,t,r){let n=[],s=new Set;const c=r.dirname(t);for(let t of e){let e=null;if(o.isRawFileWorkspaceFolder(t))t.path&&(e=r.resolvePath(c,t.path));else if(o.isRawUriWorkspaceFolder(t))try{"/"!==(e=i.URI.parse(t.uri)).path[0]&&(e=e.with({path:"/"+e.path}))}catch(e){console.warn(e)}if(e){let i=r.getComparisonKey(e);if(!s.has(i)){s.add(i);const o=t.name||r.basenameOrAuthority(e);n.push(new a({uri:e,name:o,index:n.length},t))}}}return n}}),define(t[43],i([0,1,56,57,207,5,35,6,27,31,2,23,76,19,3]),function(e,t,i,r,n,s,o,a,c,l,d,u,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.connect=t.serve=t.Server=t.createStaticIPCHandle=t.createRandomIPCHandle=t.XDG_RUNTIME_DIR=t.WebSocketNodeSocket=t.NodeSocket=void 0;class g{constructor(e){this.socket=e}dispose(){this.socket.destroy()}onData(e){const t=t=>e(u.VSBuffer.wrap(t));return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(e){return this.socket.on("close",e),{dispose:()=>this.socket.off("close",e)}}onEnd(e){return this.socket.on("end",e),{dispose:()=>this.socket.off("end",e)}}write(e){if(!this.socket.destroyed)try{this.socket.write(e.buffer)}catch(e){if("EPIPE"===e.code)return;p.onUnexpectedError(e)}}end(){this.socket.end()}drain(){return new Promise((e,t)=>{if(0===this.socket.bufferSize)return void e();const i=()=>{this.socket.off("close",i),this.socket.off("end",i),this.socket.off("error",i),this.socket.off("timeout",i),this.socket.off("drain",i),e()};this.socket.on("close",i),this.socket.on("end",i),this.socket.on("error",i),this.socket.on("timeout",i),this.socket.on("drain",i)})}}var m,v;t.NodeSocket=g,
function(e){e[e.MinHeaderByteSize=2]="MinHeaderByteSize"}(m||(m={})),function(e){e[e.PeekHeader=1]="PeekHeader",e[e.ReadHeader=2]="ReadHeader",e[e.ReadBody=3]="ReadBody",e[e.Fin=4]="Fin"}(v||(v={}));function w(e,t){if(0===t)return;let i=e.byteLength>>>2;for(let r=0;r<i;r++){const i=e.readUInt32BE(4*r);e.writeUInt32BE(i^t,4*r)}let r=4*i,n=e.byteLength-r;const s=t>>>24&255,o=t>>>16&255,a=t>>>8&255;n>=1&&e.writeUInt8(e.readUInt8(r)^s,r),n>=2&&e.writeUInt8(e.readUInt8(r+1)^o,r+1),n>=3&&e.writeUInt8(e.readUInt8(r+2)^a,r+2)}t.WebSocketNodeSocket=class extends d.Disposable{constructor(e,t,i,r){super(),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new s.Emitter),this._onClose=this._register(new s.Emitter),this._state={state:1,readLen:2,fin:0,mask:0},this.socket=e,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=t,this._recordInflateBytes=r,
t?(this._zlibInflate=n.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",e=>{console.error(e),p.onUnexpectedError(e),this._onClose.fire()}),this._zlibInflate.on("data",e=>{this._pendingInflateData.push(e)}),i&&(this._zlibInflate.write(i.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=n.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",e=>{console.error(e),p.onUnexpectedError(e),this._onClose.fire()}),this._zlibDeflate.on("data",e=>{this._pendingDeflateData.push(e)})):(this._zlibInflate=null,this._zlibDeflate=null),this._incomingData=new h.ChunkStream,this._register(this.socket.onData(e=>this._acceptChunk(e))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}
get recordedInflateBytes(){return this._recordInflateBytes?u.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):u.VSBuffer.alloc(0)}dispose(){this.socket.dispose()}onData(e){return this._onData.event(e)}onClose(e){return this._onClose.event(e)}onEnd(e){return this.socket.onEnd(e)}write(e){this._totalOutgoingDataBytes+=e.byteLength,this._zlibDeflate?(this._zlibDeflate.write(e.buffer),this._zlibDeflate.flush(2,()=>{let e=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,e=e.slice(0,e.length-4),this._write(u.VSBuffer.wrap(e),!0)})):this._write(e,!1)}_write(e,t){let i=2;e.byteLength<126?i+=0:e.byteLength<65536?i+=2:i+=8;const r=u.VSBuffer.alloc(i);if(t?r.writeUInt8(194,0):r.writeUInt8(130,0),e.byteLength<126)r.writeUInt8(e.byteLength,1);else if(e.byteLength<65536){r.writeUInt8(126,1);let t=1;r.writeUInt8(e.byteLength>>>8&255,++t),r.writeUInt8(e.byteLength>>>0&255,++t)}else{r.writeUInt8(127,1);let t=1;r.writeUInt8(0,++t),r.writeUInt8(0,++t),r.writeUInt8(0,++t),r.writeUInt8(0,++t),
r.writeUInt8(e.byteLength>>>24&255,++t),r.writeUInt8(e.byteLength>>>16&255,++t),r.writeUInt8(e.byteLength>>>8&255,++t),r.writeUInt8(e.byteLength>>>0&255,++t)}this._totalOutgoingWireBytes+=r.byteLength+e.byteLength,this.socket.write(u.VSBuffer.concat([r,e]))}end(){this.socket.end()}_acceptChunk(e){if(0!==e.byteLength)for(this._totalIncomingWireBytes+=e.byteLength,this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;)if(1===this._state.state){const e=this._incomingData.peek(this._state.readLen),t=(128&e.readUInt8(0))>>>7,i=e.readUInt8(1),r=(128&i)>>>7,n=127&i;this._state.state=2,this._state.readLen=2+(r?4:0)+(126===n?2:0)+(127===n?8:0),this._state.fin=t,this._state.mask=0}else if(2===this._state.state){const e=this._incomingData.read(this._state.readLen),t=e.readUInt8(1),i=(128&t)>>>7;let r=127&t,n=1
;126===r?r=256*e.readUInt8(++n)+e.readUInt8(++n):127===r&&(r=0*e.readUInt8(++n)+0*e.readUInt8(++n)+0*e.readUInt8(++n)+0*e.readUInt8(++n)+e.readUInt8(++n)*2**24+65536*e.readUInt8(++n)+256*e.readUInt8(++n)+e.readUInt8(++n));let s=0;i&&(s=e.readUInt8(++n)*2**24+65536*e.readUInt8(++n)+256*e.readUInt8(++n)+e.readUInt8(++n)),this._state.state=3,this._state.readLen=r,this._state.mask=s}else if(3===this._state.state){const e=this._incomingData.read(this._state.readLen);w(e,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(e.buffer)),this._zlibInflate.write(e.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const e=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=e.length,
this._onData.fire(u.VSBuffer.wrap(e))})):(this._totalIncomingDataBytes+=e.byteLength,this._onData.fire(e))}}drain(){return this.socket.drain()}},t.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const y={2:107,1:103};function S(e){const t=y[f.platform];"number"==typeof t&&e.length>=t&&console.warn(`WARNING: IPC handle "${e}" is longer than ${t} chars, try a shorter --user-data-dir`)}t.createRandomIPCHandle=function(){const e=l.generateUuid();if("win32"===process.platform)return`\\\\.\\pipe\\vscode-ipc-${e}-sock`;let i;return S(i=t.XDG_RUNTIME_DIR?a.join(t.XDG_RUNTIME_DIR,`vscode-ipc-${e}.sock`):a.join(c.tmpdir(),`vscode-ipc-${e}.sock`)),i},t.createStaticIPCHandle=function(e,r,n){const s=i.createHash("md5").update(e).digest("hex");if("win32"===process.platform)return`\\\\.\\pipe\\${s}-${n}-${r}-sock`;let o;return S(o=t.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?a.join(t.XDG_RUNTIME_DIR,`vscode-${s.substr(0,8)}-${n}-${r}.sock`):a.join(e,`${n}-${r}.sock`)),o};class b extends o.IPCServer{constructor(e){
super(b.toClientConnectionEvent(e)),this.server=e}static toClientConnectionEvent(e){const t=s.Event.fromNodeEventEmitter(e,"connection");return s.Event.map(t,e=>({protocol:new h.Protocol(new g(e)),onDidClientDisconnect:s.Event.once(s.Event.fromNodeEventEmitter(e,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}t.Server=b,t.serve=function(e){return new Promise((t,i)=>{const n=r.createServer();n.on("error",i),n.listen(e,()=>{n.removeListener("error",i),t(new b(n))})})},t.connect=function(e,t){return new Promise((i,n)=>{const s=r.createConnection(e,()=>{s.removeListener("error",n),i(h.Client.fromSocket(new g(s),t))});s.once("error",n)})}}),define(t[208],i([0,1,43]),function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.connect=t.WindowDriverChannelClient=t.WindowDriverChannel=t.WindowDriverRegistryChannelClient=t.WindowDriverRegistryChannel=t.DriverChannelClient=t.DriverChannel=void 0;t.DriverChannel=class{constructor(e){this.driver=e}
listen(e,t){throw new Error("No event found")}call(e,t,i){switch(t){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2])}
throw new Error(`Call not found: ${t}`)}};class r{constructor(e){this.channel=e}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(e){return this.channel.call("capturePage",e)}reloadWindow(e){return this.channel.call("reloadWindow",e)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(e,t){return this.channel.call("dispatchKeybinding",[e,t])}click(e,t,i,r){return this.channel.call("click",[e,t,i,r])}doubleClick(e,t){return this.channel.call("doubleClick",[e,t])}setValue(e,t,i){return this.channel.call("setValue",[e,t,i])}getTitle(e){return this.channel.call("getTitle",[e])}isActiveElement(e,t){return this.channel.call("isActiveElement",[e,t])}getElements(e,t,i){return this.channel.call("getElements",[e,t,i])}getElementXY(e,t,i,r){return this.channel.call("getElementXY",[e,t,i,r])}typeInEditor(e,t,i){return this.channel.call("typeInEditor",[e,t,i])}getTerminalBuffer(e,t){return this.channel.call("getTerminalBuffer",[e,t])}writeInTerminal(e,t,i){
return this.channel.call("writeInTerminal",[e,t,i])}}t.DriverChannelClient=r;t.WindowDriverRegistryChannel=class{constructor(e){this.registry=e}listen(e,t){throw new Error(`Event not found: ${t}`)}call(e,t,i){switch(t){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${t}`)}};t.WindowDriverRegistryChannelClient=class{constructor(e){this.channel=e}registerWindowDriver(e){return this.channel.call("registerWindowDriver",e)}reloadWindowDriver(e){return this.channel.call("reloadWindowDriver",e)}};t.WindowDriverChannel=class{constructor(e){this.driver=e}listen(e,t){throw new Error(`No event found: ${t}`)}call(e,t,i){switch(t){case"click":return this.driver.click(i[0],i[1],i[2]);case"doubleClick":return this.driver.doubleClick(i);case"setValue":return this.driver.setValue(i[0],i[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(i)
;case"getElements":return this.driver.getElements(i[0],i[1]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1])}throw new Error(`Call not found: ${t}`)}};t.WindowDriverChannelClient=class{constructor(e){this.channel=e}click(e,t,i){return this.channel.call("click",[e,t,i])}doubleClick(e){return this.channel.call("doubleClick",e)}setValue(e,t){return this.channel.call("setValue",[e,t])}getTitle(){return this.channel.call("getTitle")}isActiveElement(e){return this.channel.call("isActiveElement",e)}getElements(e,t){return this.channel.call("getElements",[e,t])}getElementXY(e,t,i){return this.channel.call("getElementXY",[e,t,i])}typeInEditor(e,t){return this.channel.call("typeInEditor",[e,t])}getTerminalBuffer(e){return this.channel.call("getTerminalBuffer",e)}writeInTerminal(e,t){
return this.channel.call("writeInTerminal",[e,t])}},t.connect=async function(e){const t=await i.connect(e,"driverClient"),n=t.getChannel("driver");return{client:t,driver:new r(n)}}}),define(t[209],i([0,1,27,108,6,17,45,15,119,10,8,43]),function(e,t,i,r,n,o,a,c,l,d,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseUserDataDir=t.parsePathArg=t.parseSearchPort=t.parseExtensionHostPort=t.NativeEnvironmentService=void 0;class p{constructor(e){if(this._args=e,!e.logsPath){const t=l.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");e.logsPath=n.join(this.userDataPath,"logs",t)}this.logsPath=e.logsPath}get args(){return this._args}get appRoot(){return n.dirname(d.FileAccess.asFileUri("",e).fsPath)}get userHome(){return u.URI.file(i.homedir())}get userDataPath(){const e=process.env.VSCODE_PORTABLE;return e?n.join(e,"user-data"):v(this._args,process)}get appSettingsHome(){return u.URI.file(n.join(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(i.tmpdir())}get userRoamingDataHome(){
return this.appSettingsHome}get settingsResource(){return o.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return o.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return u.URI.file(n.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return o.joinPath(u.URI.file(n.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return u.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return u.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return o.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return o.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const e=process.env.VSCODE_PORTABLE;return e?u.URI.file(n.join(e,"argv.json")):o.joinPath(this.userHome,c.default.dataFolderName,"argv.json")}get snippetsHome(){return o.joinPath(this.userRoamingDataHome,"snippets")}
get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file(n.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return n.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const t=m(this._args["builtin-extensions-dir"],process);return t||n.normalize(n.join(d.FileAccess.asFileUri("",e).fsPath,"..","extensions"))}get extensionsDownloadPath(){const e=m(this._args["extensions-download-dir"],process);return e||n.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const e=m(this._args["extensions-dir"],process);if(e)return e;const t=process.env.VSCODE_EXTENSIONS;if(t)return t;const i=process.env.VSCODE_PORTABLE;return i?n.join(i,"extensions"):o.joinPath(this.userHome,c.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const e=this._args.extensionDevelopmentPath;if(Array.isArray(e))return e.map(e=>/^[^:/?#]+?:\/\//.test(e)?u.URI.parse(e):u.URI.file(n.normalize(e)))}
get extensionTestsLocationURI(){const e=this._args.extensionTestsPath;if(e)return/^[^:/?#]+?:\/\//.test(e)?u.URI.parse(e):u.URI.file(n.normalize(e))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const e=this._args["disable-extension"];if(e){if("string"==typeof e)return[e];if(Array.isArray(e)&&e.length>0)return e}return!1}get debugExtensionHost(){return f(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get sharedIPCHandle(){return h.createStaticIPCHandle(this.userDataPath,"shared",c.default.version)}get serviceMachineIdResource(){return o.joinPath(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){
return u.URI.file(n.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}function f(e,t){return g(e["inspect-extensions"],e["inspect-brk-extensions"],5870,t,e.debugId)}function g(e,t,i,r,n){const s=Number(t||e)||(r?null:i);return{port:s,break:!!s&&Boolean(!!t),debugId:n}}function m(e,t){if(!e)return;const i=n.resolve(e);return n.normalize(e)===i?i:n.resolve(t.env.VSCODE_CWD||t.cwd(),e)}function v(e,t){return m(e["user-data-dir"],t)||n.resolve(r.getDefaultUserDataPath())}s([a.memoize],p.prototype,"appRoot",null),s([a.memoize],p.prototype,"userHome",null),s([a.memoize],p.prototype,"userDataPath",null),s([a.memoize],p.prototype,"appSettingsHome",null),s([a.memoize],p.prototype,"tmpDir",null),s([a.memoize],p.prototype,"userRoamingDataHome",null),s([a.memoize],p.prototype,"settingsResource",null),s([a.memoize],p.prototype,"userDataSyncHome",null),s([a.memoize],p.prototype,"userDataSyncLogResource",null),s([a.memoize],p.prototype,"sync",null),
s([a.memoize],p.prototype,"machineSettingsResource",null),s([a.memoize],p.prototype,"globalStorageHome",null),s([a.memoize],p.prototype,"workspaceStorageHome",null),s([a.memoize],p.prototype,"keybindingsResource",null),s([a.memoize],p.prototype,"keyboardLayoutResource",null),s([a.memoize],p.prototype,"argvResource",null),s([a.memoize],p.prototype,"snippetsHome",null),s([a.memoize],p.prototype,"isExtensionDevelopment",null),s([a.memoize],p.prototype,"untitledWorkspacesHome",null),s([a.memoize],p.prototype,"installSourcePath",null),s([a.memoize],p.prototype,"builtinExtensionsPath",null),s([a.memoize],p.prototype,"extensionsPath",null),s([a.memoize],p.prototype,"extensionDevelopmentLocationURI",null),s([a.memoize],p.prototype,"extensionTestsLocationURI",null),s([a.memoize],p.prototype,"debugExtensionHost",null),s([a.memoize],p.prototype,"sharedIPCHandle",null),s([a.memoize],p.prototype,"serviceMachineIdResource",null),s([a.memoize],p.prototype,"telemetryLogResource",null),t.NativeEnvironmentService=p,
t.parseExtensionHostPort=f,t.parseSearchPort=function(e,t){return g(e["inspect-search"],e["inspect-brk-search"],5876,t)},t.parsePathArg=m,t.parseUserDataDir=v}),define(t[21],i([0,1,6,45,4,209,43,15]),function(e,t,i,r,n,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EnvironmentMainService=t.IEnvironmentMainService=void 0,t.IEnvironmentMainService=n.createDecorator("nativeEnvironmentService");class l extends o.NativeEnvironmentService{get cachedLanguagesPath(){return i.join(this.userDataPath,"clp")}get backupHome(){return i.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return i.join(this.backupHome,"workspaces.json")}get mainIPCHandle(){return a.createStaticIPCHandle(this.userDataPath,"main",c.default.version)}get sandbox(){return!!this._args.__sandbox}get driverVerbose(){return!!this._args["driver-verbose"]}get disableUpdates(){return!!this._args["disable-updates"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}}
s([r.memoize],l.prototype,"cachedLanguagesPath",null),s([r.memoize],l.prototype,"backupHome",null),s([r.memoize],l.prototype,"backupWorkspacesPath",null),s([r.memoize],l.prototype,"mainIPCHandle",null),s([r.memoize],l.prototype,"sandbox",null),s([r.memoize],l.prototype,"driverVerbose",null),s([r.memoize],l.prototype,"disableUpdates",null),s([r.memoize],l.prototype,"nodeCachedDataDir",null),t.EnvironmentMainService=l}),define(t[210],i([0,1,45,21,11,9,7,20,70,2,5,10,3]),function(e,t,i,r,n,a,c,l,d,u,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SharedProcess=void 0;let g=class{constructor(e,t,i,r,s,o){this.machineId=e,this.userEnv=t,this.environmentService=i,this.lifecycleMainService=r,this.logService=s,this.themeMainService=o,this.barrier=new a.Barrier,this.window=null,this._whenReady=new Promise(e=>n.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>e(void 0)))}get _whenIpcReady(){this.window=new n.BrowserWindow({show:!1,
backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",e).fsPath,v8CacheOptions:f.browserCodeLoadingCacheStrategy,nodeIntegration:!0,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}});const t={appRoot:this.environmentService.appRoot,machineId:this.machineId,nodeCachedDataDir:this.environmentService.nodeCachedDataDir,userEnv:this.userEnv,windowId:this.window.id};this.window.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",e).with({query:`config=${encodeURIComponent(JSON.stringify(t))}`}).toString(!0));const i=e=>{this.logService.trace("SharedProcess#close prevented"),e.preventDefault(),this.window&&this.window.isVisible()&&this.window.hide()};this.window.on("close",i);const r=new u.DisposableStore;return this.lifecycleMainService.onWillShutdown(()=>{r.dispose(),
this.window&&this.window.removeListener("close",i),setTimeout(()=>{try{this.window&&this.window.close()}catch(e){}this.window=null},0)}),new Promise(e=>{r.add(h.Event.once(h.Event.fromNodeEventEmitter(n.ipcMain,"vscode:shared-process->electron-main=ready-for-payload",({sender:e})=>e))(t=>{t.send("vscode:electron-main->shared-process=payload",{sharedIPCHandle:this.environmentService.sharedIPCHandle,args:this.environmentService.args,logLevel:this.logService.getLevel(),backupWorkspacesPath:this.environmentService.backupWorkspacesPath,nodeCachedDataDir:this.environmentService.nodeCachedDataDir}),r.add(u.toDisposable(()=>t.send("vscode:electron-main->shared-process=exit"))),n.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>e(void 0))}))})}spawn(e){this.userEnv=Object.assign(Object.assign({},this.userEnv),e),this.barrier.open()}async whenReady(){await this.barrier.wait(),await this._whenReady}async whenIpcReady(){await this.barrier.wait(),await this._whenIpcReady}toggle(){
!this.window||this.window.isVisible()?this.hide():this.show()}show(){this.window&&(this.window.show(),this.window.webContents.openDevTools())}hide(){this.window&&(this.window.webContents.closeDevTools(),this.window.hide())}};s([i.memoize],g.prototype,"_whenIpcReady",null),g=s([o(2,r.IEnvironmentMainService),o(3,l.ILifecycleMainService),o(4,c.ILogService),o(5,d.IThemeMainService)],g),t.SharedProcess=g}),define(t[211],i([0,1,24,56,6,3,25,49,21,18,26,7,39,8,28,10,17]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BackupMainService=void 0;let y=class{constructor(e,t,i){this.configurationService=t,this.logService=i,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=w.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(e,t)=>m.isEqual(e,t,!a.isLinux)},this.backupHome=e.backupHome,this.workspacesJsonPath=e.backupWorkspacesPath}async initialize(){let e;try{e=JSON.parse(await c.readFile(this.workspacesJsonPath,"utf8"))
}catch(t){e=Object.create(null)}e.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(e.emptyWorkspaceInfos));let t=[];try{Array.isArray(e.rootURIWorkspaces)&&(t=e.rootURIWorkspaces.map(e=>({workspace:{id:e.id,configPath:g.URI.parse(e.configURIPath)},remoteAuthority:e.remoteAuthority})))}catch(e){}this.workspaces=await this.validateWorkspaces(t);let i=[];try{Array.isArray(e.folderURIWorkspaces)&&(i=e.folderURIWorkspaces.map(e=>g.URI.parse(e)))}catch(e){}this.folders=await this.validateFolders(i),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var e;const t=this.configurationService.getValue()
;return(null===(e=null==t?void 0:t.files)||void 0===e?void 0:e.hotExit)||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(e,t){this.workspaces.some(t=>e.workspace.id===t.workspace.id)||(this.workspaces.push(e),this.saveSync());const i=this.getBackupPath(e.workspace.id);return t&&this.moveBackupFolderSync(i,t),i}moveBackupFolderSync(e,t){if(i.existsSync(e)&&this.convertToEmptyWindowBackupSync(e),i.existsSync(t))try{i.renameSync(t,e)}catch(e){this.logService.error(`Backup: Could not move backup folder to new location: ${e.toString()}`)}}unregisterWorkspaceBackupSync(e){const t=e.id,i=this.workspaces.findIndex(e=>e.workspace.id===t);-1!==i&&(this.workspaces.splice(i,1),this.saveSync())}registerFolderBackupSync(e){return this.folders.some(t=>this.backupUriComparer.isEqual(e,t))||(this.folders.push(e),this.saveSync()),this.getBackupPath(this.getFolderHash(e))}unregisterFolderBackupSync(e){
const t=this.folders.findIndex(t=>this.backupUriComparer.isEqual(e,t));-1!==t&&(this.folders.splice(t,1),this.saveSync())}registerEmptyWindowBackupSync(e,t){const i=e||this.getRandomEmptyWindowId();return this.emptyWindows.some(e=>!!e.backupFolder&&this.backupPathComparer.isEqual(e.backupFolder,i))||(this.emptyWindows.push({backupFolder:i,remoteAuthority:t}),this.saveSync()),this.getBackupPath(i)}unregisterEmptyWindowBackupSync(e){const t=this.emptyWindows.findIndex(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,e));-1!==t&&(this.emptyWindows.splice(t,1),this.saveSync())}getBackupPath(e){return n.join(this.backupHome,e)}async validateWorkspaces(e){if(!Array.isArray(e))return[];const t=new Set,i=[];for(let r of e){const e=r.workspace;if(!f.isWorkspaceIdentifier(e))return[];if(!t.has(e.id)){t.add(e.id);const n=this.getBackupPath(e.id)
;await this.doHasBackups(n)?e.configPath.scheme!==v.Schemas.file||await c.exists(e.configPath.fsPath)?i.push(r):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return i}async validateFolders(e){if(!Array.isArray(e))return[];const t=[],i=new Set;for(let r of e){const e=this.backupUriComparer.getComparisonKey(r);if(!i.has(e)){i.add(e);const n=this.getBackupPath(this.getFolderHash(r));await this.doHasBackups(n)?r.scheme!==v.Schemas.file||await c.exists(r.fsPath)?t.push(r):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return t}async validateEmptyWorkspaces(e){if(!Array.isArray(e))return[];const t=[],i=new Set;for(let r of e){const e=r.backupFolder;if("string"!=typeof e)return[];if(!i.has(e)){i.add(e);const n=this.getBackupPath(e);await this.doHasBackups(n)?t.push(r):await this.deleteStaleBackup(n)}}return t}async deleteStaleBackup(e){try{await c.exists(e)&&await c.rimraf(e,c.RimRafMode.MOVE)}catch(e){
this.logService.error(`Backup: Could not delete stale backup: ${e.toString()}`)}}async convertToEmptyWindowBackup(e){let t=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(e=>!!e.backupFolder&&this.backupPathComparer.isEqual(e.backupFolder,t));)t=this.getRandomEmptyWindowId();const i=this.getBackupPath(t);try{await c.rename(e,i)}catch(e){return this.logService.error(`Backup: Could not rename backup folder: ${e.toString()}`),!1}return this.emptyWindows.push({backupFolder:t}),!0}convertToEmptyWindowBackupSync(e){let t=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(e=>!!e.backupFolder&&this.backupPathComparer.isEqual(e.backupFolder,t));)t=this.getRandomEmptyWindowId();const r=this.getBackupPath(t);try{i.renameSync(e,r)}catch(e){return this.logService.error(`Backup: Could not rename backup folder: ${e.toString()}`),!1}return this.emptyWindows.push({backupFolder:t}),!0}async getDirtyWorkspaces(){const e=[];for(const t of this.workspaces)await this.hasBackups(t)&&e.push(t.workspace)
;for(const t of this.folders)await this.hasBackups(t)&&e.push(t);return e}hasBackups(e){let t;return t=g.URI.isUri(e)?this.getBackupPath(this.getFolderHash(e)):l.isWorkspaceBackupInfo(e)?this.getBackupPath(e.workspace.id):e.backupFolder,this.doHasBackups(t)}async doHasBackups(e){try{const t=await c.readdir(e);for(const i of t)try{if((await c.readdir(n.join(e,i))).length>0)return!0}catch(e){}}catch(e){}return!1}saveSync(){try{c.writeFileSync(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(e){this.logService.error(`Backup: Could not save workspaces.json: ${e.toString()}`)}}async save(){try{await c.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(e){this.logService.error(`Backup: Could not save workspaces.json: ${e.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(e=>({id:e.workspace.id,configURIPath:e.workspace.configPath.toString(),remoteAuthority:e.remoteAuthority})),folderURIWorkspaces:this.folders.map(e=>e.toString()),
emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(1e3*Math.random())).toString()}getFolderHash(e){let t;return t=e.scheme===v.Schemas.file?a.isLinux?e.fsPath:e.fsPath.toLowerCase():e.toString().toLowerCase(),r.createHash("md5").update(t).digest("hex")}};y=s([o(0,d.IEnvironmentMainService),o(1,u.IConfigurationService),o(2,p.ILogService)],y),t.BackupMainService=y}),define(t[44],i([0,1,5,32,11,20,3,21,50,25,8,29,4,27,66,7,6,15,45,2]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostMainService=t.INativeHostMainService=void 0,t.INativeHostMainService=f.createDecorator("nativeHostMainService");let _=class t extends b.Disposable{constructor(e,t,r,s,o,a){super(),this.windowsMainService=e,this.dialogMainService=t,this.lifecycleMainService=r,this.environmentService=s,this.telemetryService=o,this.logService=a,this.onDidOpenWindow=i.Event.map(this.windowsMainService.onWindowOpened,e=>e.id),
this.onDidMaximizeWindow=i.Event.filter(i.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(e,t)=>t.id),e=>!!this.windowsMainService.getWindowById(e)),this.onDidUnmaximizeWindow=i.Event.filter(i.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(e,t)=>t.id),e=>!!this.windowsMainService.getWindowById(e)),this.onDidBlurWindow=i.Event.filter(i.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(e,t)=>t.id),e=>!!this.windowsMainService.getWindowById(e)),this.onDidFocusWindow=i.Event.any(i.Event.map(i.Event.filter(i.Event.map(this.windowsMainService.onWindowsCountChanged,()=>this.windowsMainService.getLastActiveWindow()),e=>!!e),e=>e.id),i.Event.filter(i.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(e,t)=>t.id),e=>!!this.windowsMainService.getWindowById(e))),this.onDidResumeOS=i.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new i.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,
this._onDidChangePassword=this._register(new i.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(e=>({id:e.id,workspace:e.openedWorkspace,folderUri:e.openedFolderUri,title:e.win.getTitle(),filename:e.getRepresentedFilename(),dirty:e.isDocumentEdited()}))}async getWindowCount(e){return this.windowsMainService.getWindowCount()}async getActiveWindowId(e){const t=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(t)return t.id}openWindow(e,t,i){return Array.isArray(t)?this.doOpenWindow(e,t,i):this.doOpenEmptyWindow(e,t)}async doOpenWindow(e,t,i=Object.create(null)){
t.length>0&&this.windowsMainService.open({context:5,contextWindowId:e,urisToOpen:t,cli:this.environmentService.args,forceNewWindow:i.forceNewWindow,forceReuseWindow:i.forceReuseWindow,preferNewWindow:i.preferNewWindow,diffMode:i.diffMode,addMode:i.addMode,gotoLineMode:i.gotoLineMode,noRecentEntry:i.noRecentEntry,waitMarkerFileURI:i.waitMarkerFileURI})}async doOpenEmptyWindow(e,t){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:e},t)}async toggleFullScreen(e){const t=this.windowById(e);t&&t.toggleFullScreen()}async handleTitleDoubleClick(e){const t=this.windowById(e);t&&t.handleTitleDoubleClick()}async isMaximized(e){const t=this.windowById(e);return!!t&&t.win.isMaximized()}async maximizeWindow(e){const t=this.windowById(e);t&&t.win.maximize()}async unmaximizeWindow(e){const t=this.windowById(e);t&&t.win.unmaximize()}async minimizeWindow(e){const t=this.windowById(e);t&&t.win.minimize()}async focusWindow(e,t){var i;t&&"number"==typeof t.windowId&&(e=t.windowId);const r=this.windowById(e)
;r&&r.focus({force:null!==(i=null==t?void 0:t.force)&&void 0!==i&&i})}async setMinimumSize(e,t,i){const r=this.windowById(e);if(r){const[e,n]=r.win.getSize(),[s,o]=r.win.getMinimumSize(),[a,c]=[null!=t?t:s,null!=i?i:o],[l,d]=[Math.max(e,a),Math.max(n,c)];s===a&&o===c||r.win.setMinimumSize(a,c),e===l&&n===d||r.win.setSize(l,d)}}async showMessageBox(e,t){return this.dialogMainService.showMessageBox(t,this.toBrowserWindow(e))}async showSaveDialog(e,t){return this.dialogMainService.showSaveDialog(t,this.toBrowserWindow(e))}async showOpenDialog(e,t){return this.dialogMainService.showOpenDialog(t,this.toBrowserWindow(e))}toBrowserWindow(e){const t=this.windowById(e);if(t)return t.win}async pickFileFolderAndOpen(e,t){const i=await this.dialogMainService.pickFileFolder(t);i&&(this.sendPickerTelemetry(i,t.telemetryEventName||"openFileFolder",t.telemetryExtraData),this.doOpenPicked(await Promise.all(i.map(async e=>await u.dirExists(e)?{folderUri:h.URI.file(e)}:{fileUri:h.URI.file(e)})),t,e))}
async pickFolderAndOpen(e,t){const i=await this.dialogMainService.pickFolder(t);i&&(this.sendPickerTelemetry(i,t.telemetryEventName||"openFolder",t.telemetryExtraData),this.doOpenPicked(i.map(e=>({folderUri:h.URI.file(e)})),t,e))}async pickFileAndOpen(e,t){const i=await this.dialogMainService.pickFile(t);i&&(this.sendPickerTelemetry(i,t.telemetryEventName||"openFile",t.telemetryExtraData),this.doOpenPicked(i.map(e=>({fileUri:h.URI.file(e)})),t,e))}async pickWorkspaceAndOpen(e,t){const i=await this.dialogMainService.pickWorkspace(t);i&&(this.sendPickerTelemetry(i,t.telemetryEventName||"openWorkspace",t.telemetryExtraData),this.doOpenPicked(i.map(e=>({workspaceUri:h.URI.file(e)})),t,e))}doOpenPicked(e,t,i){this.windowsMainService.open({context:3,contextWindowId:i,cli:this.environmentService.args,urisToOpen:e,forceNewWindow:t.forceNewWindow})}sendPickerTelemetry(e,t,i){const r=e?e.length:0;this.telemetryService.publicLog(t,Object.assign(Object.assign({},i),{outcome:r?"success":"canceled",numberOfPaths:r}))}
async showItemInFolder(e,t){n.shell.showItemInFolder(t)}async setRepresentedFilename(e,t){const i=this.windowById(e);i&&i.setRepresentedFilename(t)}async setDocumentEdited(e,t){const i=this.windowById(e);i&&i.setDocumentEdited(t)}async openExternal(e,t){return c.isLinuxSnap?this.safeSnapOpenExternal(t):n.shell.openExternal(t),!0}safeSnapOpenExternal(e){const t=process.env.GDK_PIXBUF_MODULE_FILE,i=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(e),process.env.GDK_PIXBUF_MODULE_FILE=t,process.env.GDK_PIXBUF_MODULEDIR=i}async moveItemToTrash(e,t){return n.shell.moveItemToTrash(t)}async isAdmin(){let t;return t=c.isWindows?(await new Promise((t,i)=>{e(["native-is-elevated"],t,i)}))():0===process.getuid()}async writeElevated(t,i,r,n){const s=await new Promise((t,i)=>{e(["sudo-prompt"],t,i)});return new Promise((e,t)=>{const o=[`"${this.cliPath}"`];(null==n?void 0:n.overwriteReadonly)&&o.push("--file-chmod"),
o.push("--file-write",`"${i.fsPath}"`,`"${r.fsPath}"`);const a={name:y.default.nameLong.replace("-",""),icns:c.isMacintosh&&this.environmentService.isBuilt?w.join(w.dirname(this.environmentService.appRoot),`${y.default.nameShort}.icns`):void 0};s.exec(o.join(" "),a,(i,r,n)=>{r&&this.logService.trace(`[sudo-prompt] received stdout: ${r}`),n&&this.logService.trace(`[sudo-prompt] received stderr: ${n}`),i?t(i):e(void 0)})})}get cliPath(){return c.isWindows?this.environmentService.isBuilt?w.join(w.dirname(process.execPath),"bin",`${y.default.applicationName}.cmd`):w.join(this.environmentService.appRoot,"scripts","code-cli.bat"):c.isLinux?this.environmentService.isBuilt?w.join(w.dirname(process.execPath),"bin",`${y.default.applicationName}`):w.join(this.environmentService.appRoot,"scripts","code-cli.sh"):this.environmentService.isBuilt?w.join(this.environmentService.appRoot,"bin","code"):w.join(this.environmentService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:g.totalmem(),
freemem:g.freemem(),loadavg:g.loadavg()}}async getOSProperties(){return{arch:g.arch(),platform:g.platform(),release:g.release(),type:g.type(),cpus:g.cpus()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}async killProcess(e,t,i){process.kill(t,i)}async readClipboardText(e,t){return n.clipboard.readText(t)}async writeClipboardText(e,t,i){return n.clipboard.writeText(t,i)}async readClipboardFindText(e){return n.clipboard.readFindText()}async writeClipboardFindText(e,t){return n.clipboard.writeFindText(t)}async writeClipboardBuffer(e,t,i,r){return n.clipboard.writeBuffer(t,Buffer.from(i),r)}async readClipboardBuffer(e,t){return n.clipboard.readBuffer(t)}async hasClipboard(e,t,i){return n.clipboard.has(t,i)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentService.args,forceNewTabbedWindow:!0,forceEmpty:!0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){
n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(e,t){const i=this.windowById(e);i&&i.updateTouchBar(t)}async notifyReady(e){const t=this.windowById(e);t&&t.setReady()}async relaunch(e,t){return this.lifecycleMainService.relaunch(t)}async reload(e,t){const i=this.windowById(e);if(i)return this.lifecycleMainService.reload(i,void 0!==(null==t?void 0:t.disableExtensions)?{_:[],"disable-extensions":null==t?void 0:t.disableExtensions}:void 0)}async closeWindow(e){this.closeWindowById(e,e)}async closeWindowById(e,t){const i=this.windowById(t);if(i)return i.win.close()}async quit(e){const t=this.windowsMainService.getLastActiveWindow()
;(null==t?void 0:t.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1?t.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(e,t){await this.lifecycleMainService.kill(t)}async resolveProxy(e,t){var i,r;const n=this.windowById(e),s=null===(r=null===(i=null==n?void 0:n.win)||void 0===i?void 0:i.webContents)||void 0===r?void 0:r.session;return s?s.resolveProxy(t):void 0}async openDevTools(e,t){const i=this.windowById(e);i&&i.win.webContents.openDevTools(t)}async toggleDevTools(e){const t=this.windowById(e);if(t){t.win.webContents.toggleDevTools()}}async sendInputEvent(e,t){const i=this.windowById(e);!i||"mouseDown"!==t.type&&"mouseUp"!==t.type||i.win.webContents.sendInputEvent(t)}async windowsGetStringRegKey(t,i,r,n){if(!c.isWindows)return;const s=await new Promise((t,i)=>{e(["vscode-windows-registry"],t,i)});try{return s.GetStringRegKey(i,r,n)}catch(e){return}}async getPassword(t,i,r){const n=await new Promise((t,i)=>{e(["keytar"],t,i)}),s=await n.getPassword(i,r)
;if(s)try{let{content:e,hasNextChunk:t}=JSON.parse(s);if(!e||!t)return s;let o=1;for(;t;){const s=await n.getPassword(i,`${r}-${o}`),a=JSON.parse(s);e+=a.content,t=a.hasNextChunk}return e}catch(e){return s}return s}async setPassword(i,r,n,s){const o=await new Promise((t,i)=>{e(["keytar"],t,i)});if(c.isWindows&&s.length>t.MAX_PASSWORD_LENGTH){let e=0,i=0,a=!0;for(;a;){const c=s.substring(e,e+t.PASSWORD_CHUNK_SIZE);e+=t.PASSWORD_CHUNK_SIZE;const l={content:c,hasNextChunk:a=s.length-e>0};await o.setPassword(r,i?`${n}-${i}`:n,JSON.stringify(l)),i++}}else await o.setPassword(r,n,s);this._onDidChangePassword.fire()}async deletePassword(t,i,r){const n=await new Promise((t,i)=>{e(["keytar"],t,i)}),s=await n.deletePassword(i,r);return s&&this._onDidChangePassword.fire(),s}async findPassword(t,i){return(await new Promise((t,i)=>{e(["keytar"],t,i)})).findPassword(i)}async findCredentials(t,i){return(await new Promise((t,i)=>{e(["keytar"],t,i)})).findCredentials(i)}windowById(e){
if("number"==typeof e)return this.windowsMainService.getWindowById(e)}};_.MAX_PASSWORD_LENGTH=2500,_.PASSWORD_CHUNK_SIZE=_.MAX_PASSWORD_LENGTH-100,s([S.memoize],_.prototype,"cliPath",null),_=s([o(0,r.IWindowsMainService),o(1,d.IDialogMainService),o(2,a.ILifecycleMainService),o(3,l.IEnvironmentMainService),o(4,p.ITelemetryService),o(5,v.ILogService)],_),t.NativeHostMainService=_}),define(t[212],i([0,1,2,5,102,11,7,32,44,82,31,15,22]),function(e,t,i,r,n,a,c,l,d,u,h,p,f){"use strict";var g;Object.defineProperty(t,"__esModule",{value:!0}),t.ProxyAuthHandler=void 0,function(e){e[e.Initial=1]="Initial",e[e.StoredCredentialsUsed=2]="StoredCredentialsUsed",e[e.LoginDialogShown=3]="LoginDialogShown"}(g||(g={}));let m=class e extends i.Disposable{constructor(e,t,i,r){super(),this.logService=e,this.windowsMainService=t,this.nativeHostMainService=i,this.encryptionMainService=r,this.pendingProxyResolve=void 0,this.state=g.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){
const e=r.Event.fromNodeEventEmitter(a.app,"login",(e,t,i,r,n)=>({event:e,webContents:t,req:i,authInfo:r,callback:n}));this._register(e(this.onLogin,this))}async onLogin({event:e,authInfo:t,req:i,callback:r}){if(!t.isProxy)return;if(!this.pendingProxyResolve&&this.state===g.LoginDialogShown&&i.firstAuthAttempt)return void this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");e.preventDefault();let n=void 0;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),n=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(t);try{n=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}r(null==n?void 0:n.username,null==n?void 0:n.password)}async resolveProxyCredentials(e){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const t=await this.doResolveProxyCredentials(e)
;if(t)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),t;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(t){var i,r,s,o;this.logService.trace("auth#doResolveProxyCredentials - enter",t);const a=String(n.hash({scheme:t.scheme,host:t.host,port:t.port}));let c=void 0,l=void 0;try{const t=await this.nativeHostMainService.getPassword(void 0,e.PROXY_CREDENTIALS_SERVICE_KEY,a);if(t){const e=JSON.parse(await this.encryptionMainService.decrypt(t));c=e.username,l=e.password}}catch(e){this.logService.error(e)}if(this.state!==g.StoredCredentialsUsed&&"string"==typeof c&&"string"==typeof l)return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=g.StoredCredentialsUsed,{username:c,password:l}
;const d=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!d)return void this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${d.id} to handle proxy login`);const u={authInfo:t,username:null!==(r=null===(i=this.sessionCredentials)||void 0===i?void 0:i.username)&&void 0!==r?r:c,password:null!==(o=null===(s=this.sessionCredentials)||void 0===s?void 0:s.password)&&void 0!==o?o:l,replyChannel:`vscode:proxyAuthResponse:${h.generateUuid()}`};d.sendWhenReady("vscode:openProxyAuthenticationDialog",f.CancellationToken.None,u),this.state=g.LoginDialogShown;const p=await new Promise(t=>{const i=async(r,n,s)=>{if(n===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${d.id}`),d.win.webContents.off("ipc-message",i),s){const i={username:s.username,password:s.password};try{
if(s.remember){const t=await this.encryptionMainService.encrypt(JSON.stringify(i));await this.nativeHostMainService.setPassword(void 0,e.PROXY_CREDENTIALS_SERVICE_KEY,a,t)}else await this.nativeHostMainService.deletePassword(void 0,e.PROXY_CREDENTIALS_SERVICE_KEY,a)}catch(e){this.logService.error(e)}t({username:i.username,password:i.password})}else t(void 0)};d.win.webContents.on("ipc-message",i)});return this.sessionCredentials=p,p}};m.PROXY_CREDENTIALS_SERVICE_KEY=`${p.default.urlProtocol}.proxy-credentials`,m=s([o(0,c.ILogService),o(1,l.IWindowsMainService),o(2,d.INativeHostMainService),o(3,u.IEncryptionMainService)],m),t.ProxyAuthHandler=m}),define(t[213],i([0,1,208,32,43,2,35,55,164,3,5,72,99,9,20,44]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.serve=t.Driver=void 0;let w=class{constructor(e,t,i,r,n){this.windowServer=e,this.options=t,this.windowsMainService=i,this.lifecycleMainService=r,this.nativeHostMainService=n,
this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new h.Emitter}async registerWindowDriver(e){return this.registeredWindowIds.add(e),this.reloadingWindowIds.delete(e),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(e){this.reloadingWindowIds.add(e)}async getWindowIds(){return this.windowsMainService.getWindows().map(e=>e.id).filter(e=>this.registeredWindowIds.has(e)&&!this.reloadingWindowIds.has(e))}async capturePage(e){await this.whenUnfrozen(e);const t=this.windowsMainService.getWindowById(e);if(!t)throw new Error("Invalid window");const i=t.win.webContents;return(await i.capturePage()).toPNG().toString("base64")}async reloadWindow(e){await this.whenUnfrozen(e);const t=this.windowsMainService.getWindowById(e);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(e),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(e,t){await this.whenUnfrozen(e)
;const i=f.KeybindingParser.parseUserBinding(t);for(let t of i)await this._dispatchKeybinding(e,t)}async _dispatchKeybinding(e,t){if(t instanceof p.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(e);if(!i)throw new Error("Invalid window");const r=i.win.webContents,n=new l.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),s=new d.USLayoutResolvedKeybinding(n.toChord(),u.OS).getElectronAccelerator(),o=[];t.ctrlKey&&o.push("ctrl"),t.metaKey&&o.push("meta"),t.shiftKey&&o.push("shift"),t.altKey&&o.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:s,modifiers:o}),function(e){return e<21}(t.keyCode)||r.sendInputEvent({type:"char",keyCode:s,modifiers:o}),r.sendInputEvent({type:"keyUp",keyCode:s,modifiers:o}),await g.timeout(100)}async click(e,t,i,r){const n=await this.getWindowDriver(e);await n.click(t,i,r)}async doubleClick(e,t){const i=await this.getWindowDriver(e);await i.doubleClick(t)}async setValue(e,t,i){const r=await this.getWindowDriver(e)
;await r.setValue(t,i)}async getTitle(e){const t=await this.getWindowDriver(e);return await t.getTitle()}async isActiveElement(e,t){const i=await this.getWindowDriver(e);return await i.isActiveElement(t)}async getElements(e,t,i){const r=await this.getWindowDriver(e);return await r.getElements(t,i)}async getElementXY(e,t,i,r){const n=await this.getWindowDriver(e);return await n.getElementXY(t,i,r)}async typeInEditor(e,t,i){const r=await this.getWindowDriver(e);await r.typeInEditor(t,i)}async getTerminalBuffer(e,t){const i=await this.getWindowDriver(e);return await i.getTerminalBuffer(t)}async writeInTerminal(e,t,i){const r=await this.getWindowDriver(e);await r.writeInTerminal(t,i)}async getWindowDriver(e){await this.whenUnfrozen(e);const t=`window:${e}`,r=new c.StaticRouter(e=>e===t),n=this.windowServer.getChannel("windowDriver",r);return new i.WindowDriverChannelClient(n)}async whenUnfrozen(e){for(;this.reloadingWindowIds.has(e);)await h.Event.toPromise(this.onDidReloadingChange.event)}}
;w=s([o(2,r.IWindowsMainService),o(3,m.ILifecycleMainService),o(4,v.INativeHostMainService)],w),t.Driver=w,t.serve=async function(e,t,r,s){const o=r.driverVerbose,c=s.createInstance(w,e,{verbose:o}),l=new i.WindowDriverRegistryChannel(c);e.registerChannel("windowDriverRegistry",l);const d=await n.serve(t),u=new i.DriverChannel(c);return d.registerChannel("driver",u),a.combinedDisposable(d,e)}}),define(t[214],i([0,1,57,43]),function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nodeSocketFactory=void 0,t.nodeSocketFactory=new class{connect(e,t,n,s){const o=e=>s(e,void 0),a=i.createConnection({host:e,port:t},()=>{a.removeListener("error",o);const i=Buffer.alloc(16);for(let e=0;e<16;e++)i[e]=Math.round(256*Math.random());const c=i.toString("base64");let l=[`GET ws://${e}:${t}/?${n}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`];a.write(l.join("\r\n")+"\r\n\r\n");const d=e=>{e.toString().indexOf("\r\n\r\n")>=0&&(a.off("data",d),
s(void 0,new r.NodeSocket(a)))};a.on("data",d)});a.once("error",o)}}}),define(t[215],i([0,1,57,9,2,110,7,59,180,54,214,86]),function(e,t,i,r,n,a,c,l,d,u,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TunnelService=t.BaseTunnelService=void 0;class f extends n.Disposable{constructor(e,t,n,s){super(),this.suggestedLocalPort=s,this._socketsDispose=new Map,this._options=e,this._server=i.createServer(),this._barrier=new r.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=e=>this._onConnection(e),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),
Array.from(this._socketsDispose.values()).forEach(e=>{e()})}async waitForReady(){var e;let t=await a.findFreePortFaster(null!==(e=this.suggestedLocalPort)&&void 0!==e?e:this.tunnelRemotePort,2,1e3),i=null;return(i=this._server.listen(t).address())||(t=0,i=this._server.listen(t).address()),this.tunnelLocalPort=i.port,await this._barrier.wait(),this.localAddress=`${"127.0.0.1"===this.tunnelRemoteHost?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(e){e.pause();const t=await d.connectRemoteAgentTunnel(this._options,this.tunnelRemotePort),i=t.getSocket().socket,r=t.readEntireBuffer();t.dispose(),r.byteLength>0&&e.write(r.buffer),e.on("end",()=>{this._socketsDispose.delete(e.localAddress),i.end()}),e.on("close",()=>i.end()),e.on("error",()=>{this._socketsDispose.delete(e.localAddress),i.destroy()}),i.on("end",()=>e.end()),i.on("close",()=>e.end()),i.on("error",()=>{e.destroy()}),e.pipe(i),i.pipe(e),this._socketsDispose.set(e.localAddress,()=>{e.end(),i.end()})}}
let g=class extends u.AbstractTunnelService{constructor(e,t,i,r){super(t),this.socketFactory=e,this.signService=i,this.productService=r}retainOrCreateTunnel(e,t,i,r){const n=this.getTunnelFromMap(t,i);if(n)return++n.refcount,n.value;if(this._tunnelProvider){const e=void 0===r?i:r,n={elevationRequired:this.isPortPrivileged(e)},s={remoteAddress:{host:t,port:i},localAddressPort:r},o=this._tunnelProvider.forwardPort(s,n);return o&&this.addTunnelToMap(t,i,o),o}{const n=async function(e,t,i,r){return new f(e,t,i,r).waitForReady()}({commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:e,signService:this.signService,logService:this.logService,ipcLogger:null},t,i,r);return this.addTunnelToMap(t,i,n),n}}};g=s([o(1,c.ILogService),o(2,p.ISignService),o(3,l.IProductService)],g),t.BaseTunnelService=g;let m=class extends g{constructor(e,t,i){super(h.nodeSocketFactory,e,t,i)}};m=s([o(0,c.ILogService),o(1,p.ISignService),o(2,l.IProductService)],m),t.TunnelService=m}),
define(t[216],i([0,1,207,182,2,14,19,181,18,7,23]),function(e,t,i,r,n,a,c,l,d,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let p=class extends n.Disposable{constructor(e,t){super(),this.logService=t,this.configure(e.getValue()),this._register(e.onDidChangeConfiguration(()=>this.configure(e.getValue()),this))}configure(e){this.proxyUrl=e.http&&e.http.proxy,this.strictSSL=!(!e.http||!e.http.proxyStrictSSL),this.authorization=e.http&&e.http.proxyAuthorization}async request(e,t){this.logService.trace("RequestService#request",e.url);const{proxyUrl:i,strictSSL:r}=this,n=e.agent?e.agent:await l.getProxyAgent(e.url||"",{proxyUrl:i,strictSSL:r});return e.agent=n,e.strictSSL=r,this.authorization&&(e.headers=Object.assign(Object.assign({},e.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(e,t)}async getNodeRequest(t){return("https:"===r.parse(t.url).protocol?await new Promise((t,i)=>{e(["https"],t,i)}):await new Promise((t,i)=>{e(["http"],t,i)
})).request}_request(e,t){return new Promise(async(n,s)=>{let o;const l=r.parse(e.url),d=e.getRawRequest?e.getRawRequest(e):await this.getNodeRequest(e),u={hostname:l.hostname,port:l.port?parseInt(l.port):"https:"===l.protocol?443:80,protocol:l.protocol,path:l.path,method:e.type||"GET",headers:e.headers,agent:e.agent,rejectUnauthorized:!a.isBoolean(e.strictSSL)||e.strictSSL};e.user&&e.password&&(u.auth=e.user+":"+e.password),(o=d(u,r=>{const o=a.isNumber(e.followRedirects)?e.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&o>0&&r.headers.location)this._request(Object.assign(Object.assign({},e),{url:r.headers.location,followRedirects:o-1}),t).then(n,s);else{let e=r;"gzip"===r.headers["content-encoding"]&&(e=r.pipe(i.createGunzip())),n({res:r,stream:h.streamToBufferReadableStream(e)})}})).on("error",s),e.timeout&&o.setTimeout(e.timeout),e.data&&"string"==typeof e.data&&o.write(e.data),o.end(),t.onCancellationRequested(()=>{o.abort(),s(c.canceled())})})}async resolveProxy(e){}}
;p=s([o(0,d.IConfigurationService),o(1,u.ILogService)],p),t.RequestService=p}),define(t[217],i([0,1,216,11]),function(e,t,i,r){"use strict";function n(e){return r.net.request}Object.defineProperty(t,"__esModule",{value:!0}),t.RequestMainService=void 0;t.RequestMainService=class extends i.RequestService{request(e,t){return super.request(Object.assign(Object.assign({},e||{}),{getRawRequest:n}),t)}}}),define(t[71],i([0,1,5,9,18,20,15,42,21,7,38,22]),function(e,t,i,r,n,a,c,l,d,u,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractUpdateService=t.createUpdateURL=void 0,t.createUpdateURL=function(e,t){return`${c.default.updateUrl}/api/update/${e}/${t}/${c.default.commit}`};let f=class{constructor(e,t,r,n,s){this.lifecycleMainService=e,this.configurationService=t,this.environmentService=r,this.requestService=n,this.logService=s,this._state=l.State.Uninitialized,this._onStateChange=new i.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(e){
this.logService.info("update#setState",e.type),this._state=e,this._onStateChange.fire(e)}initialize(){if(!this.environmentService.isBuilt)return;if(this.environmentService.disableUpdates)return void this.logService.info("update#ctor - updates are disabled by the environment");if(!c.default.updateUrl||!c.default.commit)return void this.logService.info("update#ctor - updates are disabled as there is no update URL");const e=n.getMigratedSettingValue(this.configurationService,"update.mode","update.channel"),t=this.getProductQuality(e);t?(this.url=this.buildUpdateFeedUrl(t),this.url?(this.setState(l.State.Idle(this.getUpdateType())),"manual"!==e?"start"===e?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),
setTimeout(()=>this.checkForUpdates(null),3e4)):this.scheduleCheckForUpdates(3e4).then(void 0,e=>this.logService.error(e)):this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference")):this.logService.info("update#ctor - updates are disabled as the update URL is badly formed")):this.logService.info("update#ctor - updates are disabled by user preference")}getProductQuality(e){return"none"===e?void 0:c.default.quality}scheduleCheckForUpdates(e=36e5){return r.timeout(e).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(36e5))}async checkForUpdates(e){this.logService.trace("update#checkForUpdates, state = ",this.state.type),"idle"===this.state.type&&this.doCheckForUpdates(e)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),"available for download"===this.state.type&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(e){}async applyUpdate(){
this.logService.trace("update#applyUpdate, state = ",this.state.type),"downloaded"===this.state.type&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),"ready"!==this.state.type?Promise.resolve(void 0):(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(e=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${e}`),e||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())}),Promise.resolve(void 0))}isLatestVersion(){return this.url?this.requestService.request({url:this.url},p.CancellationToken.None).then(e=>204===e.res.statusCode):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};f=s([o(0,a.ILifecycleMainService),o(1,n.IConfigurationService),o(2,d.IEnvironmentMainService),o(3,h.IRequestService),o(4,u.ILogService)],f),t.AbstractUpdateService=f}),
define(t[218],i([0,1,11,2,5,45,18,20,42,29,21,7,71,38]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DarwinUpdateService=void 0;let m=class extends f.AbstractUpdateService{constructor(e,t,i,n,s,o){super(e,t,n,s,o),this.telemetryService=i,this.disposables=new r.DisposableStore}get onRawError(){return n.Event.fromNodeEventEmitter(i.autoUpdater,"error",(e,t)=>t)}get onRawUpdateNotAvailable(){return n.Event.fromNodeEventEmitter(i.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return n.Event.fromNodeEventEmitter(i.autoUpdater,"update-available",(e,t,i)=>({url:t,version:i,productVersion:i}))}get onRawUpdateDownloaded(){return n.Event.fromNodeEventEmitter(i.autoUpdater,"update-downloaded",(e,t,i,r)=>({releaseNotes:t,version:i,productVersion:i,date:r}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),
this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(e){this.logService.error("UpdateService error:",e);const t="checking for updates"!==this.state.type||!!this.state.context?e:void 0;this.setState(d.State.Idle(1,t))}buildUpdateFeedUrl(e){const t="x64"===process.arch?"darwin":"darwin-arm64",r=f.createUpdateURL(t,e);try{i.autoUpdater.setFeedURL({url:r})}catch(e){return void this.logService.error("Failed to set update feed URL",e)}return r}doCheckForUpdates(e){this.setState(d.State.CheckingForUpdates(e)),i.autoUpdater.checkForUpdates()}onUpdateAvailable(e){"checking for updates"===this.state.type&&this.setState(d.State.Downloading(e))}onUpdateDownloaded(e){"downloading"===this.state.type&&(this.telemetryService.publicLog2("update:downloaded",{version:e.version}),this.setState(d.State.Ready(e)))}onUpdateNotAvailable(){
"checking for updates"===this.state.type&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!this.state.context}),this.setState(d.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};s([a.memoize],m.prototype,"onRawError",null),s([a.memoize],m.prototype,"onRawUpdateNotAvailable",null),s([a.memoize],m.prototype,"onRawUpdateAvailable",null),s([a.memoize],m.prototype,"onRawUpdateDownloaded",null),m=s([o(0,l.ILifecycleMainService),o(1,c.IConfigurationService),o(2,u.ITelemetryService),o(3,h.IEnvironmentMainService),o(4,g.IRequestService),o(5,p.ILogService)],m),t.DarwinUpdateService=m}),define(t[219],i([0,1,15,18,20,42,29,21,7,71,38,22,44]),function(e,t,i,r,n,a,c,l,d,u,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinuxUpdateService=void 0;let g=class extends u.AbstractUpdateService{constructor(e,t,i,r,n,s,o){super(e,t,r,n,s),
this.telemetryService=i,this.nativeHostMainService=o}buildUpdateFeedUrl(e){return u.createUpdateURL(`linux-${process.arch}`,e)}doCheckForUpdates(e){this.url&&(this.setState(a.State.CheckingForUpdates(e)),this.requestService.request({url:this.url},p.CancellationToken.None).then(h.asJson).then(t=>{t&&t.url&&t.version&&t.productVersion?this.setState(a.State.AvailableForDownload(t)):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!e}),this.setState(a.State.Idle(1)))}).then(void 0,t=>{this.logService.error(t),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!e});const i=e?t.message||t:void 0;this.setState(a.State.Idle(1,i))}))}async doDownloadUpdate(e){i.default.downloadUrl&&i.default.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,i.default.downloadUrl):e.update.url&&this.nativeHostMainService.openExternal(void 0,e.update.url),this.setState(a.State.Idle(1))}}
;g=s([o(0,n.ILifecycleMainService),o(1,r.IConfigurationService),o(2,c.ITelemetryService),o(3,l.IEnvironmentMainService),o(4,h.IRequestService),o(5,d.ILogService),o(6,f.INativeHostMainService)],g),t.LinuxUpdateService=g}),define(t[220],i([0,1,5,9,20,42,21,7,6,24,47,29]),function(e,t,i,r,n,a,c,l,d,u,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SnapUpdateService=void 0;let f=class{constructor(e,t,r){this.lifecycleMainService=e,this.logService=r,this._state=a.State.Uninitialized,this._onStateChange=new i.Emitter,this.onStateChange=this._onStateChange.event,t.disableUpdates?this.logService.info("update#ctor - updates are disabled"):(this.setState(a.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(3e4).then(void 0,e=>this.logService.error(e)))}get state(){return this._state}setState(e){this.logService.info("update#setState",e.type),this._state=e,this._onStateChange.fire(e)}scheduleCheckForUpdates(e=36e5){
return r.timeout(e).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(36e5))}async checkForUpdates(e){this.logService.trace("update#checkForUpdates, state = ",this.state.type),"idle"===this.state.type&&this.doCheckForUpdates(e)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),"available for download"===this.state.type&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(e){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),"downloaded"===this.state.type&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),"ready"!==this.state.type?Promise.resolve(void 0):(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(e=>{
this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${e}`),e||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())}),Promise.resolve(void 0))}getUpdateType(){return 2}doQuitAndInstall(){}};f=s([o(0,n.ILifecycleMainService),o(1,c.IEnvironmentMainService),o(2,l.ILogService)],f);let g=class extends f{constructor(e,t,r,n,s,o){super(r,n,s),this.snap=e,this.snapRevision=t,this.telemetryService=o;const a=u.watch(d.dirname(this.snap)),c=i.Event.fromNodeEventEmitter(a,"change",(e,t)=>t),l=i.Event.filter(c,e=>"current"===e),h=i.Event.debounce(l,(e,t)=>t,2e3)(this.checkForUpdates,this);r.onWillShutdown(()=>{h.dispose(),a.close()})}doCheckForUpdates(e){this.setState(a.State.CheckingForUpdates(e)),this.isUpdateAvailable().then(t=>{t?this.setState(a.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!e}),this.setState(a.State.Idle(2)))},t=>{
this.logService.error(t),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!e}),this.setState(a.State.Idle(2,t.message||t))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),h.spawn("sleep 3 && "+d.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const e=await new Promise((e,t)=>u.realpath(`${d.dirname(this.snap)}/current`,(i,r)=>i?t(i):e(r))),t=d.basename(e);return this.snapRevision!==t}isLatestVersion(){return this.isUpdateAvailable().then(void 0,e=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};g=s([o(2,n.ILifecycleMainService),o(3,c.IEnvironmentMainService),o(4,l.ILogService),o(5,p.ITelemetryService)],g),t.SnapUpdateService=g}),define(t[221],i([0,1,24,6,25,45,18,20,15,42,29,21,7,71,38,106,27,47,22,9,26,8,44]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b,_,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.Win32UpdateService=void 0;let I=void 0;function k(){return void 0===I&&(I=i.existsSync(r.join(r.dirname(process.execPath),"unins000.exe"))?0:1),I}let P=class extends g.AbstractUpdateService{constructor(e,t,i,r,n,s,o,a){super(e,t,r,n,s),this.telemetryService=i,this.fileService=o,this.nativeHostMainService=a}get cachePath(){const e=r.join(w.tmpdir(),`vscode-update-${d.default.target}-${process.arch}`);return n.mkdirp(e,void 0).then(()=>e)}initialize(){super.initialize(),0===k()&&this.telemetryService.publicLog("update:win32SetupTarget",{target:d.default.target})}buildUpdateFeedUrl(e){let t="win32";return"ia32"!==process.arch&&(t+=`-${process.arch}`),1===k()?t+="-archive":"user"===d.default.target&&(t+="-user"),g.createUpdateURL(t,e)}doCheckForUpdates(e){this.url&&(this.setState(u.State.CheckingForUpdates(e)),this.requestService.request({url:this.url},S.CancellationToken.None).then(m.asJson).then(t=>{const i=k();return t&&t.url&&t.version&&t.productVersion?1===i?(this.setState(u.State.AvailableForDownload(t)),
Promise.resolve(null)):(this.setState(u.State.Downloading(t)),this.cleanup(t.version).then(()=>this.getUpdatePackagePath(t.version).then(e=>n.exists(e).then(i=>{if(i)return Promise.resolve(e);const r=t.url,s=t.hash,o=`${e}.tmp`;return this.requestService.request({url:r},S.CancellationToken.None).then(e=>this.fileService.writeFile(E.URI.file(o),e.stream)).then(s?()=>v.checksum(o,t.hash):()=>void 0).then(()=>n.rename(o,e)).then(()=>e)})).then(e=>{const i=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:e},i&&t.supportsFastUpdate?"user"===d.default.target?this.doApplyUpdate():this.setState(u.State.Downloaded(t)):this.setState(u.State.Ready(t))}))):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!e}),this.setState(u.State.Idle(i)),Promise.resolve(null))}).then(void 0,t=>{this.logService.error(t),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!e});const i=e?t.message||t:void 0;this.setState(u.State.Idle(k(),i))}))}
async doDownloadUpdate(e){e.update.url&&this.nativeHostMainService.openExternal(void 0,e.update.url),this.setState(u.State.Idle(k()))}async getUpdatePackagePath(e){const t=await this.cachePath;return r.join(t,`CodeSetup-${d.default.quality}-${e}.exe`)}async cleanup(e=null){const t=e?t=>!new RegExp(`${d.default.quality}-${e}\\.exe$`).test(t):()=>!0,i=await this.cachePath,s=(await n.readdir(i)).filter(t).map(async e=>{try{await n.unlink(r.join(i,e))}catch(e){}});await Promise.all(s)}async doApplyUpdate(){if("downloaded"!==this.state.type&&"downloading"!==this.state.type)return Promise.resolve(void 0);if(!this.availableUpdate)return Promise.resolve(void 0);const t=this.state.update;this.setState(u.State.Updating(t));const i=await this.cachePath;this.availableUpdate.updateFilePath=r.join(i,`CodeSetup-${d.default.quality}-${t.version}.flag`),await n.writeFile(this.availableUpdate.updateFilePath,"flag"),
y.spawn(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(k()))});const s=`${d.default.win32MutexName}-ready`,o=await new Promise((t,i)=>{e(["windows-mutex"],t,i)});(async function(e,t=1e3){for(;!e();)await b.timeout(t)})(()=>o.isActive(s)).then(()=>this.setState(u.State.Ready(t)))}doQuitAndInstall(){"ready"===this.state.type&&this.availableUpdate&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?i.unlinkSync(this.availableUpdate.updateFilePath):y.spawn(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return k()}}
;s([a.memoize],P.prototype,"cachePath",null),P=s([o(0,l.ILifecycleMainService),o(1,c.IConfigurationService),o(2,h.ITelemetryService),o(3,p.IEnvironmentMainService),o(4,m.IRequestService),o(5,f.ILogService),o(6,_.IFileService),o(7,C.INativeHostMainService)],P),t.Win32UpdateService=P}),define(t[51],i([0,1,39,21,6,25,24,3,5,7,56,40,206,10,2,17,4,145,15,11,14,49,50,92]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b,_,E,C,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWorkspaceIdentifier=t.WorkspacesMainService=t.IWorkspacesMainService=void 0,t.IWorkspacesMainService=w.createDecorator("workspacesMainService");let k=class extends m.Disposable{constructor(e,t,i,r){super(),this.environmentService=e,this.logService=t,this.backupMainService=i,this.dialogMainService=r,this.untitledWorkspacesHome=this.environmentService.untitledWorkspacesHome,this._onUntitledWorkspaceDeleted=this._register(new d.Emitter),this.onUntitledWorkspaceDeleted=this._onUntitledWorkspaceDeleted.event,
this._onWorkspaceEntered=this._register(new d.Emitter),this.onWorkspaceEntered=this._onWorkspaceEntered.event}resolveLocalWorkspaceSync(e){if(!this.isWorkspacePath(e))return null;if(e.scheme!==g.Schemas.file)return null;let t;try{t=c.readFileSync(e.fsPath,"utf8")}catch(e){return null}return this.doResolveWorkspace(e,t)}isWorkspacePath(e){return i.isUntitledWorkspace(e,this.environmentService)||i.hasWorkspaceFileExtension(e)}doResolveWorkspace(e,t){try{const i=this.doParseStoredWorkspace(e,t),r=M(e);return{id:r.id,configPath:r.configPath,folders:f.toWorkspaceFolders(i.folders,r.configPath,v.extUriBiasedIgnorePathCase),remoteAuthority:i.remoteAuthority}}catch(e){this.logService.warn(e.toString())}return null}doParseStoredWorkspace(e,t){const r=p.parse(t);if(!r||!Array.isArray(r.folders))throw new Error(`${e.toString(!0)} looks like an invalid workspace file.`);return r.folders=r.folders.filter(e=>i.isStoredWorkspaceFolder(e)),r}async createUntitledWorkspace(e,t){
const{workspace:i,storedWorkspace:r}=this.newUntitledWorkspace(e,t),s=i.configPath.fsPath;return await a.mkdirp(n.dirname(s)),await a.writeFile(s,JSON.stringify(r,null,"\t")),i}createUntitledWorkspaceSync(e,t){const{workspace:i,storedWorkspace:r}=this.newUntitledWorkspace(e,t),s=i.configPath.fsPath,o=n.dirname(s);if(!c.existsSync(o)){const e=n.dirname(o);c.existsSync(e)||c.mkdirSync(e),c.mkdirSync(o)}return a.writeFileSync(s,JSON.stringify(r,null,"\t")),i}newUntitledWorkspace(e=[],t){const r=(Date.now()+Math.round(1e3*Math.random())).toString(),n=v.joinPath(this.untitledWorkspacesHome,r),s=v.joinPath(n,i.UNTITLED_WORKSPACE_NAME),o=[];for(const t of e)o.push(i.getStoredWorkspaceFolder(t.uri,!0,t.name,n,!l.isWindows,v.extUriBiasedIgnorePathCase));return{workspace:M(s),storedWorkspace:{folders:o,remoteAuthority:t}}}async getWorkspaceIdentifier(e){return M(e)}isUntitledWorkspace(e){return i.isUntitledWorkspace(e.configPath,this.environmentService)}deleteUntitledWorkspaceSync(e){
this.isUntitledWorkspace(e)&&(this.doDeleteUntitledWorkspaceSync(e),this._onUntitledWorkspaceDeleted.fire(e))}async deleteUntitledWorkspace(e){this.deleteUntitledWorkspaceSync(e)}doDeleteUntitledWorkspaceSync(e){const t=v.originalFSPath(e.configPath);try{a.rimrafSync(n.dirname(t));const i=n.join(this.environmentService.workspaceStorageHome.fsPath,e.id);c.existsSync(i)&&a.writeFileSync(n.join(i,"obsolete"),"")}catch(e){this.logService.warn(`Unable to delete untitled workspace ${t} (${e}).`)}}getUntitledWorkspacesSync(){const e=[];try{const t=a.readdirSync(this.untitledWorkspacesHome.fsPath).map(e=>v.joinPath(this.untitledWorkspacesHome,e,i.UNTITLED_WORKSPACE_NAME));for(const i of t){const t=M(i),r=this.resolveLocalWorkspaceSync(i);r?e.push({workspace:t,remoteAuthority:r.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(t)}}catch(e){"ENOENT"!==e.code&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${e}).`)}return e}async enterWorkspace(e,t,i){
if(!e||!e.win||!e.isReady)return null;if(!await this.isValidTargetWorkspacePath(e,t,i))return null;const r=this.doEnterWorkspace(e,M(i));return r?(this._onWorkspaceEntered.fire({window:e,workspace:r.workspace}),r):null}async isValidTargetWorkspacePath(e,t,i){if(!i)return!0;if(e.openedWorkspace&&v.extUriBiasedIgnorePathCase.isEqual(e.openedWorkspace.configPath,i))return!1;if(I.findWindowOnWorkspaceOrFolder(t,i)){const e={title:S.default.nameLong,type:"info",buttons:[y.localize(0,null)],message:y.localize(1,null,v.basename(i)),detail:y.localize(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(e,_.withNullAsUndefined(b.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(e,t){if(!e.config)return null;let i;return e.focus(),e.config.extensionDevelopmentPath||(i=this.backupMainService.registerWorkspaceBackupSync({workspace:t,remoteAuthority:e.remoteAuthority},e.config.backupPath)),
e.openedWorkspace&&this.isUntitledWorkspace(e.openedWorkspace)&&this.deleteUntitledWorkspaceSync(e.openedWorkspace),e.config.folderUri=void 0,e.config.workspace=t,e.config.backupPath=i,{workspace:t,backupPath:i}}};function P(e){let t=e.scheme===g.Schemas.file?v.originalFSPath(e):e.toString();return l.isLinux||(t=t.toLowerCase()),h.createHash("md5").update(t).digest("hex")}function M(e){return{configPath:e,id:P(e)}}k=s([o(0,r.IEnvironmentMainService),o(1,u.ILogService),o(2,E.IBackupMainService),o(3,C.IDialogMainService)],k),t.WorkspacesMainService=k,t.getWorkspaceIdentifier=M}),define(t[93],i([0,1,27,6,126,169,5,8,11,21,7,18,58,15,60,2,3,51,49,186,70,9,29,50,34,193,20,88,26,10,53,22]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b,_,E,C,I,k,P,M,D,L,R,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CodeWindow=t.defaultWindowState=void 0;var A,x;t.defaultWindowState=function(e=1){return{width:1024,height:768,mode:e}},function(e){e[e.UNRESPONSIVE=1]="UNRESPONSIVE",e[e.CRASHED=2]="CRASHED"
}(A||(A={})),function(e){e[e.NONE=0]="NONE",e[e.LOADING=1]="LOADING",e[e.NAVIGATING=2]="NAVIGATING",e[e.READY=3]="READY"}(x||(x={}));let F=class s extends v.Disposable{constructor(t,i,n,s,o,a,l,u,h,p,f,v){super(),this.logService=i,this.environmentService=n,this.fileService=s,this.storageService=o,this.configurationService=a,this.themeMainService=l,this.workspacesMainService=u,this.backupMainService=h,this.telemetryService=p,this.dialogMainService=f,this.lifecycleMainService=v,this._onLoad=this._register(new c.Emitter),this.onLoad=this._onLoad.event,this._onReady=this._register(new c.Emitter),this.onReady=this._onReady.event,this._onClose=this._register(new c.Emitter),this.onClose=this._onClose.event,this._onDestroy=this._register(new c.Emitter),this.onDestroy=this._onDestroy.event,this.touchBarGroups=[],this._lastFocusTime=-1,this._readyState=0,this.whenReadyCallbacks=[];{const[i,n]=this.restoreWindowState(t.state);this.windowState=i,this.logService.trace("window#ctor: using window state",i)
;const s=0===this.windowState.mode||3===this.windowState.mode,o=this.configurationService.getValue("window"),a={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:m.WindowMinimumSize.WIDTH,minHeight:m.WindowMinimumSize.HEIGHT,show:!s,title:g.default.nameLong,webPreferences:Object.assign({preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",e).fsPath,v8CacheOptions:w.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:m.zoomLevelToZoomFactor(null==o?void 0:o.zoomLevel)},this.environmentService.sandbox?{sandbox:!0,contextIsolation:!0}:{nodeIntegration:!0})};w.browserCodeLoadingCacheStrategy&&this.logService.info(`window#ctor: using vscode-file protocol and V8 cache options: ${w.browserCodeLoadingCacheStrategy}`),
w.isLinux?a.icon=r.join(this.environmentService.appRoot,"resources/linux/code.png"):w.isWindows&&!this.environmentService.isBuilt&&(a.icon=r.join(this.environmentService.appRoot,"resources/win32/code_150x150.png")),w.isMacintosh&&!this.useNativeFullScreen()&&(a.fullscreenable=!1),w.isMacintosh&&(a.acceptFirstMouse=!0,!1===(null==o?void 0:o.clickThroughInactive)&&(a.acceptFirstMouse=!1));const c=w.isMacintosh&&!0===(null==o?void 0:o.nativeTabs);c&&(a.tabbingIdentifier=g.default.nameShort);const l="custom"===m.getTitleBarStyle(this.configurationService);if(l&&(a.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,w.isMacintosh||(a.frame=!1)),this._win=new d.BrowserWindow(a),this._id=this._win.id,!0===this.environmentService.args["open-devtools"]&&this._win.webContents.openDevTools(),w.isMacintosh&&l&&this._win.setSheetOffset(22),w.isMacintosh&&n&&(!c||1===d.BrowserWindow.getAllWindows().length)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(e=>"number"==typeof e)){
const e=this.windowState;this._win.setBounds({width:e.width,height:e.height,x:e.x,y:e.y})}s&&(this._win.maximize(),3===this.windowState.mode&&this.setFullScreen(!0),this._win.isVisible()||this._win.show()),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar();const y=this;this.marketplaceHeadersPromise=b.resolveMarketplaceHeaders(g.default.version,this.environmentService,this.fileService,{get:e=>y.storageService.get(e),store(e,t){y.storageService.store(e,t)}}),this.registerListeners()}get config(){return this.currentConfig}get id(){return this._id}get win(){return this._win}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var e;return!!(null===(e=this.currentConfig)||void 0===e?void 0:e.extensionDevelopmentPath)}get isExtensionTestHost(){var e;return!!(null===(e=this.currentConfig)||void 0===e?void 0:e.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var e
;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!(null===(e=this.currentConfig)||void 0===e?void 0:e.debugId)}setRepresentedFilename(e){w.isMacintosh?this.win.setRepresentedFilename(e):this.representedFilename=e}getRepresentedFilename(){return w.isMacintosh?this.win.getRepresentedFilename():this.representedFilename}setDocumentEdited(e){w.isMacintosh&&this._win.setDocumentEdited(e),this.documentEdited=e}isDocumentEdited(){return w.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(e){w.isMacintosh&&(null==e?void 0:e.force)&&d.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?this.currentConfig.backupPath:void 0}get openedWorkspace(){return this.currentConfig?this.currentConfig.workspace:void 0}get openedFolderUri(){return this.currentConfig?this.currentConfig.folderUri:void 0}get remoteAuthority(){
return this.currentConfig?this.currentConfig.remoteAuthority:void 0}setReady(){for(this._readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onReady.fire()}ready(){return new Promise(e=>{if(this.isReady)return e(this);this.whenReadyCallbacks.push(e)})}get isReady(){return 3===this._readyState}get whenClosedOrLoaded(){return new Promise(e=>{function t(){i.dispose(),r.dispose(),e()}const i=this.onClose(()=>t()),r=this.onLoad(()=>t())})}registerListeners(){if(this._win.webContents.on("render-process-gone",(e,t)=>{"crashed"===t.reason&&this.onWindowError(2,t)}),this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.on("closed",()=>{this._onClose.fire(),this.dispose()}),this._win.webContents.session.webRequest.onBeforeRequest(null,(e,t)=>{if(e.url.indexOf(".svg")>0){const i=l.URI.parse(e.url);if(i&&!i.scheme.match(/file/i)&&i.path.endsWith(".svg"))return t({cancel:!0})}return t({})}),this._win.webContents.session.webRequest.onHeadersReceived(null,(e,t)=>{
const i=e.responseHeaders,r=i["content-type"]||i["Content-Type"];return r&&Array.isArray(r)&&r.some(e=>e.toLowerCase().indexOf("image/svg")>=0)?t({cancel:!0}):t({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this._readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),w.isMacintosh){const e=this._register(new E.RunOnceScheduler(()=>{this._win&&!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))},100)),t=(t,i,r)=>{Array.isArray(r)&&1===r.length&&"workArea"===r[0]||e.schedule()};d.screen.on("display-metrics-changed",t),this._register(v.toDisposable(()=>d.screen.removeListener("display-metrics-changed",t))),d.screen.on("display-added",t),this._register(v.toDisposable(()=>d.screen.removeListener("display-added",t))),d.screen.on("display-removed",t),this._register(v.toDisposable(()=>d.screen.removeListener("display-removed",t)))}
this._win.on("maximize",e=>{this.currentConfig&&(this.currentConfig.maximized=!0),d.app.emit("browser-window-maximize",e,this._win)}),this._win.on("unmaximize",e=>{this.currentConfig&&(this.currentConfig.maximized=!1),d.app.emit("browser-window-unmaximize",e,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",O.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",O.CancellationToken.None)}),this._win.webContents.on("did-fail-load",(e,t,i,r,n)=>{this.logService.warn("[electron event]: fail to load, ",i)}),this._register(this.configurationService.onDidChangeConfiguration(e=>this.onConfigurationUpdated())),this._register(this.workspacesMainService.onUntitledWorkspaceDeleted(e=>this.onUntitledWorkspaceDeleted(e)));this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"]},(e,t)=>this.marketplaceHeadersPromise.then(i=>t({cancel:!1,
requestHeaders:Object.assign(e.requestHeaders,i)})))}onWindowError(e,t){if(this.logService.error(2===e?`[VS Code]: renderer process crashed (detail: ${null==t?void 0:t.reason})`:"[VS Code]: detected unresponsive"),this.isExtensionDevelopmentTestFromCli)this.lifecycleMainService.kill(1);else if(this.telemetryService.publicLog2("windowerror",{type:e}),1===e){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;this.dialogMainService.showMessageBox({title:g.default.nameLong,type:"warning",buttons:[k.mnemonicButtonLabel(n.localize(0,null)),k.mnemonicButtonLabel(n.localize(1,null)),k.mnemonicButtonLabel(n.localize(2,null))],message:n.localize(3,null),detail:n.localize(4,null),noLink:!0},this._win).then(e=>{this._win&&(0===e.response?this.reload():2===e.response&&this.destroyWindow())})}else{let e;e=t&&"crashed"!==t.reason?n.localize(5,null,null==t?void 0:t.reason):n.localize(6,null,null==t?void 0:t.reason),
this.dialogMainService.showMessageBox({title:g.default.nameLong,type:"warning",buttons:[k.mnemonicButtonLabel(n.localize(7,null)),k.mnemonicButtonLabel(n.localize(8,null))],message:e,detail:n.localize(9,null),noLink:!0},this._win).then(e=>{this._win&&(0===e.response?this.reload():1===e.response&&this.destroyWindow())})}}destroyWindow(){this._onDestroy.fire(),this._win.destroy()}onUntitledWorkspaceDeleted(e){this.openedWorkspace&&this.openedWorkspace.id===e.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const e=this.getMenuBarVisibility();e!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=e,this.setMenuBarVisibility(e));let t=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(null==t?void 0:t.endsWith("/"))&&(t=t.substr(0,t.length-1));const i=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0
;if(-1===(t||"").indexOf("@")&&(t!==this.currentHttpProxy||i!==this.currentNoProxy)){this.currentHttpProxy=t,this.currentNoProxy=i;const e=t||"",r=i?`${i},<local>`:"<local>";this.logService.trace(`Setting proxy to '${e}', bypassing '${r}'`),this._win.webContents.session.setProxy({proxyRules:e,proxyBypassRules:r,pacScript:""})}}addTabbedWindow(e){w.isMacintosh&&this._win.addTabbedWindow(e.win)}load(e,t,i){var r,n;const s=null===(n=null!==(r=this.currentConfig)&&void 0!==r?r:this.pendingLoadConfig)||void 0===n?void 0:n.userEnv;s&&T.isLaunchedFromCli(s)&&!T.isLaunchedFromCli(e.userEnv)&&(e.userEnv=Object.assign(Object.assign({},s),e.userEnv)),0===this._readyState?this.currentConfig=e:(this.pendingLoadConfig=e,this._readyState=2);const o=Object.assign({},e);void 0!==i&&(o["disable-extensions"]=i),this.isDocumentEdited()&&(t&&this.backupMainService.isHotExitEnabled()||this.setDocumentEdited(!1)),t||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(g.default.nameLong)),
a.mark("code/willOpenNewWindow"),this._win.loadURL(this.getUrl(o)),this.environmentService.isBuilt||this.environmentService.extensionTestsLocationURI||(this.showTimeoutHandle=setTimeout(()=>{!this._win||this._win.isVisible()||this._win.isMinimized()||(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onLoad.fire()}reload(e){const t=Object.assign({},this.currentConfig);delete t.filesToOpenOrCreate,delete t.filesToDiff,delete t.filesToWait,this.isExtensionDevelopmentHost&&e&&(t.verbose=e.verbose,t["inspect-extensions"]=e["inspect-extensions"],t["inspect-brk-extensions"]=e["inspect-brk-extensions"],t.debugId=e.debugId,t["extensions-dir"]=e["extensions-dir"]),t.isInitialStartup=!1;const i=e?e["disable-extensions"]:void 0;this.load(t,!0,i)}getUrl(e){var t;e.windowId=this._win.id,e.sessionId=`window:${this._win.id}`,e.logLevel=this.logService.getLevel(),e.logsPath=this.environmentService.logsPath
;const n=this.configurationService.getValue("window"),o=null==n?void 0:n.zoomLevel;"number"==typeof o&&(e.zoomLevel=o),e.fullscreen=this.isFullScreen,e.colorScheme={dark:d.nativeTheme.shouldUseDarkColors,highContrast:d.nativeTheme.shouldUseInvertedColorScheme||d.nativeTheme.shouldUseHighContrastColors},e.autoDetectHighContrast=null===(t=null==n?void 0:n.autoDetectHighContrast)||void 0===t||t,e.accessibilitySupport=d.app.accessibilitySupportEnabled,e.maximized=this._win.isMaximized(),e.perfMarks=a.getMarks(),e.partsSplashPath=r.join(this.environmentService.userDataPath,"rapid_render.json"),e.os={release:i.release()};const c=f.parseArgs(process.argv,f.OPTIONS),l=Object.assign(c,e);for(const e in l){const t=l[e];null!=t&&""!==t&&!1!==t||delete l[e]}let u=this.doGetUrl(l);return u.length>s.MAX_URL_LENGTH&&(this.logService.warn("Application URL exceeds maximum of 2MB and was shortened."),(u=this.doGetUrl(Object.assign(Object.assign({},l),{userEnv:void 0
}))).length>s.MAX_URL_LENGTH&&this.logService.error("Application URL exceeds maximum of 2MB and cannot be loaded.")),u}doGetUrl(t){let i;return i=this.environmentService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",R.FileAccess.asBrowserUri(i,e).with({query:`config=${encodeURIComponent(JSON.stringify(t))}`}).toString(!0)}serializeWindowState(){if(!this._win)return t.defaultWindowState();if(this.isFullScreen){let e;try{e=d.screen.getDisplayMatching(this.getBounds())}catch(e){}const i=t.defaultWindowState();return{mode:3,display:e?e.id:void 0,width:this.windowState.width||i.width,height:this.windowState.height||i.height,x:this.windowState.x||0,y:this.windowState.y||0}}const e=Object.create(null);let i;if(i=!w.isMacintosh&&this._win.isMaximized()?0:1,e.mode=0===i?0:1,1===i||0===i){let t;t=1===i?this.getBounds():this._win.getNormalBounds(),e.x=t.x,e.y=t.y,e.width=t.width,e.height=t.height}return e}restoreWindowState(e){let i=!1;if(e)try{
const t=d.screen.getAllDisplays();i=t.length>1,e=this.validateWindowState(e,t)}catch(e){this.logService.warn(`Unexpected error validating window state: ${e}\n${e.stack}`)}return[e||t.defaultWindowState(),i]}validateWindowState(e,i){var r,n;if(this.logService.trace(`window#validateWindowState: validating window state on ${i.length} display(s)`,e),"number"!=typeof e.x||"number"!=typeof e.y||"number"!=typeof e.width||"number"!=typeof e.height)return void this.logService.trace("window#validateWindowState: unexpected type of state values");if(e.width<=0||e.height<=0)return void this.logService.trace("window#validateWindowState: unexpected negative values");if(1===i.length){const t=this.getWorkingArea(i[0]);if(t){function s(){e&&"number"==typeof e.x&&"number"==typeof e.y&&t&&(e.x<t.x&&(e.x=t.x),e.y<t.y&&(e.y=t.y))}this.logService.trace("window#validateWindowState: 1 monitor working area",t),s(),e.width>t.width&&(e.width=t.width),e.height>t.height&&(e.height=t.height),e.x>t.x+t.width-128&&(e.x=t.x+t.width-e.width),
e.y>t.y+t.height-128&&(e.y=t.y+t.height-e.height),s()}return e}if(e.display&&3===e.mode){const s=i.find(t=>t.id===e.display);if(s&&"number"==typeof(null===(r=s.bounds)||void 0===r?void 0:r.x)&&"number"==typeof(null===(n=s.bounds)||void 0===n?void 0:n.y)){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const e=t.defaultWindowState(3);return e.x=s.bounds.x,e.y=s.bounds.y,e}}let o,a;try{o=d.screen.getDisplayMatching({x:e.x,y:e.y,width:e.width,height:e.height}),a=this.getWorkingArea(o)}catch(e){}return o&&a&&e.x+e.width>a.x&&e.y+e.height>a.y&&e.x<a.x+a.width&&e.y<a.y+a.height?(this.logService.trace("window#validateWindowState: multi-monitor working area",a),e):void 0}getWorkingArea(e){return e.workArea.width>0&&e.workArea.height>0?e.workArea:e.bounds.width>0&&e.bounds.height>0?e.bounds:void 0}getBounds(){const e=this._win.getPosition(),t=this._win.getSize();return{x:e[0],y:e[1],width:t[0],height:t[1]}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}
setFullScreen(e){this.useNativeFullScreen()?this.setNativeFullScreen(e):this.setSimpleFullScreen(e),this.sendWhenReady(e?"vscode:enterFullScreen":"vscode:leaveFullScreen",O.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(e){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(e)}setSimpleFullScreen(e){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(e),this._win.webContents.focus()}useNativeFullScreen(){const e=this.configurationService.getValue("window");return!e||"boolean"!=typeof e.nativeFullScreen||(!!e.nativeTabs||!1!==e.nativeFullScreen)}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let e=m.getMenuBarVisibility(this.configurationService);return["visible","toggle","hidden"].indexOf(e)<0&&(e="default"),e}setMenuBarVisibility(e,t=!0){
w.isMacintosh||("toggle"===e&&t&&this.send("vscode:showInfoMessage",n.localize(10,null)),"hidden"===e?setTimeout(()=>{this.doSetMenuBarVisibility(e)}):this.doSetMenuBarVisibility(e))}doSetMenuBarVisibility(e){const t=this.isFullScreen;switch(e){case"default":this._win.setMenuBarVisibility(!t),this._win.autoHideMenuBar=t;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1}}handleTitleDoubleClick(){if(w.isMacintosh){switch(d.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.win.minimize();break;case"None":break;case"Maximize":default:this.win.isMaximized()?this.win.unmaximize():this.win.maximize()}}else this.win.isMaximized()?this.win.unmaximize():this.win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(e,t,...i){
this.isReady?this.send(e,...i):this.ready().then(()=>{t.isCancellationRequested||this.send(e,...i)})}send(e,...t){this._win&&this._win.webContents.send(e,...t)}updateTouchBar(e){w.isMacintosh&&this.touchBarGroups.forEach((t,i)=>{const r=e[i];t.segments=this.createTouchBarGroupSegments(r)})}createTouchBar(){if(w.isMacintosh){for(let e=0;e<10;e++){const e=this.createTouchBarGroup();this.touchBarGroups.push(e)}this._win.setTouchBar(new d.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(e=[]){const t=this.createTouchBarGroupSegments(e),i=new d.TouchBar.TouchBarSegmentedControl({segments:t,mode:"buttons",segmentStyle:"automatic",change:e=>{this.sendWhenReady("vscode:runAction",O.CancellationToken.None,{id:i.segments[e].id,from:"touchbar"})}});return i}createTouchBarGroupSegments(e=[]){return e.map(e=>{var t,i;let r,n
;return e.icon&&!P.ThemeIcon.isThemeIcon(e.icon)&&(null===(i=null===(t=e.icon)||void 0===t?void 0:t.dark)||void 0===i?void 0:i.scheme)===R.Schemas.file&&(r=d.nativeImage.createFromPath(l.URI.revive(e.icon.dark).fsPath)).isEmpty()&&(r=void 0),n="string"==typeof e.title?e.title:e.title.value,{id:e.id,label:r?void 0:n,icon:r}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};F.MAX_URL_LENGTH=2*L.ByteSize.MB,F=s([o(1,h.ILogService),o(2,u.IEnvironmentMainService),o(3,L.IFileService),o(4,D.IStorageMainService),o(5,p.IConfigurationService),o(6,_.IThemeMainService),o(7,y.IWorkspacesMainService),o(8,S.IBackupMainService),o(9,C.ITelemetryService),o(10,I.IDialogMainService),o(11,M.ILifecycleMainService)],F),t.CodeWindow=F}),define(t[94],i([0,1,7,90,3,4,32,25,51,18,8,11,30,53,22]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LaunchMainService=t.ILaunchMainService=t.ID=void 0,t.ID="launchMainService",
t.ILaunchMainService=a.createDecorator(t.ID);let v=class{constructor(e,t,i,r,n){this.logService=e,this.windowsMainService=t,this.urlService=i,this.workspacesMainService=r,this.configurationService=n}async start(e,t){this.logService.trace("Received data from other instance: ",e,t),n.isMacintosh&&p.app.focus({steal:!0});const i=function(e){return e["open-url"]&&e._urls&&e._urls.length>0?f.coalesce(e._urls.map(e=>{try{return{uri:h.URI.parse(e),url:e}}catch(e){return null}})):[]}(e);if(!i.length)return this.startOpenWindow(e,t);{let e=Promise.resolve();if(0===this.windowsMainService.getWindowCount()){e=this.windowsMainService.openEmptyWindow({context:4})[0].ready()}e.then(()=>{for(const{uri:e,url:t}of i)this.urlService.open(e,{originalUrl:t})})}}async startOpenWindow(e,t){const i=g.isLaunchedFromCli(t)?0:4;let r=[];const s=e.wait&&e.waitMarkerFilePath?h.URI.file(e.waitMarkerFilePath):void 0;if(e.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(e.extensionDevelopmentPath,{
context:i,cli:e,userEnv:t,waitMarkerFileURI:s});else if(e._.length||e["folder-uri"]||e["file-uri"])r=this.windowsMainService.open({context:i,cli:e,userEnv:t,forceNewWindow:e["new-window"],preferNewWindow:!e["reuse-window"]&&!e.wait,forceReuseWindow:e["reuse-window"],diffMode:e.diff,addMode:e.add,noRecentEntry:!!e["skip-add-to-recently-opened"],waitMarkerFileURI:s,gotoLineMode:e.goto});else{let o=!1;if(e["new-window"]||e["unity-launch"])o=!0;else if(e["reuse-window"])o=!1;else{const e=this.configurationService.getValue("window");switch((null==e?void 0:e.openWithoutArgumentsInNewWindow)||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!n.isMacintosh}}if(o)r=this.windowsMainService.open({context:i,cli:e,userEnv:t,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:s});else{const t=this.windowsMainService.getLastActiveWindow();t?(t.focus(),r=[t]):r=this.windowsMainService.open({context:i,cli:e,forceEmpty:!0})}}
if(s&&1===r.length&&r[0])return Promise.race([r[0].whenClosedOrLoaded,l.whenDeleted(s.fsPath)]).then(()=>void 0,()=>void 0)}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const e=[];return p.BrowserWindow.getAllWindows().forEach(t=>{const i=this.windowsMainService.getWindowById(t.id);i?e.push(this.codeWindowToInfo(i)):e.push(this.browserWindowToInfo(t))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:e,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(e){const t=this.windowsMainService.getWindows();return(await Promise.all(t.map(t=>new Promise(i=>{const r=t.remoteAuthority;if(r){const n=`vscode:getDiagnosticInfoResponse${t.id}`,s={includeProcesses:e.includeProcesses,folders:e.includeWorkspaceMetadata?this.getFolderURIs(t):void 0}
;t.sendWhenReady("vscode:getDiagnosticInfo",m.CancellationToken.None,{replyChannel:n,args:s}),p.ipcMain.once(n,(e,t)=>{t||i({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),i(t)}),setTimeout(()=>{i({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else i(void 0)})))).filter(e=>!!e)}getFolderURIs(e){const t=[];if(e.openedFolderUri)t.push(e.openedFolderUri);else if(e.openedWorkspace){const i=e.openedWorkspace.configPath,r=this.workspacesMainService.resolveLocalWorkspaceSync(i);if(r){r.folders.forEach(e=>{t.push(e.uri)})}}return t}codeWindowToInfo(e){const t=this.getFolderURIs(e);return this.browserWindowToInfo(e.win,t,e.remoteAuthority)}browserWindowToInfo(e,t=[],i){return{pid:e.webContents.getOSProcessId(),title:e.getTitle(),folderURIs:t,remoteAuthority:i}}};v=s([o(0,i.ILogService),o(1,c.IWindowsMainService),o(2,r.IURLService),o(3,d.IWorkspacesMainService),o(4,u.IConfigurationService)],v),t.LaunchMainService=v}),
define(t[222],i([0,1,137,27,15,58,11,94,81,89,21,3,7,75,50,4,60,10,44]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IssueMainService=t.IIssueMainService=void 0;t.IIssueMainService=v.createDecorator("issueMainService");let b=class{constructor(e,t,i,r,n,s,o,a){this.machineId=e,this.userEnv=t,this.environmentService=i,this.launchMainService=r,this.logService=n,this.diagnosticsService=s,this.dialogMainService=o,this.nativeHostMainService=a,this._issueWindow=null,this._issueParentWindow=null,this._processExplorerWindow=null,this._processExplorerParentWindow=null,this.registerListeners()}registerListeners(){c.ipcMain.on("vscode:issueSystemInfoRequest",async e=>{Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]).then(t=>{const[i,r]=t;this.diagnosticsService.getSystemInfo(i,r).then(t=>{this.safeSend(e,"vscode:issueSystemInfoResponse",t)})})}),
c.ipcMain.on("vscode:listProcesses",async e=>{const t=[];try{const e=await this.launchMainService.getMainProcessId();t.push({name:i.localize(0,null),rootProcess:await g.listProcesses(e)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(e=>{d.isRemoteDiagnosticError(e)?t.push({name:e.hostName,rootProcess:e}):e.processes&&t.push({name:e.hostName,rootProcess:e.processes})})}catch(e){this.logService.error(`Listing processes failed: ${e}`)}this.safeSend(e,"vscode:listProcessesResponse",t)}),c.ipcMain.on("vscode:issueReporterClipboard",e=>{const t={message:i.localize(1,null),type:"warning",buttons:[i.localize(2,null),i.localize(3,null)]};this._issueWindow&&this.dialogMainService.showMessageBox(t,this._issueWindow).then(t=>{this.safeSend(e,"vscode:issueReporterClipboardResponse",0===t.response)})}),c.ipcMain.on("vscode:issuePerformanceInfoRequest",e=>{this.getPerformanceInfo().then(t=>{this.safeSend(e,"vscode:issuePerformanceInfoResponse",t)})}),
c.ipcMain.on("vscode:issueReporterConfirmClose",()=>{const e={message:i.localize(4,null),type:"warning",buttons:[i.localize(5,null),i.localize(6,null)]};this._issueWindow&&this.dialogMainService.showMessageBox(e,this._issueWindow).then(e=>{0===e.response&&this._issueWindow&&(this._issueWindow.destroy(),this._issueWindow=null)})}),c.ipcMain.on("vscode:workbenchCommand",(e,t)=>{const{id:i,from:r,args:n}=t;let s;switch(r){case"issueReporter":s=this._issueParentWindow;break;case"processExplorer":s=this._processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${r}`)}s&&s.webContents.send("vscode:runAction",{id:i,from:r,args:n})}),c.ipcMain.on("vscode:openExternal",(e,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),c.ipcMain.on("vscode:closeIssueReporter",e=>{this._issueWindow&&this._issueWindow.close()}),c.ipcMain.on("vscode:closeProcessExplorer",e=>{this._processExplorerWindow&&this._processExplorerWindow.close()}),c.ipcMain.on("vscode:windowsInfoRequest",e=>{
this.launchMainService.getMainProcessInfo().then(t=>{this.safeSend(e,"vscode:windowsInfoResponse",t.windows)})})}safeSend(e,t,...i){e.sender.isDestroyed()||e.sender.send(t,...i)}async openReporter(t){if(!this._issueWindow&&(this._issueParentWindow=c.BrowserWindow.getFocusedWindow(),this._issueParentWindow)){const r=this.getWindowPosition(this._issueParentWindow,700,800);this._issueWindow=new c.BrowserWindow({fullscreen:!1,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:i.localize(7,null),backgroundColor:t.styles.backgroundColor||"#1E1E1E",webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",e).fsPath,v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:w.zoomLevelToZoomFactor(t.zoomLevel),sandbox:!0,contextIsolation:!0}}),this._issueWindow.setMenuBarVisibility(!1);const n={};this.logService.trace("issueService#openReporter: opening issue reporter"),
this._issueWindow.loadURL(this.getIssueReporterPath(t,n)),this._issueWindow.on("close",()=>this._issueWindow=null),this._issueParentWindow.on("closed",()=>{this._issueWindow&&(this._issueWindow.close(),this._issueWindow=null)})}this._issueWindow&&this._issueWindow.focus()}async openProcessExplorer(t){if(!this._processExplorerWindow&&(this._processExplorerParentWindow=c.BrowserWindow.getFocusedWindow(),this._processExplorerParentWindow)){const r=this.getWindowPosition(this._processExplorerParentWindow,800,500);this._processExplorerWindow=new c.BrowserWindow({skipTaskbar:!0,resizable:!0,fullscreen:!1,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,backgroundColor:t.styles.backgroundColor,title:i.localize(8,null),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",e).fsPath,v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:w.zoomLevelToZoomFactor(t.zoomLevel),sandbox:!0,
contextIsolation:!0}}),this._processExplorerWindow.setMenuBarVisibility(!1);const n={appRoot:this.environmentService.appRoot,windowId:this._processExplorerWindow.id,userEnv:this.userEnv,machineId:this.machineId,data:t};this._processExplorerWindow.loadURL(_("vs/code/electron-sandbox/processExplorer/processExplorer.html",n)),this._processExplorerWindow.on("close",()=>this._processExplorerWindow=null),this._processExplorerParentWindow.on("close",()=>{this._processExplorerWindow&&(this._processExplorerWindow.close(),this._processExplorerWindow=null)})}this._processExplorerWindow&&this._processExplorerWindow.focus()}async getSystemStatus(){return Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]).then(e=>{const[t,i]=e;return this.diagnosticsService.getDiagnostics(t,i)})}getWindowPosition(e,t,i){let r;const n=c.screen.getAllDisplays();if(1===n.length)r=n[0];else{if(p.isMacintosh){
const e=c.screen.getCursorScreenPoint();r=c.screen.getDisplayNearestPoint(e)}!r&&e&&(r=c.screen.getDisplayMatching(e.getBounds())),r||(r=c.screen.getPrimaryDisplay()||n[0])}const s={width:t,height:i},o=r.bounds;return s.x=o.x+o.width/2-s.width/2,s.y=o.y+o.height/2-s.height/2,o.width>0&&o.height>0&&(s.x<o.x&&(s.x=o.x),s.y<o.y&&(s.y=o.y),s.x>o.x+o.width&&(s.x=o.x),s.y>o.y+o.height&&(s.y=o.y),s.width>o.width&&(s.width=o.width),s.height>o.height&&(s.height=o.height)),s}getPerformanceInfo(){return new Promise(async(e,t)=>{Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]).then(i=>{const[r,n]=i;this.diagnosticsService.getPerformanceInfo(r,n).then(t=>{e(t)}).catch(e=>{this.logService.warn("issueService#getPerformanceInfo ",e.message),t(e)})})})}getIssueReporterPath(e,t){if(!this._issueWindow)throw new Error("Issue window has been disposed");return _("vs/code/electron-sandbox/issue/issueReporter.html",{
appRoot:this.environmentService.appRoot,windowId:this._issueWindow.id,machineId:this.machineId,userEnv:this.userEnv,data:e,features:t,disableExtensions:this.environmentService.disableExtensions,os:{type:r.type(),arch:r.arch(),release:r.release()},product:{nameShort:n.default.nameShort,version:n.default.version,commit:n.default.commit,date:n.default.date,reportIssueUrl:n.default.reportIssueUrl}})}};function _(t,i){const r=a.parseArgs(process.argv,a.OPTIONS),n=Object.assign(r,i);for(const e of Object.keys(n)){const t=e;void 0!==n[t]&&null!==n[t]&&""!==n[t]||delete n[t]}return y.FileAccess.asBrowserUri(t,e,!0).with({query:`config=${encodeURIComponent(JSON.stringify(n))}`}).toString(!0)}b=s([o(2,h.IEnvironmentMainService),o(3,l.ILaunchMainService),o(4,f.ILogService),o(5,u.IDiagnosticsService),o(6,m.IDialogMainService),o(7,S.INativeHostMainService)],b),t.IssueMainService=b}),define(t[223],i([0,1,11,2,3,17,8,93,18,20,7,37,32]),function(e,t,i,r,n,a,c,l,d,u,h,p,f){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.getWindowsStateStoreData=t.restoreWindowsState=t.WindowsStateHandler=void 0;let g=class e extends r.Disposable{constructor(t,i,r,n,s){super(),this.windowsMainService=t,this.stateService=i,this.lifecycleMainService=r,this.logService=n,this.configurationService=s,this._state=m(this.stateService.getItem(e.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){i.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeWindowClose(e=>this.onBeforeWindowClose(e)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onWindowsCountChanged(e=>{e.newCount-e.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onWindowDestroyed(e=>this.onBeforeWindowClose(e))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const t={openedWindows:[],
lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!t.lastActiveWindow){let e=this.windowsMainService.getLastActiveWindow();e&&!e.isExtensionDevelopmentHost||(e=this.windowsMainService.getWindows().find(e=>!e.isExtensionDevelopmentHost)),e&&(t.lastActiveWindow=this.toWindowState(e))}const i=this.windowsMainService.getWindows().find(e=>e.isExtensionDevelopmentHost&&!e.isExtensionTestHost);i&&(t.lastPluginDevelopmentHostWindow=this.toWindowState(i)),this.windowsMainService.getWindowCount()>1&&(t.openedWindows=this.windowsMainService.getWindows().filter(e=>!e.isExtensionDevelopmentHost).map(e=>this.toWindowState(e)));const r=w(t);this.stateService.setItem(e.windowsStateStorageKey,r),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",r)}onBeforeWindowClose(e){if(this.lifecycleMainService.quitRequested)return;const t=this.toWindowState(e)
;e.isExtensionDevelopmentHost&&!e.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=t:e.isExtensionDevelopmentHost||!e.openedWorkspace&&!e.openedFolderUri||this._state.openedWindows.forEach(i=>{const r=e.openedWorkspace&&i.workspace&&i.workspace.id===e.openedWorkspace.id,n=e.openedFolderUri&&i.folderUri&&a.extUriBiasedIgnorePathCase.isEqual(i.folderUri,e.openedFolderUri);(r||n)&&(i.uiState=t.uiState)}),1===this.windowsMainService.getWindowCount()&&(this.lastClosedState=t)}toWindowState(e){return{workspace:e.openedWorkspace,folderUri:e.openedFolderUri,backupPath:e.backupPath,remoteAuthority:e.remoteAuthority,uiState:e.serializeWindowState()}}getNewWindowState(e){const t=this.doGetNewWindowState(e),i=this.configurationService.getValue("window");let r
;return t.hasDefaultState?r=!!((null==i?void 0:i.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):(r=!!(this.lifecycleMainService.wasRestarted||(null==i?void 0:i.restoreFullscreen)))&&n.isMacintosh&&this.windowsMainService.getWindows().some(e=>e.isFullScreen)&&(r=!1),3!==t.mode||r||(t.mode=1),t}doGetNewWindowState(e){const t=this.windowsMainService.getLastActiveWindow();if(!e.extensionTestsPath){if(e.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const i=e.workspace;if(i){const e=this.state.openedWindows.filter(e=>e.workspace&&e.workspace.id===i.id).map(e=>e.uiState);if(e.length)return e[0]}if(e.folderUri){const t=this.state.openedWindows.filter(t=>t.folderUri&&a.extUriBiasedIgnorePathCase.isEqual(t.folderUri,e.folderUri)).map(e=>e.uiState);if(t.length)return t[0]}else if(e.backupPath){const t=this.state.openedWindows.filter(t=>t.backupPath===e.backupPath).map(e=>e.uiState)
;if(t.length)return t[0]}const r=this.lastClosedState||this.state.lastActiveWindow;if(!t&&r)return r.uiState}let r;const s=i.screen.getAllDisplays();if(1===s.length)r=s[0];else{if(n.isMacintosh){const e=i.screen.getCursorScreenPoint();r=i.screen.getDisplayNearestPoint(e)}!r&&t&&(r=i.screen.getDisplayMatching(t.getBounds())),r||(r=i.screen.getPrimaryDisplay()||s[0])}let o=l.defaultWindowState();o.x=Math.round(r.bounds.x+r.bounds.width/2-o.width/2),o.y=Math.round(r.bounds.y+r.bounds.height/2-o.height/2);const c=this.configurationService.getValue("window");let d=!0;if(null==c?void 0:c.newWindowDimensions)if("maximized"===c.newWindowDimensions)o.mode=0,d=!1;else if("fullscreen"===c.newWindowDimensions)o.mode=3,d=!1;else if(("inherit"===c.newWindowDimensions||"offset"===c.newWindowDimensions)&&t){const e=t.serializeWindowState();3===e.mode?o.mode=3:o=e,d=3!==o.mode&&"offset"===c.newWindowDimensions}return d&&(o=this.ensureNoOverlap(o)),o.hasDefaultState=!0,o}ensureNoOverlap(e){
if(0===this.windowsMainService.getWindows().length)return e;e.x="number"==typeof e.x?e.x:0,e.y="number"==typeof e.y?e.y:0;const t=this.windowsMainService.getWindows().map(e=>e.getBounds());for(;t.some(t=>t.x===e.x||t.y===e.y);)e.x+=30,e.y+=30;return e}};function m(e){const t={openedWindows:[]},i=e||{openedWindows:[]};return i.lastActiveWindow&&(t.lastActiveWindow=v(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(t.lastPluginDevelopmentHostWindow=v(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(t.openedWindows=i.openedWindows.map(e=>v(e))),t}function v(e){const t={uiState:e.uiState};return e.backupPath&&(t.backupPath=e.backupPath),e.remoteAuthority&&(t.remoteAuthority=e.remoteAuthority),e.folder&&(t.folderUri=c.URI.parse(e.folder)),e.workspaceIdentifier&&(t.workspace={id:e.workspaceIdentifier.id,configPath:c.URI.parse(e.workspaceIdentifier.configURIPath)}),t}function w(e){return{lastActiveWindow:e.lastActiveWindow&&y(e.lastActiveWindow),
lastPluginDevelopmentHostWindow:e.lastPluginDevelopmentHostWindow&&y(e.lastPluginDevelopmentHostWindow),openedWindows:e.openedWindows.map(e=>y(e))}}function y(e){return{workspaceIdentifier:e.workspace&&{id:e.workspace.id,configURIPath:e.workspace.configPath.toString()},folder:e.folderUri&&e.folderUri.toString(),backupPath:e.backupPath,remoteAuthority:e.remoteAuthority,uiState:e.uiState}}g.windowsStateStorageKey="windowsState",g=s([o(0,f.IWindowsMainService),o(1,p.IStateService),o(2,u.ILifecycleMainService),o(3,h.ILogService),o(4,d.IConfigurationService)],g),t.WindowsStateHandler=g,t.restoreWindowsState=m,t.getWindowsStateStoreData=w}),define(t[61],i([0,1,144,30,37,11,7,34,5,3,39,51,9,17,8,10,21,25,20,4,2]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WorkspacesHistoryMainService=t.IWorkspacesHistoryMainService=void 0,t.IWorkspacesHistoryMainService=b.createDecorator("workspacesHistoryMainService");let E=class e extends _.Disposable{
constructor(e,t,i,r,n){super(),this.stateService=e,this.logService=t,this.workspacesMainService=i,this.environmentService=r,this.lifecycleMainService=n,this._onRecentlyOpenedChange=this._register(new d.Emitter),this.onRecentlyOpenedChange=this._onRecentlyOpenedChange.event,this.macOSRecentDocumentsUpdater=this._register(new f.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesMainService.onWorkspaceEntered(e=>this.addRecentlyOpened([{workspace:e.workspace}])))}handleWindowsJumpList(){u.isWindows&&(this.updateWindowsJumpList(),this._register(this.onRecentlyOpenedChange(()=>this.updateWindowsJumpList())))}addRecentlyOpened(t){const i=[],r=[];for(let n of t)if(h.isRecentWorkspace(n))this.workspacesMainService.isUntitledWorkspace(n.workspace)||-1!==I(i,n.workspace)||i.push(n);else if(h.isRecentFolder(n))-1===k(i,n.folderUri)&&i.push(n);else{
const t=P(r,n.fileUri)>=0,i=n.fileUri.scheme===v.Schemas.file&&e.COMMON_FILES_FILTER.indexOf(g.basename(n.fileUri))>=0;t||i||(r.push(n),u.isWindows&&n.fileUri.scheme===v.Schemas.file&&a.app.addRecentDocument(n.fileUri.fsPath))}this.addEntriesFromStorage(i,r),i.length>e.MAX_TOTAL_RECENT_ENTRIES&&(i.length=e.MAX_TOTAL_RECENT_ENTRIES),r.length>e.MAX_TOTAL_RECENT_ENTRIES&&(r.length=e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:i,files:r}),this._onRecentlyOpenedChange.fire(),u.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(e){const t=t=>{const i=C(t);for(const t of e)if(g.extUriBiasedIgnorePathCase.isEqual(t,i))return!1;return!0},i=this.getRecentlyOpened(),r=i.workspaces.filter(t),n=i.files.filter(t);r.length===i.workspaces.length&&n.length===i.files.length||(this.saveRecentlyOpened({files:n,workspaces:r}),this._onRecentlyOpenedChange.fire(),
u.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!u.isMacintosh)return;a.app.clearRecentDocuments();const t=this.getRecentlyOpened(),i=[];let r=0;for(let n=0;n<t.workspaces.length&&r<e.MAX_MACOS_DOCK_RECENT_WORKSPACES;n++){const e=C(t.workspaces[n]);if(e.scheme===v.Schemas.file){const t=g.originalFSPath(e);await y.exists(t)&&(i.push(t),r++)}}const n=[];for(let s=0;s<t.files.length&&r<e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;s++){const o=C(t.files[s]);if(o.scheme===v.Schemas.file){const t=g.originalFSPath(o);if(e.COMMON_FILES_FILTER.includes(g.basename(o))||i.includes(t))continue;await y.exists(t)&&(n.push(t),r++)}}n.reverse().forEach(e=>a.app.addRecentDocument(e)),i.reverse().forEach(e=>a.app.addRecentDocument(e))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),a.app.clearRecentDocuments(),this._onRecentlyOpenedChange.fire()}getRecentlyOpened(e){var t,i,r
;const n=[],s=[],o=null===(t=null==e?void 0:e.config)||void 0===t?void 0:t.workspace;o&&!this.workspacesMainService.isUntitledWorkspace(o)&&n.push({workspace:o});const a=null===(i=null==e?void 0:e.config)||void 0===i?void 0:i.folderUri;a&&n.push({folderUri:a});const c=null===(r=null==e?void 0:e.config)||void 0===r?void 0:r.filesToOpenOrCreate;if(c)for(let e of c){const t=e.fileUri;t&&-1===P(s,t)&&s.push({fileUri:t})}return this.addEntriesFromStorage(n,s),{workspaces:n,files:s}}addEntriesFromStorage(e,t){let i=this.getRecentlyOpenedFromStorage();for(let t of i.workspaces){let i=h.isRecentFolder(t)?k(e,t.folderUri):I(e,t.workspace);i>=0?e[i].label=e[i].label||t.label:e.push(t)}for(let e of i.files){let i=P(t,e.fileUri);i>=0?t[i].label=t[i].label||e.label:t.push(e)}}getRecentlyOpenedFromStorage(){const t=this.stateService.getItem(e.recentlyOpenedStorageKey);return h.restoreRecentlyOpened(t,this.logService)}saveRecentlyOpened(t){const i=h.toStoreData(t);this.stateService.setItem(e.recentlyOpenedStorageKey,i)}
updateWindowsJumpList(){if(!u.isWindows)return;const e=[];if(e.push({type:"tasks",items:[{type:"task",title:i.localize(0,null),description:i.localize(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let t=[];for(let e of a.app.getJumpListSettings().removedItems){const i=e.args;if(i){const e=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(i);e&&t.push(m.URI.parse(e[2]))}}this.removeRecentlyOpened(t);let n=!1;const s=r.coalesce(this.getRecentlyOpened().workspaces.slice(0,7).map(e=>{const t=h.isRecentWorkspace(e)?e.workspace:e.folderUri,r=e.label?l.splitName(e.label).name:this.getSimpleWorkspaceLabel(t,this.environmentService.untitledWorkspacesHome);let s,o;return h.isSingleFolderWorkspaceIdentifier(t)?(s=i.localize(2,null,l.getBaseLabel(t),l.getPathLabel(g.dirname(t),this.environmentService)),o=`--folder-uri "${t.toString()}"`):(n=!0,
s=i.localize(3,null,l.getBaseLabel(t.configPath),l.getPathLabel(g.dirname(t.configPath),this.environmentService)),o=`--file-uri "${t.configPath.toString()}"`),{type:"task",title:r.substr(0,255),description:s.substr(0,255),program:process.execPath,args:o,iconPath:"explorer.exe",iconIndex:0}}));s.length>0&&e.push({type:"custom",name:n?i.localize(4,null):i.localize(5,null),items:s})}e.push({type:"recent"});try{a.app.setJumpList(e)}catch(e){this.logService.warn("updateWindowsJumpList#setJumpList",e)}}getSimpleWorkspaceLabel(e,t){if(h.isSingleFolderWorkspaceIdentifier(e))return g.basename(e);if(g.extUriBiasedIgnorePathCase.isEqualOrParent(e.configPath,t))return i.localize(6,null);let r=g.basename(e.configPath);return r.endsWith(h.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-h.WORKSPACE_EXTENSION.length-1)),i.localize(7,null,r)}};function C(e){return h.isRecentFolder(e)?e.folderUri:h.isRecentFile(e)?e.fileUri:e.workspace.configPath}function I(e,t){return e.findIndex(e=>h.isRecentWorkspace(e)&&e.workspace.id===t.id)
}function k(e,t){return e.findIndex(e=>h.isRecentFolder(e)&&g.extUriBiasedIgnorePathCase.isEqual(e.folderUri,t))}function P(e,t){return e.findIndex(e=>g.extUriBiasedIgnorePathCase.isEqual(e.fileUri,t))}E.MAX_TOTAL_RECENT_ENTRIES=100,E.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,E.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,E.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],E.recentlyOpenedStorageKey="openedPathsList",E=s([o(0,n.IStateService),o(1,c.ILogService),o(2,p.IWorkspacesMainService),o(3,w.IEnvironmentMainService),o(4,S.ILifecycleMainService)],E),t.WorkspacesHistoryMainService=E}),define(t[224],i([0,1,138,3,21,11,60,18,29,42,15,9,7,34,32,61,174,8,37,20,44,22]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b,_,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Menubar=void 0;let C=class e{constructor(e,t,i,n,s,o,a,l,d,u){this.updateService=e,this.configurationService=t,this.windowsMainService=i,this.environmentService=n,this.telemetryService=s,this.workspacesHistoryMainService=o,
this.stateService=a,this.lifecycleMainService=l,this.logService=d,this.nativeHostMainService=u,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new p.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new p.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(r.isMacintosh||"native"===c.getTitleBarStyle(this.configurationService))&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const t=this.stateService.getItem(e.lastKnownMenubarStorageKey);t&&(t.menus&&(this.menubarMenus=t.menus),t.keybindings&&(this.keybindings=t.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(e,t,i)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:null==t?void 0:t.id}),
this.fallbackMenuHandlers["workbench.action.newWindow"]=(e,t,i)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:null==t?void 0:t.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(e,t,i)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(i),telemetryExtraData:{from:"menu"}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(e,t,i)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(i),telemetryExtraData:{from:"menu"}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const e=h.default.twitterUrl;e&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(e,"openTwitterUrl"));const t=h.default.requestFeatureUrl;t&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(t,"openUserVoiceUrl"));const i=h.default.reportIssueUrl
;i&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(i,"openReportIssues"));const n=h.default.licenseUrl;n&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(r.language){const e=n.indexOf("?")>0?"&":"?";this.openUrl(`${n}${e}lang=${r.language}`,"openLicenseUrl")}else this.openUrl(n,"openLicenseUrl")});const s=h.default.privacyStatementUrl;s&&n&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(r.language){const e=n.indexOf("?")>0?"&":"?";this.openUrl(`${s}${e}lang=${r.language}`,"openPrivacyStatement")}else this.openUrl(s,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onWindowsCountChanged(e=>this.onWindowsCountChanged(e)),this.nativeHostMainService.onDidBlurWindow(()=>this.onWindowFocusChange()),this.nativeHostMainService.onDidFocusWindow(()=>this.onWindowFocusChange())}get currentEnableMenuBarMnemonics(){
let e=this.configurationService.getValue("window.enableMenuBarMnemonics");return"boolean"!=typeof e&&(e=!0),e}get currentEnableNativeTabs(){if(!r.isMacintosh)return!1;let e=this.configurationService.getValue("window.nativeTabs");return"boolean"!=typeof e&&(e=!1),e}updateMenu(t,i){this.menubarMenus=t.menus,this.keybindings=t.keybindings,this.stateService.setItem(e.lastKnownMenubarStorageKey,t),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onWindowsCountChanged(e){r.isMacintosh&&(0===e.oldCount&&e.newCount>0||e.oldCount>0&&0===e.newCount)&&(this.closedLastWindow=0===e.newCount,this.scheduleUpdateMenu())}onWindowFocusChange(){r.isMacintosh&&(this.noActiveWindow=!a.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const e=a.Menu.getApplicationMenu();if(e&&this.oldMenus.push(e),
0===Object.keys(this.menubarMenus).length)return void a.Menu.setApplicationMenu(r.isMacintosh?new a.Menu:null);const t=new a.Menu;let n;if(r.isMacintosh){const e=new a.Menu;n=new a.MenuItem({label:h.default.nameShort,submenu:e}),this.setMacApplicationMenu(e),t.append(n)}if(r.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const e=new a.Menu;e.append(new a.MenuItem({label:this.mnemonicLabel(i.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),a.app.dock.setMenu(e)}const s=new a.Menu,o=new a.MenuItem({label:this.mnemonicLabel(i.localize(1,null)),submenu:s});this.setMenuById(s,"File"),t.append(o);const c=new a.Menu,l=new a.MenuItem({label:this.mnemonicLabel(i.localize(2,null)),submenu:c});this.setMenuById(c,"Edit"),t.append(l);const d=new a.Menu,u=new a.MenuItem({label:this.mnemonicLabel(i.localize(3,null)),submenu:d});this.setMenuById(d,"Selection"),t.append(u);const p=new a.Menu,f=new a.MenuItem({label:this.mnemonicLabel(i.localize(4,null)),submenu:p})
;this.setMenuById(p,"View"),t.append(f);const g=new a.Menu,m=new a.MenuItem({label:this.mnemonicLabel(i.localize(5,null)),submenu:g});this.setMenuById(g,"Go"),t.append(m);const v=new a.Menu,w=new a.MenuItem({label:this.mnemonicLabel(i.localize(6,null)),submenu:v});this.setMenuById(v,"Run"),t.append(w);const y=new a.Menu,S=new a.MenuItem({label:this.mnemonicLabel(i.localize(7,null)),submenu:y});let b;if(this.setMenuById(y,"Terminal"),t.append(S),this.shouldDrawMenu("Window")){const e=new a.Menu;b=new a.MenuItem({label:this.mnemonicLabel(i.localize(8,null)),submenu:e,role:"window"}),this.setMacWindowMenu(e)}b&&t.append(b);const _=new a.Menu,E=new a.MenuItem({label:this.mnemonicLabel(i.localize(9,null)),submenu:_,role:"help"});this.setMenuById(_,"Help"),t.append(E),t.items&&t.items.length>0?a.Menu.setApplicationMenu(t):a.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(e){
const t=this.createMenuItem(i.localize(10,null,h.default.nameLong),"workbench.action.showAboutDialog"),r=this.getUpdateMenuItems();let n;if(this.shouldDrawMenu("Preferences")){const e=new a.Menu;this.setMenuById(e,"Preferences"),n=new a.MenuItem({label:this.mnemonicLabel(i.localize(11,null)),submenu:e})}const s=new a.Menu,o=new a.MenuItem({label:i.localize(12,null),role:"services",submenu:s}),c=new a.MenuItem({label:i.localize(13,null,h.default.nameLong),role:"hide",accelerator:"Command+H"}),l=new a.MenuItem({label:i.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),d=new a.MenuItem({label:i.localize(15,null),role:"unhide"}),u=new a.MenuItem(this.likeAction("workbench.action.quit",{label:i.localize(16,null,h.default.nameLong),click:()=>{const e=this.windowsMainService.getLastActiveWindow();(0===this.windowsMainService.getWindowCount()||a.BrowserWindow.getFocusedWindow()||(null==e?void 0:e.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),p=[t];p.push(...r),n&&p.push(I(),n),
p.push(I(),o,I(),c,l,d,I(),u),p.forEach(t=>e.append(t))}shouldDrawMenu(e){if(!r.isMacintosh&&"custom"===c.getTitleBarStyle(this.configurationService))return!1;switch(e){case"File":case"Help":if(r.isMacintosh)return 0===this.windowsMainService.getWindowCount()&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[e];case"Window":if(r.isMacintosh)return 0===this.windowsMainService.getWindowCount()&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[e]}}setMenu(e,t){t.forEach(t=>{if(w.isMenubarMenuItemSeparator(t))e.append(I());else if(w.isMenubarMenuItemSubmenu(t)){const i=new a.Menu,r=new a.MenuItem({label:this.mnemonicLabel(t.label),submenu:i});this.setMenu(i,t.submenu.items),e.append(r)
}else w.isMenubarMenuItemUriAction(t)?e.append(this.createOpenRecentMenuItem(t.uri,t.label,t.id)):w.isMenubarMenuItemAction(t)&&("workbench.action.showAboutDialog"===t.id&&this.insertCheckForUpdatesItems(e),r.isMacintosh&&(0===this.windowsMainService.getWindowCount()&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow)?this.fallbackMenuHandlers[t.id]?e.append(new a.MenuItem(this.likeAction(t.id,{label:this.mnemonicLabel(t.label),click:this.fallbackMenuHandlers[t.id]}))):e.append(this.createMenuItem(t.label,t.id,!1,t.checked)):e.append(this.createMenuItem(t.label,t.id,!1!==t.enabled,!!t.checked)))})}setMenuById(e,t){this.menubarMenus&&this.menubarMenus[t]&&this.setMenu(e,this.menubarMenus[t].items)}insertCheckForUpdatesItems(e){const t=this.getUpdateMenuItems();t.length&&(t.forEach(t=>e.append(t)),e.append(I()))}createOpenRecentMenuItem(e,t,i){const r=y.URI.revive(e),n="openRecentFile"===i?{fileUri:r}:"openRecentWorkspace"===i?{workspaceUri:r}:{folderUri:r}
;return new a.MenuItem(this.likeAction(i,{label:t,click:(e,t,i)=>{const s=this.isOptionClick(i);this.windowsMainService.open({context:2,cli:this.environmentService.args,urisToOpen:[n],forceNewWindow:s,gotoLineMode:!1}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([r])}},!1))}isOptionClick(e){return!(!e||!(!r.isMacintosh&&(e.ctrlKey||e.shiftKey)||r.isMacintosh&&(e.metaKey||e.altKey)))}createRoleMenuItem(e,t,i){const r={label:this.mnemonicLabel(e),role:i,enabled:!0};return new a.MenuItem(this.withKeybinding(t,r))}setMacWindowMenu(e){const t=new a.MenuItem({label:i.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),r=new a.MenuItem({label:i.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),n=new a.MenuItem({label:i.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),s=this.createMenuItem(i.localize(20,null),"workbench.action.switchWindow"),o=[]
;this.currentEnableNativeTabs&&(o.push(I()),o.push(this.createMenuItem(i.localize(21,null),"workbench.action.newWindowTab")),o.push(this.createRoleMenuItem(i.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),o.push(this.createRoleMenuItem(i.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),o.push(this.createRoleMenuItem(i.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),o.push(this.createRoleMenuItem(i.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[t,r,I(),s,...o,I(),n].forEach(t=>e.append(t))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new a.MenuItem({label:this.mnemonicLabel(i.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate");const e=this.windowsMainService.getLastActiveWindow(),t=e&&`window:${e.id}`;this.updateService.checkForUpdates(t)},0)})];case"checking for updates":
return[new a.MenuItem({label:i.localize(27,null),enabled:!1})];case"available for download":return[new a.MenuItem({label:this.mnemonicLabel(i.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new a.MenuItem({label:i.localize(29,null),enabled:!1})];case"downloaded":return[new a.MenuItem({label:this.mnemonicLabel(i.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new a.MenuItem({label:i.localize(31,null),enabled:!1})];case"ready":return[new a.MenuItem({label:this.mnemonicLabel(i.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}static _menuItemIsTriggeredViaKeybinding(e,t){if(!t)return!1;let i=/ctrl/.test(t),r=/shift/.test(t),n=/alt/.test(t),s=/cmd/.test(t)||/super/.test(t);return!!(i||r||n||s)&&(i===e.ctrlKey&&r===e.shiftKey&&n===e.altKey&&s===e.metaKey)}createMenuItem(t,i,n,s){
const o=this.mnemonicLabel(t),c="function"==typeof i?i:(t,r,n)=>{const s=t?t.userSettingsLabel:null;let o=i;Array.isArray(i)&&(o=this.isOptionClick(n)?i[1]:i[0]),s&&e._menuItemIsTriggeredViaKeybinding(n,s)?this.runActionInRenderer({type:"keybinding",userSettingsLabel:s}):this.runActionInRenderer({type:"commandId",commandId:o})},l="boolean"==typeof s&&s,d={label:o,click:c,enabled:"boolean"==typeof n?n:this.windowsMainService.getWindowCount()>0};let u;return l&&(d.type="checkbox",d.checked=l),"string"==typeof i?u=i:Array.isArray(i)&&(u=i[0]),r.isMacintosh&&("editor.action.clipboardCutAction"===u?d.role="cut":"editor.action.clipboardCopyAction"===u?d.role="copy":"editor.action.clipboardPasteAction"===u&&(d.role="paste"),"undo"===u?d.click=this.makeContextAwareClickHandler(c,{inDevTools:e=>e.undo(),inNoWindow:()=>a.Menu.sendActionToFirstResponder("undo:")}):"redo"===u?d.click=this.makeContextAwareClickHandler(c,{inDevTools:e=>e.redo(),inNoWindow:()=>a.Menu.sendActionToFirstResponder("redo:")
}):"editor.action.selectAll"===u&&(d.click=this.makeContextAwareClickHandler(c,{inDevTools:e=>e.selectAll(),inNoWindow:()=>a.Menu.sendActionToFirstResponder("selectAll:")}))),new a.MenuItem(this.withKeybinding(u,d))}makeContextAwareClickHandler(e,t){return()=>{const i=a.BrowserWindow.getFocusedWindow();return i?i.webContents.isDevToolsFocused()&&i.webContents.devToolsWebContents?t.inDevTools(i.webContents.devToolsWebContents):void e():t.inNoWindow()}}runActionInRenderer(e){let t=a.BrowserWindow.getFocusedWindow();if(!t){const e=this.windowsMainService.getLastActiveWindow();(null==e?void 0:e.isMinimized())&&(t=e.win)}const i=t?this.windowsMainService.getWindowById(t.id):void 0;if(i){if(this.logService.trace("menubar#runActionInRenderer",e),r.isMacintosh&&!this.environmentService.isBuilt&&!i.isReady&&("commandId"===e.type&&"workbench.action.toggleDevTools"===e.commandId||"commandId"!==e.type&&"alt+cmd+i"===e.userSettingsLabel))return;if("commandId"===e.type){const t={id:e.commandId,from:"menu"}
;i.sendWhenReady("vscode:runAction",E.CancellationToken.None,t)}else{const t={userSettingsLabel:e.userSettingsLabel};i.sendWhenReady("vscode:runKeybinding",E.CancellationToken.None,t)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",e)}withKeybinding(e,t){const i="string"==typeof e?this.keybindings[e]:void 0;if(null==i?void 0:i.label){if(!1!==i.isNative)t.accelerator=i.label,t.userSettingsLabel=i.userSettingsLabel;else if("string"==typeof t.label){const e=t.label.indexOf("[");t.label=e>=0?`${t.label.substr(0,e)} [${i.label}]`:`${t.label} [${i.label}]`}}else t.accelerator=void 0;return t}likeAction(e,t,i=!t.accelerator){i&&(t=this.withKeybinding(e,t));const r=t.click;return t.click=(t,i,n)=>{this.reportMenuActionTelemetry(e),r&&r(t,i,n)},t}openUrl(e,t){this.nativeHostMainService.openExternal(void 0,e),this.reportMenuActionTelemetry(t)}reportMenuActionTelemetry(e){this.telemetryService.publicLog2("workbenchActionExecuted",{id:e,from:"menu"})}mnemonicLabel(e){
return g.mnemonicMenuLabel(e,!this.currentEnableMenuBarMnemonics)}};function I(){return new a.MenuItem({type:"separator"})}C.lastKnownMenubarStorageKey="lastKnownMenubarData",C=s([o(0,u.IUpdateService),o(1,l.IConfigurationService),o(2,m.IWindowsMainService),o(3,n.IEnvironmentMainService),o(4,d.ITelemetryService),o(5,v.IWorkspacesHistoryMainService),o(6,S.IStateService),o(7,b.ILifecycleMainService),o(8,f.ILogService),o(9,_.INativeHostMainService)],C),t.Menubar=C}),define(t[225],i([0,1,224,7,4,20]),function(e,t,i,r,n,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MenubarMainService=t.IMenubarMainService=void 0,t.IMenubarMainService=n.createDecorator("menubarMainService");let c=class{constructor(e,t,i){this.instantiationService=e,this.lifecycleMainService=t,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(i.Menubar)}async updateMenubar(e,t){
this.logService.trace("menubarService#updateMenubar",e),(await this.menubar).updateMenu(t,e)}};c=s([o(0,n.IInstantiationService),o(1,a.ILifecycleMainService),o(2,r.ILogService)],c),t.MenubarMainService=c}),define(t[226],i([0,1,24,6,142,30,49,21,37,93,11,20,18,7,60,92,5,15,61,3,39,4,10,8,17,85,223,51,46,2,50,14,28,34,22]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b,_,E,C,I,k,P,M,D,L,R,T,O,A,x,F){"use strict";function U(e){return!!e.folderUri}function W(e){return!!e.workspace}Object.defineProperty(t,"__esModule",{value:!0}),t.WindowsMainService=void 0;let N=class e extends R.Disposable{constructor(e,t,i,r,n,s,o,a,c,l,d,u){super(),this.machineId=e,this.initialUserEnv=t,this.logService=i,this.stateService=r,this.environmentService=n,this.lifecycleMainService=s,this.backupMainService=o,this.configurationService=a,this.workspacesHistoryMainService=c,this.workspacesMainService=l,this.instantiationService=d,this.dialogMainService=u,this._onWindowOpened=this._register(new w.Emitter),
this.onWindowOpened=this._onWindowOpened.event,this._onWindowReady=this._register(new w.Emitter),this.onWindowReady=this._onWindowReady.event,this._onWindowDestroyed=this._register(new w.Emitter),this.onWindowDestroyed=this._onWindowDestroyed.event,this._onWindowsCountChanged=this._register(new w.Emitter),this.onWindowsCountChanged=this._onWindowsCountChanged.event,this.windowsStateHandler=this._register(new M.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.lifecycleMainService.when(2).then(()=>this.registerListeners())}registerListeners(){this._register(this.workspacesMainService.onWorkspaceEntered(e=>this._onWindowReady.fire(e.window)))}openEmptyWindow(e,t){let i=this.environmentService.args;const r=null==t?void 0:t.remoteAuthority;i&&i.remote!==r&&(i=Object.assign(Object.assign({},i),{remote:r}));const n=null==t?void 0:t.forceReuseWindow,s=!n;return this.open(Object.assign(Object.assign({},e),{cli:i,forceEmpty:!0,forceNewWindow:s,
forceReuseWindow:n}))}open(e){this.logService.trace("windowsManager#open"),e=this.validateOpenConfig(e);const t=[],n=[],s=[],o=[],a=[];let c,l=0;const d=this.getPathsToOpen(e);this.logService.trace("windowsManager#open pathsToOpen",d);for(const i of d)U(i)?e.addMode?t.push(i):n.push(i):W(i)?s.push(i):i.fileUri?(c||(c={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:i.remoteAuthority}),c.filesToOpenOrCreate.push(i)):i.backupPath?a.push({backupFolder:r.basename(i.backupPath),remoteAuthority:i.remoteAuthority}):l++;e.diffMode&&2===(null==c?void 0:c.filesToOpenOrCreate.length)&&(c.filesToDiff=c.filesToOpenOrCreate,c.filesToOpenOrCreate=[]),c&&e.waitMarkerFileURI&&(c.filesToWait={paths:[...c.filesToDiff,...c.filesToOpenOrCreate],waitMarkerFileUri:e.waitMarkerFileURI}),e.initialStartup?(o.push(...this.workspacesMainService.getUntitledWorkspacesSync()),s.push(...o),a.push(...this.backupMainService.getEmptyWindowBackupPaths())):a.length=0;const{windows:u,filesOpenedInWindow:h}=this.doOpen(e,s,n,a,l,c,t)
;if(this.logService.trace(`windowsManager#open used window count ${u.length} (workspacesToOpen: ${s.length}, foldersToOpen: ${n.length}, emptyToRestore: ${a.length}, emptyToOpen: ${l})`),u.length>1)if(h)h.focus();else{let t=!0,i=!0;if(this.windowsStateHandler.state.lastActiveWindow&&!e.forceEmpty&&!e.cli._.length&&!e.cli["file-uri"]&&!e.cli["folder-uri"]&&!(e.urisToOpen&&e.urisToOpen.length)){const e=u.filter(e=>this.windowsStateHandler.state.lastActiveWindow&&e.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);e.length&&(e[0].focus(),t=!1,i=!1)}if(t)for(let e=u.length-1;e>=0;e--){const t=u[e];if(!(t.openedWorkspace&&o.some(e=>t.openedWorkspace&&e.workspace.id===t.openedWorkspace.id)||t.backupPath&&a.some(e=>t.backupPath&&e.backupFolder===r.basename(t.backupPath)))){t.focus(),i=!1;break}}i&&u[u.length-1].focus()}const p=c&&c.filesToDiff.length>0;if(!u.some(e=>e.isExtensionDevelopmentHost)&&!p&&!e.noRecentEntry){const e=[];for(const t of d)t.workspace?e.push({label:t.label,
workspace:t.workspace}):t.folderUri?e.push({label:t.label,folderUri:t.folderUri}):t.fileUri&&e.push({label:t.label,fileUri:t.fileUri});this.workspacesHistoryMainService.addRecentlyOpened(e)}const f=e.waitMarkerFileURI;return 0===e.context&&f&&1===u.length&&u[0]&&u[0].whenClosedOrLoaded.then(()=>i.unlink(f.fsPath,()=>void 0)),u}validateOpenConfig(e){return!e.addMode||!e.initialStartup&&this.getLastActiveWindow()||(e.addMode=!1),e}doOpen(e,t,i,r,n,s,o){const c=[];let l=void 0;function d(e,t){c.push(e),t&&(l=e,s=void 0)}let{openFolderInNewWindow:u,openFilesInNewWindow:h}=this.shouldOpenNewWindow(e);if(!e.initialStartup&&o.length>0){const e=o[0].remoteAuthority,t=this.getLastActiveWindowForAuthority(e);t&&d(this.doAddFoldersToExistingWindow(t,o.map(e=>e.folderUri)))}const p=i.length+t.length+r.length;if(s&&0===p){const r=s.filesToOpenOrCreate[0]||s.filesToDiff[0],n=this.getWindows().filter(e=>s&&e.remoteAuthority===s.remoteAuthority);let o=void 0
;(null==r?void 0:r.fileUri)&&!h&&(4!==e.context&&0!==e.context&&1!==e.context||(o=v.findWindowOnFile(n,r.fileUri,e=>e.configPath.scheme===C.Schemas.file?this.workspacesMainService.resolveLocalWorkspaceSync(e.configPath):null)),o||(o=this.doGetLastActiveWindow(n))),o?o.openedWorkspace?t.push({workspace:o.openedWorkspace,remoteAuthority:o.remoteAuthority}):o.openedFolderUri?i.push({folderUri:o.openedFolderUri,remoteAuthority:o.remoteAuthority}):d(this.doOpenFilesInExistingWindow(e,o,s),!0):d(this.openInBrowserWindow({userEnv:e.userEnv,cli:e.cli,initialStartup:e.initialStartup,filesToOpen:s,forceNewWindow:!0,remoteAuthority:s.remoteAuthority,forceNewTabbedWindow:e.forceNewTabbedWindow}),!0)}const f=a.distinct(t,e=>e.workspace.id);if(f.length>0){const t=a.coalesce(f.map(e=>v.findWindowOnWorkspaceOrFolder(this.getWindows(),e.workspace.configPath)));if(t.length>0){const i=t[0],r=(null==s?void 0:s.remoteAuthority)===i.remoteAuthority?s:void 0;d(this.doOpenFilesInExistingWindow(e,i,r),!!r),u=!0}f.forEach(i=>{
if(t.some(e=>e.openedWorkspace&&e.openedWorkspace.id===i.workspace.id))return;const r=i.remoteAuthority,n=(null==s?void 0:s.remoteAuthority)===r?s:void 0;d(this.doOpenFolderOrWorkspace(e,i,u,n),!!n),u=!0})}const g=a.distinct(i,e=>k.extUriBiasedIgnorePathCase.getComparisonKey(e.folderUri));if(g.length>0){const t=a.coalesce(g.map(e=>v.findWindowOnWorkspaceOrFolder(this.getWindows(),e.folderUri)));if(t.length>0){const i=t[0],r=(null==s?void 0:s.remoteAuthority)===i.remoteAuthority?s:void 0;d(this.doOpenFilesInExistingWindow(e,i,r),!!r),u=!0}g.forEach(i=>{if(t.some(e=>k.extUriBiasedIgnorePathCase.isEqual(e.openedFolderUri,i.folderUri)))return;const r=i.remoteAuthority,n=(null==s?void 0:s.remoteAuthority)===r?s:void 0;d(this.doOpenFolderOrWorkspace(e,i,u,n),!!n),u=!0})}const m=a.distinct(r,e=>e.backupFolder);if(m.length>0&&m.forEach(t=>{const i=t.remoteAuthority,r=(null==s?void 0:s.remoteAuthority)===i?s:void 0;d(this.openInBrowserWindow({userEnv:e.userEnv,cli:e.cli,initialStartup:e.initialStartup,filesToOpen:r,
remoteAuthority:i,forceNewWindow:!0,forceNewTabbedWindow:e.forceNewTabbedWindow,emptyWindowBackupInfo:t}),!!r),u=!0}),0===c.length||s){s&&!n&&n++;const t=s?s.remoteAuthority:e.cli&&e.cli.remote||void 0;for(let i=0;i<n;i++)d(this.doOpenEmpty(e,u,t,s),!!s),u=!0}return{windows:a.distinct(c),filesOpenedInWindow:l}}doOpenFilesInExistingWindow(e,t,i){var r;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),t.focus();const n={filesToOpenOrCreate:null==i?void 0:i.filesToOpenOrCreate,filesToDiff:null==i?void 0:i.filesToDiff,filesToWait:null==i?void 0:i.filesToWait,termProgram:null===(r=null==e?void 0:e.userEnv)||void 0===r?void 0:r.TERM_PROGRAM};return t.sendWhenReady("vscode:openFiles",F.CancellationToken.None,n),t}doAddFoldersToExistingWindow(e,t){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),e.focus();const i={foldersToAdd:t};return e.sendWhenReady("vscode:addFolders",F.CancellationToken.None,i),e}doOpenEmpty(e,t,i,r,n){
return t||n||"number"!=typeof e.contextWindowId||(n=this.getWindowById(e.contextWindowId)),this.openInBrowserWindow({userEnv:e.userEnv,cli:e.cli,initialStartup:e.initialStartup,remoteAuthority:i,forceNewWindow:t,forceNewTabbedWindow:e.forceNewTabbedWindow,filesToOpen:r,windowToUse:n})}doOpenFolderOrWorkspace(e,t,i,r,n){return i||n||"number"!=typeof e.contextWindowId||(n=this.getWindowById(e.contextWindowId)),this.openInBrowserWindow({workspace:t.workspace,folderUri:t.folderUri,userEnv:e.userEnv,cli:e.cli,initialStartup:e.initialStartup,remoteAuthority:t.remoteAuthority,forceNewWindow:i,forceNewTabbedWindow:e.forceNewTabbedWindow,filesToOpen:r,windowToUse:n})}getPathsToOpen(e){var t;let i,r=!1,n=!1;if(e.urisToOpen&&e.urisToOpen.length>0?(i=this.doExtractPathsFromAPI(e),r=!0):e.forceEmpty?i=[Object.create(null)]:e.cli._.length||e.cli["folder-uri"]||e.cli["file-uri"]?(0===(i=this.doExtractPathsFromCLI(e.cli)).length&&i.push(Object.create(null)),
r=!0):(0===(i=this.doGetWindowsFromLastSession()).length&&i.push(Object.create(null)),n=!0),!e.addMode&&r){const e=i.filter(e=>!!e.folderUri);if(e.length>1){const t=e[0].remoteAuthority;if(e.every(e=>e.remoteAuthority===t)){const r=this.workspacesMainService.createUntitledWorkspaceSync(e.map(e=>({uri:e.folderUri})));i.push({workspace:r,remoteAuthority:t}),i=i.filter(e=>!e.folderUri)}}}return e.initialStartup&&!n&&"preserve"===(null===(t=this.configurationService.getValue("window"))||void 0===t?void 0:t.restoreWindows)&&i.unshift(...this.doGetWindowsFromLastSession().filter(e=>e.workspace||e.folderUri||e.backupPath)),i}doExtractPathsFromAPI(e){const t=[],i={gotoLineMode:e.gotoLineMode};for(const r of e.urisToOpen||[]){if(!r)continue;const e=this.parseUri(r,i);if(e)e.label=r.label,t.push(e);else{const e=this.resourceFromURIToOpen(r);let t,i;e.scheme===C.Schemas.file?(t=n.localize(0,null),i=n.localize(1,null,x.getPathLabel(e.fsPath,this.environmentService))):(t=n.localize(2,null),
i=n.localize(3,null,e.toString()));const s={title:y.default.nameLong,type:"info",buttons:[n.localize(4,null)],message:t,detail:i,noLink:!0};this.dialogMainService.showMessageBox(s,O.withNullAsUndefined(h.BrowserWindow.getFocusedWindow()))}}return t}doExtractPathsFromCLI(e){const t=[],i={ignoreFileNotFound:!0,gotoLineMode:e.goto,remoteAuthority:e.remote||void 0},r=e["folder-uri"];if(r)for(const e of r){const r=this.argToUri(e);if(r){const e=this.parseUri({folderUri:r},i);e&&t.push(e)}}const n=e["file-uri"];if(n)for(const e of n){const r=this.argToUri(e);if(r){const n=this.parseUri(_.hasWorkspaceFileExtension(e)?{workspaceUri:r}:{fileUri:r},i);n&&t.push(n)}}const s=e._;for(const e of s){const r=this.parsePath(e,i);r&&t.push(r)}return t.length?t:[]}doGetWindowsFromLastSession(){const e=this.getRestoreWindowsSetting();switch(e){case"none":return[];case"one":case"all":case"preserve":case"folders":const t=[];"one"!==e&&t.push(...this.windowsStateHandler.state.openedWindows),
this.windowsStateHandler.state.lastActiveWindow&&t.push(this.windowsStateHandler.state.lastActiveWindow);const i=[];for(const r of t)if(r.workspace){const e=this.parseUri({workspaceUri:r.workspace.configPath},{remoteAuthority:r.remoteAuthority});(null==e?void 0:e.workspace)&&i.push(e)}else if(r.folderUri){const e=this.parseUri({folderUri:r.folderUri},{remoteAuthority:r.remoteAuthority});(null==e?void 0:e.folderUri)&&i.push(e)}else"folders"!==e&&r.backupPath&&i.push({backupPath:r.backupPath,remoteAuthority:r.remoteAuthority});return i}}getRestoreWindowsSetting(){let e;if(this.lifecycleMainService.wasRestarted)e="all";else{const t=this.configurationService.getValue("window");e=(null==t?void 0:t.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(e)||(e="all")}return e}argToUri(e){try{const t=I.URI.parse(e);return t.scheme?t:void this.logService.error(`Invalid URI input string, scheme missing: ${e}`)}catch(t){this.logService.error(`Invalid URI input string: ${e}, ${t.message}`)}}
parseUri(e,t={}){if(!e)return;let i=this.resourceFromURIToOpen(e);if(i.scheme===C.Schemas.file)return this.parsePath(i.fsPath,t,m.isFileToOpen(e));const r=t.remoteAuthority||P.getRemoteAuthority(i);if(i=k.normalizePath(i),i=k.removeTrailingPathSeparator(i),m.isFileToOpen(e)){if(t.gotoLineMode){const e=A.parseLineAndColumnAware(i.path);return{fileUri:i.with({path:e.path}),lineNumber:e.line,columnNumber:e.column,remoteAuthority:r}}return{fileUri:i,remoteAuthority:r}}return m.isWorkspaceToOpen(e)?{workspace:D.getWorkspaceIdentifier(i),remoteAuthority:r}:{folderUri:i,remoteAuthority:r}}resourceFromURIToOpen(e){return m.isWorkspaceToOpen(e)?e.workspaceUri:m.isFolderToOpen(e)?e.folderUri:e.fileUri}parsePath(e,t,n){if(!e)return;let s,o;if(t.gotoLineMode){const t=A.parseLineAndColumnAware(e);s=t.line,o=t.column,e=t.path}const a=t.remoteAuthority;if(a){const t=e.charCodeAt(0);47!==t&&(A.isWindowsDriveLetter(t)&&58===e.charCodeAt(e.charCodeAt(1))&&(e=A.toSlashes(e)),e=`/${e}`);const i=I.URI.from({
scheme:C.Schemas.vscodeRemote,authority:a,path:e});if(47!==e.charCodeAt(e.length-1))if(_.hasWorkspaceFileExtension(e)){if(n)return{fileUri:i,remoteAuthority:a}}else if(-1!==r.posix.basename(e).indexOf("."))return{fileUri:i,remoteAuthority:a};return{folderUri:i,remoteAuthority:a}}let c=r.normalize(e);try{const e=i.statSync(c);if(e.isFile()){if(!n){const e=this.workspacesMainService.resolveLocalWorkspaceSync(I.URI.file(c));if(e)return{workspace:{id:e.id,configPath:e.configPath},remoteAuthority:e.remoteAuthority,exists:!0}}return{fileUri:I.URI.file(c),lineNumber:s,columnNumber:o,remoteAuthority:a,exists:!0}}if(e.isDirectory())return{folderUri:I.URI.file(c),remoteAuthority:a,exists:!0}}catch(e){const i=I.URI.file(c);if(this.workspacesHistoryMainService.removeRecentlyOpened([i]),null==t?void 0:t.ignoreFileNotFound)return{fileUri:i,remoteAuthority:a,exists:!1}}}shouldOpenNewWindow(e){
const t=this.configurationService.getValue("window"),i=(null==t?void 0:t.openFoldersInNewWindow)||"default",r=(null==t?void 0:t.openFilesInNewWindow)||"off";let n=(e.preferNewWindow||e.forceNewWindow)&&!e.forceReuseWindow;e.forceNewWindow||e.forceReuseWindow||"on"!==i&&"off"!==i||(n="on"===i);let s=!1;return e.forceNewWindow||e.forceReuseWindow?s=!!e.forceNewWindow&&!e.forceReuseWindow:(b.isMacintosh?1===e.context&&(s=!0):3===e.context||2===e.context||e.userEnv&&"vscode"===e.userEnv.TERM_PROGRAM||(s=!0),e.cli.extensionDevelopmentPath||"on"!==r&&"off"!==r||(s="on"===r)),{openFolderInNewWindow:!!n,openFilesInNewWindow:s}}openExtensionDevelopmentHostWindow(e,t){const i=v.findWindowOnExtensionDevelopmentPath(this.getWindows(),e);if(i)return this.lifecycleMainService.reload(i,t.cli),i.focus(),[i];let r=t.cli["folder-uri"]||[],n=t.cli["file-uri"]||[],s=t.cli._;if(!(s.length||r.length||n.length||t.cli.extensionTestsPath)){
const e=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,t=e&&(e.workspace||e.folderUri);t&&(_.isSingleFolderWorkspaceIdentifier(t)?t.scheme===C.Schemas.file?s=[t.fsPath]:r=[t.toString()]:t.configPath.scheme===C.Schemas.file?s=[k.originalFSPath(t.configPath)]:n=[t.configPath.toString()])}let o="";for(const t of e)if(t.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const e=I.URI.parse(t);e.scheme===C.Schemas.vscodeRemote&&(o?e.authority!==o&&this.logService.error("more than one extension development path authority"):o=e.authority)}s=s.filter(e=>{const t=I.URI.file(e);return!v.findWindowOnWorkspaceOrFolder(this.getWindows(),t)&&t.authority===o}),r=r.filter(e=>{const t=this.argToUri(e);return(!t||!v.findWindowOnWorkspaceOrFolder(this.getWindows(),t))&&(!!t&&t.authority===o)}),n=n.filter(e=>{const t=this.argToUri(e);return(!t||!v.findWindowOnWorkspaceOrFolder(this.getWindows(),t))&&(!!t&&t.authority===o)}),t.cli._=s,t.cli["folder-uri"]=r,t.cli["file-uri"]=n;const a=!s.length&&!r.length&&!n.length
;a&&o&&(t.cli.remote=o);const c={context:t.context,cli:t.cli,forceNewWindow:!0,forceEmpty:a,userEnv:t.userEnv,noRecentEntry:!0,waitMarkerFileURI:t.waitMarkerFileURI};return this.open(c)}openInBrowserWindow(t){const i=Object.assign({},t.cli);i.appRoot=this.environmentService.appRoot,i.machineId=this.machineId,i.nodeCachedDataDir=this.environmentService.nodeCachedDataDir,i.mainPid=process.pid,i.execPath=process.execPath,i.userEnv=Object.assign(Object.assign({},this.initialUserEnv),t.userEnv),i.isInitialStartup=t.initialStartup,i.workspace=t.workspace,i.folderUri=t.folderUri,i.remoteAuthority=t.remoteAuthority;const n=t.filesToOpen;let s;if(n&&(i.filesToOpenOrCreate=n.filesToOpenOrCreate,i.filesToDiff=n.filesToDiff,i.filesToWait=n.filesToWait),t.emptyWindowBackupInfo&&(i.backupPath=r.join(this.environmentService.backupHome,t.emptyWindowBackupInfo.backupFolder)),t.forceNewWindow||t.forceNewTabbedWindow||(s=t.windowToUse||this.getLastActiveWindow())&&s.focus(),s){const e=s.config
;!i.extensionDevelopmentPath&&e&&e.extensionDevelopmentPath&&(i.extensionDevelopmentPath=e.extensionDevelopmentPath,i.verbose=e.verbose,i["inspect-brk-extensions"]=e["inspect-brk-extensions"],i.debugId=e.debugId,i["inspect-extensions"]=e["inspect-extensions"],i["extensions-dir"]=e["extensions-dir"])}else{const r=this.windowsStateHandler.getNewWindowState(i),n=s=this.instantiationService.createInstance(u.CodeWindow,{state:r,extensionDevelopmentPath:i.extensionDevelopmentPath,isExtensionTestHost:!!i.extensionTestsPath});if(t.forceNewTabbedWindow){const e=this.getLastActiveWindow();e&&e.addTabbedWindow(n)}e.WINDOWS.push(n),this._onWindowOpened.fire(n),this._onWindowsCountChanged.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),L.once(n.onReady)(()=>this._onWindowReady.fire(n)),L.once(n.onClose)(()=>this.onWindowClosed(n)),L.once(n.onDestroy)(()=>this._onWindowDestroyed.fire(n)),n.win.webContents.removeAllListeners("devtools-reload-page"),
n.win.webContents.on("devtools-reload-page",()=>this.lifecycleMainService.reload(n)),this.lifecycleMainService.registerWindow(n)}return s.isReady?this.lifecycleMainService.unload(s,4).then(e=>{e||this.doOpenInBrowserWindow(s,i,t)}):this.doOpenInBrowserWindow(s,i,t),s}doOpenInBrowserWindow(e,t,i){if(!t.extensionDevelopmentPath)if(t.workspace)t.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:t.workspace,remoteAuthority:t.remoteAuthority});else if(t.folderUri)t.backupPath=this.backupMainService.registerFolderBackupSync(t.folderUri);else{const e=i.emptyWindowBackupInfo&&i.emptyWindowBackupInfo.backupFolder;t.backupPath=this.backupMainService.registerEmptyWindowBackupSync(e,t.remoteAuthority)}e.load(t)}onWindowClosed(t){const i=e.WINDOWS.indexOf(t);e.WINDOWS.splice(i,1),this._onWindowsCountChanged.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const e=h.BrowserWindow.getFocusedWindow();if(e)return this.getWindowById(e.id)}getLastActiveWindow(){
return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(e){return this.doGetLastActiveWindow(this.getWindows().filter(t=>t.remoteAuthority===e))}doGetLastActiveWindow(e){const t=Math.max.apply(Math,e.map(e=>e.lastFocusTime));return e.find(e=>e.lastFocusTime===t)}sendToFocused(e,...t){const i=this.getFocusedWindow()||this.getLastActiveWindow();i&&i.sendWhenReady(e,F.CancellationToken.None,...t)}sendToAll(e,t,i){for(const r of this.getWindows())i&&i.indexOf(r.id)>=0||r.sendWhenReady(e,F.CancellationToken.None,t)}getWindows(){return e.WINDOWS}getWindowCount(){return e.WINDOWS.length}getWindowById(e){const t=this.getWindows().filter(t=>t.id===e);return a.firstOrDefault(t)}getWindowByWebContents(e){const t=h.BrowserWindow.fromWebContents(e);if(t)return this.getWindowById(t.id)}};N.WINDOWS=[],
N=s([o(2,g.ILogService),o(3,d.IStateService),o(4,l.IEnvironmentMainService),o(5,p.ILifecycleMainService),o(6,c.IBackupMainService),o(7,f.IConfigurationService),o(8,S.IWorkspacesHistoryMainService),o(9,D.IWorkspacesMainService),o(10,E.IInstantiationService),o(11,T.IDialogMainService)],N),t.WindowsMainService=N}),define(t[227],i([0,1,51,32,61,49]),function(e,t,i,r,n,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WorkspacesService=void 0;let c=class{constructor(e,t,i,r){this.workspacesMainService=e,this.windowsMainService=t,this.workspacesHistoryMainService=i,this.backupMainService=r,this.onRecentlyOpenedChange=this.workspacesHistoryMainService.onRecentlyOpenedChange}async enterWorkspace(e,t){const i=this.windowsMainService.getWindowById(e);return i?this.workspacesMainService.enterWorkspace(i,this.windowsMainService.getWindows(),t):null}createUntitledWorkspace(e,t,i){return this.workspacesMainService.createUntitledWorkspace(t,i)}deleteUntitledWorkspace(e,t){
return this.workspacesMainService.deleteUntitledWorkspace(t)}getWorkspaceIdentifier(e,t){return this.workspacesMainService.getWorkspaceIdentifier(t)}async getRecentlyOpened(e){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(e))}async addRecentlyOpened(e,t){return this.workspacesHistoryMainService.addRecentlyOpened(t)}async removeRecentlyOpened(e,t){return this.workspacesHistoryMainService.removeRecentlyOpened(t)}async clearRecentlyOpened(e){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};c=s([o(0,i.IWorkspacesMainService),o(1,r.IWindowsMainService),o(2,n.IWorkspacesHistoryMainService),o(3,a.IBackupMainService)],c),t.WorkspacesService=c}),
define(t[228],i([0,1,11,3,226,20,159,42,195,115,43,210,94,4,69,68,7,37,21,18,90,196,29,189,191,188,190,35,15,212,167,2,32,8,39,227,66,221,219,218,222,172,19,198,213,225,9,113,6,17,125,10,220,88,187,211,49,61,197,51,24,89,80,146,44,162,50,14,34,204,200,26,40,31,23,82,205,165,154,53,28,22,156,175,46]),function(e,t,i,r,n,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b,_,E,C,I,k,P,M,D,L,R,T,O,A,x,F,U,W,N,B,j,z,$,K,H,q,V,G,Y,X,Q,J,Z,ee,te,ie,re,ne,se,oe,ae,ce,le,de,ue,he,pe,fe,ge,me,ve,we,ye,Se,be,_e,Ee,Ce,Ie,ke,Pe,Me,De,Le,Re,Te){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CodeApplication=void 0;let Oe=class extends O.Disposable{constructor(e,t,i,r,n,s,o,a,c){super(),this.mainIpcServer=e,this.userEnv=t,this.instantiationService=i,this.logService=r,this.environmentService=n,this.lifecycleMainService=s,this.configurationService=o,this.stateService=a,this.fileService=c,this.registerListeners()}registerListeners(){K.setUnexpectedErrorHandler(e=>this.onUnexpectedError(e)),
process.on("uncaughtException",e=>this.onUnexpectedError(e)),process.on("unhandledRejection",e=>K.onUnexpectedError(e)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),Y.registerContextMenuListener(),i.app.on("accessibility-support-changed",(e,t)=>{var i;null===(i=this.windowsMainService)||void 0===i||i.sendToAll("vscode:accessibilitySupportChanged",t)}),i.app.on("activate",(e,t)=>{var i;this.logService.trace("app#activate"),t||null===(i=this.windowsMainService)||void 0===i||i.openEmptyWindow({context:1})}),i.app.on("remote-require",(e,t,i)=>{this.logService.trace("app#on(remote-require): prevented"),e.preventDefault()}),i.app.on("remote-get-global",(e,t,i)=>{this.logService.trace(`App#on(remote-get-global): prevented on ${i}`),e.preventDefault()}),i.app.on("remote-get-builtin",(e,t,i)=>{this.logService.trace(`App#on(remote-get-builtin): prevented on ${i}`),"clipboard"!==i&&e.preventDefault()}),i.app.on("remote-get-current-window",e=>{
this.logService.trace("App#on(remote-get-current-window): prevented"),e.preventDefault()}),i.app.on("remote-get-current-web-contents",e=>{this.environmentService.args.driver||(this.logService.trace("App#on(remote-get-current-web-contents): prevented"),e.preventDefault())}),i.app.on("web-contents-created",(e,t)=>{t.on("will-attach-webview",(e,t,i)=>{const r=e=>{if(!e)return!1;const t=x.URI.parse(e);if(t.scheme===Z.Schemas.vscodeWebview)return"/index.html"===t.path||"/electron-browser/index.html"===t.path;const i=t.fsPath.toLowerCase(),r=x.URI.file(this.environmentService.appRoot).fsPath.toLowerCase();return i.startsWith(r+X.sep)};delete t.preload,t.nodeIntegration=!1,r(i.src)&&r(t.preloadURL)||(delete t.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),e.preventDefault())}),t.on("will-navigate",e=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),e.preventDefault()}),t.on("new-window",(e,t)=>{var i;e.preventDefault(),
null===(i=this.nativeHostMainService)||void 0===i||i.openExternal(void 0,t)}),i.session.defaultSession.setPermissionRequestHandler((e,t,i)=>i(!1)),i.session.defaultSession.setPermissionCheckHandler((e,t)=>!1)});let e=[],t=null;i.app.on("open-file",(i,r)=>{this.logService.trace("app#open-file: ",r),i.preventDefault(),e.push(this.getWindowOpenableFromPathSync(r)),null!==t&&(clearTimeout(t),t=null),t=setTimeout(()=>{var i;null===(i=this.windowsMainService)||void 0===i||i.open({context:1,cli:this.environmentService.args,urisToOpen:e,gotoLineMode:!1,preferNewWindow:!0}),e=[],t=null},100)}),i.app.on("new-window-for-tab",()=>{var e;null===(e=this.windowsMainService)||void 0===e||e.openEmptyWindow({context:4})}),i.ipcMain.on("vscode:fetchShellEnv",async e=>{var t;const i=e.sender,r=null===(t=this.windowsMainService)||void 0===t?void 0:t.getWindowByWebContents(e.sender);let n=!1;function s(e){clearTimeout(a),clearTimeout(l),n||(n=!0,i.isDestroyed()||i.send("vscode:acceptShellEnv",e))}
const o=new De.CancellationTokenSource,a=setTimeout(()=>null==r?void 0:r.sendWhenReady("vscode:showShellEnvSlowWarning",o.token),3e3),l=setTimeout(()=>{o.dispose(!0),null==r||r.sendWhenReady("vscode:showShellEnvTimeoutError",De.CancellationToken.None),s({})},1e4);let d,u;(null==r?void 0:r.config)?(d=r.config,u=Object.assign(Object.assign({},process.env),r.config.userEnv)):(d=this.environmentService.args,u=process.env),s(await c.resolveShellEnv(this.logService,d,u))}),i.ipcMain.handle("vscode:writeNlsFile",async(e,t,i)=>{const r=this.validateNlsPath([t]);if(!r||"string"!=typeof i)throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(r,_e.VSBuffer.fromString(i))}),i.ipcMain.handle("vscode:readNlsFile",async(e,...t)=>{const i=this.validateNlsPath(t);if(!i)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(i)).value.toString()}),i.ipcMain.on("vscode:toggleDevTools",e=>e.sender.toggleDevTools()),
i.ipcMain.on("vscode:openDevTools",e=>e.sender.openDevTools()),i.ipcMain.on("vscode:reloadWindow",e=>e.sender.reload())}validateNlsPath(e){let t=void 0;for(const i of e)"string"==typeof i&&(t="string"!=typeof t?i:X.join(t,i));if("string"==typeof t&&X.isAbsolute(t)&&Me.isEqualOrParent(t,this.environmentService.cachedLanguagesPath,!r.isLinux))return x.URI.file(t)}onUnexpectedError(e){var t;if(e){const i={message:e.message,stack:e.stack};null===(t=this.windowsMainService)||void 0===t||t.sendToFocused("vscode:reportError",JSON.stringify(i))}this.logService.error(`[uncaught exception in main]: ${e}`),e.stack&&this.logService.error(e.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentService.appRoot}`),this.logService.debug("args:",this.environmentService.args);const e=L.default.win32AppUserModelId;r.isWindows&&e&&i.app.setAppUserModelId(e);try{
r.isMacintosh&&!0===this.configurationService.getValue("window.nativeTabs")&&!i.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&i.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(e){this.logService.error(e)}const t=this._register(this.instantiationService.createInstance(T.FileProtocolHandler)),n=new u.Server;this.logService.trace("Resolving machine identifier...");const s=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${s}`);const o=this.instantiationService.createInstance(p.SharedProcess,s,this.userEnv),a=o.whenIpcReady().then(()=>(this.logService.trace("Shared process: IPC ready"),h.connect(this.environmentService.sharedIPCHandle,"main"))),l=o.whenReady().then(()=>(this.logService.trace("Shared process: init ready"),a));this.lifecycleMainService.when(3).then(()=>{this._register(new G.RunOnceScheduler(async()=>{o.spawn(await c.resolveShellEnv(this.logService,this.environmentService.args,process.env))},3e3)).schedule()})
;const d=await this.createServices(s,o,l);if(this.environmentService.driverHandle){const e=await q.serve(n,this.environmentService.driverHandle,this.environmentService,d);this.logService.info("Driver started at:",this.environmentService.driverHandle),this._register(e)}this._register(d.createInstance(R.ProxyAuthHandler));const f=d.invokeFunction(e=>this.openFirstWindow(e,n,a,t));d.invokeFunction(e=>this.afterWindowOpen(e)),this.environmentService.args.trace&&this.stopTracingEventually(f)}async resolveMachineId(){let e=this.stateService.getItem(C.machineIdKey);return(!e||r.isMacintosh&&"6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead"===e)&&(e=await W.getMachineId(),this.stateService.setItem(C.machineIdKey,e)),e}async createServices(e,t,i){const s=new m.ServiceCollection;switch(process.platform){case"win32":s.set(l.IUpdateService,new v.SyncDescriptor(N.Win32UpdateService));break;case"linux":
r.isLinuxSnap?s.set(l.IUpdateService,new v.SyncDescriptor(ee.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):s.set(l.IUpdateService,new v.SyncDescriptor(B.LinuxUpdateService));break;case"darwin":s.set(l.IUpdateService,new v.SyncDescriptor(j.DarwinUpdateService))}s.set(A.IWindowsMainService,new v.SyncDescriptor(n.WindowsMainService,[e,this.userEnv])),s.set(fe.IDialogMainService,new v.SyncDescriptor(fe.DialogMainService)),s.set(pe.ISharedProcessMainService,new v.SyncDescriptor(pe.SharedProcessMainService,[t])),s.set(f.ILaunchMainService,new v.SyncDescriptor(f.LaunchMainService)),s.set(le.IDiagnosticsService,D.createChannelSender(D.getDelayedChannel(i.then(e=>e.getChannel("diagnostics"))))),s.set(z.IIssueMainService,new v.SyncDescriptor(z.IssueMainService,[e,this.userEnv])),s.set(Ee.IEncryptionMainService,new v.SyncDescriptor(Ee.EncryptionMainService,[e])),s.set(Ie.IKeyboardLayoutMainService,new v.SyncDescriptor(Ie.KeyboardLayoutMainService)),
s.set(ke.IDisplayMainService,new v.SyncDescriptor(ke.DisplayMainService)),s.set(he.INativeHostMainService,new v.SyncDescriptor(he.NativeHostMainService)),s.set(we.IWebviewManagerService,new v.SyncDescriptor(ve.WebviewMainService)),s.set(F.IWorkspacesService,new v.SyncDescriptor(U.WorkspacesService)),s.set(V.IMenubarMainService,new v.SyncDescriptor(V.MenubarMainService)),s.set(Le.IExtensionUrlTrustService,new v.SyncDescriptor(Re.ExtensionUrlTrustService));const o=new te.StorageMainService(this.logService,this.environmentService);s.set(te.IStorageMainService,o),this.lifecycleMainService.onWillShutdown(e=>e.join(o.close()));const a=new re.BackupMainService(this.environmentService,this.configurationService,this.logService);if(s.set(ne.IBackupMainService,a),s.set(se.IWorkspacesHistoryMainService,new v.SyncDescriptor(se.WorkspacesHistoryMainService)),s.set(_.IURLService,new v.SyncDescriptor(oe.NativeURLService)),s.set(ae.IWorkspacesMainService,new v.SyncDescriptor(ae.WorkspacesMainService)),
this.environmentService.isExtensionDevelopment||this.environmentService.args["disable-telemetry"]||!L.default.enableTelemetry)s.set(C.ITelemetryService,I.NullTelemetryService);else{const t=D.getDelayedChannel(i.then(e=>e.getChannel("telemetryAppender"))),r={appender:new k.TelemetryAppenderClient(t),commonProperties:M.resolveCommonProperties(L.default.commit,L.default.version,e,L.default.msftInternalDomains,this.environmentService.installSourcePath),piiPaths:[this.environmentService.appRoot,this.environmentService.extensionsPath],sendErrorTelemetry:!0};s.set(C.ITelemetryService,new v.SyncDescriptor(P.TelemetryService,[r]))}return await a.initialize(),this.instantiationService.createChild(s)}stopTracingEventually(e){this.logService.info("Tracing: waiting for windows to get ready...");let t=!1;const r=async e=>{var r;if(t)return;t=!0;const n=await i.contentTracing.stopRecording(Q.joinPath(this.environmentService.userHome,`${L.default.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath)
;e?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${n}`):null===(r=this.dialogMainService)||void 0===r||r.showMessageBox({type:"info",message:J.localize(0,null),detail:J.localize(1,null,n),buttons:[J.localize(2,null)]},ge.withNullAsUndefined(i.BrowserWindow.getFocusedWindow()))},n=setTimeout(()=>r(!0),3e4);Promise.all(e.map(e=>e.ready())).then(()=>{clearTimeout(n),r(!1)})}openFirstWindow(e,t,i,n){const s=e.get(f.ILaunchMainService),o=D.createChannelReceiver(s,{disableMarshalling:!0});this.mainIpcServer.registerChannel("launch",o);const a=e.get(l.IUpdateService),c=new d.UpdateChannel(a);t.registerChannel("update",c);const u=e.get(z.IIssueMainService),h=D.createChannelReceiver(u);t.registerChannel("issue",h);const p=e.get(Ee.IEncryptionMainService),g=D.createChannelReceiver(p);t.registerChannel("encryption",g);const m=e.get(Ie.IKeyboardLayoutMainService),v=D.createChannelReceiver(m);t.registerChannel("keyboardLayout",v);const y=e.get(ke.IDisplayMainService),S=D.createChannelReceiver(y)
;t.registerChannel("display",S);const b=this.nativeHostMainService=e.get(he.INativeHostMainService),C=D.createChannelReceiver(this.nativeHostMainService);t.registerChannel("nativeHost",C),i.then(e=>e.registerChannel("nativeHost",C));const I=e.get(pe.ISharedProcessMainService),k=D.createChannelReceiver(I);t.registerChannel("sharedProcess",k);const P=e.get(F.IWorkspacesService),M=D.createChannelReceiver(P);t.registerChannel("workspaces",M);const L=e.get(V.IMenubarMainService),R=D.createChannelReceiver(L);t.registerChannel("menubar",R);const T=e.get(_.IURLService),O=D.createChannelReceiver(T);t.registerChannel("url",O);const U=e.get(Le.IExtensionUrlTrustService),W=D.createChannelReceiver(U);t.registerChannel("extensionUrlTrust",W);const N=e.get(we.IWebviewManagerService),B=D.createChannelReceiver(N);t.registerChannel("webview",B);const j=e.get(te.IStorageMainService),K=this._register(new ie.GlobalStorageDatabaseChannel(this.logService,j));t.registerChannel("storage",K),i.then(e=>e.registerChannel("storage",K))
;const q=new $.LoggerChannel(e.get(w.ILogService));t.registerChannel("logger",q),i.then(e=>e.registerChannel("logger",q));const G=this.windowsMainService=e.get(A.IWindowsMainService);n.injectWindowsMainService(G),t.registerChannel(de.ExtensionHostDebugBroadcastChannel.ChannelName,new ue.ElectronExtensionHostDebugBroadcastChannel(G)),this.lifecycleMainService.phase=2,this.dialogMainService=e.get(fe.IDialogMainService);const Y=[],X=[...this.environmentService.args["open-url"]&&this.environmentService.args._urls||[],...global.getOpenUrls()||[]].map(e=>{try{return{uri:x.URI.parse(e),url:e}}catch(e){return null}}).filter(e=>{if(!e)return!1;if(this.shouldBlockURI(e.uri))return!1;const t=this.getWindowOpenableFromProtocolLink(e.uri);return!t||(Y.push(t),!1)}),Q=this,J=this.environmentService;T.registerHandler({async handleURL(e,t){if(Q.shouldBlockURI(e))return!0;const i=Q.getWindowOpenableFromProtocolLink(e);if(i)return G.open({context:5,cli:Object.assign({},J.args),urisToOpen:[i],gotoLineMode:!0}),!0
;if(r.isMacintosh&&0===G.getWindowCount()){const[i]=G.open({context:5,cli:Object.assign({},J.args),forceEmpty:!0,gotoLineMode:!0});return await i.ready(),T.open(e,t)}return!1}});const Z=this._register(new Ce.ActiveWindowManager({onDidOpenWindow:b.onDidOpenWindow,onDidFocusWindow:b.onDidFocusWindow,getActiveWindowId:()=>b.getActiveWindowId(-1)})),ee=new D.StaticRouter(e=>Z.getActiveClientId().then(t=>e===t)),re=new E.URLHandlerRouter(ee),ne=t.getChannel("urlHandler",re);T.registerHandler(new E.URLHandlerChannelClient(ne)),this._register(new H.ElectronURLListener(X,T,G,this.environmentService));const se=this.environmentService.args,oe=global.macOpenFiles,ae=Pe.isLaunchedFromCli(process.env)?0:4,ce=se._.length,le=!!se["folder-uri"],ge=!!se["file-uri"],me=!0===se["skip-add-to-recently-opened"],ve=se.wait&&se.waitMarkerFilePath?x.URI.file(se.waitMarkerFilePath):void 0;return Y.length>0?G.open({context:ae,cli:se,urisToOpen:Y,gotoLineMode:!0,initialStartup:!0
}):!se["new-window"]||ce||le||ge?!oe.length||ce||le||ge?G.open({context:ae,cli:se,forceNewWindow:se["new-window"]||!ce&&se["unity-launch"],diffMode:se.diff,noRecentEntry:me,waitMarkerFileURI:ve,gotoLineMode:se.goto,initialStartup:!0}):G.open({context:1,cli:se,urisToOpen:oe.map(e=>this.getWindowOpenableFromPathSync(e)),noRecentEntry:me,waitMarkerFileURI:ve,initialStartup:!0}):G.open({context:ae,cli:se,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:me,waitMarkerFileURI:ve,initialStartup:!0})}shouldBlockURI(e){if(e.authority===Z.Schemas.file&&r.isWindows){if(1===i.dialog.showMessageBoxSync({title:L.default.nameLong,type:"question",buttons:[me.mnemonicButtonLabel(J.localize(3,null)),me.mnemonicButtonLabel(J.localize(4,null))],cancelId:1,message:J.localize(5,null,me.getPathLabel(e.fsPath),L.default.nameShort),detail:J.localize(6,null),noLink:!0}))return!0}return!1}getWindowOpenableFromProtocolLink(e){if(e.path){if(e.authority===Z.Schemas.file)return{fileUri:x.URI.file(e.fsPath)}
;if(e.authority===Z.Schemas.vscodeRemote){const t=e.path.indexOf(X.posix.sep,1);if(-1!==t){const i=e.path.substring(1,t),r=e.path.substring(t),n=x.URI.from({scheme:Z.Schemas.vscodeRemote,authority:i,path:r,query:e.query,fragment:e.fragment});return F.hasWorkspaceFileExtension(r)?{workspaceUri:n}:{folderUri:n}}}}}getWindowOpenableFromPathSync(e){try{if(ce.statSync(e).isDirectory())return{folderUri:x.URI.file(e)};if(F.hasWorkspaceFileExtension(e))return{workspaceUri:x.URI.file(e)}}catch(e){}return{fileUri:x.URI.file(e)}}async afterWindowOpen(t){var n;this.lifecycleMainService.phase=3;const s=L.default.win32MutexName;if(r.isWindows&&s)try{const t=new(0,e.__$__nodeRequire("windows-mutex").Mutex)(s);Te.once(this.lifecycleMainService.onWillShutdown)(()=>t.release())}catch(e){this.logService.error(e)}i.protocol.registerHttpProtocol(Z.Schemas.vscodeRemoteResource,(e,t)=>{t({url:e.url.replace(/^vscode-remote-resource:/,"http:"),method:e.method})});const o=t.get(l.IUpdateService)
;(o instanceof N.Win32UpdateService||o instanceof B.LinuxUpdateService||o instanceof j.DarwinUpdateService)&&o.initialize(),c.resolveShellEnv(this.logService,this.environmentService.args,process.env);try{const e=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString();if(void 0===JSON.parse(Se.stripComments(e))["enable-crash-reporter"]){const t=["","\t// Allows to disable crash reporting.","\t// Should restart the app if the value is changed.",`\t"enable-crash-reporter": ${null===(n=this.configurationService.getValue("telemetry.enableCrashReporter"))||void 0===n||n},`,"","\t// Unique id used for correlating crash reports sent from this instance.","\t// Do not edit this value.",`\t"crash-reporter-id": "${be.generateUuid()}"`,"}"],i=e.substring(0,e.length-2).concat(",\n",t.join("\n"));await this.fileService.writeFile(this.environmentService.argvResource,_e.VSBuffer.fromString(i))}}catch(e){this.logService.error(e)}}}
;Oe=s([o(2,g.IInstantiationService),o(3,w.ILogService),o(4,S.IEnvironmentMainService),o(5,a.ILifecycleMainService),o(6,b.IConfigurationService),o(7,y.IStateService),o(8,ye.IFileService)],Oe),t.CodeApplication=Oe}),define(t[233],i([0,1,11,24,12,3,15,53,147,25,20,43,35,161,69,68,7,185,37,52,18,178,38,217,228,34,173,171,19,70,46,86,184,168,170,10,26,54,215,59,28,14,16,6,30,21,194]),function(e,t,i,r,n,s,o,a,c,l,d,u,h,p,f,g,m,v,w,y,S,b,_,E,C,I,k,P,M,D,L,R,T,O,A,x,F,U,W,N,B,j,z,$,K,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class q extends Error{constructor(){super(...arguments),this.isExpected=!0}}(new class{main(){let e;M.setUnexpectedErrorHandler(e=>console.error(e));try{e=a.parseMainProcessArgv(process.argv),e=this.validatePaths(e)}catch(e){return console.error(e.message),void i.app.exit(1)}if(e.wait&&!e.waitMarkerFilePath){const t=c.createWaitMarkerFile(e.verbose);t&&(a.addArg(process.argv,"--waitMarkerFilePath",t),e.waitMarkerFilePath=t)}this.startup(e)}async startup(e){
const t=new P.BufferLogService,[i,r,n]=this.createServices(e,t);try{await i.invokeFunction(async e=>{const t=e.get(S.IConfigurationService),i=e.get(w.IStateService);try{await this.initServices(n,t,i)}catch(e){throw this.handleStartupDataDirError(n,e),e}}),await i.invokeFunction(async s=>{const o=s.get(m.ILogService),a=s.get(d.ILifecycleMainService),c=s.get(F.IFileService),l=s.get(S.IConfigurationService),u=await this.doStartup(e,o,n,a,i,!0);return t.logger=new k.SpdLogService("main",n.logsPath,t.getLevel()),L.once(a.onWillShutdown)(()=>{c.dispose(),l.dispose()}),i.createInstance(C.CodeApplication,u,r).startup()})}catch(e){i.invokeFunction(this.quit,e)}}createServices(e,t){const i=new f.ServiceCollection,r=new H.EnvironmentMainService(e),n=this.patchEnvironment(r);i.set(y.IEnvironmentService,r),i.set(H.IEnvironmentMainService,r);const s=new m.MultiplexLogService([new m.ConsoleLogMainService(m.getLogLevel(r)),t]);process.once("exit",()=>s.dispose()),i.set(m.ILogService,s);const a=new O.FileService(s)
;i.set(F.IFileService,a);const c=new A.DiskFileSystemProvider(s);return a.registerProvider(x.Schemas.file,c),i.set(S.IConfigurationService,new b.ConfigurationService(r.settingsResource,a)),i.set(d.ILifecycleMainService,new g.SyncDescriptor(d.LifecycleMainService)),i.set(w.IStateService,new g.SyncDescriptor(v.StateService)),i.set(_.IRequestService,new g.SyncDescriptor(E.RequestMainService)),i.set(D.IThemeMainService,new g.SyncDescriptor(D.ThemeMainService)),i.set(R.ISignService,new g.SyncDescriptor(T.SignService)),i.set(N.IProductService,Object.assign({_serviceBrand:void 0},o.default)),i.set(U.ITunnelService,new g.SyncDescriptor(W.TunnelService)),[new p.InstantiationService(i,!0),n,r]}initServices(e,t,i){const r=Promise.all([e.extensionsPath,e.nodeCachedDataDir,e.logsPath,e.globalStorageHome.fsPath,e.workspaceStorageHome.fsPath,e.backupHome].map(e=>e?l.mkdirp(e):void 0)),n=t.initialize(),s=i.init();return Promise.all([r,n,s])}patchEnvironment(e){const t={VSCODE_IPC_HOOK:e.mainIPCHandle}
;return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(e=>{const i=process.env[e];"string"==typeof i&&(t[e]=i)}),Object.assign(process.env,t),t}async doStartup(e,t,i,a,c,l){let d;try{d=await u.serve(i.mainIPCHandle),L.once(a.onWillShutdown)(()=>d.dispose())}catch(d){if("EADDRINUSE"!==d.code)throw this.handleStartupDataDirError(i,d),d;let p;try{p=await u.connect(i.mainIPCHandle,"main")}catch(d){if(!l||s.isWindows||"ECONNREFUSED"!==d.code)throw"EPERM"===d.code&&this.showStartupWarningDialog(n.localize(0,null,o.default.nameShort),n.localize(1,null)),d;try{r.unlinkSync(i.mainIPCHandle)}catch(e){throw t.warn("Could not delete obsolete instance handle",e),e}return this.doStartup(e,t,i,a,c,!1)}if(i.extensionTestsLocationURI&&!i.debugExtensionHost.break){const e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw t.error(e),p.dispose(),new Error(e)}let f=void 0;e.wait||e.status||(f=setTimeout(()=>{
this.showStartupWarningDialog(n.localize(2,null,o.default.nameShort),n.localize(3,null))},1e4));const g=h.createChannelSender(p.getChannel("launch"),{disableMarshalling:!0});if(e.status)return c.invokeFunction(async()=>{const e=(await u.connect(i.sharedIPCHandle,"main")).getChannel("diagnostics"),t=h.createChannelSender(e),r=await g.getMainProcessInfo(),n=await g.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),s=await t.getDiagnostics(r,n);throw console.log(s),new q});throw s.isWindows&&await this.windowsAllowSetForegroundWindow(g,t),t.trace("Sending env to running instance..."),await g.start(e,process.env),p.dispose(),f&&clearTimeout(f),new q("Sent env to running instance. Terminating...")}if(e.status)throw t.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new q("Terminating...");return process.env.VSCODE_PID=String(process.pid),d}handleStartupDataDirError(e,t){if("EACCES"===t.code||"EPERM"===t.code){
const t=K.coalesce([e.userDataPath,e.extensionsPath,u.XDG_RUNTIME_DIR]);this.showStartupWarningDialog(n.localize(4,null),n.localize(5,null,t.join("\n")))}}showStartupWarningDialog(e,t){i.dialog.showMessageBoxSync({title:o.default.nameLong,type:"warning",buttons:[I.mnemonicButtonLabel(n.localize(6,null))],message:e,detail:t,noLink:!0})}async windowsAllowSetForegroundWindow(t,i){if(s.isWindows){const r=await t.getMainProcessId();i.trace("Sending some foreground love to the running instance:",r);try{(await new Promise((t,i)=>{e(["windows-foreground-love"],t,i)})).allowSetForegroundWindow(r)}catch(e){i.error(e)}}}quit(e,t){const i=e.get(m.ILogService),r=e.get(d.ILifecycleMainService);let n=0;t&&(t.isExpected?t.message&&i.trace(t.message):(n=1,t.stack?i.error(t.stack):i.error(`Startup error: ${t.toString()}`))),r.kill(n)}validatePaths(e){if(e["open-url"]&&(e._urls=e._,e._=[]),!e.remote){const t=this.doValidatePaths(e._,e.goto);e._=t}return e}doValidatePaths(e,t){
const i=process.env.VSCODE_CWD||process.cwd(),r=e.map(e=>{let r=String(e),n=void 0;t&&(r=(n=B.parseLineAndColumnAware(r)).path),r&&(r=this.preparePath(i,r));const s=B.sanitizeFilePath(r,i),o=$.basename(s);return o&&!B.isValidBasename(o)?null:t&&n?(n.path=s,this.toPath(n)):s}),n=s.isWindows||s.isMacintosh,o=K.distinct(r,e=>e&&n?e.toLowerCase():e||"");return K.coalesce(o)}preparePath(e,t){return s.isWindows&&(t=z.rtrim(t,'"')),t=z.trim(z.trim(t," "),"\t"),s.isWindows&&(t=$.resolve(e,t),t=z.rtrim(t,".")),t}toPath(e){const t=[e.path];return j.isNumber(e.line)&&t.push(String(e.line)),j.isNumber(e.column)&&t.push(String(e.column)),t.join(":")}}).main()})}).call(this);
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0c9e2dadd986d0bc085f1c5352245531eef65e84/core/vs/code/electron-main/main.js.map
